IMPLEMENTATION MODULE Lines;

IMPORT  SYSTEM,         (* Wegend ADR           *)
        M_Types,        (* Typ-definitionen     *)
        M_AES,          (* AES-Funktionen       *)
        M_VDI,          (* VDI-Funktionen       *)
        M_Appl,         (* Applikation-Manager  *)
        M_Event,        (* Event-Dispatcher     *)
        M_Messages,     (* Nachrichten          *)
        M_Random,       (* Zufallszahlen        *)
        M_Windows;      (* Fenster-Manager      *)


VAR     GraphWin:       INTEGER; (* Das Fenster *)
        TimerId:        INTEGER;

CONST   maxLines =        30;
        (*maxDrawLines =    4000;*)

TYPE    LineDescr =       ARRAY [0..3] OF INTEGER;

VAR     Ball, Vel, max:   LineDescr;
        maxX, maxY, min:  INTEGER;
        _Lines:            ARRAY [0..maxLines-1] OF LineDescr;
        index, t, i, new, old, ii, color, colcount: INTEGER;
        r: M_Types.tRect;
        fback: INTEGER;


PROCEDURE DrawLines;
VAR i: INTEGER;
BEGIN
 IF (new >= maxLines) THEN       (* undraw old line *)
  i:= M_VDI.vsl_color (M_Appl.DefaultWS.Handle, fback);
  M_VDI.v_pline (M_Appl.DefaultWS.Handle, 2, SYSTEM.ADR (_Lines[old MOD maxLines]));
  INC (old);
 END;
 _Lines[new MOD maxLines]:= Ball;  (* draw new line *)
 INC (new);
 i:= M_VDI.vsl_color (M_Appl.DefaultWS.Handle, color);
 M_VDI.v_pline (M_Appl.DefaultWS.Handle, 2, SYSTEM.ADR (Ball));
END DrawLines;

PROCEDURE HandleTimer (para: M_Types.PtrEP);
VAR i, f: INTEGER;
    re, a, r1, r2: M_Types.tRect;
BEGIN
 IF GraphWin > 0 THEN
  
  IF NOT M_Windows.WinIconified (GraphWin) THEN
   
   FOR i:= 0 TO 3 DO
    t:= Ball[i] + Vel[i];
    IF t >= max[i] THEN
     t:= max[i] * 2 - Vel[i] - Ball[i];
     Vel[i]:= - Vel[i];
    END;
    IF ODD(i) THEN  min:= r.y  ELSE  min:= r.x;  END;
    IF t < min THEN
     IF t < 0 THEN  t:= - t  ELSE  t:= min;  END;
     Vel[i]:= - Vel[i];
    END;
    Ball[i]:= t;
   END; (* FOR *)
  
   (* Linien ausgeben *)
   M_Windows.RewriteWindow (GraphWin, M_Appl.DefaultWS.Handle, DrawLines);

   INC (colcount);
   IF colcount > 10 THEN
    INC (color);
    IF color >= M_Appl.DefaultWS.DefColors THEN  color:= 0;  END;
    IF color = fback THEN  INC (color); END;
    colcount:= 0;
   END;
  END;
 END;
END HandleTimer;

PROCEDURE WinHandler (w: M_Windows.PtrWinpara);
BEGIN
 w^.action:= M_Types.LONGBITSET{}; (* Erstmal nicht reagieren *)
 CASE w^.message OF
  M_Messages.WinRedraw:         TheLines;
                                |
  M_Messages.WinTopped:         w^.action:= M_Types.LONGBITSET{M_Windows.wTopped};
                                |
  M_Messages.WinClosed:         GraphWin:= -1;
                                M_Event.RemoveMUTIMER (TimerId);
                                w^.action:= M_Types.LONGBITSET{M_Windows.wClose};
                                |
  M_Messages.WinFulled:         TheLines;
                                w^.action:= M_Types.LONGBITSET{M_Windows.wFulled};
                                |
  M_Messages.WinSized:          TheLines;
                                w^.action:= M_Types.LONGBITSET{M_Windows.wSized};
                                |
  M_Messages.WinMoved:          M_Windows.SetWinPos (GraphWin, w^.spec.x, w^.spec.y);
                                TheLines;
                                |
  M_Messages.WinBottomed:       w^.action:= M_Types.LONGBITSET{M_Windows.wBottomed};
                                |
  M_Messages.WinIconify:        w^.action:= M_Types.LONGBITSET{M_Windows.wIconify};
                                |
  M_Messages.WinUniconify:      w^.action:= M_Types.LONGBITSET{M_Windows.wUniconify};
                                |
  ELSE                          ;
 END;
END WinHandler;

PROCEDURE TheLines;
VAR i: INTEGER;
BEGIN
 IF GraphWin < 0 THEN
  (* M_VDI.vswr_mode (DefaultWS.Handle, XORMODE); *)
  GraphWin:= M_Windows.OpenWindow (WinHandler,
                         {M_AES.MOVE, M_AES.NAME, M_AES.CLOSER, M_AES.Size, 
                          M_AES.FULL, M_AES.SMALLER}, {},
                         fback, 
                         7, -1, -1, 250,
                         200, 0, 0, 0, 0,
                         ' The Lines ', 
                         ' ', 
                         NIL, 
                         NIL);
  (* Timer-Event anmelden. Alle 10ms *)
  TimerId:= M_Event.InstMUTIMER (HandleTimer, 10);
 END;
 M_Windows.GetUseableRect (GraphWin, r);
 maxX:= r.x + r.w;
 maxY:= r.y + r.h;
 max[0]:= maxX;
 max[1]:= maxY;
 max[2]:= maxX;
 max[3]:= maxY;
 FOR i:= 0 TO 3 DO
  Vel[i]:= M_Random.RndInt (16) - 8;
  ii:= max[i] - 100;
  Ball[i]:= M_Random.RndInt (ii) + 50;
 END;
 new:= 0;
 old:= 0;
END TheLines;

BEGIN
 GraphWin:= -1;
 colcount:= 0;
 IF M_Appl.DefaultWS.DefColors > 2 THEN  fback:= 1 ELSE fback:= 0; END;
 IF color = fback THEN INC (color); END;
END Lines.
