MODULE WinHello;

IMPORT  M_Types,        (* Typ-definitionen     *)
        M_Sys,          (* Grundlegendes        *)
        M_Convert,      (* Zahlenkonvertierung  *)
        M_Strings,      (* Stringmanipulation   *)
        M_AES,          (* AES-Interface        *)
        M_Appl,         (* Applikation-Manager  *)
        M_Event,        (* Event-Dispatcher     *)
        M_Messages,     (* Nachrichten          *)
        M_Terminal,     (* Textfenster          *)
        M_Windows;      (* Fenster-Manager      *)

VAR FirstWin,
    SecondWin,
    ThirdWin    : INTEGER;
    ProgEnde    : INTEGER;


PROCEDURE WinHandler (w: M_Windows.PtrWinpara);
BEGIN
 w^.action:= M_Types.LONGBITSET{};
 CASE w^.message OF
  M_Messages.WinRedraw:         ;
                                |
  M_Messages.WinTopped:         w^.action := M_Types.LONGBITSET{M_Windows.wTopped};
                                |
  M_Messages.WinClosed:         w^.action := M_Types.LONGBITSET{M_Windows.wClose};
                                DEC (ProgEnde);
                                |
  M_Messages.WinFulled:         w^.action := M_Types.LONGBITSET{M_Windows.wFulled};
                                |
  M_Messages.WinSized:          w^.action := M_Types.LONGBITSET{M_Windows.wSized};
                                |
  M_Messages.WinMoved:          w^.action := M_Types.LONGBITSET{M_Windows.wMoved};
                                |
  M_Messages.WinBottomed:       w^.action := M_Types.LONGBITSET{M_Windows.wBottomed};
                                |
  M_Messages.WinIconify:        M_Windows.SetIcontext (w^.window, 'SCHRUMPF');
                                w^.action := M_Types.LONGBITSET{M_Windows.wIconify};
                                |
  M_Messages.WinUniconify:      w^.action := M_Types.LONGBITSET{M_Windows.wUniconify};
                                |
  ELSE (* Ignorieren *);
 END;
END WinHandler;

PROCEDURE OpenWin (wname, winfo: ARRAY OF CHAR; farbe: INTEGER; mn: BOOLEAN;
                   xPos, yPos, Breite, Hoehe, wrap: INTEGER): INTEGER;
VAR f: BITSET;
BEGIN
 f:= {M_AES.MOVE, M_AES.NAME, M_AES.CLOSER, M_AES.FULL, M_AES.INFO, M_AES.Size, M_AES.SMALLER};
 INC (ProgEnde);
 RETURN M_Terminal.OpenTextwindow (
                        WinHandler,     (* Fensterhandler *)
                        f, {}, 
                        xPos, yPos, Breite, Hoehe, (* Grsse *)
                        0, 0, 0, 0,     (* Offsets *)
                        0, 1,           (* Farben *)
                        -1, -1,         (* Font,Gre *)
                        {},             (* Effekte *)
                        wrap,           (* Umbruch *)
                        wname,          (* Titel *)
                        winfo,          (* Infozeile *)
                        NIL);           (* Ressource *)
END OpenWin;

VAR name: M_Types.CSTRING;
    term: INTEGER;

BEGIN
 ProgEnde:= 0;
 M_Appl.MouseOn;
 M_Appl.MouseArrow;
 M_Convert.IntToStr (M_Appl.ApplIdent, 3, name);
 M_Strings.StrCat (name, ' <- Applikationsnummer!');

 FirstWin:= OpenWin (' Hello World 1 ', name, 12, FALSE, 100, 100, 250, 150, 50);
 M_Terminal.WriteLine (FirstWin, 'Hello World');

 SecondWin := OpenWin (' Hello World 2 ', name, 12, FALSE, 400, 300, 200, 100, 50);
 M_Terminal.WriteLine (SecondWin, 'Hello World');

 ThirdWin := OpenWin (' Hello World 3 ', name, 12, FALSE, 200, 150, 200, 100, 50);
 M_Terminal.WriteLine (ThirdWin, 'Hello World');

 REPEAT
  M_Event.CentralDispatcher;
 UNTIL ProgEnde < 1;

 term := 0;
 M_Appl.ApplTerm (term);
END WinHello.
