(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * MagicAES     Application Environment Services       Pascal Interface *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_AES;

FROM SYSTEM     IMPORT  ADDRESS, BYTE;
FROM M_Types    IMPORT  Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6, Bit7, Bit8,
                        Bit9, Bit10, Bit11, Bit12, Bit13, Bit14, Bit15, Bit16,
                        Bit17, Bit18, Bit19, Bit20, Bit21, Bit22, Bit23, Bit24,
                        Bit25, Bit26, Bit27, Bit28, Bit29, Bit30, Bit31,
                        tRect, LONGBITSET, PtrCSTRING;

CONST   MouseLeft =     Bit0;   (* Bitwert fr Maustasten *)
        MouseRight =    Bit1;

TYPE    tAESGLOBAL =    RECORD
                         apVersion:     SHORTINT;  (* globl 0 *)
                         apCount:       SHORTINT;  (* globl 1 *)
                         apId:          SHORTINT;  (* globl 2 *)
                         apPprivate:    LONGINT;   (* globl 3/4 *)
                         apPtree:       ADDRESS;   (* globl 5/6 *)
                         apPmem:        ADDRESS;   (* globl 7/8 *)
                         apLmem:        SHORTINT;  (* globl 9 *)
                         apNplanes:     SHORTINT;  (* globl 10 *)
                         Reserved1:     SHORTINT;  (* globl 11 *)
                         Reserved2:     SHORTINT;  (* globl 12 *)
                         apBvdisk:      SHORTCARD; (* globl 13 *)
                         apBvhard:      SHORTCARD; (* globl 14 *)
                        END;

TYPE    tControl =      RECORD
                         opcode:        SHORTINT;
                         sizeIntIn:     SHORTINT;
                         sizeIntOut:    SHORTINT;
                         sizeAddrIn:    SHORTINT;
                         sizeAddrOut:   SHORTINT;
                        END;

TYPE    tIntIn =        ARRAY [0..16] OF SHORTINT;
        tIntOut =       ARRAY [0.. 7] OF SHORTINT;
        tAddrIn =       ARRAY [0.. 2] OF ADDRESS;
        tAddrOut =      ARRAY [0.. 1] OF ADDRESS;

VAR     CallResult:  SHORTINT;
        (* Enthlt nach einem AESCall den eventuellen Fehlercode *)

PROCEDURE AESCall (op, c1, c2, c3, c4: SHORTINT): SHORTINT;
(* Fhrt eine AES-Operation aus *)

(*-- AES-Objc --------------------------------------------------------*)

CONST   GBOX =          20;
        GTEXT =         21;
        GBOXTEXT =      22;
        GIMAGE =        23;
        GPROGDEF =      24;
        GIBOX =         25;
        GBUTTON =       26;
        GBOXCHAR =      27;
        GSTRING =       28;
        GFTEXT =        29;
        GFBOXTEXT =     30;
        GICON =         31;
        GTITLE =        32;
        GCICON =        33;     (* object type number for AES   *)

CONST   SELECTABLE =    Bit0;
        DEFAULT =       Bit1;
        ExitFlag =      Bit2;   (* EXIT ist reserviertes Wort... *)
        EDITABLE =      Bit3;
        RBUTTON =       Bit4;
        LASTOB =        Bit5;
        TOUCHEXIT =     Bit6;
        HIDETREE =      Bit7;
        INDIRECT =      Bit8;

CONST   SELECTED =      Bit0;
        CROSSED =       Bit1;
        CHECKED =       Bit2;
        DISABLED =      Bit3;
        OUTLINED =      Bit4;
        SHADOWED =      Bit5;
        WHITEBAK =      Bit6;
        DRAW3D =        Bit7;
                        
CONST   WHITE =          0;     (* Farben *)
        BLACK =          1;
        RED =            2;
        GREEN  =         3;
        BLUE  =          4;
        CYAN  =          5;
        YELLOW  =        6;
        MAGENTA  =       7;
        LWHITE =         8;
        LBLACK  =        9;
        LRED =          10;
        LGREEN =        11;
        LBLUE =         12;
        LCYAN =         13;
        LYELLOW =       14;
        LMAGENTA =      15;


TYPE    BoxInfo =       RECORD
                         char:  CHAR;   (* Bit 24..31 *)
                         frame: CHAR;   (* Bit 16..23 *)
                         flags: BITSET; (* Bit0..Bit3:   Innenfarbe (0..15)
                                          * Bit4..Bit6:   Raster
                                          * Bit7:         Text transparent oder deckend
                                          * Bit8..Bit11:  Textfarbe
                                          * Bit12..Bit15: Rahmenfarbe
                                          *)
                        END;           

TYPE    PtrTEDINFO =    POINTER TO TEDINFO;
        TEDINFO =       RECORD
                         tePtext:     PtrCSTRING;
                         tePtmplt:    PtrCSTRING;
                         tePvalid:    PtrCSTRING;
                         teFont:      SHORTINT;
                         teResvd1:    SHORTINT;
                         teJust:      SHORTINT;
                         teColor:     BITSET;
                         teResvd2:    SHORTINT;
                         teThickness: SHORTINT;
                         teTxtlen:    SHORTINT;
                         teTmplen:    SHORTINT;
                        END;

TYPE    PtrBITBLK =     POINTER TO BITBLK;
        BITBLK =        RECORD
                         biData:  ADDRESS;
                         biWb:    SHORTINT;
                         biHl:    SHORTINT;
                         biX:     SHORTINT;
                         biY:     SHORTINT;
                         biColor: SHORTINT;
                        END;    

        tObjctree = POINTER TO tObjects;

TYPE    PtrPARMBLK =    POINTER TO PARMBLK;
        PARMBLK =       RECORD
                         pbTree:      tObjctree;
                         pbObj:       SHORTINT;
                         prPrevstate: BITSET;
                         prCurrstate: BITSET;
                         pbX:         SHORTINT;
                         pbY:         SHORTINT;
                         pbW:         SHORTINT;
                         pbH:         SHORTINT;
                         pbXc:        SHORTINT;
                         pbYc:        SHORTINT;
                         pbWc:        SHORTINT;
                         pbHc:        SHORTINT;
                         pbParm:      ADDRESS;
                        END;

TYPE    PtrUSERBLK =    POINTER TO USERBLK;
        USERBLK =       RECORD
                         ubCode: ADDRESS;
                         ubPara: LONGINT;
                        END;

TYPE    PtrICONBLK =    POINTER TO ICONBLK;
        ICONBLK =       RECORD
                         ibPmask: ADDRESS;
                         ibPdata: ADDRESS;
                         ibPtext: ADDRESS;
                         ibChar:  BITSET;
                         ibXchar: SHORTINT;
                         ibYchar: SHORTINT;
                         ibXicon: SHORTINT;
                         ibYicon: SHORTINT;
                         ibWicon: SHORTINT;
                         ibHicon: SHORTINT;
                         ibXtext: SHORTINT;
                         ibYtext: SHORTINT;
                         ibWtext: SHORTINT;
                         ibHtext: SHORTINT;
                         (* ibResvd: SHORTINT;  Steht im Profibuch, gibts aber 
                          *                    in der wirklichen Welt nicht!!!
                          *                    REEEEESCHKEEEEEEEEE!!!!
                          *)
                        END;

TYPE    PtrCICON =      POINTER TO CICON;
        CICON =         RECORD
                         numplanes: SHORTINT; (* number of planes in the following data *)
                         coldata:   ADDRESS; (* ADDRESS to color bitmap in standard form *)
                         colmask:   ADDRESS; (* ADDRESS to single plane mask of col_data *)
                         seldata:   ADDRESS; (* ADDRESS to color bitmap of selected icon *)
                         selmask:   ADDRESS; (* ADDRESS to single plane mask of selected icon *)
                         nextres:   PtrCICON; (* ADDRESS to next icon for a different resolution *)
                        END;

TYPE    PtrCICONBLK =   POINTER TO CICONBLK;
        CICONBLK =      RECORD
                         mono:  ICONBLK;  (* default monochrome icon *)
                         color: PtrCICON; (* list of color icons for different resolutions *)
                        END;

TYPE    PtrObjcspec =   POINTER TO Objcspec;
        Objcspec =      RECORD
                         CASE :SHORTINT OF
                          0: address    : ADDRESS;|
                          1: Box        : BoxInfo;| (* steht direkt im Langwort! *)
                          2: TedPtr     : PtrTEDINFO;|
                          3: StringPtr  : PtrCSTRING;|
                          4: ImagePtr   : PtrBITBLK;|
                          5: UserDefPtr : PtrUSERBLK;|
                          6: IconPtr    : PtrICONBLK;|
                          7: CiconPtr   : PtrCICONBLK;|
                          8: obSpecPtr  : PtrObjcspec;|
                         END;
                        END;

TYPE    tOBJECT = RECORD  (* OBJECT ist reserviert *)
                  obNext:   SHORTINT;
                  obHead:   SHORTINT;
                  obTail:   SHORTINT;
                  obType:   SHORTINT;
                  obFlags:  BITSET;
                  obState:  BITSET;
                  obSpec:   Objcspec;
                  obX:      SHORTINT;
                  obY:      SHORTINT;
                  obWidth:  SHORTINT;
                  obHeight: SHORTINT;
                 END;

TYPE    tObjects  = ARRAY [0..0FFFFH] OF tOBJECT;

PROCEDURE objc_add    (tree: ADDRESS; parent, child: SHORTINT);
PROCEDURE objc_delete (tree: ADDRESS; obj: SHORTINT);
PROCEDURE objc_draw   (tree: ADDRESS; start, depth: SHORTINT; pxy: tRect);
PROCEDURE objc_find   (tree: ADDRESS; start, depth, x, y: SHORTINT): SHORTINT;
PROCEDURE objc_offset (tree: ADDRESS; obj: SHORTINT; VAR x, y: SHORTINT);
PROCEDURE objc_order  (tree: ADDRESS; obj, newpos: SHORTINT);

CONST   EDSTART =       0;
        EDINIT =        1;
        EDCHAR =        2;
        EDEND =         3;

PROCEDURE objc_edit (tree: ADDRESS; obj: SHORTINT; VAR pos: SHORTINT; char, kind: SHORTINT);
PROCEDURE objc_change (tree: ADDRESS; obj: SHORTINT; pxy: tRect; state: BITSET; mode: SHORTINT);

CONST   GetAttributs =  0;
        SetAttributs =  1;

CONST   LK3DIND =       0;
        LK3DACT =       1;
        INDBUTCOL =     2;
        ACTBUTCOL =     3;
        BACKGRCOL =     4;
        AD3DVALUE =     5;

PROCEDURE objc_sysvar (mode, which, i1, i2: SHORTINT; VAR o1, o2: SHORTINT);

(*-- AES-Appl --------------------------------------------------------*)

CONST   Timer   =       Bit0;
        Button =        Bit1;
        Mouse =         Bit2;
        Keyboard =      Bit3;


TYPE    RecordEntry =   RECORD
                         kind:  LONGBITSET;     (* Siehe Timer .. Keyboard *)
                         event: LONGINT;
                        END;

PROCEDURE appl_init(): SHORTINT;
PROCEDURE appl_read (id, len: SHORTINT; pipe: ADDRESS);
PROCEDURE appl_write (id, len: SHORTINT; pipe: ADDRESS);

TYPE    FindMode =      (Normal, AesId, MintId, CurrProcess);
                        (* AesID..CurrProcess wird erst ab AES 4.0 
                         * (MultiTOS) untersttzt.
                         *)

PROCEDURE appl_find (mode: FindMode; id: SHORTINT; name: ADDRESS): SHORTINT;
PROCEDURE appl_tplay (num, speed: SHORTINT; buffer: ADDRESS);
PROCEDURE appl_trecord (count: SHORTINT; buffer: ADDRESS): SHORTINT;
PROCEDURE appl_bvset (disk, hard: BITSET);
PROCEDURE appl_yield;
PROCEDURE appl_exit;


(* Ab AES 4.0 *)

CONST   ApsFirst = 0; (* Suchmodus *)
        ApsNext =  1;
        ApsShell = 2;

CONST   SystemProcess = 1; (* Applikationstyp *)
        Application =   2;
        Accessory =     4;

PROCEDURE appl_search (mode: SHORTINT; name: ADDRESS; VAR typ, id: SHORTINT): SHORTINT;

CONST AESFont =         0;
      AESSmallfont =    1;
      AESResolution =   2;
      AESLanguage =     3;

PROCEDURE appl_getinfo (typ: SHORTINT; VAR out1, out2, out3, out4: SHORTINT);

(*-- AES-Evnt --------------------------------------------------------*)


CONST   KRSHIFT =       Bit0;   (* Tastatur-Status *)
        KLSHIFT =       Bit1;
        KCTRL =         Bit2;
        KALT =          Bit3;
        KCAPS =         Bit4;   (* Fr AES undokumentiert! *)

PROCEDURE evnt_keybd (VAR taste, scan: SHORTINT; VAR ascii: CHAR);
PROCEDURE evnt_button (maxclicks: SHORTINT; mask, state: BITSET; VAR x, y: SHORTINT; VAR button, kbshift: BITSET): SHORTINT;

CONST   EnterRect =     0;
        LeaveRect =     1;

PROCEDURE evnt_mouse  (mode: SHORTINT; m1rect: tRect; VAR x, y: SHORTINT;  VAR button, kbshift: BITSET);

CONST   MNSELECTED =     10;    (* Eventmessages *)
        WMREDRAW =       20;
        WMTOPPED =       21;
        WMCLOSED =       22;
        WMFULLED =       23;
        WMARROWED =      24;
        WAUPPAGE =        0;
        WADNPAGE =        1;
        WAUPLINE =        2;
        WADNLINE =        3;
        WALFPAGE =        4;
        WARTPAGE =        5;
        WALFLINE =        6;
        WARTLINE =        7;
        WMHSLID =        25;
        WMVSLID =        26;
        WMSIZED =        27;
        WMMOVED =        28;
        WMNEWTOP =       29;
        WMUNTOPPED =     30;     (* Neu in AES 4.0 *)
        WMONTOP =        31;     (* Neu in AES 4.0 *)
        WMICONIFY =      34;     (* Neu in AES 4.1 *)
        WMUNICONIFY =    35;     (* Neu in AES 4.1 *)
        WMALLICONIFY =   36;     (* Neu in AES 4.1 *)
        ACOPEN =         40;
        ACCLOSE =        41;
        APTERM =         50;     (* Neu in AES 4.0 *)
        APTFAIL =        51;     (* Neu in AES 4.0 *)
        APRESCHG =       57;     (* Neu in AES 4.0 *)
        SHUTCOMPLETED =  60;     (* Neu in AES 4.0 *)
        RESCHCOMPLETED = 61;     (* Neu in AES 4.0 *)
        APDRAGDROP =     63;     (* Neu in AES 4.0 *)
        SHWDRAW =        72;     (* Neu in AES 4.0 *)
        CHEXIT =         90;     (* Neu in AES 4.0 *)

PROCEDURE evnt_mesag (buffer: ADDRESS);
PROCEDURE evnt_timer (count: LONGINT);


CONST   MUKEYBD =       Bit0;      (* Event-Typen *)
        MUBUTTON =      Bit1;
        MUM1 =          Bit2;
        MUM2 =          Bit3;
        MUMESAG =       Bit4;
        MUTIMER =       Bit5;

PROCEDURE evnt_multi (wich: BITSET;
                     maxclicks: SHORTINT;
                     mask, state: BITSET;
                     m1mode: SHORTINT;
                     m1rect: tRect;
                     m2mode: SHORTINT;
                     m2rect: tRect;
                     msgBuff: ADDRESS;
                     loTimer, hiTimer: SHORTINT;
                     VAR x, y: SHORTINT;
                     VAR button: BITSET;
                     VAR taste: SHORTINT;
                     VAR kbshift: BITSET;
                     VAR scan: SHORTINT;
                     VAR ascii: CHAR;
                     VAR clicks: SHORTINT;
                     VAR events: BITSET);

PROCEDURE evnt_pmulti (VAR events: BITSET);
PROCEDURE evnt_dclicks (new: SHORTINT; setclick: BOOLEAN): SHORTINT;


(*-- AES-Form -----------------------------------------------------------*)

PROCEDURE form_do (tree: ADDRESS; start: SHORTINT): SHORTINT;

CONST   FMDSTART =      0;
        FMDGROW =       1;
        FMDSHRINK =     2;
        FMDFINISH =     3;

PROCEDURE form_dial   (flag: SHORTINT; small, big: tRect);
PROCEDURE form_alert  (button: SHORTINT; str: ADDRESS): SHORTINT;
PROCEDURE form_error  (errNum: SHORTINT);
PROCEDURE form_center (tree: ADDRESS; VAR rect: tRect);
PROCEDURE form_keybd  (tree: ADDRESS; obj, chin: SHORTINT; VAR nextObj, chout: SHORTINT): SHORTINT;
PROCEDURE form_button (tree: ADDRESS; obj, clicks: SHORTINT; VAR next: SHORTINT): SHORTINT;


(*-- AES-FSel -----------------------------------------------------------*)

PROCEDURE fsel_input (pfad, name: ADDRESS): BOOLEAN;
PROCEDURE fsel_exinput (info, pfad, name: ADDRESS): BOOLEAN;

(*-- AES-Graf -----------------------------------------------------------*)

PROCEDURE graf_rubberbox (x, y, mw, mh: SHORTINT; VAR lw, lh: SHORTINT);
PROCEDURE graf_dragbox   (moving, boundary: tRect; VAR x, y: SHORTINT);
PROCEDURE graf_movebox   (rect: tRect; dx, dy: SHORTINT);
PROCEDURE graf_growbox   (source, dest: tRect);
PROCEDURE graf_shrinkbox (source, dest: tRect);
PROCEDURE graf_watchbox  (tree: ADDRESS; item: SHORTINT; instate, outstate: BITSET): SHORTINT;

CONST   Horizontal =    0;
        Vertical =      1;

PROCEDURE graf_slidebox (tree: ADDRESS; parent, obj: SHORTINT; dir: SHORTINT): SHORTINT;
PROCEDURE graf_handle (VAR handle, wCh, hCh, wbox, hbox: SHORTINT);

CONST   ARROW =          0;
        TEXTCRSR =       1;
        BUSYBEE =        2;
        POINTHAND =      3;
        FLATHAND =       4;
        THINCROSS =      5;
        THICKCROSS =     6;
        OUTLCROSS =      7;
        USERDEF =      255;
        MOFF =         256;
        MON =          257;
        SAVEMOUSE =    258; (* Ab AES 4.0!!! *)
        LASTSAVED =    259; (* Ab AES 4.0!!! *)
        PREVIOSMOUSE = 260; (* Ab AES 4.0!!! *)

PROCEDURE graf_mouse   (form: SHORTINT; user: ADDRESS);
PROCEDURE graf_mkstate (VAR x, y: SHORTINT; VAR button, kbshift: BITSET);


(*-- AES-Menu -----------------------------------------------------------*)

CONST   Reset = 0;
        Setflag = 1;

PROCEDURE menu_bar (tree: ADDRESS; action: SHORTINT): SHORTINT;
(* Ab AES 4.0: Wird als 'action' -1 bergeben, bekommt am als Returnwert
 * die Application-Id des Prozesses, dem die aktuelle Menzeile gehrt.
 *)

PROCEDURE menu_icheck (tree: ADDRESS; item, action: SHORTINT);
PROCEDURE menu_ienable (tree: ADDRESS; item, action: SHORTINT);
PROCEDURE menu_tnormal (tree: ADDRESS; item, action: SHORTINT);
(* Aus welchen Grnden auch immer: Bei action sind reset und set vertauscht *)

PROCEDURE menu_text (tree: ADDRESS; item: SHORTINT; str: ADDRESS);
PROCEDURE menu_register (apid: SHORTINT; str: ADDRESS): SHORTINT;
(* AES 4.0: Wenn apid = -1 wird str zum NAMEN der Application (siehe 
 * ApplFind!)  Dieses Verhalten scheint auch in AES-Versionen vor 4.0 
 * zu funktionieren, ist dort aber NICHT DOKUMENTIERT!!!
 *)

PROCEDURE menu_unregister (apid: SHORTINT);

(* Ab AES 4.0 *)

TYPE    MENU =  RECORD
                 mnTree:   ADDRESS; (* the object tree of the menu *)
                 mnMenu:   SHORTINT; (* the parent object of the menu items *)
                 mnItem:   SHORTINT; (* the starting menu item *)
                 mnScroll: SHORTINT; (* the scroll field status of the menu *)
                 mnKstate: BITSET;  (* The CTRL, ALT, SHIFT Key state *)
                END;

TYPE    MNSET = RECORD
                 display: LONGINT; (* the submenu display delay *)
                 drag:    LONGINT; (* the submenu drag delay *)
                 delay:   LONGINT; (* the single-click scroll delay *)
                 speed:   LONGINT; (* the continuous scroll delay *)
                 height:  SHORTINT; (* the menu scroll height *)
                END;

PROCEDURE menu_popup (men: MENU; xpos, ypos: SHORTINT; VAR mdata: MENU): SHORTINT;

CONST   InquireMenu = 0;
        AttachMenu =  1;
        RemoveMenu =  2;

PROCEDURE menu_attach (flag: SHORTINT; tree: ADDRESS; item: SHORTINT; VAR mdata: MENU): SHORTINT;

CONST   InquireStart = 0;
        SetStart =     1;

PROCEDURE menu_istart (flag: SHORTINT; tree: ADDRESS; men, item: SHORTINT);
PROCEDURE menu_settings (flag: SHORTINT; VAR value: MNSET);

(*-- AES-Rsrc -----------------------------------------------------------*)

PROCEDURE rsrc_load (name: ADDRESS): BOOLEAN;
PROCEDURE rsrc_free;

CONST   RTREE =         0;
        ROBJECT =       1;
        RTEDINFO =      2;
        RICONBLK =      3;
        RBITBLK =       4;
        RSTRING =       5;
        RIMAGEDATA =    6;
        ROBSPEC =       7;
        RTEPTEXT =      8;
        RTEPTMPLT =     9;
        RTEPVALID =     10;
        RIBPMASK =      11;
        RIBPDATA =      12;
        RIBPTEXT =      13;
        RBIDATA =       14;
        RFRSTR =        15;
        RFRIMG =        16;

PROCEDURE rsrc_gaddr (typ, item: SHORTINT): ADDRESS;
PROCEDURE rsrc_saddr (typ, item: SHORTINT; tree: ADDRESS);
PROCEDURE rsrc_obfix (tree: ADDRESS; obj: SHORTINT);
PROCEDURE rsrc_rcfix (header: ADDRESS);


(*-- AES-Scrp -----------------------------------------------------------*)

CONST   scCSV =         Bit0;
        scTXT =         Bit1;
        scGEM =         Bit2;
        scIMG =         Bit3;
        scDCA =         Bit4;
        scUSR =         Bit5;

PROCEDURE scrp_read  (pfad: ADDRESS; VAR return: BITSET);
(* Funktioniert nicht auf die beschriebene Art mit dem ST/E/TT GEM *)

PROCEDURE scrp_write (pfad: ADDRESS);
PROCEDURE scrp_clear; 


(*-- AES-Shel -----------------------------------------------------------*)

PROCEDURE shel_read (command, path: ADDRESS);

CONST   LaunchProg =       0; (* exec *)
        LaunchAppl =       1;
        LaunchAcc =        3;
        ShutDown =         4;
        ChangeRez =        5;
        BroadCast =        7;
        Environment =      8;
        MsgRecognize =     9;
        SendMessage =     10;

CONST   NoGraphic =        0; (* appl *)
        Graphic =          1;
        AbortShutdown =    0; (* bei exec = shutdown! *)
        PartialShutdown =  1;
        CompleteShutdown = 2;

CONST   Now =           0;
        AtEnd =         1;


PROCEDURE shel_write (exec, appl, start: SHORTINT; command, path: ADDRESS);
PROCEDURE shel_get (len: SHORTINT; buffer: ADDRESS): SHORTINT;
(* AES 4.0: Liefert die Lnge des Puffers, wenn len = -1 *)

PROCEDURE shel_put (len: SHORTINT; buffer: ADDRESS);
PROCEDURE shel_find (name: ADDRESS);
PROCEDURE shel_envrn (param: ADDRESS; name: ADDRESS);
PROCEDURE shel_rdef (command, path: ADDRESS);
PROCEDURE shel_wdef (command, path: ADDRESS);


(*-- AES-Wind -----------------------------------------------------------*)

CONST   NAME =          Bit0;
        CLOSER =        Bit1;
        FULL =          Bit2;
        MOVE =          Bit3;
        INFO =          Bit4;
        Size =          Bit5;   (* SIZE ist reserviertes Wort *)
        UPARROW =       Bit6;
        DNARROW =       Bit7;
        VSLIDE =        Bit8;
        LFARROW =       Bit9;
        RTARROW =       Bit10;
        HSLIDE =        Bit11;
        HOTCLOSEBOX =   Bit12;  (* Was immer das auch ist... *)
        Unused1 =       Bit13;
        SMALLER =       Bit14;  (* ... in MTOS 1.07 ist das Iconifier *)
        Unused2 =       Bit15;

PROCEDURE wind_create (comp: BITSET; size: tRect): SHORTINT;
PROCEDURE wind_open   (handle: SHORTINT; size: tRect);
PROCEDURE wind_close  (handle: SHORTINT);
PROCEDURE wind_delete (handle: SHORTINT);

CONST   WFRESVD1 =      1;
        WFNAME =        2;
        WFINFO =        3;
        WFWORKXYWH =    4;
        WFCURRXYWH =    5;
        WFPREVXYWH =    6;
        WFFULLXYWH =    7;
        WFHSLIDE =      8;
        WFVSLIDE =      9;
        WFTOP =         10;
        WFFIRSTXYWH =   11;
        WFNEXTXYWH =    12;
        WFRESVD13 =     13;
        WFNEWDESK =     14;
        WFHSLSIZE =     15;
        WFVSLSIZE =     16;
        WFSCREEN =      17;
        WFCOLOR =       18;     (* Neu in AES 4.0 *)
        WFDCOLOR =      19;     (* Neu in AES 4.0 *)
        WFOWNER =       20;     (* Neu in AES 4.0 *)
        WFBEVENT =      24;     (* Neu in AES 4.0 *)
        WFBOTTOM =      25;     (* Neu in AES 4.0 *)

                                (* Neu in AES 4.1 *)
        WFTOOLBAR =     30;     (* Toolbar parameter for wind_get/set *)
        WF_FTOOLBAR =   31;     (* Get the First Toolbar rectangle *)
        WF_NTOOLBAR=    32;     (* Get the Next Toolbar rectang *)
        WM_TOOLBAR =    37;     (* Toolbar Button Event Message *)

PROCEDURE wind_get  (handle, typ: SHORTINT; VAR para: tRect);
PROCEDURE wind_set  (handle, typ: SHORTINT; para: tRect);
PROCEDURE wind_find (x, y: SHORTINT): SHORTINT;

CONST   ENDUPDATE =     0;
        BEGUPDATE =     1;
        ENDMCTRL =      2;
        BEGMCTRL =      3;
        REQUPDATE =   257;
        REQMCTRL =    259;

PROCEDURE wind_update (mode: SHORTINT): SHORTINT;
(* AES 4.0: Bei REQUPDATE bzw. REQMCTRL checkt das AES, ob ein Prozess 
 * schon ein BEGUPDATE bzw. BEGMCTRL abgesetzt hat, und returniert
 * 0 als Fehlercode, falls dies der Fall ist.  Ansonsten wird ein normaler
 * BEGUPDATE bzw. BEGMCTRL ausgefhrt.
 *)

CONST   WCBORDER =      0;
        WCWORK =        1;

PROCEDURE wind_calc (mode: SHORTINT; comp: BITSET; VAR inr, outr: tRect);
PROCEDURE wind_new;


(*--- AES-Xgraf_ ---------------------------------------------------------*)

PROCEDURE xgrf_stepcalc (ow, oh, x, y, w, h: SHORTINT; VAR cx, cy, count, xstep, ystep: SHORTINT);
PROCEDURE xgrf_2box (xc, yc, wc, hc, corners, count, xstep, ystep, doubled: SHORTINT);

END M_AES.

