(*------------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_AES;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM SYSTEM     IMPORT  ADDRESS, BYTE, ADR;
FROM M_Sys      IMPORT  App, CallGEM, WordToBitset, CastToInt, Hi, Lo;
FROM M_Types    IMPORT  Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6, Bit7, Bit8,
                        Bit9, Bit10, Bit11, Bit12, Bit13, Bit14, Bit15, Bit16,
                        Bit17, Bit18, Bit19, Bit20, Bit21, Bit22, Bit23, Bit24,
                        Bit25, Bit26, Bit27, Bit28, Bit29, Bit30, Bit31,
                        tRect, LONGBITSET;


TYPE IntArray = ARRAY [0..07FFFH] OF SHORTINT;

VAR  iarray:    POINTER TO IntArray;

PROCEDURE AESCall (op, c1, c2, c3, c4: SHORTINT): SHORTINT;
BEGIN
 WITH App^.AESPB^.cbControl^ DO
  opcode:= op;
  sizeIntIn:= c1;
  sizeIntOut:= c2;
  sizeAddrIn:= c3;
  sizeAddrOut:= c4;
 END;
 CallGEM (200, App^.AESPB);
 CallResult:= App^.AESPB^.cbPintout^[0];
 RETURN CallResult;
END AESCall;

PROCEDURE appl_init(): SHORTINT;
BEGIN
 RETURN AESCall (10, 0, 1, 0, 0);
END appl_init;

PROCEDURE appl_read (id, len: SHORTINT; pipe: ADDRESS);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:=  id;
  cbPintin^[1]:=  len;
  cbPadrin^[0]:= pipe;
 END;
 CallResult:= AESCall (11, 2, 1, 1, 0);
END appl_read;

PROCEDURE appl_write (id, len: SHORTINT; pipe: ADDRESS);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:=  id;
  cbPintin^[1]:=  len;
  cbPadrin^[0]:= pipe;
 END;
 CallResult:= AESCall (12, 2, 1, 1, 0);
END appl_write;

PROCEDURE appl_find (mode: FindMode; id: SHORTINT; name: ADDRESS): SHORTINT;
VAR x: RECORD
        CASE :BOOLEAN OF
         TRUE:  h, l: SHORTCARD;|
         FALSE: p: ADDRESS;|
        END;
       END;
BEGIN
 CASE mode OF
  Normal:      x.p:= name;|
  AesId:       x.h:= 0FFFEH;  x.l:= id;|
  MintId:      x.h:= 0FFFFH;  x.l:= id;|
  CurrProcess: x.p:= ADDRESS (0);|
 END;
 App^.AESPB^.cbPadrin^[0]:= x.p;
 CallResult:= AESCall (13, 0, 1, 1, 0);
 RETURN CallResult;
END appl_find;

PROCEDURE appl_tplay (num, speed: SHORTINT; buffer: ADDRESS);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:=  num;
  cbPintin^[1]:=  speed;
  cbPadrin^[0]:= buffer;
 END;
 CallResult:= AESCall (14, 2, 1, 1, 0);
END appl_tplay;

PROCEDURE appl_trecord (count: SHORTINT; buffer: ADDRESS): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:=  count;
  cbPadrin^[0]:= buffer;
 END;
 RETURN AESCall (15, 1, 1, 1, 0);
END appl_trecord;

PROCEDURE appl_bvset (disk, hard: BITSET);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= CastToInt (disk);
  cbPintin^[1]:= CastToInt (hard);
 END;
 CallResult:= AESCall (16, 2, 1, 1, 0);
END appl_bvset;

PROCEDURE appl_yield;
BEGIN
 CallResult:= AESCall (17, 0, 1, 0, 0);
END appl_yield;

PROCEDURE appl_search (mode: SHORTINT; name: ADDRESS; VAR typ, id: SHORTINT): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= mode;
  cbPadrin^[0]:= name;
  CallResult:= AESCall (18, 1, 3, 1, 0);
  typ:= cbPintout^[1];
  id:= cbPintout^[2];
 END;
 RETURN CallResult;
END appl_search;

PROCEDURE appl_exit;
BEGIN
 CallResult:= AESCall (19, 0, 1, 0, 0);
END appl_exit;

PROCEDURE appl_getinfo (typ: SHORTINT; VAR out1, out2, out3, out4: SHORTINT);
BEGIN
 App^.AESPB^.cbPintin^[0]:= typ;
 CallResult:= AESCall (130, 1, 5, 0, 0);
 WITH App^.AESPB^ DO
  out1:= cbPintout^[1];
  out2:= cbPintout^[2];
  out3:= cbPintout^[3];
  out4:= cbPintout^[4];
 END;
END appl_getinfo;

PROCEDURE evnt_keybd (VAR taste, scan: SHORTINT; VAR ascii: CHAR);
BEGIN
 taste:= AESCall (20, 0, 1, 0, 0); (* Auf Keyboard-Event warten *)
 scan:= Hi (taste);
 ascii:= CHR (Lo (taste));
END evnt_keybd;

PROCEDURE evnt_multi (wich: BITSET;  maxclicks: SHORTINT;
                     mask, state: BITSET;
                     m1mode: SHORTINT;  m1rect: tRect;
                     m2mode: SHORTINT;  m2rect: tRect;
                     msgBuff: ADDRESS;
                     loTimer, hiTimer: SHORTINT;
                     VAR x, y: SHORTINT;
                     VAR button: BITSET;
                     VAR taste: SHORTINT;
                     VAR kbshift: BITSET;
                     VAR scan: SHORTINT;
                     VAR ascii: CHAR;
                     VAR clicks: SHORTINT;
                     VAR events: BITSET);
BEGIN (* multi *)
 (* Array's laden *)

 WITH App^.AESPB^ DO
  cbPintin^[0]:= CastToInt (wich);
  cbPintin^[1]:= maxclicks;
  cbPintin^[2]:= CastToInt (mask);
  cbPintin^[3]:= CastToInt (state);
  cbPintin^[4]:= m1mode;
  cbPintin^[5]:= m1rect.x;
  cbPintin^[6]:= m1rect.y;
  cbPintin^[7]:= m1rect.w;
  cbPintin^[8]:= m1rect.h;
  cbPintin^[9]:= m2mode;
  cbPintin^[10]:= m2rect.x;
  cbPintin^[11]:= m2rect.y;
  cbPintin^[12]:= m2rect.w;
  cbPintin^[13]:= m2rect.h;
  cbPintin^[14]:= loTimer;
  cbPintin^[15]:= hiTimer;
  cbPadrin^[0]:= msgBuff;
 END;
 CallResult:= AESCall (25, 16, 7, 1, 0);
 WordToBitset (CallResult, events);
 WITH App^.AESPB^ DO
  x:= cbPintout^[1];
  y:= cbPintout^[2];
  WordToBitset (cbPintout^[3], button);
  WordToBitset (cbPintout^[4], kbshift);
  taste:= cbPintout^[5];
  scan:= Hi (taste);
  ascii:= CHR (Lo (taste));
  clicks:= cbPintout^[6];
 END;
END evnt_multi;

PROCEDURE evnt_pmulti (VAR events: BITSET);
BEGIN
 CallResult:= AESCall (25, 16, 7, 1, 0);
 WordToBitset (CallResult, events);
END evnt_pmulti;

PROCEDURE evnt_button (maxclicks: SHORTINT; mask, state: BITSET;
     VAR x, y: SHORTINT;  VAR button, kbshift: BITSET): SHORTINT;
VAR clicks: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= maxclicks;
  cbPintin^[1]:= CastToInt (mask);
  cbPintin^[2]:= CastToInt (state);
  clicks:= AESCall (21, 3, 5, 0, 0);
  x:= cbPintout^[1];
  y:= cbPintout^[2];
  WordToBitset (cbPintout^[3], button);
  WordToBitset (cbPintout^[4], kbshift);
 END;
 RETURN clicks;
END evnt_button;

PROCEDURE evnt_mouse  (mode: SHORTINT; m1rect: tRect;
          VAR x, y: SHORTINT;  VAR button, kbshift: BITSET);
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= mode;
  iarray:= ADR  (m1rect);
  FOR i:= 0 TO 3 DO  cbPintin^[1 + i]:= iarray^[i];  END;
  CallResult:= AESCall (22, 5, 5, 0, 0);
  x:= cbPintout^[1];
  y:= cbPintout^[2];
  WordToBitset (cbPintout^[3], button);
  WordToBitset (cbPintout^[4], kbshift);
 END;
END evnt_mouse;

PROCEDURE evnt_mesag (buffer: ADDRESS);
BEGIN
 App^.AESPB^.cbPadrin^[0]:= buffer;
 CallResult:= AESCall (23, 0, 1, 1, 0);
END evnt_mesag;

PROCEDURE evnt_timer (count: LONGINT);
VAR trick: RECORD
            CASE : BOOLEAN OF
             TRUE:  long: LONGINT;|
             FALSE: hi, lo: SHORTINT;|
            END;
           END;
BEGIN
 trick.long:= count;
 WITH App^.AESPB^ DO
  cbPintin^[0]:= trick.lo;
  cbPintin^[1]:= trick.hi;
 END;
 CallResult:= AESCall (24, 2, 1, 0, 0);
END evnt_timer;

PROCEDURE evnt_dclicks (new: SHORTINT; setclick: BOOLEAN): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= new;
  IF setclick THEN
   cbPintin^[1]:= 1;
  ELSE
   cbPintin^[1]:= 0;
  END;
 END;
 RETURN AESCall (26, 2, 1, 0, 0);
END evnt_dclicks;

PROCEDURE form_do (tree: ADDRESS; start: SHORTINT): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= start;
  cbPadrin^[0]:= tree;
 END;
 RETURN AESCall (50, 1, 1, 1, 0);
END form_do;

PROCEDURE form_dial (flag: SHORTINT; small, big: tRect);
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= flag;
  iarray:= ADR (small);
  FOR i:= 0 TO 3 DO  cbPintin^[1 + i]:= iarray^[i];  END;
  iarray:= ADR (big);
  FOR i:= 0 TO 3 DO  cbPintin^[5 + i]:= iarray^[i];  END;
 END;
 CallResult:= AESCall (51, 9, 1, 1, 0);
END form_dial;

PROCEDURE form_alert  (button: SHORTINT; str: ADDRESS): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= button;
  cbPadrin^[0]:= str;
 END;
 RETURN AESCall (52, 1, 1, 1, 0);
END form_alert;

PROCEDURE form_error  (errNum: SHORTINT);
BEGIN
 App^.AESPB^.cbPintin^[0]:= errNum;
 CallResult:= AESCall (53, 1, 1, 0, 0);
END form_error;

PROCEDURE form_center (tree: ADDRESS; VAR rect: tRect);
VAR i: SHORTINT;
BEGIN
 App^.AESPB^.cbPadrin^[0]:= tree;
 CallResult:= AESCall (54, 0, 5, 1, 0);
 WITH App^.AESPB^ DO
  rect.x:= cbPintout^[1];
  rect.y:= cbPintout^[2];
  rect.w:= cbPintout^[3];
  rect.h:= cbPintout^[4];
 END;
END form_center;

PROCEDURE form_keybd (tree: ADDRESS;  obj, chIn: SHORTINT;
                     VAR nextObj, chOut: SHORTINT): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= obj;
  cbPintin^[1]:= chIn;
  cbPintin^[2]:= 0;
  cbPadrin^[0]:= tree;
  CallResult:= AESCall (55, 3, 3, 1, 0);
  nextObj:= cbPintout^[1];
  chOut:= cbPintout^[2];
 END;
 RETURN CallResult;
END form_keybd;

PROCEDURE form_button (tree: ADDRESS; obj, clicks: SHORTINT;
             VAR next: SHORTINT): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= obj;
  cbPintin^[1]:= clicks;
  cbPadrin^[0]:= tree;
  CallResult:= AESCall (56, 2, 2, 1, 0);
  next:= cbPintout^[1];
 END;
 RETURN CallResult;
END form_button;

PROCEDURE fsel_input (pfad, name: ADDRESS): BOOLEAN;
BEGIN
 WITH App^.AESPB^ DO
  cbPadrin^[0]:= pfad;
  cbPadrin^[1]:= name;
  CallResult:= AESCall (90, 0, 2, 2, 0);
  RETURN cbPintout^[1] = 1;
 END;
END fsel_input;

PROCEDURE fsel_exinput (info, pfad, name: ADDRESS): BOOLEAN;
BEGIN
 WITH App^.AESPB^ DO
  cbPadrin^[0]:= pfad;
  cbPadrin^[1]:= name;
  cbPadrin^[2]:= info;
  CallResult:= AESCall (91, 0, 2, 3, 0);
  RETURN cbPintout^[1] = 1;
 END;
END fsel_exinput;

PROCEDURE graf_rubberbox (x, y, mw, mh: SHORTINT; VAR lw, lh: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= x;
  cbPintin^[1]:= y;
  cbPintin^[2]:= mw;
  cbPintin^[3]:= mh;
  CallResult:= AESCall (70, 4, 3, 0, 0);
  lw:= cbPintout^[1];
  lh:= cbPintout^[2];
 END;
END graf_rubberbox;

PROCEDURE graf_dragbox (moving, boundary: tRect; VAR x, y: SHORTINT);
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= moving.w;
  cbPintin^[1]:= moving.h;
  cbPintin^[2]:= moving.x;
  cbPintin^[3]:= moving.y;
  iarray:= ADR (boundary);
  FOR i:= 0 TO 3 DO  cbPintin^[i+4]:= iarray^[i];  END;
  CallResult:= AESCall (71, 8, 3, 0, 0);
  x:= cbPintout^[1];
  y:= cbPintout^[2];
 END;
END graf_dragbox;

PROCEDURE graf_movebox (rect: tRect; dx, dy: SHORTINT);
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= rect.x;
  cbPintin^[1]:= rect.y;
  cbPintin^[2]:= rect.w;
  cbPintin^[3]:= rect.h;
  cbPintin^[4]:= dx;
  cbPintin^[5]:= dy;
 END;
 CallResult:= AESCall (72, 6, 1, 0, 0);
END graf_movebox;

PROCEDURE graf_growbox (source, dest: tRect);
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  iarray:= ADR (source);
  FOR i:= 0 TO 3 DO  cbPintin^[i]:= iarray^[i];  END;
  iarray:= ADR (dest);
  FOR i:= 0 TO 3 DO  cbPintin^[i+4]:= iarray^[i];  END;
 END;
 CallResult:= AESCall (73, 8, 1, 0, 0);
END graf_growbox;

PROCEDURE graf_shrinkbox (source, dest: tRect);
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  iarray:= ADR (source);
  FOR i:= 0 TO 3 DO  cbPintin^[i]:= iarray^[i];  END;
  iarray:= ADR (dest);
  FOR i:= 0 TO 3 DO  cbPintin^[i+4]:= iarray^[i];  END;
 END;
 CallResult:= AESCall (74, 8, 1, 0, 0);
END graf_shrinkbox;

PROCEDURE graf_watchbox (tree: ADDRESS; item: SHORTINT;
   instate, outstate: BITSET): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[1]:= item;
  cbPintin^[2]:= CastToInt (instate);
  cbPintin^[3]:= CastToInt (outstate);
  cbPadrin^[0]:= tree;
 END;
 RETURN AESCall (75, 4, 1, 1, 0);
END graf_watchbox;

PROCEDURE graf_slidebox (tree: ADDRESS; parent, obj, dir: SHORTINT): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= parent;
  cbPintin^[1]:= obj;
  cbPintin^[2]:= dir;
  cbPadrin^[0]:= tree;
 END;
 RETURN AESCall (76, 3, 1, 1, 0);
END graf_slidebox;

PROCEDURE graf_handle (VAR handle, wCh, hCh, wbox, hbox: SHORTINT);
BEGIN
 CallResult:= AESCall (77, 0, 5, 0, 0);
 WITH App^.AESPB^ DO
  handle:= cbPintout^[0];
  wCh:= cbPintout^[1];
  hCh:= cbPintout^[2];
  wbox:= cbPintout^[3];
  hbox:= cbPintout^[4];
 END;
END graf_handle;

PROCEDURE graf_mouse (form: SHORTINT; user: ADDRESS);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= form;
  cbPadrin^[0]:= user;
 END;
 CallResult:= AESCall (78, 1, 1, 1, 0);
END graf_mouse;

PROCEDURE graf_mkstate (VAR x, y: SHORTINT; VAR button, kbshift: BITSET);
BEGIN
 CallResult:= AESCall (79, 0, 5, 0, 0);
 WITH App^.AESPB^ DO
  x:= cbPintout^[1];
  y:= cbPintout^[2];
  WordToBitset (cbPintout^[3], button);
  WordToBitset (cbPintout^[4], kbshift);
 END;
END graf_mkstate;

PROCEDURE menu_bar (tree: ADDRESS; action: SHORTINT): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= action;
  cbPadrin^[0]:= tree;
 END;
 RETURN AESCall (30, 1, 1, 1, 0);
END menu_bar;

PROCEDURE menu_icheck (tree: ADDRESS; item: SHORTINT; action: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= item;
  cbPintin^[1]:= action;
  cbPadrin^[0]:= tree;
 END;
 CallResult:= AESCall (31, 2, 1, 1, 0);
END menu_icheck;

PROCEDURE menu_ienable (tree: ADDRESS; item: SHORTINT; action: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= item;
  cbPintin^[1]:= action;
  cbPadrin^[0]:= tree;
 END;
 CallResult:= AESCall (32, 2, 1, 1, 0);
END menu_ienable;

PROCEDURE menu_tnormal (tree: ADDRESS; item: SHORTINT; action: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= item;
  cbPintin^[1]:= action;
  cbPadrin^[0]:= tree;
 END;
 CallResult:= AESCall (33, 2, 1, 1, 0);
END menu_tnormal;

PROCEDURE menu_text (tree: ADDRESS; item: SHORTINT; str: ADDRESS);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= item;
  cbPadrin^[0]:= tree;
  cbPadrin^[1]:= str;
 END;
 CallResult:= AESCall (34, 1, 1, 2, 0);
END menu_text;

PROCEDURE menu_register (apid: SHORTINT; str: ADDRESS): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= apid;
  cbPadrin^[0]:= str;
 END;
 RETURN AESCall (35, 1, 1, 1, 0);
END menu_register;

PROCEDURE menu_unregister (apid: SHORTINT);
BEGIN
 App^.AESPB^.cbPintin^[0]:= apid;
 CallResult:= AESCall (36, 1, 1, 1, 0);
END menu_unregister;

PROCEDURE menu_popup (men: MENU; xpos, ypos: SHORTINT; VAR mdata: MENU): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= xpos;
  cbPintin^[1]:= ypos;
  cbPadrin^[0]:= ADR (men);
  cbPadrin^[1]:= ADR (mdata);
 END;
 CallResult:= AESCall (36, 2, 1, 2, 0);
 RETURN CallResult;
END menu_popup;

PROCEDURE menu_attach (flag: SHORTINT; tree: ADDRESS; item: SHORTINT; VAR mdata: MENU): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= flag;
  cbPintin^[1]:= item;
  cbPadrin^[0]:= tree;
  cbPadrin^[1]:= ADR (mdata);
 END;
 CallResult:= AESCall (37, 2, 1, 2, 0);
 RETURN CallResult;
END menu_attach;

PROCEDURE menu_istart (flag: SHORTINT; tree: ADDRESS; men, item: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= flag;
  cbPintin^[1]:= men;
  cbPintin^[2]:= item;
  cbPadrin^[0]:= tree;
 END;
 CallResult:= AESCall (38, 3, 1, 1, 0);
END menu_istart;

PROCEDURE menu_settings (flag: SHORTINT; VAR value: MNSET);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= flag;
  cbPadrin^[0]:= ADR (value);
 END;
 CallResult:= AESCall (39, 1, 1, 1, 0);
END menu_settings;

PROCEDURE rsrc_load (name: ADDRESS): BOOLEAN;
BEGIN
 App^.AESPB^.cbPadrin^[0]:= name;
 CallResult:= AESCall (110, 0, 1, 1, 0);
 RETURN CallResult <> 0;
END rsrc_load;

PROCEDURE rsrc_free;
BEGIN
 CallResult:= AESCall (111, 0, 1, 0, 0);
END rsrc_free;

PROCEDURE rsrc_gaddr (typ, item: SHORTINT): ADDRESS;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= typ;
  cbPintin^[1]:= item;
 END;
 CallResult:= AESCall (112, 2, 1, 0, 1);
 RETURN App^.AESPB^.cbPadrout^[0];
END rsrc_gaddr;

PROCEDURE rsrc_saddr (typ, item: SHORTINT; tree: ADDRESS);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= typ;
  cbPintin^[1]:= item;
  cbPadrin^[0]:= tree;
 END;
 CallResult:= AESCall (113, 2, 1, 1, 0);
END rsrc_saddr;

PROCEDURE rsrc_obfix (tree: ADDRESS; obj: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= obj;
  cbPadrin^[0]:= tree;
 END;
 CallResult:= AESCall (114, 1, 1, 1, 0);
END rsrc_obfix;

PROCEDURE rsrc_rcfix (header: ADDRESS);
BEGIN
 App^.AESPB^.cbPadrin^[0]:= header;
 CallResult:= AESCall (115, 0, 1, 1, 0);
END rsrc_rcfix;

PROCEDURE scrp_read (pfad: ADDRESS; VAR return: BITSET);
BEGIN
 App^.AESPB^.cbPadrin^[0]:= pfad;
 CallResult:= AESCall (80, 0, 1, 1, 0);
 WordToBitset (CallResult, return);
END scrp_read;

PROCEDURE scrp_write (pfad: ADDRESS);
BEGIN
 App^.AESPB^.cbPadrin^[0]:= pfad;
 CallResult:= AESCall (81, 0, 1, 1, 0);
END scrp_write;

PROCEDURE scrp_clear; 
BEGIN
 CallResult:= AESCall (82, 0, 1, 0, 0);
END scrp_clear;

PROCEDURE shel_read (command, path: ADDRESS);
BEGIN
 WITH App^.AESPB^ DO
  cbPadrin^[0]:= command;
  cbPadrin^[1]:= path;
 END;
 CallResult:= AESCall (120, 0, 1, 2, 0);
END shel_read;

PROCEDURE shel_write (exec, appl, start: SHORTINT;
                     command, path: ADDRESS);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:=  exec;
  cbPintin^[1]:=  appl;
  cbPintin^[2]:=  start;
  cbPadrin^[0]:= command;
  cbPadrin^[1]:= path;
 END;
 CallResult:= AESCall (121, 3, 1, 2, 0);
END shel_write;

PROCEDURE shel_get (len: SHORTINT; buffer: ADDRESS): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:=  len;
  cbPadrin^[0]:= buffer;
 END;
 RETURN AESCall (122, 1, 1, 1, 0);
END shel_get;

PROCEDURE shel_put (len: SHORTINT; buffer: ADDRESS);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:=  len;
  cbPadrin^[0]:= buffer;
 END;
 CallResult:= AESCall (123, 1, 1, 1, 0);
END shel_put;

PROCEDURE shel_find (name: ADDRESS);
BEGIN
 App^.AESPB^.cbPadrin^[0]:= name;
 CallResult:= AESCall (124, 0, 1, 1, 0);
END shel_find;

PROCEDURE shel_envrn (param: ADDRESS; name: ADDRESS);
BEGIN
 WITH App^.AESPB^ DO
  cbPadrin^[0]:= param;
  cbPadrin^[1]:= name;
 END;
 CallResult:= AESCall (125, 0, 1, 2, 0);
END shel_envrn;

PROCEDURE shel_rdef (command, path: ADDRESS);
(* Erst ab GEM 2.0 *)
BEGIN
 WITH App^.AESPB^ DO
  cbPadrin^[0]:= command;
  cbPadrin^[1]:= path;
 END;
 CallResult:= AESCall (126, 0, 1, 2, 0);
END shel_rdef;

PROCEDURE shel_wdef (command, path: ADDRESS);
(* Erst ab GEM 2.0 *)
BEGIN
 WITH App^.AESPB^ DO
  cbPadrin^[0]:= command;
  cbPadrin^[1]:= path;
 END;
 CallResult:= AESCall (127, 0, 1, 2, 0);
END shel_wdef;

PROCEDURE wind_create (comp: BITSET; size: tRect): SHORTINT;
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= CastToInt (comp);
  iarray:= ADR (size);
  FOR i:= 0 TO 3 DO  cbPintin^[i+1]:= iarray^[i];  END;
 END;
 RETURN AESCall (100, 5, 1, 0, 0);
END wind_create;

PROCEDURE wind_open (handle: SHORTINT; size: tRect);
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= handle;
  iarray:= ADR (size);
  FOR i:= 0 TO 3 DO  cbPintin^[i+1]:= iarray^[i];  END;
 END;
 CallResult:= AESCall (101, 5, 1, 0, 0);
END wind_open;

PROCEDURE wind_close  (handle: SHORTINT);
BEGIN
 App^.AESPB^.cbPintin^[0]:= handle;
 CallResult:= AESCall (102, 1, 1, 0, 0);
END wind_close;

PROCEDURE wind_delete (handle: SHORTINT);
BEGIN
 App^.AESPB^.cbPintin^[0]:= handle;
 CallResult:= AESCall (103, 1, 1, 0, 0);
END wind_delete;

PROCEDURE wind_get (handle, typ: SHORTINT; VAR para: tRect);
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= handle;
  cbPintin^[1]:= typ;
  CallResult:= AESCall (104, 2, 5, 0, 0);
  iarray:= ADR (para);
  FOR i:= 0 TO 3 DO  iarray^[i]:= cbPintout^[i+1];  END;
 END;
END wind_get;

PROCEDURE wind_set (handle, typ: SHORTINT; para: tRect);
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= handle;
  cbPintin^[1]:= typ;
  iarray:= ADR (para);
  FOR i:= 0 TO 3 DO  cbPintin^[i+2]:= iarray^[i];  END;
 END;
 CallResult:= AESCall (105, 6, 1, 0, 0);
END wind_set;

PROCEDURE wind_find (x, y: SHORTINT): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= x;
  cbPintin^[1]:= y;
 END;
 RETURN AESCall (106, 2, 1, 0, 0);
END wind_find;

PROCEDURE wind_update (mode: SHORTINT): SHORTINT;
BEGIN
 App^.AESPB^.cbPintin^[0]:= mode;
 RETURN AESCall (107, 1, 1, 0, 0);
END wind_update;

PROCEDURE wind_calc (mode: SHORTINT; comp: BITSET; 
                    VAR inr, outr: tRect); 
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= mode;
  cbPintin^[1]:= CastToInt (comp);
  iarray:= ADR (inr);
  FOR i:= 0 TO 3 DO  cbPintin^[i+2]:= iarray^[i];  END;
  CallResult:= AESCall (108, 6, 5, 0, 0);
  iarray:= ADR (outr);
  FOR i:= 0 TO 3 DO  iarray^[i]:= cbPintout^[i+1];  END;
 END;
END wind_calc;

PROCEDURE wind_new;
BEGIN
 CallResult:= AESCall (109, 0, 0, 0, 0);
END wind_new;

PROCEDURE objc_add (tree: ADDRESS; parent, child: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= parent;
  cbPintin^[1]:= child;
  cbPadrin^[0]:= tree;
 END;
 CallResult:= AESCall (40, 2, 1, 1, 0);
END objc_add;

PROCEDURE objc_delete (tree: ADDRESS; obj: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= obj;
  cbPadrin^[0]:= tree;
 END;
 CallResult:= AESCall (41, 1, 1, 1, 0);
END objc_delete;

PROCEDURE objc_draw (tree: ADDRESS; start, depth: SHORTINT; pxy: tRect);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= start;
  cbPintin^[1]:= depth;
  cbPintin^[2]:= pxy.x;
  cbPintin^[3]:= pxy.y;
  cbPintin^[4]:= pxy.w;
  cbPintin^[5]:= pxy.h;
  cbPadrin^[0]:= tree;
 END;
 CallResult:= AESCall (42, 6, 1, 1, 0);
END objc_draw;

PROCEDURE objc_find (tree: ADDRESS;
                   start, depth, x, y: SHORTINT): SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= start;
  cbPintin^[1]:= depth;
  cbPintin^[2]:= x;
  cbPintin^[3]:= y;
  cbPadrin^[0]:= tree;
 END;
 RETURN AESCall (43, 4, 1, 1, 0);
END objc_find;

PROCEDURE objc_offset (tree: ADDRESS; obj: SHORTINT; VAR x, y: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= obj;
  cbPadrin^[0]:= tree;
  CallResult:= AESCall (44, 1, 3, 1, 0);
  x:= cbPintout^[1];
  y:= cbPintout^[2];
 END;
END objc_offset;

PROCEDURE objc_order (tree: ADDRESS; obj, newpos: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= obj;
  cbPintin^[1]:= newpos;
  cbPadrin^[0]:= tree;
 END;
 CallResult:= AESCall (45, 2, 1, 1, 0);
END objc_order;

PROCEDURE objc_edit (tree: ADDRESS; obj: SHORTINT; VAR pos: SHORTINT;
                  char, kind: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= obj;
  cbPintin^[1]:= char;
  cbPintin^[2]:= pos;
  cbPintin^[3]:= kind;
  cbPadrin^[0]:= tree;
  CallResult:= AESCall (46, 4, 2, 1, 0);
  pos:= cbPintout^[1];
 END;
END objc_edit;

PROCEDURE objc_change (tree: ADDRESS; obj: SHORTINT; pxy: tRect;
                      state: BITSET; mode: SHORTINT);
VAR i: SHORTINT;
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= obj;
  cbPintin^[1]:= 0;
  iarray:= ADR (pxy);
  FOR i:= 0 TO 3 DO  cbPintin^[i+2]:= iarray^[i];  END;
  cbPintin^[6]:= CastToInt (state);
  cbPintin^[7]:= mode;
  cbPadrin^[0]:= tree;
  CallResult:= AESCall (47, 8, 1, 1, 0);
 END;
END objc_change;

PROCEDURE objc_sysvar (mode, which, i1, i2: SHORTINT; VAR o1, o2: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= mode;
  cbPintin^[1]:= which;
  cbPintin^[2]:= i1;
  cbPintin^[3]:= i2;
  CallResult:= AESCall (48, 4, 3, 0, 0);
  o1:= cbPintout^[1];
  o2:= cbPintout^[2];
 END;
END objc_sysvar;

PROCEDURE xgrf_stepcalc (ow, oh, x, y, w, h: SHORTINT;
                        VAR cx, cy, count, xstep, ystep: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= ow;
  cbPintin^[1]:= oh;
  cbPintin^[2]:= x;
  cbPintin^[3]:= y;
  cbPintin^[4]:= w;
  cbPintin^[5]:= h;
  CallResult:= AESCall (130, 6, 6, 0, 0);
  cx:=    cbPintout^[1];
  cy:=    cbPintout^[2];
  count:= cbPintout^[3];
  xstep:= cbPintout^[4];
  ystep:= cbPintout^[5];
 END;
END xgrf_stepcalc;

PROCEDURE xgrf_2box (xc, yc, wc, hc, corners, count, xstep, ystep, doubled: SHORTINT);
BEGIN
 WITH App^.AESPB^ DO
  cbPintin^[0]:= count;
  cbPintin^[1]:= xstep;
  cbPintin^[2]:= ystep;
  cbPintin^[3]:= doubled;
  cbPintin^[4]:= corners;
  cbPintin^[5]:= xc;
  cbPintin^[6]:= yc;
  cbPintin^[7]:= wc;
  cbPintin^[8]:= hc;
 END;
 CallResult:= AESCall (131, 9, 1, 0, 0);
END xgrf_2box;

END M_AES.
