(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Alerts;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

IMPORT M_Event, M_Types, M_Strings, M_AES;
FROM SYSTEM     IMPORT  ADDRESS, BYTE, ADR;
FROM M_Sys      IMPORT  App, CallGEM, WordToBitset, CastToInt, Hi, Lo, CallMagic;
FROM M_Types    IMPORT  Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6, Bit7, Bit8,
                        Bit9, Bit10, Bit11, Bit12, Bit13, Bit14, Bit15, Bit16,
                        Bit17, Bit18, Bit19, Bit20, Bit21, Bit22, Bit23, Bit24,
                        Bit25, Bit26, Bit27, Bit28, Bit29, Bit30, Bit31,
                        tRect, LONGBITSET, Stacksize;

(*$?Compiler=Megamax:
  IMPORT Calls, MOSGlobals;

VAR     ahndl:          AlertHandler;
        a:              PtrAlertpara;
        mem, user:      MOSGlobals.MemArea;
        stack:          ARRAY [0..Stacksize-1] OF BYTE;
        caller:         ADDRESS;


 (*$S-*)
 (*$R-*)
 PROCEDURE mm2 (VAR regs: Calls.Registers);
 VAR r: Calls.Registers;
 BEGIN
  a:= regs.regA0.ad;
  ahndl (a);
 END mm2;
 (*$S=*)
 (*$R=*)
*)

PROCEDURE Alert (x, y, def: SHORTINT; str: ARRAY OF CHAR): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (str);
  AddrIn[1]:= NIL;
  IntIn[0]:= def;
  IntIn[1]:= x;
  IntIn[2]:= y;
  IntIn[3]:= ORD ((x > 0) OR (y >0));
  IntIn[4]:= 1;
  CallMagic (500);
  RETURN IntOut[0];
 END;
END Alert;

PROCEDURE WindowAlert (x, y, def: SHORTINT; str: ARRAY OF CHAR; 
                       handler: AlertHandler);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (str);
(*$?Compiler=Megamax:  AddrIn[1]:= caller;  ahndl:= handler; *)
(*$?Compiler=Haenisch:  AddrIn[1]:= ADDRESS (handler); *)
  IntIn[0]:= def;
  IntIn[1]:= x;
  IntIn[2]:= y;
  IntIn[3]:= ORD ((x > 0) OR (y >0));
  IntIn[4]:= 0;
 END;
 CallMagic (500);
END WindowAlert;

PROCEDURE SetIconColor (fcolor, bcolor: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= fcolor;
  IntIn[1]:= bcolor;
 END;
 CallMagic (502);
END SetIconColor;

PROCEDURE Iconslot (slotnum: SHORTINT): M_AES.PtrCICONBLK;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= slotnum;
  CallMagic (503);
  RETURN AddrOut[0];
 END;
END Iconslot;

PROCEDURE SetIconslot (slotnum: SHORTINT; icon: M_AES.PtrCICONBLK);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= icon;
  IntIn[0]:= slotnum;
 END;
 CallMagic (504);
END SetIconslot;

BEGIN
(*$?Compiler=Megamax:
 mem.bottom:= ADR (stack);
 mem.length:= Stacksize;
 Calls.NewCaller (mm2, FALSE, mem, caller);
 IF caller = NIL THEN  HALT;  END;
 *)
END M_Alerts.
 
