(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modular  Applications  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mpAppl       Basisfunktionen einer Applikation                       *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_Appl;

FROM M_Types IMPORT tRect, WORKSTATION, MFORM;

(*----------------------------------------------------------------------*
 *     Auf die folgenden Typen und Variablen NUR LESEND ZUGREIFEN!!!    *
 *----------------------------------------------------------------------*)

VAR     ApplIdent:      SHORTINT; (* Application-ID des Programms        *)
        AESVersion:     INTEGER;  (* AES-Versionsnummer                  *)
        AESFontid:      SHORTINT; (* Fontid der AES-Workstation          *)
        AESFontsize:    SHORTINT; (* Defaultsize des AES-Fonts in Pixel  *)
        CharWidth:      SHORTINT; (* Zeichenbreite der AES-Workstation   *)
        CharHeight:     SHORTINT; (* Zeichenhhe der AES-Workstation     *)
        BoxWidth:       SHORTINT; (* Boxbreite der AES-Workstation       *)
        BoxHeight:      SHORTINT; (* Boxhehe der AES-Workstation        *)
        DeskX:          SHORTINT; (* X-Position des Desktop-Fensters     *)
        DeskY:          SHORTINT; (* Y-Position des Desktop-Fensters     *)
        ScreenRect:     tRect;
        Win0Rect:       tRect;

VAR     Multitask:      BOOLEAN; (* Wenn TRUE, luft die Applikation 
                                  * unter einem Multitask-System
                                  *)

VAR     KaosTos:        BOOLEAN; (* Diese Variable zeigt an, ob es
                                  * sich bei der vorliegenden TOS-Version
                                  * um ein KAOS (A. Kromke TOS) handelt.
                                  *)

VAR     MiNTInstalled:  BOOLEAN; (* Luft MiNT??? *)
        MiNTVersion:    LONGINT;

VAR     DefaultWS:      WORKSTATION;
        (* Info der geffneten Workstation  *)

PROCEDURE ApplInit;

TYPE TermProc = PROCEDURE(): SHORTINT;

PROCEDURE InstallTermproc (proc: TermProc);
PROCEDURE ApplTerm (return: SHORTINT);
PROCEDURE ApplPath (VAR path: ARRAY OF CHAR);
PROCEDURE ApplName (VAR name: ARRAY OF CHAR);

TYPE Device = (Screen,   (* Device-Nummer  1..10 *)
               Plotter,  (*               11..20 *)
               Printer,  (*               21..30 *)
               Metafile, (*               31..40 *)
               Camera,   (*               41..50 *)
               Tablett,  (*               51..60 *)
               dev61_70, (*               61..70 *)
               dev71_80, (*               71..80 *)
               dev81_90, (*               81..90 *)
               Memory);  (*               91..99 *)

PROCEDURE OpenWorkstation (device: Device; devnum, w, h: SHORTINT; 
                           rc: BOOLEAN; VAR wsinfo: WORKSTATION);
PROCEDURE CloseWorkstation (VAR wsinfo: WORKSTATION);
PROCEDURE AvailableDrivers (dev: Device): SHORTINT;
PROCEDURE DriverInfo (dev: Device; num: SHORTINT; VAR wsinfo: WORKSTATION);
PROCEDURE VqGdos(): LONGINT;
PROCEDURE MouseOn;
PROCEDURE MouseArrow;
PROCEDURE MouseCursor;
PROCEDURE MouseBusy;
PROCEDURE MouseFinger;
PROCEDURE MouseHand;
PROCEDURE MouseThincross;
PROCEDURE MouseThickcross;
PROCEDURE MouseOutline;
PROCEDURE MouseUser;
PROCEDURE MouseRotor;
PROCEDURE MouseOff;
PROCEDURE MouseOffRect (r: tRect);
PROCEDURE UserMouse (VAR form: MFORM);
PROCEDURE MouseState (VAR form: SHORTINT; VAR sichtbar: BOOLEAN);
PROCEDURE StoreMouse;
PROCEDURE RestoreMouse;
PROCEDURE SetMouse (x, y: SHORTINT);
PROCEDURE LockScreen;
PROCEDURE UnlockScreen;
PROCEDURE FreezeScreen;
PROCEDURE UnfreezeScreen;
PROCEDURE ScreenLocked (): BOOLEAN;

END M_Appl.


