(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Appl;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM M_Sys IMPORT App, CallMagic, Terminate;
FROM SYSTEM IMPORT TSIZE, ADR, ADDRESS;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
IMPORT M_Cookie, M_Strings, M_AES, M_VDI, M_Types;


(*IMPORT RTD;*)

CONST   ABCGEM =        00210H;

CONST   cNDC =           0;
        cRC =            2;

TYPE    TermPtr =       POINTER TO TermInfo;
        TermInfo =      RECORD
                         proc:  TermProc;
                         next:  TermPtr;
                        END;


VAR     vapplpath:      ARRAY [0..255] OF CHAR;
        vapplname:      ARRAY [0..255] OF CHAR;

VAR     ProgReturn:     SHORTINT;
        init:           SHORTINT;
        gdos:           LONGINT;


PROCEDURE ApplInit;
VAR gem: SHORTINT;
    b: BOOLEAN;
    l: LONGINT;
    name: M_Types.CSTRING;
    attr: M_VDI.tTextAttrArray;
    a: M_Cookie.Anytype;
BEGIN
 IF init <> 30961 THEN
  
  ApplIdent:= M_AES.appl_init();
  CallMagic (1); (* Magic initialisieren *)
  CallMagic (609); KaosTos:= App^.MagicPB^.IntOut[0] = 1;
  CallMagic (608); Multitask:= App^.MagicPB^.IntOut[0] = 1;

  MiNTInstalled:= M_Cookie.FindCookie (M_Cookie.MiNT, a);
  MiNTVersion:= a.long;
 
  CallMagic (604);
  WITH App^.MagicPB^ DO
   AESFontid:=   IntOut[0];
   AESFontsize:= IntOut[1];
   CharWidth:=   IntOut[2];
   CharHeight:=  IntOut[3];
   BoxWidth:=    IntOut[4];
   BoxHeight:=   IntOut[5];

   AddrIn[0]:= ADR (ScreenRect);  CallMagic (605);

   AddrIn[0]:= ADR (Win0Rect);  CallMagic (606);

   OpenWorkstation (Screen, -1, 0, 0, TRUE, DefaultWS);
 
   CallMagic (607);

   DeskX:=   IntOut[0];
   DeskY:=   IntOut[1];

  END;
  gem:= App^.AESPB^.cbPglobal^.apVersion;

  IF gem <> ABCGEM THEN  gdos:= M_VDI.vq_gdos()  ELSE  gdos:= ABCGEM  END;

  (* Exitproc:= ADDR (ApplTerm); *)

  CallMagic (621);
  
 END;
END ApplInit;

PROCEDURE InstallTermproc (proc: TermProc);
VAR p: TermPtr;

 PROCEDURE newTerm(): TermPtr;
 VAR q: TermPtr;
 BEGIN
  ALLOCATE (q, TSIZE (TermPtr));
  IF q = NIL THEN  HALT;  END;
  q^.proc:= proc;
  q^.next:= NIL;
  RETURN q;
 END newTerm;

BEGIN
 IF App^.TermProc = NIL THEN
  App^.TermProc:= newTerm();
 ELSE
  p := newTerm();
  p^.next := App^.TermProc;
  App^.TermProc:= p;
 END;
END InstallTermproc;

PROCEDURE ApplTerm (return: SHORTINT);
VAR  p: TermPtr;
     i: SHORTINT;
BEGIN
 (* Installierte TermProcedures abarbeiten *)
 p:= App^.TermProc;
 WHILE (p <> NIL) DO  i:= p^.proc();  p:= p^.next;  END;
 App^.MagicPB^.IntIn[0]:= return;
 CallMagic (4);   (* Alles deinstallieren *)
 CallMagic (601); (* appl_exit *)
 CallMagic (2);   (* ExitMagic *)
 Terminate (return);
END ApplTerm;

PROCEDURE ApplPath (VAR path: ARRAY OF CHAR);
VAR i: SHORTINT;
BEGIN
 i:= -1;
 REPEAT
  INC (i);  path[i]:= vapplpath[i];
 UNTIL vapplpath[i] = 0C;
END ApplPath;

PROCEDURE ApplName (VAR name: ARRAY OF CHAR);
VAR i: SHORTINT;
BEGIN
 i:= -1;
 REPEAT
  INC (i);  name[i]:= vapplname[i];
 UNTIL vapplname[i] = 0C;
END ApplName;

PROCEDURE OpenWorkstation (device: Device; devnum, w, h: SHORTINT; rc: BOOLEAN;
                           VAR wsinfo: M_Types.WORKSTATION);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (wsinfo);
  IntIn[0]:=  ORD (device);
  IntIn[1]:=  devnum;
  IntIn[2]:=  w;
  IntIn[3]:=  h;
  IntIn[4]:=  ORD (rc);
 END;
 CallMagic (602);
END OpenWorkstation;

PROCEDURE AvailableDrivers (dev: Device): SHORTINT;
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (dev);
 CallMagic (642);
 RETURN App^.MagicPB^.IntOut[0];
END AvailableDrivers;

PROCEDURE DriverInfo (dev: Device; num: SHORTINT; VAR wsinfo: M_Types.WORKSTATION);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (wsinfo);
  IntIn[0]:= ORD (dev);
  IntIn[1]:= num;
 END;
 CallMagic (643);
END DriverInfo;

PROCEDURE CloseWorkstation (VAR wsinfo: M_Types.WORKSTATION);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADR (wsinfo);
 CallMagic (603);
END CloseWorkstation;

PROCEDURE MouseOn;
BEGIN
 CallMagic (620);
END MouseOn;

PROCEDURE MouseArrow;
BEGIN
 CallMagic (621);
END MouseArrow;

PROCEDURE MouseCursor;
BEGIN
 CallMagic (622);
END MouseCursor;

PROCEDURE MouseBusy;
BEGIN
 CallMagic (623);
END MouseBusy;

PROCEDURE MouseFinger;
BEGIN
 CallMagic (624);
END MouseFinger;

PROCEDURE MouseHand;
BEGIN
 CallMagic (625);
END MouseHand;

PROCEDURE MouseThincross;
BEGIN
 CallMagic (626);
END MouseThincross;

PROCEDURE MouseThickcross;
BEGIN
 CallMagic (627);
END MouseThickcross;

PROCEDURE MouseOutline;
BEGIN
 CallMagic (628);
END MouseOutline;

PROCEDURE MouseRotor;
BEGIN
 CallMagic (640);
END MouseRotor;

PROCEDURE MouseUser;
BEGIN
 CallMagic (629);
END MouseUser;

PROCEDURE MouseOff;
BEGIN
 CallMagic (630);
END MouseOff;

PROCEDURE UserMouse (VAR form: M_Types.MFORM);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADR (form);
 CallMagic (631);
END UserMouse;

PROCEDURE MouseState (VAR form: SHORTINT; VAR sichtbar: BOOLEAN);
BEGIN
 CallMagic (632);
 WITH App^.MagicPB^ DO
  form:= IntOut[0];
  sichtbar:= IntOut[0] = 1;
 END;
END MouseState;

PROCEDURE StoreMouse;
BEGIN
 CallMagic (633);
END StoreMouse;

PROCEDURE RestoreMouse;
VAR view: BOOLEAN;
BEGIN
 CallMagic (634);
END RestoreMouse;

PROCEDURE SetMouse (x, y: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= x;
  IntIn[1]:= y;
 END;
 CallMagic (635);
END SetMouse;

PROCEDURE MouseOffRect (r: M_Types.tRect);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADR (r);
 CallMagic (641);
END MouseOffRect;

PROCEDURE VqGdos (): LONGINT;
BEGIN 
 RETURN gdos;
END VqGdos;

PROCEDURE LockScreen;
BEGIN
 CallMagic (636);
END LockScreen;

PROCEDURE UnlockScreen;
BEGIN
 CallMagic (637);
END UnlockScreen;

PROCEDURE FreezeScreen;
BEGIN
 CallMagic (638);
END FreezeScreen;

PROCEDURE UnfreezeScreen;
BEGIN
 CallMagic (639);
END UnfreezeScreen;

PROCEDURE ScreenLocked (): BOOLEAN;
BEGIN
 RETURN M_Types.ScreenLocked IN App^.flags;
END ScreenLocked;

PROCEDURE GetHelp (cmd: ARRAY OF CHAR): INTEGER;
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADR (cmd);
 CallMagic (645);
 RETURN App^.MagicPB^.IntOut[0];
END GetHelp;

PROCEDURE InitMtAppl;
VAR s: ARRAY [0..255] OF CHAR;
    c, d, l, i: SHORTINT;
    ap, b: ADDRESS;
BEGIN
 IF init <> 30961 THEN
  ApplInit;  (* Applikation und Workstations initialisieren *)
  ap:= ADR(vapplpath);  b:= ADR(s);
  M_AES.shel_read (ap, b);
  l:= 0;  WHILE vapplpath[l] <> 0C DO  INC (l);  END;
  c:= l;  d:= 1;
  WHILE ((c > 1) AND (vapplpath[c-1] <> '\')) DO
   DEC (c);  INC (d);
  END; (* WHILE *)
  FOR i:= 1 TO d DO 
   vapplname[i-1]:= vapplpath[c];
   vapplpath[c]:= 0C;
   INC (c);
  END;
  vapplname[d]:= 0C;
  init:= 30961;
 END;
END InitMtAppl;

BEGIN
 init:= 0;
 InitMtAppl;
END M_Appl.
