(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Area;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM SYSTEM     IMPORT  ADDRESS, ADR;
FROM M_Sys      IMPORT  App, CallMagic;
FROM M_Types    IMPORT  tRect;
FROM M_VDI      IMPORT  MFDB;


PROCEDURE NewAREA (VAR a: AREA): BOOLEAN;
BEGIN
 CallMagic (700);
 WITH App^.MagicPB^ DO
  a:= AddrOut[0];
  RETURN IntOut[0] = 1;
 END;
END NewAREA;

PROCEDURE DisposeAREA (VAR a: AREA);
BEGIN
 App^.MagicPB^.AddrIn[0]:= a;
 CallMagic (701);
 a:= NIL;
END DisposeAREA;

PROCEDURE FreeArea (a: AREA);
BEGIN
 App^.MagicPB^.AddrIn[0]:= a;
 CallMagic (702);
END FreeArea;

PROCEDURE SaveArea (hndl: SHORTINT; a: AREA; rect: tRect): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= hndl;
  AddrIn[0]:= a;
  AddrIn[1]:= ADR (rect);
  CallMagic (703);
  RETURN IntOut[0] = 1;
 END;
END SaveArea;

PROCEDURE RestoreArea (hndl: SHORTINT; a: AREA);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= hndl;
  AddrIn[0]:= a;
 END;
 CallMagic (705);
END RestoreArea;

PROCEDURE CopyArea (hndl: SHORTINT; a: AREA; xx, yy: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= hndl;
  IntIn[1]:= xx;
  IntIn[2]:= yy;
  AddrIn[0]:= a;
 END;
 CallMagic (704);
END CopyArea;

PROCEDURE MoveArea (hndl: SHORTINT; a: AREA; xmove, ymove: SHORTINT;
                    VAR xx, yy: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= hndl;
  IntIn[1]:= xmove;
  IntIn[2]:= ymove;
  AddrIn[0]:= a;
  CallMagic (706);
  xx:= IntOut[0];
  yy:= IntOut[1];
 END;
END MoveArea;

PROCEDURE SetMFDB (VAR m: MFDB; adr: ADDRESS; w, h, fm, planes: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (m);
  AddrIn[1]:= adr;
  IntIn[0]:= w;
  IntIn[1]:= h;
  IntIn[2]:= fm;
  IntIn[3]:= planes;
  CallMagic (708);
 END;
END SetMFDB;

END M_Area.
