(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_BIOS;

FROM SYSTEM     IMPORT  LOC, BYTE, ADDRESS;
FROM M_Types    IMPORT  Nihil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LONGBITSET, PtrPD;

TYPE    PtrMD =         POINTER TO MD;
        MD =            RECORD
                         mLink:   PtrMD;
                         mStart:  ADDRESS;
                         mLength: LONGCARD;
                         mOwn:    PtrPD;
                        END;

TYPE    PtrMPB =        POINTER TO MPB;
        MPB =           RECORD           (* memory parameter block *)
                         mpMfl:   PtrMD; (* memory free list *)
                         mpMal:   PtrMD; (* memory allocated list *)
                         moRover: PtrMD; (* roving pointer *)
                        END;

PROCEDURE Getmpb (VAR mpb: ADDRESS);

CONST   PRT =           0;
        AUX =           1;
        CON =           2;
        MIDI =          3;
        IKBD =          4;
        RAWCON =        5;

PROCEDURE Bconstat (device: SHORTINT): BOOLEAN;
PROCEDURE Bconin (device: SHORTINT): LONGCARD;
PROCEDURE Bconout (device: SHORTINT; c: CHAR);

CONST   DrvA =           0;
        DrvB =           1;
        DrvC =           2;
        DrvD =           3;
        DrvE =           4;
        DrvF =           5;
        DrvG =           6;
        DrvH =           7;
        DrvI =           8;
        DrvJ =           9;
        DrvK =          10;
        DrvL =          11;
        DrvM =          12;
        DrvN =          13;
        DrvO =          14;
        DrvP =          15;

CONST   Read =          0;
        Write =         1;
        ReadNoMC =      2;
        WriteNoMC =     3;

PROCEDURE Rwabs (rw: SHORTINT; buf: ADDRESS; count, recno, dev: SHORTINT): LONGINT;
PROCEDURE Setexc (vecnum: SHORTINT; vec: ADDRESS): ADDRESS;
PROCEDURE Tickcal (): LONGCARD;


TYPE    PtrBPB =        POINTER TO BPB; (* BIOS Parameter Block *)
        BPB =           RECORD
                         recsiz: SHORTCARD;
                         clsiz:  SHORTCARD;
                         clsizb: SHORTCARD;
                         rdlen:  SHORTCARD;
                         fsiz:   SHORTCARD;
                         fatrec: SHORTCARD;
                         datrec: SHORTCARD;
                         numcl:  SHORTCARD;
                         bflags: SHORTCARD;
                        END;


PROCEDURE Getbpb (drive: SHORTINT): ADDRESS;
PROCEDURE Bcostat (device: SHORTINT): BOOLEAN;
PROCEDURE Mediach (dev: SHORTINT): SHORTINT;
PROCEDURE Drvmap (): LONGBITSET;

CONST   KRSHIFT =       Bit0;   (* Tastatur-Status *)
        KLSHIFT =       Bit1;
        KCTRL =         Bit2;
        KALT =          Bit3;
        KCAPS =         Bit4;
        KRMOUSE =       Bit5;
        KLMOUSE =       Bit6;
        KRESERVED =     Bit7;

PROCEDURE Kbshift (keys: BITSET): BITSET;

END M_BIOS.

