(*----------------------------------------------------------------------*)
 
IMPLEMENTATION MODULE M_BIOS;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

IMPORT M_Types;
IMPORT SYSTEM;

(*$?Compiler=Haenisch:
  FROM SYSTEM IMPORT CODE, STORE;
 *)


CONST TRAP13 = 04E4DH;
      AddSP =  0DFFCH;
      D0 =     0;

(* Wegen bergang auf lokale Variablen entfernt  SE 04.01.94
VAR long, result: LONGCARD;
    lc: LONGCARD;
    li: LONGINT;
    lb: M_Types.LONGBITSET;
    i:  SHORTINT;
    c:  SHORTCARD;
    b:  BITSET;
    a:  SYSTEM.ADDRESS;
    x:  SHORTCARD;
 *)


PROCEDURE Getmpb (VAR mpb: SYSTEM.ADDRESS);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00008H);
CODE(03F3CH,00000H);
CODE(04E4DH);
CODE(05C8FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #0, -(SP)
  TRAP    #13
  ADDQ.L  #6, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.L  mpb(A6), -(SP)
  MOVE.W  #0, -(SP)
  TRAP    #13
  ADDQ.L  #6, SP
 END;
  *)
END Getmpb;

PROCEDURE Bconstat (device: SHORTINT): BOOLEAN;
VAR c : SHORTCARD;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00001H);
CODE(04E4DH);
CODE(0588FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);

(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #1, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  device(A6), -(SP)
  MOVE.W  #1, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.W  D0, c(A6)
 END;
   *)
 RETURN c # 0;
END Bconstat;

PROCEDURE Bconin (device: SHORTINT): LONGCARD;
VAR lc : LONGCARD;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00002H);
CODE(04E4DH);
CODE(0588FH);
CODE(03D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #2, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.W  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  device(A6), -(SP)
  MOVE.W  #2, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.W  D0, lc(A6)
 END;
   *)
 RETURN lc;
END Bconin;

PROCEDURE Bconout (device: SHORTINT; c: CHAR);
VAR x : SHORTCARD;
BEGIN
 x:= ORD (c);
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0FFFEH);
CODE(03F2EH,00008H);
CODE(03F3CH,00003H);
CODE(04E4DH);
CODE(05C8FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  -2(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #3, -(SP)
  TRAP    #13
  ADDQ.L  #6, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  x(A6), -(SP)
  MOVE.W  device(A6), -(SP)
  MOVE.W  #3, -(SP)
  TRAP    #13
  ADDQ.L  #6, SP
 END;
  *)
END Bconout;

PROCEDURE Rwabs (rw: SHORTINT; buf: SYSTEM.ADDRESS;
                 count, recno, dev: SHORTINT): LONGINT;
VAR li : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*42 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00012H);
CODE(03F2EH,00010H);
CODE(03F2EH,0000EH);
CODE(02F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00004H);
CODE(04E4DH);
CODE(04FEFH,0000EH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  18(A6), -(SP)
  MOVE.W  16(A6), -(SP)
  MOVE.W  14(A6), -(SP)
  MOVE.L  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #4, -(SP)
  TRAP    #13
  LEA     $E(SP), SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  dev(A6), -(SP)      
  MOVE.W  recno(A6), -(SP)
  MOVE.W  count(A6), -(SP)
  MOVE.L  buf(A6), -(SP)
  MOVE.W  rw(A6), -(SP)
  MOVE.W  #4, -(SP)
  TRAP    #13
  LEA     $E(SP), SP
  MOVE.L  D0, li(A6)
 END;
   *)
 RETURN li;
END Rwabs;

PROCEDURE Setexc (vecnum: SHORTINT; vec: SYSTEM.ADDRESS): SYSTEM.ADDRESS;
VAR a : SYSTEM.ADDRESS;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00005H);
CODE(04E4DH);
CODE(0508FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  10(A6), -(SP)
  MOVE.W  8(A6), -(SP);
  MOVE.W  #5, -(SP)
  TRAP    #13
  ADDQ.L  #8, SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.L  vec(A6), -(SP)
  MOVE.W  vecnum(A6), -(SP);
  MOVE.W  #5, -(SP)
  TRAP    #13
  ADDQ.L  #8, SP
  MOVE.L  D0, a(A6)
 END;
   *)
 RETURN a;
END Setexc;

PROCEDURE Tickcal(): LONGCARD;
VAR lc : LONGCARD;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00006H);
CODE(04E4DH);
CODE(0548FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #6, -(SP)
  TRAP    #13
  ADDQ.L  #2, SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  #6, -(SP)
  TRAP    #13
  ADDQ.L  #2, SP
  MOVE.L  D0, lc(A6)
 END;
   *)
 RETURN lc;
END Tickcal;

PROCEDURE Getbpb (drive: SHORTINT): SYSTEM.ADDRESS;
VAR a : SYSTEM.ADDRESS;

BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00007H);
CODE(04E4DH);
CODE(0588FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #7, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  drive(A6), -(SP)  
  MOVE.W  #7, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.L  D0, a(A6)
 END; 
   *)
 RETURN a;
END Getbpb;

PROCEDURE Bcostat (device: SHORTINT): BOOLEAN;
VAR c : SHORTCARD;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00008H);
CODE(04E4DH);
CODE(0588FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #8, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  device(A6), -(SP)
  MOVE.W  #8, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.W  D0, c(A6)
 END;
   *)
 RETURN c # 0;
END Bcostat;

PROCEDURE Mediach (dev: SHORTINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00009H);
CODE(04E4DH);
CODE(0588FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #9, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  dev(A6), -(SP)
  MOVE.W  #9, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END Mediach;

PROCEDURE Drvmap (): M_Types.LONGBITSET;
VAR lb : M_Types.LONGBITSET;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,0000AH);
CODE(04E4DH);
CODE(0548FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #10, -(SP)
  TRAP    #13
  ADDQ.L  #2, SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  #10, -(SP)
  TRAP    #13
  ADDQ.L  #2, SP
  MOVE.L  D0, lb(A6)
 END; 
   *)
 RETURN lb;
END Drvmap;

PROCEDURE Kbshift (keys: BITSET): BITSET;
VAR b : BITSET;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:29*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,0000BH);
CODE(04E4DH);
CODE(0588FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP);
  MOVE.W  #11, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  keys(A6), -(SP);
  MOVE.W  #11, -(SP)
  TRAP    #13
  ADDQ.L  #4, SP
  MOVE.W  D0, b(A6)
 END;
   *)
 RETURN b;
END Kbshift;

END M_BIOS.

