IMPLEMENTATION MODULE M_Command;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

IMPORT M_Types, M_Sys, M_Strings;

CONST   TermChar = ' ';

TYPE    tEnv =    ARRAY [0..07FFFFFFDH] OF CHAR;

VAR     pCount:   SHORTCARD;
        Base:     M_Types.PtrPD;
        IsArgv:   BOOLEAN;
        arg:      SHORTCARD; (* Pos. des ersten Arg. im Environment *)
        env:      POINTER TO tEnv;
        path:     ARRAY [0..255] OF CHAR;

PROCEDURE ArgV (): BOOLEAN;
BEGIN
 RETURN IsArgv;
END ArgV;

PROCEDURE ParamCount (): SHORTCARD;
BEGIN
 RETURN pCount;
END ParamCount;

PROCEDURE EnvLine (n, pos: SHORTINT; VAR line: ARRAY OF CHAR): BOOLEAN;
VAR l, d, x, p: SHORTINT;
BEGIN
 line[0]:= CHR (0);
 IF Base^.pEnv <> M_Types.Null THEN
  env:= Base^.pEnv;  x:= pos;  p:= 0;  d:= 0;  l:= HIGH (line);
  REPEAT
   IF p = n THEN
    WHILE (env^[x] <> CHR(0)) AND (d < l) DO
     line[d]:= env^[x];  INC (x);  INC (d);
    END; (* WHILE *)
    line[d]:= CHR (0);
    RETURN TRUE;
   END;
   IF (env^[x] = CHR(0)) THEN
    IF (env^[x + 1] = CHR(0)) THEN
     (* Doppelnull, fertisch *)  RETURN FALSE;
    END;
    INC (p);
   END;
   INC (x);
  UNTIL p > n;
 END;
 RETURN FALSE;
END EnvLine;

PROCEDURE ParamStr (index: SHORTCARD; VAR param: ARRAY OF CHAR);
VAR c, d, x, l, p: SHORTCARD;
    cs: M_Types.CSTRING;
    b: BOOLEAN;
BEGIN
 param[0]:= CHR(0);
 IF IsArgv THEN  (* Parameter im Environment *)
  IF index = 0 THEN  (* argv0 liefern, da ist der Programmpfad! *)
   M_Strings.StrCopy (param, path);
   RETURN;
  ELSE 
   IF index > 0 THEN 
    b:= EnvLine (index - 1, arg, param);
    RETURN;
   END;
  END;
 ELSE (* Kein Argv, Parameter in der Kommandozeile *)
  IF (index > 0) AND (index <= pCount) THEN 
   p:= 1;  c:= 1;  l:= ORD(Base^.pCmdlin[0]);
  
   (* Argumente durchforsten *)
   WHILE c < l DO 

    (* Fhrende Fllzeichen berspringen *)
    WHILE (Base^.pCmdlin[c] = TermChar) AND (c <= l) DO 
     INC (c);
    END;

    (* Da haben wirs ja schon *)
    IF index = p THEN 
     d:= 0;
     WHILE (Base^.pCmdlin[c] <> TermChar) AND (c <= l) DO 
      param[d]:= Base^.pCmdlin[c];  INC (c);  INC (d);
     END;
     param[d]:= 0C;
     RETURN;
    END;

    INC (c);

    IF Base^.pCmdlin[c] = TermChar THEN  INC (p); END;

   END; (* WHILE c < l *) 
  END; 
 END;
END ParamStr;

PROCEDURE EnvVar (name: ARRAY OF CHAR; VAR value: ARRAY OF CHAR): BOOLEAN;
VAR b: BOOLEAN;
    i, c: SHORTINT;
    cs: M_Types.CSTRING;
BEGIN
 i:= 0;  value[0]:= CHR(0);
 REPEAT
  b:= EnvLine (i, 0, value);
  IF b THEN 
   c:= M_Strings.StrWPos (name, value, 0, CHR(0), CHR(0));
   IF c > 0 THEN 
(*    M_Strings.StrDelete (value, c, SHORT (M_Strings.StrLen(name))); *)
    RETURN TRUE;
   END;
  END;
  INC (i);
 UNTIL b = FALSE; (* Ende des Environments *)
 RETURN FALSE;
END EnvVar;

PROCEDURE InitCommand;
VAR v: SHORTINT; (* Counter durchs Environment *)
    x, c, l: SHORTINT;
BEGIN
 IsArgv:= FALSE;  pCount:= 0;  arg:= 0;  v:= 0;

 (* Basepage auslesen *)
 Base:= M_Sys.BasepagePtr();

 l:= ORD(Base^.pCmdlin[0]);
 IF l > 126 THEN  (* Sollte eine ARGV-Zeile sein. *)
  env:= Base^.pEnv;
  (* 'ARGV=' suchen *)
  REPEAT
   IsArgv:= (env^[v    ] = 'A') AND 
            (env^[v + 1] = 'R') AND 
            (env^[v + 2] = 'G') AND
            (env^[v + 3] = 'V') AND
            (env^[v + 4] = '=');
   IF IsArgv THEN  env^[v]:= CHR(0);  INC (v, 5); 
             ELSE  INC (v);  END;
  UNTIL (env^[v] = CHR(0)) AND (env^[v + 1] = CHR(0)) OR IsArgv;
 END;
 
 IF IsArgv THEN 
  (* Nach erstem Null-Char suchen, v zeigt auf das Zeichen nach 'ARGV=' *)
  WHILE env^[v] <> CHR(0) DO  INC (v);  END;
  INC (v); (* Erstes Zeichen des folgenden Parameters *)
  (* Hier beginnt der erste Parameter. Das ist der Name und Pfad unter
   * dem das Programm gestartet wurde...
   *)
  x:= 0;
  WHILE (env^[v] <> CHR(0)) AND (x < 255) DO 
   path[x]:= env^[v];  INC (v);  INC (x);
  END;
  path[x]:= CHR(0);

  arg:= v + 1; (* Position des ersten Arguments im Environment *)
  pCount:= 0; (* Argumentzhler lschen *)
  REPEAT (* Argumente zhlen *)
   WHILE env^[v] <> CHR(0) DO  INC (v); END;
   INC (pCount); INC (v);
  UNTIL env^[v] = CHR(0);(* Doppelnull, fertisch *);
  DEC (pCount);

 ELSE (* Kein ARGV, Parameter aus der Basepage holen *)
  IF (l > 0) THEN 
   pCount:= 1;  c:= 1;
   (* Fhrende Fllzeichen berspringen *)

   WHILE (Base^.pCmdlin[c] = TermChar) AND (c < l) DO 
    INC (c); IF c = l THEN  DEC (pCount); END;
   END;
   (* Argumente zhlen *)
   WHILE c < l DO 
    IF (Base^.pCmdlin[c] = TermChar) THEN 
     INC (pCount); 
     WHILE (Base^.pCmdlin[c] = TermChar) AND (c < l) DO 
      INC (c);
      IF c = l THEN  DEC (pCount); END;
     END;
    END;
    INC (c);
   END;
  ELSE 
   pCount:= 0;
  END; 
 END;
END InitCommand;

BEGIN
 InitCommand;
END M_Command.


