(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Convert;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

IMPORT M_Types;
FROM M_Sys IMPORT  App, CallMagic;
FROM SYSTEM IMPORT ADDRESS, ADR;

PROCEDURE NumToStr (num: LONGINT; len, base: SHORTINT; neg: BOOLEAN; VAR s: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  LongIn[0]:= num;
  IntIn[0]:= len;
  IntIn[1]:= base;
  IntIn[2]:= ORD(neg);
 END;
 CallMagic (100);
END NumToStr;

PROCEDURE StrToNum (s: ARRAY OF CHAR; base: SHORTINT; neg: BOOLEAN; max: LONGINT): LONGINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  IntIn[0]:= base;
  IntIn[1]:= ORD (neg);
  LongIn[0]:= max;
  CallMagic (101);
  RETURN LongOut[0];
 END;
END StrToNum;

PROCEDURE RealToStr (v: REAL; n: SHORTINT; VAR s: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (v);
  AddrIn[1]:= ADR (s);
  IntIn[0]:= n;
 END;
 CallMagic (111);
END RealToStr;

PROCEDURE StrToReal (s: ARRAY OF CHAR): REAL;
VAR r: REAL;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (r);
  AddrIn[1]:= ADR (s);
 END;
 CallMagic (106);
 RETURN r;
END StrToReal;

PROCEDURE StrToInt (s: ARRAY OF CHAR): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  CallMagic (102);
  RETURN IntOut[0];
 END;
END StrToInt;

PROCEDURE StrToLInt (s: ARRAY OF CHAR): LONGINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  CallMagic (103);
  RETURN LongOut[0];
 END;
END StrToLInt;

PROCEDURE HexToInt (s: ARRAY OF CHAR): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  CallMagic (104);
  RETURN IntOut[0];
 END;
END HexToInt;

PROCEDURE HexToLInt (s: ARRAY OF CHAR): LONGINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  CallMagic (105);
  RETURN LongOut[0];
 END;
END HexToLInt;

PROCEDURE IntToStr (v: SHORTINT; n: SHORTINT; VAR s: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  IntIn[0]:= v;
  IntIn[1]:= n;
 END;
 CallMagic (107);
END IntToStr;

PROCEDURE IntToHexStr (v: SHORTINT; n: SHORTINT; VAR s: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  IntIn[0]:= v;
  IntIn[1]:= n;
 END;
 CallMagic (108);
END IntToHexStr;

PROCEDURE LIntToHexStr (v: LONGINT; n: SHORTINT; VAR s: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  LongIn[0]:= v;
  IntIn[0]:= n;
 END;
 CallMagic (110);
END LIntToHexStr;

PROCEDURE LIntToStr (v: LONGINT; n: SHORTINT; VAR s: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  LongIn[0]:= v;
  IntIn[0]:= n;
 END;
 CallMagic (109);
END LIntToStr;

END M_Convert.
