(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1992 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_Cookie;

IMPORT SYSTEM;

CONST   CPU =           '_CPU'; (* Hauptprozessor: 0, 10, 20, 30 usw. *)
        FPU =           '_FPU'; (* Mathe-Koprozessor: 0, 1, 2 im HighWord *)
        Machine =       '_MCH'; (* Rechner; HighWord: 0=ST, 1=STE, 2=TT *)
        Video =         '_VDO'; (* Video-Hardware; HighWord: 0=ST, 1=STE, 2=TT *)
        Sound =         '_SND'; (* Bits im Longword: 0: GI/Yamaha(ST), 1: DMA(TT) *)
        Switches =      '_SWI'; (* BIOS-interne Konfigurationswerte *)
        FastReadBuff =  '_FRB'; (* Adresse des 64KB-Puffers f. Disk-Treiber im TT *)
        LaserPrinter =  '_SLM'; (* Wird vom Diablo-Treiber (ab Version 1.4) gesetzt. *)
        STeFix =        '_INF'; (* Fix fr den Desktop.Inf-Bug im Desktop des STE. *)
        DosFlock =      '_FLK'; (* GEMDOS verfgt ber Record-Locking *)
        Network =       '_NET'; (* Typ des verwendeten Netzwerks *)
        Poolfix =       '_OOL'; (* Poolfix 3 von Atari Corp *)
        DayTime =       '_IDT'; (* Datums und Zeitformat *)
        HdDisk =        '_FDC'; (* Laufwerk-Konfiguration ab TOS 2.06
                                 * im 1. Word  0 =  DD-Laufwerke (720/360kB)
                                 *             1 =  HD-Laufwerke (1.44MB)
                                 *             2 =  ED-Laufwerke (2.88MB)
                                 *)

CONST   Overscan =      'OVER'; (* Autoswitch-Overscan von K.Isakovic *)
        TOS14Fix =      'TFIX'; (* Tos14Fix *)
        VDIFix =        'VFIX'; (* VDIFix-Progamm von K.Isakovic *)
        ReflexCard =    'RFLX'; (* Treiber der Reflex-Karte von OverScan GbR *)
        NVDI =          'NVDI'; (* NVDI von Bela *)
        BigScreen2 =    'BIGS'; (* Grobildschirmsimulator von Julian Reschke *)
        VirtualScreen = 'VSCR'; (* Zeiger auf Infostruktur von Bigscreen2 *)
        Gemini =        'GMNI'; (* GEMINI, der Shareware-Desktop *)
        Mupfel =        'MUPF'; (* MUPFEL von Gereon Steffens *)
        MakeJar =       'MkJr'; (* MakeCookiejar von Thomas Schallar *)
        TTTF =          'TTTF'; (* ThirtyTwoToTwentyFour von Marcel Waldvogel *)
        FileSelector =  'FSEL'; (* Extended Fileselector z.B. Patzelbox *)
        LetemFly =      'LTMF'; (* Let'em Fly von Oliver Scheel *)
        MiNT =          'MiNT'; (* MiNT *)
        MagX =          'MagX'; (* MagX von Kromke & Behne Bros. *)
        Magic =         'MPRO'; (* Magic 4.00 *)

TYPE    Anytype =  RECORD
                    CASE : SHORTINT OF
                     0: ptr: SYSTEM.ADDRESS;|
                     1: long: LONGCARD;|
                     2: hi, lo: SHORTINT;|
                     3: b4, b3, b2, b1: SYSTEM.BYTE;|
                    END;
                   END;

PROCEDURE FindCookie (id: ARRAY OF CHAR; VAR value: Anytype): BOOLEAN;
PROCEDURE ModifyCookie (id: ARRAY OF CHAR; newvalue: Anytype): BOOLEAN;
PROCEDURE AddCookie (id: ARRAY OF CHAR; value: Anytype): BOOLEAN;
PROCEDURE DelCookie (id: ARRAY OF CHAR): BOOLEAN;

TYPE  Listmode = (first, next);

PROCEDURE ListCookies (flag: Listmode; VAR id: ARRAY OF CHAR; 
                      VAR value: Anytype; VAR num: SHORTINT): BOOLEAN;
PROCEDURE MaxCookies(): SHORTINT;
PROCEDURE UsedCookies(): SHORTINT;
PROCEDURE JarInstalled(): BOOLEAN;

END M_Cookie.

