(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Cookie;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

IMPORT M_DOS, SYSTEM;

CONST MaxCooks = 1024; (* Mehr Cookies wird ja wohl keiner haben *)

TYPE tCookie =  RECORD
                 id:  LONGCARD;
                 val: LONGCARD;
                END;

TYPE tdummy =   RECORD
                 CASE : BOOLEAN OF
                  TRUE:  str: ARRAY [0..3] OF CHAR; (* Identifier *)|
                  FALSE: lc:  LONGCARD;|
                 END;
                END;

TYPE tJar =     POINTER TO ARRAY [0..MaxCooks] OF tCookie;

VAR Jar[05A0H]: tJar;

VAR dummy, d1:  tdummy;

VAR NullCookie: RECORD
                 id:  LONGCARD;
                 val: LONGCARD;
                END;


VAR stack:      SYSTEM.ADDRESS;
    NoJar:      SYSTEM.ADDRESS;

PROCEDURE FindCookie (cookie: ARRAY OF CHAR; VAR value: Anytype): BOOLEAN;
VAR (*$Reg*)  c: SHORTCARD;
    b: BOOLEAN;
BEGIN
 value.ptr:= 0;
 stack:= 0;  M_DOS.Super (stack);  b:= FALSE;
 IF Jar # NoJar THEN
  FOR c:= 0 TO 3 DO  dummy.str[c]:= cookie[c];  END;
  c:= 0;
  WHILE (Jar^[c].id # 0) AND (NOT b) DO
   IF Jar^[c].id = dummy.lc THEN
    value.long:= Jar^[c].val;  b:= TRUE;
   END;
   INC (c);
  END;
 END;
 M_DOS.Super (stack);
 RETURN b;
END FindCookie;

PROCEDURE ModifyCookie (cookie: ARRAY OF CHAR; newvalue: Anytype): BOOLEAN;
VAR p: tJar;
    (*$Reg*)  c: SHORTCARD;
    b: BOOLEAN;
BEGIN
 stack:= 0;  M_DOS.Super (stack);  b:= FALSE;
 IF Jar # NoJar THEN
  FOR c:= 0 TO 3 DO  dummy.str[c]:= cookie[c];  END;
  p:= Jar;  c:= 0;
  WHILE (p^[c].id # 0) AND NOT b DO
   IF p^[c].id = dummy.lc THEN
    p^[c].val:= newvalue.long;  b:= TRUE;
   END;
   INC (c);
  END;
 END;
 M_DOS.Super (stack);
 RETURN FALSE;
END ModifyCookie;

VAR p: tJar;
    cook: SHORTCARD;

PROCEDURE ListCookies (flag: Listmode; VAR id: ARRAY OF CHAR;
                       VAR value: Anytype; VAR num: SHORTINT): BOOLEAN;
VAR (*$Reg*)  c: SHORTCARD;  ok: BOOLEAN;
BEGIN
 id[0]:= 0C;  num:= 0;  c:= 0;  value.long:= 0;  ok:= FALSE;
 stack:= 0;  M_DOS.Super (stack);
 IF Jar # NoJar THEN
  IF flag = first THEN  p:= Jar;  cook:= 0;  END;
  IF p^[cook].id # 0 THEN
   value.long:= p^[cook].val;  (* Den Cookie-Wert bertragen *)
   dummy.lc:= p^[cook].id;  (* den Longcard in einen String wandeln *)
   FOR c:= 0 TO 3 DO  id[c]:= dummy.str[c];  END;
   num:= cook;
   IF HIGH (id) > 3 THEN id[4]:= 0C;  END; (* Fr Terminierung sorgen *)
   INC (cook); (* Nchster Cookie *)
   ok:= TRUE;
  END;
 END;
 M_DOS.Super (stack);
 RETURN ok;
END ListCookies;

PROCEDURE AddCookie (id: ARRAY OF CHAR; value: Anytype): BOOLEAN;
VAR c, cc: SHORTCARD;
BEGIN
 IF ModifyCookie (id, value) THEN  RETURN TRUE;  END;
 stack:= 0;  M_DOS.Super (stack);  cc:= 0;
 (* Null-Cookie suchen *)
 WHILE Jar^[cc].id <> 0 DO  INC (cc);  END;
 IF VAL(LONGCARD, cc) < (Jar^[cc].val - 1) THEN (* Noch Platz *)
  (* NULL-Cookie umkopieren *)
  Jar^[cc+1].id:= Jar^[cc].id;
  Jar^[cc+1].val:= Jar^[cc].val;
  FOR c:= 0 TO 3 DO  dummy.str[c]:= id[c];  END;
  Jar^[cc].id:= dummy.lc;
  Jar^[cc].val:= value.long;
  M_DOS.Super (stack);
  RETURN TRUE;
 END;
 M_DOS.Super (stack);
 RETURN FALSE;
END AddCookie;

PROCEDURE DelCookie (id: ARRAY OF CHAR): BOOLEAN;
VAR c, cc, nc: SHORTINT;
    val: Anytype;
BEGIN
 IF NOT FindCookie (id, val) THEN  RETURN FALSE;  END;
 (* Cookie suchen *)
 FOR c:= 0 TO 3 DO  dummy.str[c]:= id[c];  END;
 stack:= 0;  M_DOS.Super (stack);  cc:= 0;
 (* Den zu lschenden Cookie suchen *)
 cc:= 0;  WHILE Jar^[cc].id <> dummy.lc DO  INC (cc);  END;
 (* Null-Cookie suchen *)
 nc:= 0;  WHILE Jar^[nc].id <> 0 DO  INC (nc); END;
 WHILE cc < nc DO 
  Jar^[cc].id:= Jar^[cc+1].id;
  Jar^[cc].val:= Jar^[cc+1].val;
  INC (cc);
 END;
 M_DOS.Super (stack);
 RETURN TRUE;
END DelCookie;

PROCEDURE MaxCookies(): SHORTINT;
VAR c: SHORTINT;
    v: Anytype;
BEGIN
 c:= 0;  v.long:= 0;
 stack:= 0;  M_DOS.Super (stack);
 IF Jar <> NoJar THEN 
  (* Null-Cookie suchen *)
  WHILE Jar^[c].id <> 0 DO  INC (c);  END;
  v.long:= Jar^[c].val;
 END;
 M_DOS.Super (stack);
 RETURN VAL(SHORTINT, v.long);
END MaxCookies;

PROCEDURE UsedCookies(): SHORTINT;
VAR c: SHORTINT;
BEGIN
 c:= 0;
 stack:= 0;  M_DOS.Super (stack);
 IF Jar <> NoJar THEN
  WHILE Jar^[c].id <> 0 DO  INC (c);  END;
 END;
 M_DOS.Super (stack);
 RETURN c;
END UsedCookies;

PROCEDURE JarInstalled(): BOOLEAN;
VAR inst: BOOLEAN;
BEGIN
 stack:= 0;  M_DOS.Super (stack);
 inst:= Jar <> NoJar;
 M_DOS.Super (stack);
 RETURN inst;
END JarInstalled;

BEGIN
 cook:= 0;
 NoJar:= 00000000;
 NullCookie.id:= 0;
 NullCookie.val:= 0;
END M_Cookie.
