(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)

(*----------------------------------------------------------------------*
 * mpDials      'magische' Dialoge...                                   *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_Dials;

FROM Portab IMPORT tCompiler, Compiler;

FROM SYSTEM     IMPORT  ADDRESS;
FROM M_AES      IMPORT  tObjctree;
FROM M_Types    IMPORT  LONGBITSET, tKey, tRect, tCtrlArray;
IMPORT M_Types;

CONST MoveBox =         17; 
      SpecButton =      18;
      SpecText =        19;
      FrameBox =        20;
      TripleButton =    23;
     
CONST TitleText =    127;  (* Titeltext eines Dialogs *)
      Invisible =    126;  (* "unsichtbares" Objekt *)
      SliderBox =    125;  (* Grundobjekt eines Sliders, vom Typ GIBOX *)
      DropCircle =   124;  (* Drop-Circlebutton *)
      DropBox =      123;  (* Dropbox-Objekt *)
      ListBox =      122;  (* Listbox-Objekt *)
      SpecBox =      121;  (* GBox, mit Spezialeffekten *)
      SpecBoxchar =  120;  (* GBoxchar, dessen Zeichen als Shortkey gesetzt wird! *)
      TimerObjc =    119;  (* Timer *)
      HelpButt =     118;  (* Automatischer Hilfebutton *)
      IconButton =   117;  (* Button mit Icon als Text *)

PROCEDURE DisposeDials;

CONST aSelect =       M_Types.Bit0;
      aDeselect =     M_Types.Bit1;
      aCheck =        M_Types.Bit2;
      aUncheck =      M_Types.Bit3;
      aDisable =      M_Types.Bit4;
      aEnable =       M_Types.Bit5;
      aTriple1 =      M_Types.Bit6;
      aTriple2 =      M_Types.Bit7;
      aTriple3 =      M_Types.Bit8;
      aSlider =       M_Types.Bit9;
      aBell =         M_Types.Bit10;
      aAsterik =      M_Types.Bit11;
      aNoAsterik =    M_Types.Bit12;
      aDraw =         M_Types.Bit13;
      aDrawSlider =   M_Types.Bit14;
      aDrawChilds =   M_Types.Bit15;
      aDrawParent =   M_Types.Bit16;
      aDrawDial =     M_Types.Bit17;
      aDrawList =     M_Types.Bit18;
      aClose =        M_Types.Bit19;
      aUpdateSlider = M_Types.Bit20;
      aTopDialog =    M_Types.Bit21;
      aCallback =     M_Types.Bit22;
      aDelEdit =      M_Types.Bit23;
      aChangeEdit =   M_Types.Bit24;
      aRes25 =        M_Types.Bit25;
      aRes26 =        M_Types.Bit26;
      aRes27 =        M_Types.Bit27;
      aRes28 =        M_Types.Bit28;
      aRes29 =        M_Types.Bit29;
      aRes30 =        M_Types.Bit30;
      aKillDial =     M_Types.Bit31;

TYPE  IntArray =        POINTER TO tCtrlArray;

TYPE PtrDialpara =      POINTER TO DialParameter;
     DialParameter =    RECORD
                         message: SHORTINT;   (* Was ist passiert?    *)
                         tree:    tObjctree;  (* Objektbaum           *)
                         objc:    SHORTINT;   (* Welches Objekt?      *)
                         mx, my:  SHORTINT;   (* Mausposition         *)
                         key:     tKey;       (* Tastencode           *)
                         asc:     CHAR;       (* Ascii-Code           *)
                         mstate:  BITSET;     (* Maustastenstatus     *)
                         kstate:  BITSET;     (* Sondertastenstatus   *)
                         spec:    tRect;      (* Special-Parameter    *)
                         start:   SHORTINT;   (* Edit-Element         *)
                         pos:     SHORTINT;   (* Edit-Position        *)
                         action:  LONGBITSET; (* Was ist noch zu tun? *)
                         list:    IntArray;   (* Objektliste          *)
                         res:     ADDRESS;    (* Reserviert           *)
                         (* Folgende Werte werden ab Magic Revison 5 eingetragen *)
                         window:  SHORTINT;   (* Fensterkennung des Dialogs *)
                         open:    SHORTINT;   (* > 0 Dialog ist geffnet *)  
                         mode:    SHORTINT;   (* Modus, in dem er geffnet wurde *)
                        END;

(*$?Compiler=Haenisch: (*$K+*) *)
TYPE DialHandler = PROCEDURE (PtrDialpara);
(*$?Compiler=Haenisch: (*$K=*) *)

TYPE Dialmode =  (dNormal,      (* "Normaler" Dialog                     *)
                  dSpecial,     (* Spezialdialog zb. Popup               *)
                  dFlydial,     (* fliegender Dialog                     *)
                  dModal,       (* modaler Fensterdialog                 *)
                  dNonmodal);   (* nichtmodaler Fensterdialog            *)

CONST dPos =         M_Types.Bit0;
      dAllkeys =     M_Types.Bit1;
      dMouse =       M_Types.Bit2;
      dLeaveOut =    M_Types.Bit3;
      dButton =      M_Types.Bit4;
      dUpArrow =     M_Types.Bit5;
      dDownArrow =   M_Types.Bit6;
      dVSlider =     M_Types.Bit7;
      dLeftArrow =   M_Types.Bit8;
      dRightArrow =  M_Types.Bit9;
      dHSlider =     M_Types.Bit10;
      dFuller =      M_Types.Bit11;
      dInfo =        M_Types.Bit12;
      dSizer =       M_Types.Bit13;
      dIconifier =   M_Types.Bit14;
      dCenter =      M_Types.Bit15;
      dWintop =      M_Types.Bit16;
      dForceWindow = M_Types.Bit17;
      dWinKeys =     M_Types.Bit18;

PROCEDURE OpenDial (tree: tObjctree; mode: Dialmode; flags: LONGBITSET;
                    edit, edpos, ok, cancel, xpos, ypos: SHORTINT;
                    name: ARRAY OF CHAR);
PROCEDURE CloseDial (tree: tObjctree);
PROCEDURE DialInfo (tree: tObjctree;
                    VAR mode: Dialmode;
                    VAR win:  SHORTINT;
                    VAR open: BOOLEAN);
PROCEDURE NewDial (tree: tObjctree; handler: DialHandler): BOOLEAN;
PROCEDURE DisposeDial (tree: tObjctree);
PROCEDURE ObjcExtype (tree: tObjctree; entry, extyp: SHORTINT);
PROCEDURE GetObjcExtype (tree: tObjctree; entry: SHORTINT;
                         VAR extyp, typ: SHORTINT);
PROCEDURE SetUserkey (tree: tObjctree; objc: SHORTINT; key: tKey;
                      action, doset: BOOLEAN);
PROCEDURE ResetUserkeys (tree: tObjctree);
PROCEDURE UserValids (tree: tObjctree; str: ARRAY OF CHAR);

CONST   CSCREEN =       0;
        CMOUSE =        1;
        CPOS =          2;

PROCEDURE DialCenter (tree: tObjctree; flag, xx, yy: SHORTINT; VAR rect: tRect);
PROCEDURE DialDraw (tree: tObjctree; entry, depth: SHORTINT; clip: tRect);
PROCEDURE DialChange (tree: tObjctree; entry: SHORTINT; state: SHORTCARD;
                      clip: tRect; doset, draw: BOOLEAN);
PROCEDURE DisableDialog (tree: tObjctree);
PROCEDURE EnableDialog (tree: tObjctree);

TYPE TripleState = (TriState1, TriState2, TriState3, TriError);

PROCEDURE GetTriple (tree: tObjctree; entry: SHORTINT): TripleState;
PROCEDURE SetTriple (tree: tObjctree; entry: SHORTINT; state: TripleState);

PROCEDURE GetSlider (tree: tObjctree; entry: SHORTINT;
                     VAR spos, ssize: SHORTINT);
PROCEDURE SetSlider (tree: tObjctree; entry, spos, ssize: SHORTINT); 
PROCEDURE FreeListbox (tree: tObjctree; item: SHORTINT); 
PROCEDURE RedrawListbox (tree: tObjctree; item, start: SHORTINT);

TYPE ListboxMode = (Select, Check, SelectMulti, CheckMulti);

PROCEDURE SetListboxMode (tree: tObjctree; item: SHORTINT; mode: ListboxMode);
PROCEDURE SetDropboxElement (tree: tObjctree; item, entry: SHORTINT; draw: BOOLEAN);
PROCEDURE FindSelected (tree: tObjctree; item, start: SHORTINT): SHORTINT;
PROCEDURE FindChecked (tree: tObjctree; item, start: SHORTINT): SHORTINT;
PROCEDURE SelectMatching (tree: tObjctree; item, start: SHORTINT;
                          entry: ARRAY OF CHAR;
                          state: SHORTINT; sel, first: BOOLEAN);
PROCEDURE SelectMatchPtr (tree: tObjctree; item, start: SHORTINT; data: ADDRESS;
                          state: SHORTINT;  sel, first: BOOLEAN);
PROCEDURE SelectEntry (tree: tObjctree; item, entry: SHORTINT;
                       state: SHORTINT; draw: BOOLEAN);
PROCEDURE SelectAll (tree: tObjctree; item, start: SHORTINT;
                     state: SHORTINT; sel: BOOLEAN);
PROCEDURE AddEntry (tree: tObjctree; item: SHORTINT; state: BITSET; data: ADDRESS; entry: ARRAY OF CHAR): BOOLEAN;
PROCEDURE InsertEntry (tree: tObjctree; item, pos: SHORTINT; state: BITSET; data: ADDRESS; entry: ARRAY OF CHAR): BOOLEAN;
PROCEDURE ChangeEntry (tree: tObjctree; item, pos: SHORTINT; state: BITSET; data: ADDRESS; entry: ARRAY OF CHAR): BOOLEAN;
PROCEDURE DelEntry (tree: tObjctree; item: SHORTINT; num: SHORTINT): BOOLEAN;
PROCEDURE FindEntry (tree: tObjctree; item, start: SHORTINT; entry: ARRAY OF CHAR): SHORTINT;
PROCEDURE GetEntry (tree: tObjctree; item: SHORTINT; num: SHORTINT; VAR data: ADDRESS; VAR entry: ARRAY OF CHAR);
PROCEDURE ActEntry (tree: tObjctree; item: SHORTINT): SHORTINT;
PROCEDURE MaxEntry (tree: tObjctree; item: SHORTINT): SHORTINT;
PROCEDURE DropNext (tree: tObjctree; item: SHORTINT);
PROCEDURE DropEntry (tree: tObjctree; item: SHORTINT; dir: SHORTINT);
PROCEDURE DisableDropbox (tree: tObjctree; item: SHORTINT; draw: BOOLEAN);
PROCEDURE EnableDropbox (tree: tObjctree; item: SHORTINT; draw: BOOLEAN);
PROCEDURE DrawString (r: tRect; mode, col, bcol, brast: SHORTINT;
                      s: ARRAY OF CHAR;
                      flags: BITSET; center, middle, del: BOOLEAN): tKey;
PROCEDURE Rect (r: tRect; color, fill: SHORTINT);
PROCEDURE Frame (r: tRect; color, thick: SHORTINT);
PROCEDURE Frame2 (r: tRect; color1, color2, thick: INTEGER);
PROCEDURE Shadow (r: tRect; color, thick: SHORTINT);
PROCEDURE Line (x, y, w, h, color: SHORTINT);

END M_Dials.

