(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Dials;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM SYSTEM     IMPORT  ADDRESS, ADR, STORE, BYTE;
FROM Storage    IMPORT  ALLOCATE, DEALLOCATE;
FROM M_AES      IMPORT  tObjctree;
FROM M_Types    IMPORT  LONGBITSET, CSTRING, tKey, tRect, Stacksize;
FROM M_Sys      IMPORT  App, CallMagic, CastToLInt, CastToInt;

(*$?Compiler=Megamax:
  IMPORT Calls, MOSGlobals;

TYPE    PtrDH =         POINTER TO DH;
        DH =            RECORD
                         tree:    ADDRESS;
                         handler: DialHandler;
                         next:    PtrDH;
                        END;

VAR     dhlist:         PtrDH;
        p, q:           PtrDH;
        mem, user:      MOSGlobals.MemArea;
        stack:          ARRAY [0..Stacksize-1] OF BYTE;
        caller:         ADDRESS;

VAR a: PtrDialpara;


  (*$S-*)
  (*$R-*)
  PROCEDURE mm2 (VAR regs: Calls.Registers);
  VAR r: Calls.Registers;
  BEGIN
   a:= regs.regA0.ad;
   p:= dhlist;
   WHILE p <> NIL DO
    IF p^.tree = a^.tree THEN  p^.handler (a);  RETURN  END;
    p:= p^.next;
   END;
  END mm2;
  (*$S=*)
  (*$R=*)
 *)

PROCEDURE DisposeDials;
BEGIN
 CallMagic (1101);
(*$?Compiler=Megamax:
 p:= dhlist;
 WHILE p <> NIL DO
  q:= p;  p:= p^.next;  DISPOSE (q);
 END;
 *)
END DisposeDials;

PROCEDURE OpenDial (tree: tObjctree; mode: Dialmode; flags: LONGBITSET;
                    edit, edpos, ok, cancel, xpos, ypos: SHORTINT;
                    name: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (name);
  LongIn[0]:= CastToLInt (flags);
  IntIn[0]:=  ORD (mode);
  IntIn[1]:=  0;
  IntIn[2]:=  edit;
  IntIn[3]:=  edpos;
  IntIn[4]:=  ok;
  IntIn[5]:=  cancel;
  IntIn[6]:=  xpos;
  IntIn[7]:=  ypos;
 END;
 CallMagic (1102);
END OpenDial; 

PROCEDURE CloseDial (tree: tObjctree);
BEGIN
 App^.MagicPB^.AddrIn[0]:= tree;
 CallMagic (1103);
END CloseDial;

PROCEDURE DialInfo (tree: tObjctree; VAR mode: Dialmode; VAR win: SHORTINT; VAR open: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  CallMagic (1104);
  mode:= VAL(Dialmode, IntOut[0]);
  win:= IntOut[1];
  open:= IntOut[1] = 1;
 END;
END DialInfo;

PROCEDURE NewDial (tree: tObjctree; handler: DialHandler): BOOLEAN;
VAR
(*$?Compiler=Megamax:
    x: PtrDH;
    b: BOOLEAN;
 *)
BEGIN
(*$?Compiler=Megamax:
 NEW (x);  IF x = NIL THEN  RETURN FALSE;  END;
 *)
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
(*$?Compiler=Haenisch:
  AddrIn[1]:= ADDRESS(handler);
 *)
(*$?Compiler=Megamax:
  AddrIn[1]:= caller;
 *)
  CallMagic (1105);
(*$?Compiler=Haenisch:
  RETURN IntOut[0] = 1;
 *)
(*$?Compiler=Megamax:
  IF IntOut[0] = 1 THEN
   x^.tree:= tree;
   x^.handler:= handler;
   x^.next:= dhlist;
   dhlist:= x;
   RETURN TRUE;
  ELSE
   RETURN FALSE;
  END;
 *)
 END;
END NewDial;

PROCEDURE DisposeDial (tree: tObjctree);
BEGIN
 App^.MagicPB^.AddrIn[0]:= tree;
 CallMagic (1106);
(*$?Compiler=Megamax:
 p:= dhlist;  q:= dhlist;
 WHILE p <> NIL DO
  IF p^.tree = tree THEN 
   IF q <> NIL THEN q^.next:= p^.next; END;
   DISPOSE (p);
  END;
  q:= p;  p:= p^.next;
 END;
 *)
END DisposeDial;

PROCEDURE ObjcExtype (tree: tObjctree; entry, extyp: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  IntIn[1]:= extyp;
 END;
 CallMagic (1107);
END ObjcExtype;

PROCEDURE GetObjcExtype (tree: tObjctree; entry: SHORTINT; VAR extyp, typ: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  CallMagic (1108);
  extyp:= IntOut[0];
  typ:= IntOut[1];
 END;
END GetObjcExtype;

PROCEDURE SetUserkey (tree: tObjctree; objc: SHORTINT; key: tKey; action, doset: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= objc;
  IntIn[1]:= ORD (key);
  IntIn[2]:= ORD (action);
  IntIn[3]:= ORD (doset);
 END;
 CallMagic (1109);
END SetUserkey;

PROCEDURE ResetUserkeys (tree: tObjctree);
BEGIN
 App^.MagicPB^.AddrIn[0]:= tree;
 CallMagic (1110);
END ResetUserkeys;

PROCEDURE UserValids (tree: tObjctree; str: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (str);
 END;
 CallMagic (1111);
END UserValids;

PROCEDURE DialCenter (tree: tObjctree; flag, xx, yy: SHORTINT; VAR rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (rect);
  IntIn[0]:= flag;
  IntIn[1]:= xx;
  IntIn[2]:= yy;
 END;
 CallMagic (1112);
END DialCenter;

PROCEDURE DialDraw (tree: tObjctree; entry, depth: SHORTINT; clip: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (clip);
  IntIn[0]:= entry;
  IntIn[1]:= depth;
 END;
 CallMagic (1113);
END DialDraw; 

PROCEDURE DialChange (tree: tObjctree; entry: SHORTINT; state: SHORTCARD;
                      clip: tRect; doset, draw: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (clip);
  IntIn[0]:= entry;
  IntIn[1]:= ORD (state);
  IntIn[2]:= ORD (doset);
  IntIn[3]:= ORD (draw);
 END;
 CallMagic (1114);
END DialChange;

PROCEDURE DisableDialog (tree: tObjctree);
BEGIN
 App^.MagicPB^.AddrIn[0]:= tree;
 CallMagic (1115);
END DisableDialog;

PROCEDURE EnableDialog (tree: tObjctree);
BEGIN
 App^.MagicPB^.AddrIn[0]:= tree;
 CallMagic (1116);
END EnableDialog;

PROCEDURE GetTriple (tree: tObjctree; entry: SHORTINT): TripleState;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  CallMagic (1117);
  RETURN VAL(TripleState, IntOut[0]);
 END;
END GetTriple;

PROCEDURE SetTriple (tree: tObjctree; entry: SHORTINT; state: TripleState);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  IntIn[1]:= ORD (state);
 END;
 CallMagic (1118);
END SetTriple;

PROCEDURE GetSlider (tree: tObjctree; entry: SHORTINT; VAR spos, ssize: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  CallMagic (1119);
  spos:=  IntOut[0];
  ssize:= IntOut[1];
 END;
END GetSlider;

PROCEDURE SetSlider (tree: tObjctree; entry, spos, ssize: SHORTINT); 
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  IntIn[1]:= spos;
  IntIn[2]:= ssize;
 END;
 CallMagic (1120);
END SetSlider;

PROCEDURE DrawString (r: tRect; mode, col, bcol, brast: SHORTINT;
                      s: ARRAY OF CHAR;
                      flags: BITSET; center, middle, del: BOOLEAN): tKey;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (s);
  AddrIn[1]:= ADR (r);
  IntIn[0]:= mode;
  IntIn[1]:= col;
  IntIn[2]:= bcol;
  IntIn[3]:= brast;
  IntIn[4]:= CastToInt (flags);
  IntIn[5]:= ORD (center);
  IntIn[6]:= ORD (middle);
  IntIn[7]:= ORD (del);
  CallMagic (1121);
  RETURN  VAL(tKey, IntOut[0]);
 END;
END DrawString;

PROCEDURE Rect (r: tRect; color, fill: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[1]:= ADR (r);
  IntIn[0]:= color;
  IntIn[1]:= fill;
 END;
 CallMagic (1122);
END Rect;

PROCEDURE Frame (r: tRect; color, thick: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[1]:= ADR (r);
  IntIn[0]:= color;
  IntIn[1]:= thick;
 END;
 CallMagic (1123);
END Frame;

PROCEDURE Shadow (r: tRect; color, thick: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[1]:= ADR (r);
  IntIn[0]:= color;
  IntIn[1]:= thick;
 END;
 CallMagic (1124);
END Shadow;

PROCEDURE Line (x, y, w, h, color: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= x;
  IntIn[1]:= y;
  IntIn[2]:= w;
  IntIn[3]:= h;
  IntIn[4]:= color;
 END;
 CallMagic (1125);
END Line;

PROCEDURE FreeListbox (tree: tObjctree; item: SHORTINT); 
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
 END;
 CallMagic (1126);
END FreeListbox;

PROCEDURE AddEntry (tree: tObjctree; item: SHORTINT; state: BITSET; data: ADDRESS; entry: ARRAY OF CHAR): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (entry);
  AddrIn[2]:= data;
  IntIn[0]:= item;
  IntIn[1]:= CastToInt (state);
  CallMagic (1127);
  RETURN IntOut[0] = 1;
 END;
END AddEntry;

PROCEDURE DelEntry (tree: tObjctree; item: SHORTINT; num: SHORTINT): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= num;
  CallMagic (1128);
  RETURN IntOut[0] = 1;
 END;
END DelEntry;

PROCEDURE FindEntry (tree: tObjctree; item, start: SHORTINT; entry: ARRAY OF CHAR): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (entry);
  IntIn[0]:= item;
  IntIn[1]:= start;
  CallMagic (1129);
  RETURN IntOut[0];
 END;
END FindEntry;

PROCEDURE GetEntry (tree: tObjctree; item: SHORTINT; num: SHORTINT; VAR data: ADDRESS; VAR entry: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (entry);
  IntIn[0]:= item;
  IntIn[1]:= num;
  CallMagic (1130);
  data:= AddrOut[0];
 END;
END GetEntry;

PROCEDURE ActEntry (tree: tObjctree; item: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  CallMagic (1131);
  RETURN IntOut[0];
 END;
END ActEntry;

PROCEDURE MaxEntry (tree: tObjctree; item: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  CallMagic (1132);
  RETURN IntOut[0];
 END;
END MaxEntry;

PROCEDURE RedrawListbox (tree: tObjctree; item, start: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= start;
 END;
 CallMagic (1133);
END RedrawListbox;

PROCEDURE SetListboxMode (tree: tObjctree; item: SHORTINT; mode: ListboxMode);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= ORD (mode);
 END;
 CallMagic (1134);
END SetListboxMode;

PROCEDURE FindSelected (tree: tObjctree; item, start: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= start;
  CallMagic (1135);
  RETURN IntOut[0];
 END;
END FindSelected;

PROCEDURE FindChecked (tree: tObjctree; item, start: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= start;
  CallMagic (1136);
  RETURN IntOut[0];
 END;
END FindChecked;

PROCEDURE SelectMatching (tree: tObjctree; item, start: SHORTINT;
                          entry: ARRAY OF CHAR;
                          state: SHORTINT; sel, first: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (entry);
  IntIn[0]:= item;
  IntIn[1]:= start;
  IntIn[2]:= ORD (sel);
  IntIn[3]:= ORD (first);
  IntIn[4]:= state;
 END;
 CallMagic (1137);
END SelectMatching;

PROCEDURE SelectMatchPtr (tree: tObjctree; item, start: SHORTINT; 
                          data: ADDRESS; state: SHORTINT; sel, first: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= data;
  IntIn[0]:= item;
  IntIn[1]:= start;
  IntIn[2]:= ORD (sel);
  IntIn[3]:= ORD (first);
  IntIn[4]:= ORD (state);
 END;
 CallMagic (1148);
END SelectMatchPtr;

PROCEDURE SelectAll (tree: tObjctree; item, start: SHORTINT; state: SHORTINT; sel: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= start;
  IntIn[2]:= ORD (sel);
  IntIn[3]:= state;
 END;
 CallMagic (1138);
END SelectAll;

PROCEDURE SetDropboxElement (tree: tObjctree; item, entry: SHORTINT; draw: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= entry;
  IntIn[2]:= ORD (draw);
 END;
 CallMagic (1139);
END SetDropboxElement;

PROCEDURE SelectEntry (tree: tObjctree; item, entry: SHORTINT; state: SHORTINT; draw: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= entry;
  IntIn[2]:= ORD (draw);
  IntIn[3]:= state;
 END;
 CallMagic (1140);
END SelectEntry;

PROCEDURE DropNext (tree: tObjctree; item: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
 END;
 CallMagic (1141);
END DropNext;

PROCEDURE DropEntry (tree: tObjctree; item: SHORTINT; dir: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= dir;
 END;
 CallMagic (1147);
END DropEntry;

PROCEDURE InsertEntry (tree: tObjctree; item, pos: SHORTINT; state: BITSET; data: ADDRESS; entry: ARRAY OF CHAR): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= data;
  AddrIn[2]:= ADR (entry);
  IntIn[0]:= item;
  IntIn[1]:= pos;
  IntIn[2]:= CastToInt (state);
  CallMagic (1142);
  RETURN IntOut[0] = 1;
 END;
END InsertEntry;

PROCEDURE ChangeEntry (tree: tObjctree; item, pos: SHORTINT; state: BITSET; data: ADDRESS; entry: ARRAY OF CHAR): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= data;
  AddrIn[2]:= ADR (entry);
  IntIn[0]:= item;
  IntIn[1]:= pos;
  IntIn[2]:= CastToInt (state);
  CallMagic (1143);
  RETURN IntOut[0] = 1;
 END;
END ChangeEntry;

PROCEDURE EnableDropbox (tree: tObjctree; item: SHORTINT; draw: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= ORD (draw);
 END;
 CallMagic (1144);
END EnableDropbox;

PROCEDURE DisableDropbox (tree: tObjctree; item: SHORTINT; draw: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= item;
  IntIn[1]:= ORD (draw);
 END;
 CallMagic (1145);
END DisableDropbox;

PROCEDURE Frame2 (r: tRect; color1, color2, thick: INTEGER);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[1]:= ADR (r);
  IntIn[0]:= color1;
  IntIn[1]:= color2;
  IntIn[2]:= thick;
 END;
 CallMagic (1146);
END Frame2;



BEGIN
(*$?Compiler=Megamax:
 dhlist:= NIL;
 mem.bottom:= ADR (stack);
 mem.length:= Stacksize;
 Calls.NewCaller (mm2, FALSE, mem, caller);
 IF caller = NIL THEN  HALT;  END;
 *)
END M_Dials.
