IMPLEMENTATION MODULE M_Dir;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)
IMPORT SYSTEM, M_Types, M_Sys, M_Cookie, M_Strings, M_AES, M_VDI, M_DOS, XBRA;

CONST   NullChar =      0C;

VAR     version:        SHORTINT;
        slash:          ARRAY [0..0] OF CHAR;
        exselector:     BOOLEAN;
        stack:          SYSTEM.ADDRESS;

VAR     Search:         RECORD
                         name:  ARRAY [0..255] OF CHAR;
                         attr:  BITSET;
                         first: BOOLEAN;
                         dta:   M_DOS.PtrDTA;
                        END; 

VAR     defDTA:         M_DOS.DTA;
        defDtaPtr:      M_DOS.PtrDTA;


PROCEDURE GetDir (VAR pfad, name: ARRAY OF CHAR; msg: ARRAY OF CHAR): BOOLEAN;
VAR c: SHORTINT;
    m: ARRAY [0..30] OF CHAR;
    b: BOOLEAN;
BEGIN
 GetPath (pfad);
 IF exselector THEN
  M_Strings.StrCopy (m, msg);  m[30]:= NullChar;
  b:= M_AES.fsel_exinput(SYSTEM.ADR(m), SYSTEM.ADR(pfad), SYSTEM.ADR(name));
 ELSE (* Normalen Selector verwenden *)
  b:= M_AES.fsel_input (SYSTEM.ADR(pfad), SYSTEM.ADR(name));
 END;
 IF NOT b THEN  name[0]:= NullChar;  END;
 RETURN b;
END GetDir;

PROCEDURE GetFile (wild, message: ARRAY OF CHAR; VAR file: ARRAY OF CHAR): BOOLEAN;
VAR p: ARRAY [0..255] OF CHAR;
    n: ARRAY [0..15] OF CHAR;
BEGIN
 M_Strings.StrCopy (p, wild);  n:= '';
 IF GetDir (p, n, message) THEN
  M_Strings.StrCopy (file, p);  DelTail (file);  M_Strings.StrCopy (file, n);
  RETURN TRUE;
 ELSE
  RETURN FALSE;
 END;
END GetFile;

PROCEDURE GetPath (VAR pfad: ARRAY OF CHAR);
VAR drive, c, d: SHORTINT;
    p, suff:     ARRAY [0..40] OF CHAR;
BEGIN
 IF (pfad[0] = NullChar) OR (pfad[0] = '*') THEN
  c:= SHORT (M_Strings.StrLen (pfad));
  IF c > 0 THEN
   DEC (c);
   WHILE (c > 0) & (pfad[c] # '.') DO  DEC (c);  END;
   IF c > 0 THEN
    d:= c;
    WHILE (pfad[c] # NullChar) DO
     suff [c - d]:= pfad[c];  INC (c);
    END (* WHILE *);
    suff[c - d]:= NullChar;
   END (* IF *);
  ELSE
   suff[0]:= NullChar;
  END (* IF *);
  drive:= M_DOS.Dgetdrv ();
  p:= '';
  pfad[0]:= CHR (ORD ('A') + SHORTCARD (drive));
  pfad[1]:= ':';  pfad[2]:= NullChar;
  M_DOS.Dgetpath (p, drive + 1);
  M_Strings.StrCat (pfad, p);
  M_Strings.StrCat (pfad, '\*');
  IF suff[0] # NullChar THEN
   M_Strings.StrCat (pfad, suff)
  ELSE
   M_Strings.StrCat (pfad, '.*');
  END (* IF kein alter Suffix *);
 END (* IF pf leer *);
END GetPath;

PROCEDURE DelTail (VAR s: ARRAY OF CHAR);
VAR c: SHORTINT;
BEGIN
 c:= SHORT (M_Strings.StrLen (s));
 WHILE (c > 0) & (s [c - 1] # '\') DO
  DEC (c);  s[c]:= NullChar;
 END (* WHILE *);
END DelTail;

PROCEDURE SplitPath (path: ARRAY OF CHAR; VAR pfad, name, suff: ARRAY OF CHAR);
VAR c, d, len, pLen:  SHORTINT;
BEGIN
 len:= SHORT (M_Strings.StrLen (path));
 IF len = 0 THEN  RETURN;  END;
 pfad[0]:= NullChar;
 name[0]:= NullChar;
 suff[0]:= NullChar;
 c:= len;

 (* Suffix abspalten wenn vorhanden: *)
 IF c > 0 THEN
  DEC (c); (* Index des letzten Zeichens *)
  WHILE (c > 0) & (path[c] # '.') DO  DEC (c);  END;
  IF c > 0 THEN (* wir haben den Punkt gefunden *)
   d:= 0;
   INC (c);
   WHILE (path[c] # NullChar) AND (d < 3) DO
    suff[d]:= path[c];  INC (c);  INC (d);
   END (* WHILE *);
   IF d <= SHORTINT (HIGH (suff)) THEN  suff[d]:= NullChar  END;
  END (* IF *);
 ELSE
  suff[0]:= NullChar
 END (* IF *);
  
 c:= len;
 IF c > 0 THEN DEC (c); END;

 (* Dateinamen abspalten: *)
 WHILE (c > 0) & (path[c] # '\') & (path[c] # ':') DO  DEC (c);  END;
 IF (path[c] = '\') OR (path[c] = ':') THEN INC (c); END;
 pLen:= c;
 d:= 0;
 FOR c:= c TO len - 1 DO  name[d]:= path[c];  INC (d);  END;
 IF d <= SHORTINT (HIGH (name)) THEN  name[d]:= NullChar;  END;

 (* Pfad kopieren: *)
 IF pLen > 0 THEN
  FOR d:= 0 TO pLen - 1 DO  pfad[d]:= path[d];  END;
 END (* IF *);
 pfad[pLen]:= NullChar;

END SplitPath;

PROCEDURE GetVersion (): SHORTINT;
BEGIN
 RETURN version;
END GetVersion;

PROCEDURE ExSelector (): BOOLEAN;
BEGIN
 RETURN exselector;
END ExSelector;

PROCEDURE SearchParas (maske: ARRAY OF CHAR; attribut: BITSET;
                       ptr: M_DOS.PtrDTA; firsttime: BOOLEAN);
BEGIN
 WITH Search DO
  M_Strings.StrCopy (name, maske);
  attr:= attribut;
  first:= firsttime;
  dta:= ptr;
 END;   
END SearchParas;

PROCEDURE Found (): BOOLEAN;
VAR err: SHORTINT;
BEGIN
 M_DOS.Fsetdta (Search.dta);
 IF Search.first THEN
  err:= M_DOS.Fsfirst (Search.name, Search.attr);
  Search.first:= FALSE;
 ELSE
  err:= M_DOS.Fsnext ();
 END;
 RETURN (err = 0);
END Found;

PROCEDURE Exist (datei: ARRAY OF CHAR): BOOLEAN;
(* Testet, ob Datei oder Ordner schon existiert *)
VAR err: SHORTINT;
BEGIN
 M_DOS.Fsetdta (defDtaPtr);
 RETURN M_DOS.Fsfirst (datei, {0..15}) = 0;
END Exist;

PROCEDURE Replace (oldName, wildcard: ARRAY OF CHAR; VAR new: ARRAY OF CHAR);
(* Bildet aus wildcard und oldName einen neuen Dateinamen (new). *)
CONST cMaxLen =  11;
      cPrefLen =  8;

 PROCEDURE MakeMask (wild: ARRAY OF CHAR; VAR maske: ARRAY OF CHAR);
 (* Expandiert einen Dateinamen auf 12 Zeichen, ? und * werden als ?
  * eingetragen. Nichtvorhandene Zeichen werden Blanks!
  *)
 VAR c, d, i: SHORTCARD;
 BEGIN (* MachMaske *)
  c:= 0;  d:= 0;  M_Strings.StrCopy (maske, "????????????"); (* Vorgefertigte Maske *)
  LOOP 
   IF (wild[d] = CHR(0)) OR (d > HIGH(wild)) THEN
    (* Wildcard zu Ende, Rest der Maske mit Blanks auffllen *)
    FOR i:= c TO cMaxLen DO maske[i]:= " "; END;
    RETURN;
   ELSIF (wild[d] = "*") THEN
    (* Auf einen * mu ein Punkt in der Wildcard folgen! *E*.MOD ist illegal! *)
    INC(d, 2); (* Punkt auslassen *)
    EXIT; (* Fertig mit Prefix-Teil *)
   ELSIF (wild[d] = ".") THEN
    (* Punkt gefunden, Prefix bis zur Maximalen Lnge mit Blanks auffllen *)
    FOR i:= c TO cPrefLen DO  maske[i]:= " ";  END; 
    INC(d);
    EXIT; (* Fertig mit Prefix-Teil *)
   ELSE (* Zeichen aus wild nach maske bertragen *)
    maske[c]:= wild[d];  INC(c);  INC(d);
   END;
  END;
  c:= cPrefLen + 1; (* Index von maske auf "nach dem Punkt" einstellen *)
  LOOP
   IF (wild[d] = CHR(0)) OR (d > HIGH(wild)) THEN
    (* Wildcard zu Ende, Rest der Maske mit Blanks auffllen *)
    FOR i:= c TO cMaxLen DO maske[i]:= " "; END;
    RETURN;
   END;
   IF (c > cMaxLen) OR (wild[d]="*") THEN 
    EXIT (* wild fertig, bzw. maske voll *)
   END;
   (* Zeichen aus wild nach maske bertragen *)
   maske[c]:= wild[d];  INC(c); INC(d); 
  END;
 END MakeMask;


VAR c, d: SHORTCARD;
    wild, maske: ARRAY [0..11] OF CHAR;

BEGIN (* Ersetze *)
 MakeMask (wildcard, wild); (* Masken erstellen *)
 MakeMask (oldName, maske);
 (* Alle legalen Zeichen aus wild nach maske bertragen (auch Blanks!) *)
 FOR c:= 0 TO cMaxLen DO
  IF wild[c] # "?" THEN maske[c]:= wild[c] END;
 END;
 (* new zur Sicherheit lschen *)
 FOR c:= 0 TO cMaxLen DO new[c]:= CHR(0);  END;
 c:= 0;  d:= 0;
 LOOP
  IF (d > cMaxLen) THEN EXIT END; (* Neuer Name fertig *)
  IF d = cPrefLen THEN (* Punktposition, Punkt in new einsetzen *)
   new[c]:= ".";  INC(c);  INC(d); 
  END;
  IF (maske[d] # "?") AND (maske[d] # " ") THEN  
   (* Blanks und ? aussparen, haben nix im neuen Namen zu suchen! *)
   new[c]:= maske[d];  INC(c); INC(d);
  ELSE
   INC(d);
  END;
 END;
 IF c < HIGH (new) THEN new[c]:= NullChar;  END;
END Replace;

CONST   GEMtrap = 88H;
        Kennung = 'FSmp';

VAR     c:      SHORTINT;
        adr:    SYSTEM.ADDRESS;
        val:    M_Cookie.Anytype;

BEGIN
 slash[0]:= '\';
 exselector:= FALSE;
 defDtaPtr:= SYSTEM.ADR(defDTA);
 exselector:= M_Cookie.FindCookie ('FSEL', val);
 IF NOT exselector THEN
  exselector:= XBRA.Installed (Kennung, GEMtrap, adr);
 END;
 version:= M_Sys.TosVersion();
 IF NOT exselector THEN  exselector:= version > Tos102;  END;
END M_Dir.

