(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1992 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_DOS;

FROM Portab IMPORT tCompiler, Compiler;
IMPORT SYSTEM, M_Types;

CONST   EOK =      0;
        Error =   -1;
        EDrvNR =  -2;     (* Drive not ready *)
        EUnCmd =  -3;     (* Unknown command *)
        ECRC =    -4;     (* CRC error *)
        EBadRq =  -5;     (* Bad request *)
        ESeek  =  -6;     (* Seek error *)
        EMedia =  -7;     (* Unknown media *)
        ESecNF =  -8;     (* Sector not found *)
        EPaper =  -9;     (* No paper *)
        EWritF = -10;     (* Write fault *)
        EReadF = -11;     (* Read fault *)
        EGenrl = -12;     (* General error *)
        EWrPro = -13;     (* Write protect *)
        EChng =  -14;     (* Media change *)
        EUnDev = -15;     (* Unknown device *)
        EBadSF = -16;     (* Bad sectors on format *)
        EOther = -17;     (* Insert other disk *)
        EInvFN = -32;     (* Invalid function number *)
        EFilNF = -33;     (* File not found *)
        EPthNF = -34;     (* Path not found *)
        ENHndl = -35;     (* No handles left *)
        EAccDn = -36;     (* Access denied *)
        EIHndl = -37;     (* Invalid handle *)
        ENSMem = -39;     (* Insufficient memory *)
        EIMBA =  -40;     (* Invalid memory block address *)
        EDrive = -46;     (* Invaild drive specified *)
        ENMFil = -49;     (* No more files *)
        ERange = -64;     (* Range error *)
        EIntrn = -65;     (* Internal error *)
        EPLFmt = -66;     (* Invalid program load format *)
        EGSBF =  -67;     (* Setblock failure due to growth restr *)

CONST   ELOCKED = -58;    (* Record is locked *)
        ENSLOCK = -59;    (* Matching Lock not found *)


PROCEDURE Pterm0;


TYPE tChar =    RECORD
                 CASE : SHORTCARD OF
                  0:  long:     LONGCARD;|
                  1:  hi:       SHORTCARD;
                      lo:       SHORTCARD;|
                  2:  kbshift:  CHAR;
                      reserved: CHAR;
                      scan:     CHAR;
                      char:     CHAR;|
                 END;
                END;

PROCEDURE Cconin (): LONGCARD;
PROCEDURE Cconout (ch: CHAR);
PROCEDURE Cauxin (): SHORTCARD;
PROCEDURE Cauxout (ch: CHAR);
PROCEDURE Cprnout (ch: CHAR);

CONST Input = 377C;

PROCEDURE Crawio  (ch: CHAR): LONGCARD;
PROCEDURE Crawin  (): LONGCARD;
PROCEDURE Cnecin  (): LONGCARD;
PROCEDURE Cconws  ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *) string: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *));
PROCEDURE Cconrs  (VAR string: ARRAY OF CHAR);
PROCEDURE Cconis  (): BOOLEAN;
PROCEDURE Dsetdrv (drive: SHORTCARD; VAR DriveMap: M_Types.LONGBITSET);
PROCEDURE Cconos  (): BOOLEAN;
PROCEDURE Cprnos  (): BOOLEAN;
PROCEDURE Cauxis  (): BOOLEAN;
PROCEDURE Cauxos  (): BOOLEAN;
PROCEDURE Dgetdrv (): SHORTCARD;

TYPE    PtrDTA =        POINTER TO DTA;
        DTA =           RECORD
                         dReserved: ARRAY [0..20] OF SYSTEM.BYTE;
                         dAttrib:   SYSTEM.BYTE;
                         dTime:     SHORTCARD;
                         dDate:     SHORTCARD;
                         dLength:   LONGCARD;
                         dFname:    ARRAY [0..13] OF CHAR;
                        END;

PROCEDURE Fsetdta  (dtaptr: SYSTEM.ADDRESS);
PROCEDURE Super    (VAR stack: SYSTEM.ADDRESS);
PROCEDURE Tgetdate (): SHORTCARD;
PROCEDURE Tsetdate (date: SHORTCARD);
PROCEDURE Tgettime (): SHORTCARD;
PROCEDURE Tsettime (time: SHORTCARD);
PROCEDURE Fgetdta  (): SYSTEM.ADDRESS;
PROCEDURE Sversion (): SHORTCARD;
PROCEDURE Ptermres (keep: LONGCARD; return: SHORTCARD);

TYPE    DISKINFO =      RECORD
                         bFree:   LONGCARD;
                         bTotal:  LONGCARD;
                         bSecsiz: LONGCARD;
                         bClsiz:  LONGCARD;
                        END;

PROCEDURE Dfree   (VAR dib: ARRAY OF SYSTEM.LOC; drive: SHORTCARD);
PROCEDURE Dcreate ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)   pfad: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *)): SHORTINT;
PROCEDURE Ddelete ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)   pfad: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *)): SHORTINT;
PROCEDURE Dsetpath ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)   pfad: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *)): SHORTINT;

CONST   ReadOnly =      M_Types.Bit0;
        Hidden =        M_Types.Bit1;
        System =        M_Types.Bit2;
        Volume =        M_Types.Bit3;
        Folder =        M_Types.Bit4;
        Archive =       M_Types.Bit5;

PROCEDURE Fcreate ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)   name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *); attr: BITSET): SHORTINT;

CONST   NamePRN =       'PRN:';
        NameAUX =       'AUX:';
        NameCON =       'CON:';

CONST   CON =           -1;
        AUX =           -2;
        PRT =           -3;

CONST   StdIn =         0;      (* Keyboard *)
        StdOut =        1;      (* Console *)
        Serial =        2;      (* RS232 *)
        Printer =       3;      (* Centronics *)
        
CONST   Read =          {};      (* Modus *)
        Write =         M_Types.Bit0;
        ReadWrite =     M_Types.Bit1;
        Reserved1 =     M_Types.Bit2;
        Reserved2 =     M_Types.Bit3;
        ShareFlag1 =    M_Types.Bit4;
        ShareFlag2 =    M_Types.Bit5;
        ShareFlag3 =    M_Types.Bit6;
        Inheritance =   M_Types.Bit7;

PROCEDURE Fopen  ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)   name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *); mode: BITSET): SHORTINT;
PROCEDURE Fclose (handle: SHORTINT): SHORTINT;
PROCEDURE Fread  (handle: SHORTINT; VAR count: LONGCARD; buffer: SYSTEM.ADDRESS);
PROCEDURE Fwrite (handle: SHORTINT; VAR count: LONGCARD; buffer: SYSTEM.ADDRESS);
PROCEDURE Fdelete ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)   name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *)): BOOLEAN;

CONST   SeekStart =     0;      (* Seekmodus *)
        SeekPos =       1;
        SeekEnd =       2;

PROCEDURE Fseek (offset: LONGINT; handle, mode: SHORTINT): LONGCARD;
PROCEDURE Fattrib ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)   name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *); set: BOOLEAN; VAR attr: BITSET);
PROCEDURE Fdup (handle: SHORTINT): SHORTINT;
PROCEDURE Fforce (std, nonstd: SHORTINT): BOOLEAN;
PROCEDURE Dgetpath (VAR pfad: ARRAY OF CHAR; drive: SHORTCARD);

CONST Minus1 =  0FFFFFFFFH;

PROCEDURE Malloc  (bytes: LONGCARD): SYSTEM.ADDRESS;
PROCEDURE Mfree (addr: SYSTEM.ADDRESS): BOOLEAN;
PROCEDURE Mshrink (addr: SYSTEM.ADDRESS; newSize: LONGCARD): BOOLEAN;

CONST   LoadnGo =       0;
        Load =          3;
        Run =           4;
        NewPD =         5;

PROCEDURE Pexec (mode: SHORTCARD; VAR name, tail, env: ARRAY OF CHAR): LONGCARD;
PROCEDURE Pterm (code: SHORTINT);
PROCEDURE Fsfirst ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)   name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *); attr: BITSET): SHORTINT;
PROCEDURE Fsnext (): SHORTINT;
PROCEDURE Frename ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)   curr,  new: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *)): SHORTINT;

TYPE    DOSTIME =       RECORD
                         time: SHORTCARD;
                         date: SHORTCARD;
                        END;

PROCEDURE Fdatime (handle: SHORTINT; VAR dostime: ARRAY OF SYSTEM.LOC;
                   set: BOOLEAN);

CONST   STRAM =         0;
        FASTRAM =       1;
        STRAMpref =     2;
        FASTRAMpref =   2;

PROCEDURE Mxalloc (bytes: LONGCARD; mode: SHORTINT): SYSTEM.ADDRESS;
PROCEDURE Maddalt (start: SYSTEM.ADDRESS; size: LONGCARD): SHORTINT;

CONST   CreateLock =    0;
        RemoveLock =    1;        

PROCEDURE Flock (handle, mode: SHORTINT; start, length: LONGCARD);

TYPE    MSGTYPEPTR =    POINTER TO MSGTYPE;
        MSGTYPE =       RECORD
                         msg1: LONGINT;
                         msg2: LONGINT;
                         pid:  SHORTINT;
                        END;

TYPE    XATTRPTR =      POINTER TO XATTR;
        XATTR =         RECORD
                         mode:      SHORTCARD;
                         index:     LONGINT;
                         dev:       SHORTCARD;
                         reserved1: SHORTCARD;
                         nlink:     SHORTCARD;
                         uid:       SHORTCARD;
                         gid:       SHORTCARD;
                         size:      LONGINT;
                         blksize:   LONGINT;
                         nblocks:   LONGINT;
                         mtime:     SHORTINT;
                         mdate:     SHORTINT;
                         atime:     SHORTINT;
                         adate:     SHORTINT;
                         ctime:     SHORTINT;
                         cdate:     SHORTINT;
                         attr:      SHORTINT;
                         reserved2: SHORTINT;
                         reserved3: ARRAY [0..1] OF LONGINT;
                        END;

TYPE    SIGACTIONPtr =  POINTER TO SIGACTION;
        SIGACTION =     RECORD
                         saHandler: SYSTEM.ADDRESS;
                         saMask:    LONGINT;
                         saFlags:   SHORTINT;
                        END;


PROCEDURE Syield      (): SHORTINT;
PROCEDURE Fpipe       (VAR usrh: ARRAY OF SYSTEM.LOC): SHORTINT;
PROCEDURE Fcntl       (f: SHORTINT; arg: LONGINT; cmd: SHORTINT): SHORTINT;
PROCEDURE Finstat     (f: SHORTINT): LONGINT;
PROCEDURE Foutstat    (f: SHORTINT): LONGINT;
PROCEDURE Fgetchar    (f, mode: SHORTINT): LONGINT;
PROCEDURE Fputchar    (f: SHORTINT; c: LONGINT; mode: SHORTINT): LONGINT;
PROCEDURE Pwait       (): LONGINT;
PROCEDURE Pnice       (delta: SHORTINT): SHORTINT;
PROCEDURE Pgetpid     (): SHORTINT;
PROCEDURE Pgetppid    (): SHORTINT;
PROCEDURE Pgetpgrp    (): SHORTINT;
PROCEDURE Psetpgrp    (pid, newgrp: SHORTINT): SHORTINT;
PROCEDURE Pgetuid     (): SHORTINT;
PROCEDURE Psetuid     (id: SHORTINT): SHORTINT;
PROCEDURE Pkill       (pid, sig: SHORTINT): SHORTINT;
PROCEDURE Psignal     (sig: SHORTINT; handler: SYSTEM.ADDRESS): SYSTEM.ADDRESS;
PROCEDURE Pvfork      (): SHORTINT;
PROCEDURE Pgetgid     (): SHORTINT;
PROCEDURE Psetgid     (id: SHORTINT): SHORTINT;
PROCEDURE Psigblock   (mask: LONGINT): LONGINT;
PROCEDURE Psigsetmask (mask: LONGINT): LONGINT;
PROCEDURE Pusrval     (arg: LONGINT): LONGINT;
PROCEDURE Pdomain     (newdom: SHORTINT): SHORTINT;
PROCEDURE Psigreturn;
PROCEDURE Pfork       (): SHORTINT;
PROCEDURE Pwait3      (flag: SHORTINT; VAR rusage: ARRAY OF SYSTEM.LOC): LONGINT;
PROCEDURE Fselect     (timeout: SHORTCARD; VAR rfds, wfds, xfds: LONGINT): SHORTINT;
PROCEDURE Prusage     (VAR r: ARRAY OF SYSTEM.LOC);
PROCEDURE Psetlimit   (lim: SHORTINT; value: LONGINT): LONGINT;
PROCEDURE Talarm      (secs: LONGINT): LONGINT;
PROCEDURE Pause;
PROCEDURE Sysconf     (n: SHORTINT): LONGINT;
PROCEDURE Psigpending (): LONGINT;
PROCEDURE Dpathconf   ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)  name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *) ; n: SHORTINT): LONGINT;
PROCEDURE Pmsg        (mode: SHORTINT; mbox: LONGINT; VAR msg: MSGTYPE): LONGINT;
PROCEDURE Fmidipipe   (pid, inp, outp: SHORTINT): LONGINT;
PROCEDURE Prenice     (pid, delta: SHORTINT): SHORTINT;
PROCEDURE Dopendir    ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)  name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *) ; flag: SHORTINT): LONGINT;
PROCEDURE Dreaddir    (buflen: SHORTINT; dir: LONGINT; VAR buf: ARRAY OF CHAR): LONGINT;
PROCEDURE Drewinddir  (dir: LONGINT): LONGINT;
PROCEDURE Dclosedir   (dir: LONGINT): LONGINT;
PROCEDURE Fxattr      (flag: SHORTINT; (*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *) name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *); VAR buf: XATTR): LONGINT;
PROCEDURE Flink       ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)  oldname,  newname: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *)): LONGINT;
PROCEDURE Fsymlink    ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)  oldname,  newname: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *)): LONGINT;
PROCEDURE Freadlink   (size: SHORTINT; VAR buf: ARRAY OF CHAR; (*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)  name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *)): LONGINT;
PROCEDURE Dcntl       (cmd: SHORTINT; (*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)  name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *); arg: LONGINT): LONGINT;
PROCEDURE Fchown      ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)  name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *); uid, gid: SHORTINT): LONGINT;
PROCEDURE Fchmod      ((*$?Compiler=Megamax: REF *) (*$?Compiler=Haenisch: VAR *)  name: (*$?Compiler=Megamax: ARRAY OF CHAR *) (*$?Compiler=Haenisch: STRING *); mode: SHORTINT): LONGINT;
PROCEDURE Pumask      (mode: SHORTCARD): LONGINT;
PROCEDURE Psemaphore  (mode: SHORTINT; id, timeout: LONGINT): LONGINT;
PROCEDURE Dlock       (mode, drive: SHORTINT): LONGINT;
PROCEDURE Psigpause   (mask: LONGINT);
PROCEDURE Psigaction  (sig: SHORTINT; act, oact: SIGACTIONPtr): LONGINT;
PROCEDURE Pgeteuid    (): SHORTINT;
PROCEDURE Pgetegid    (): SHORTINT;
PROCEDURE Pwaitpid    (pid, flag: SHORTINT; VAR rusage: ARRAY OF SYSTEM.LOC): LONGINT;

END M_DOS.

