(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Event;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

IMPORT SYSTEM, M_AES;
FROM M_Types    IMPORT  HandleEvent, MaxHandler, tRect, PtrEP, Stacksize;
FROM M_Sys      IMPORT  App, CallMagic;

(*$?Compiler=Megamax:
  IMPORT Calls, MOSGlobals;

TYPE Handlerliste = ARRAY [0..MaxHandler] OF HandleEvent;

VAR     keybd:          Handlerliste;
        button:         Handlerliste;
        mesag:          Handlerliste;
        moved:          Handlerliste;
        timer:          Handlerliste;
        rects:          Handlerliste;
        mem:            MOSGlobals.MemArea;
        stack:          ARRAY [0..Stacksize-1] OF SYSTEM.BYTE;
        caller:         SYSTEM.ADDRESS;

(* Umsetzen der Handler *)

VAR a: PtrEP;


  (*$R-, S-*)
  PROCEDURE mm2 (VAR regs: Calls.Registers);
  BEGIN
   a:= regs.regA0.ad;
   CASE a^.res3 OF
    0:    keybd[a^.id](a);|
    1:    button[a^.id](a);|
    2:    mesag[a^.id](a);|
    3:    timer[a^.id](a);|
    4:    moved[a^.id](a);|
    5:    rects[a^.id](a);|
    ELSE  ;
   END;
  END mm2;
  (*$S=, R=*)
 *)

PROCEDURE SetPriority (which: SHORTCARD; id: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= ORD (which);
  IntIn[1]:= id;
  CallMagic (1314);
  RETURN IntOut[0];
 END;
END SetPriority;

PROCEDURE InstMUKEYBD (handler: HandleEvent): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
(*$?Compiler=Haenisch:
  AddrIn[0]:= SYSTEM.ADDRESS(handler);
 *)
(*$?Compiler=Megamax:
  AddrIn[0]:= caller;
 *)
  CallMagic (1300);
(*$?Compiler=Megamax:
  keybd[IntOut[0]]:= handler;
 *)
  RETURN IntOut[0];
 END;
END InstMUKEYBD;

PROCEDURE InstMUBUTTON (handler: HandleEvent): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
(*$?Compiler=Haenisch:
  AddrIn[0]:= SYSTEM.ADDRESS(handler);
 *)
(*$?Compiler=Megamax:
  AddrIn[0]:= caller;
 *)
  CallMagic (1301);
(*$?Compiler=Megamax:
  button[IntOut[0]]:= handler;
 *)
  RETURN IntOut[0];
 END;
END InstMUBUTTON;

PROCEDURE InstMUMESAG (handler: HandleEvent): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
(*$?Compiler=Haenisch:
  AddrIn[0]:= SYSTEM.ADDRESS(handler);
 *)
(*$?Compiler=Megamax:
  AddrIn[0]:= caller;
 *)
  CallMagic (1302);
(*$?Compiler=Megamax:
  mesag[IntOut[0]]:= handler;
 *)
  RETURN IntOut[0];
 END;
END InstMUMESAG;

PROCEDURE InstMURECT (handler: HandleEvent; rect: tRect): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
(*$?Compiler=Haenisch:
  AddrIn[0]:= SYSTEM.ADDRESS(handler);
 *)
(*$?Compiler=Megamax:
  AddrIn[0]:= caller;
 *)
  AddrIn[1]:= SYSTEM.ADR (rect);
  CallMagic (1303);
(*$?Compiler=Megamax:
  rects[IntOut[0]]:= handler;
 *)
  RETURN IntOut[0];
 END;
END InstMURECT;

PROCEDURE ChangeMURECT (handlerID: SHORTINT; rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= SYSTEM.ADR (rect);
  IntIn[0]:= handlerID;
 END;
 CallMagic (1318);
END ChangeMURECT;

PROCEDURE LazyMUMOVED (val: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= val;
 CallMagic (1319);
END LazyMUMOVED;

PROCEDURE InstMUMOVED (handler: HandleEvent): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
(*$?Compiler=Haenisch:
  AddrIn[0]:= SYSTEM.ADDRESS(handler);
 *)
(*$?Compiler=Megamax:
  AddrIn[0]:= caller;
 *)
  CallMagic (1304);
(*$?Compiler=Megamax:
  moved[IntOut[0]]:= handler;
 *)
  RETURN IntOut[0];
 END;
END InstMUMOVED;

PROCEDURE InstMUTIMER (handler: HandleEvent; time: LONGINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
(*$?Compiler=Haenisch:
  AddrIn[0]:= SYSTEM.ADDRESS(handler);
 *)
(*$?Compiler=Megamax:
  AddrIn[0]:= caller;
 *)
  LongIn[0]:= time;
  CallMagic (1305);
(*$?Compiler=Megamax:
  timer[IntOut[0]]:= handler;
 *)
  RETURN IntOut[0];
 END;
END InstMUTIMER;

PROCEDURE EnableEvent (event: SHORTCARD);
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (event);  CallMagic (1313);
END EnableEvent;

PROCEDURE DisableEvent (event: SHORTCARD);
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (event);  CallMagic (1312);
END DisableEvent;

PROCEDURE RemoveMUKEYBD (id: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= id;  CallMagic (1306);
END RemoveMUKEYBD;

PROCEDURE RemoveMUBUTTON (id: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= id;  CallMagic (1307);
END RemoveMUBUTTON;

PROCEDURE RemoveMUMESAG (id: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= id;  CallMagic (1308);
END RemoveMUMESAG;

PROCEDURE RemoveMUMOVED (id: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= id;  CallMagic (1310);
END RemoveMUMOVED;

PROCEDURE RemoveMURECT (id: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= id;  CallMagic (1309);
END RemoveMURECT;

PROCEDURE RemoveMUTIMER (id: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= id;  CallMagic (1311);
END RemoveMUTIMER;

(*----------------------------------------------------------------------*
 * Mr. Dispatcher persnlich...                                         *
 *----------------------------------------------------------------------*)

PROCEDURE CentralDispatcher;
VAR i: SHORTINT;
BEGIN
 CallMagic (1316);
 i:= M_AES.AESCall (25, 16, 7, 1, 0);
 CallMagic (1317);
END CentralDispatcher;

VAR i: SHORTINT;

BEGIN
(*$?Compiler=Megamax:
 mem.bottom:= SYSTEM.ADR (stack);
 mem.length:= Stacksize;
 Calls.NewCaller (mm2, FALSE, mem, caller);
 IF caller = NIL THEN  HALT;  END;
 *)
END M_Event.
