(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_Fonts;

IMPORT M_Types;

CONST   ErrNoFonts =      0;    (* Keine Fonts geladen  *)
        ErrNoGdos =      -1;    (* Kein GDOS            *)
        ErrLessMem =     -2;    (* Kein Speicher        *)
        ErrWorkstation = -3;    (* Workstation nicht ber mpAppl geffnet *)

PROCEDURE LoadFonts (handle: SHORTINT; message: BOOLEAN): SHORTINT;
PROCEDURE FontsLoaded (handle: SHORTINT): SHORTINT;
PROCEDURE UnloadFonts (handle: SHORTINT);

CONST   FFIRST = 0;
        FNEXT =  1;
        FPREV =  2;
        FLAST =  3;

PROCEDURE FontList (handle, flag: SHORTINT): SHORTINT;
PROCEDURE FontAvailable (handle, fontid: SHORTINT): BOOLEAN;

TYPE tFontinfo = RECORD
                  name:   M_Types.CSTRING;     (* Name des Fonts *)
                  id:     SHORTINT;     (* Font-ID *)
                  color:  SHORTINT;     (* Farbindex *)
                  rot:    SHORTINT;     (* Rotationsrichtung *)
                  halign: SHORTINT;     (* Horizontale Ausrichtung *)
                  valign: SHORTINT;     (* Vertikale Ausrichtung *)
                  chw:    SHORTINT;     (* Zeichenbreite *)
                  chh:    SHORTINT;     (* Zeichenhhe *)
                  boxw:   SHORTINT;     (* Zellenbreite *)
                  boxh:   SHORTINT;     (* Zellenhhe *)
                  effect: BITSET;      (* Texteffekte *)
                  min:    SHORTINT;     (* Minimale Gre des Fonts *)
                  max:    SHORTINT;     (* Maximale Gre des Fonts *)
                  point:  SHORTINT;     (* aktuelle Gre des Fonts *)
                  width:  SHORTINT;     (* Breite bei FSM-Fonts *)
                  skew:   SHORTINT;     (* Neigung bei FSM-Fonts *)
                  mono:   SHORTINT;     (* TRUE, wenn Monospaced *)
                  fsm:    SHORTINT;     (* TRUE, wenn FSM-Font *)
                  (* Ab Library-Version Nummer $406 *)
                  typ:    SHORTINT;     (* Typnummer bei Libs >= $406 *)
                 END;

PROCEDURE FontInfo (handle, font: SHORTINT; VAR info: tFontinfo);
PROCEDURE UpdateFontInfo (handle: SHORTINT; info: tFontinfo);
PROCEDURE FontActive (handle: SHORTINT): SHORTINT;
PROCEDURE FontSelect (handle: SHORTINT; font: SHORTINT; actual: BOOLEAN);
PROCEDURE FontSize (handle, point: SHORTINT;
                    VAR chw, chh, boxw, boxh: SHORTINT): SHORTINT;
PROCEDURE FontDefsize (handle: SHORTINT): SHORTINT;
PROCEDURE NextBigger  (handle: SHORTINT): SHORTINT;
PROCEDURE NextSmaller (handle: SHORTINT): SHORTINT;
PROCEDURE FontColor (handle, color: SHORTINT);
PROCEDURE FontEffect (handle: SHORTINT; effekt: BITSET);
PROCEDURE FontRotate (handle, angle: SHORTINT): SHORTINT;
PROCEDURE FontWidth (handle, width: SHORTINT);
PROCEDURE FontSkew (handle, skew: SHORTINT);
PROCEDURE FontExtent (handle: SHORTINT; str: ARRAY OF CHAR; VAR rect: M_Types.tPxyRect);
PROCEDURE FontError(): SHORTINT;

END M_Fonts.

