(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Fonts;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

IMPORT M_Types;
FROM SYSTEM     IMPORT  ADDRESS, ADR;
FROM M_Sys      IMPORT  App, CallMagic, CastToInt;


PROCEDURE LoadFonts (handle: SHORTINT; message: BOOLEAN): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  IntIn[1]:= ORD (message);
  CallMagic (1400);
  RETURN IntOut[0];
 END;
END LoadFonts;

PROCEDURE FontsLoaded (handle: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  CallMagic (1401);
  RETURN IntOut[0];
 END;
END FontsLoaded;

PROCEDURE UnloadFonts (handle: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= handle;
 CallMagic (1402);
END UnloadFonts;

PROCEDURE FontList (handle, flag: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  IntIn[1]:= flag;
  CallMagic (1403);
  RETURN IntOut[0];
 END;
END FontList;

PROCEDURE FontAvailable (handle, fontid: SHORTINT): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  IntIn[1]:= fontid;
  CallMagic (1404);
  RETURN IntOut[0] = 1;
 END;
END FontAvailable;

PROCEDURE FontInfo (handle, font: SHORTINT; VAR info: tFontinfo);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (info);
  IntIn[0]:= handle;
  IntIn[1]:= font;
 END;
 CallMagic (1405);
END FontInfo;

PROCEDURE UpdateFontInfo (handle: SHORTINT; info: tFontinfo);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (info);
  IntIn[0]:= handle;
 END;
 CallMagic (1406);
END UpdateFontInfo;

PROCEDURE FontActive (handle: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  CallMagic (1407);
  RETURN IntOut[0];
 END;
END FontActive;

PROCEDURE FontSelect (handle: SHORTINT; font: SHORTINT; actual: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  IntIn[1]:= font;
  IntIn[2]:= ORD (actual);
 END;
 CallMagic (1408);
END FontSelect;

PROCEDURE FontSize (handle: SHORTINT; point: SHORTINT;
                   VAR chw, chh, boxw, boxh: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  IntIn[1]:= point;
  CallMagic (1409);
  chw:= IntOut[1];
  chh:= IntOut[2];
  boxw:= IntOut[3];
  boxh:= IntOut[4];
  RETURN IntOut[0];
 END;
END FontSize;

PROCEDURE FontDefsize (handle: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  CallMagic (1410);
  RETURN IntOut[0];
 END;
END FontDefsize;

PROCEDURE NextBigger (handle: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  CallMagic (1411);
  RETURN IntOut[0];
 END;
END NextBigger;

PROCEDURE NextSmaller (handle: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  CallMagic (1412);
  RETURN IntOut[0];
 END;
END NextSmaller;

PROCEDURE FontColor (handle, color: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  IntIn[1]:= color;
 END;
 CallMagic (1413);
END FontColor;

PROCEDURE FontEffect (handle: SHORTINT; effekt: BITSET);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  IntIn[1]:= CastToInt (effekt);
 END;
 CallMagic (1414);
END FontEffect;

PROCEDURE FontRotate (handle, angle: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  IntIn[1]:= angle;
  CallMagic (1415);
  RETURN IntOut[0];
 END;
END FontRotate;

PROCEDURE FontWidth (handle, width: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  IntIn[1]:= width;
 END;
 CallMagic (1416);
END FontWidth;

PROCEDURE FontSkew (handle: SHORTINT; skew: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= handle;
  IntIn[1]:= skew;
 END;
 CallMagic (1417);
END FontSkew;

PROCEDURE FontExtent (handle: SHORTINT; str: ARRAY OF CHAR; VAR rect: M_Types.tPxyRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (str);
  AddrIn[1]:= ADR (rect);
  IntIn[0]:= handle;
 END;
 CallMagic (1418);
END FontExtent;

PROCEDURE FontError (): SHORTINT;
BEGIN
 CallMagic (1419);
 RETURN App^.MagicPB^.IntOut[0];
END FontError;

END M_Fonts.
