(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_Menus;

FROM Portab IMPORT tCompiler, Compiler;

IMPORT SYSTEM, M_Types, M_AES;

CONST mCheck =        M_Types.Bit0; (* Hckchen setzen   *)
      mUncheck =      M_Types.Bit1; (* Hckchen lschen  *)
      mDisable =      M_Types.Bit2; (* Eintrag disablen  *)
      mEnable =       M_Types.Bit3; (* Eintrag freigeben *)
      mSwapDisabled = M_Types.Bit4; (* Bei den Eintrgen, die in spec.x..spec.h
                                     * stehen werden die Disabled-Flags 
                                     * geswapped. Disabled wird zu nicht 
                                     * disabled und umgekehrt.
                                     *)
      mSwapChecked =  M_Types.Bit5; (* Wie mSwapDisabled, nur mit den CHECKED-Flag *)
      mBell =         M_Types.Bit6; (* Das Stadler-Flag: Klingeling! *)

TYPE PtrMenupara =      POINTER TO MenuParameter;
     MenuParameter =    RECORD
                         tree:          M_AES.tObjctree;
                         key:           M_Types.tKey;
                         window:        SHORTINT;
                         mx, my:        SHORTINT;
                         menu, entry:   SHORTINT;
                         spec:          M_Types.tRect;
                         action:        BITSET;
                        END;

(*$?Compiler=Haenisch: (*$K+*) *)
TYPE MenuHandler = PROCEDURE (PtrMenupara);
(*$?Compiler=Haenisch: (*$K=*) *)

PROCEDURE InitMenuline (menu: M_AES.tObjctree; handler: MenuHandler;
                       lines: BOOLEAN): BOOLEAN;
PROCEDURE InstallDeskMenu (menu: M_AES.tObjctree);
PROCEDURE ReleaseDeskMenu;
PROCEDURE DisableDeskMenu;
PROCEDURE EnableDeskMenu;

END M_Menus.

