(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Process;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM SYSTEM     IMPORT  ADDRESS, NEWPROCESS, TRANSFER, TSIZE;
FROM Storage    IMPORT  ALLOCATE, DEALLOCATE;

TYPE    SIGNAL =        POINTER TO PROCESS;
        PROCESS =       RECORD
                         next:  SIGNAL;
                         queue: SIGNAL;
                         core:  ADDRESS;
                         ready: BOOLEAN;
                        END;

VAR     currProcess:    SIGNAL;

PROCEDURE StartProcess (p: PROC; n: LONGCARD);
VAR s0: SIGNAL;
    workSpace: ADDRESS;
BEGIN
 s0:= currProcess;
 ALLOCATE (workSpace,  n);  
 ALLOCATE (currProcess,  TSIZE (PROCESS));  
 WITH currProcess^ DO
  next:= s0^.next;
  s0^.next:= currProcess;
  ready:= TRUE;
  queue:= NIL;
 END;
 NEWPROCESS (p, workSpace, n, currProcess^.core); 
 TRANSFER (s0^.core, currProcess^.core);
END StartProcess;

PROCEDURE SEND (VAR s: SIGNAL);
VAR s0: SIGNAL;
BEGIN
 IF s # NIL THEN
  s0:= currProcess;  currProcess:= s;
  WITH currProcess^ DO
   s:= queue;  ready:= TRUE;  queue:= NIL;
  END;
  TRANSFER (s0^.core, currProcess^.core);
 END;
END SEND;

PROCEDURE WAIT (VAR s: SIGNAL);
(* fuege currProcess in die Schlange (queue) ein *)
VAR s0, s1: SIGNAL;
BEGIN
 IF s = NIL THEN
  s:= currProcess;
 ELSE
  s0:= s;  s1:= s0^.queue;
  WHILE s1 # NIL DO  s0:= s1;  s1:= s0^.queue;  END;
  s0^.queue:= currProcess;
 END;
 s0:= currProcess;
 REPEAT
  currProcess:= currProcess^.next;
 UNTIL currProcess^.ready;
 IF currProcess = s0 THEN  HALT;  END; (* Deadlock sollte nicht sein aber... *)
 s0^.ready:= FALSE;
 TRANSFER (s0^.core, currProcess^.core);
END WAIT;

PROCEDURE Awaited (s: SIGNAL): BOOLEAN;
BEGIN
 RETURN s # NIL;
END Awaited;

PROCEDURE InitSignal (VAR s: SIGNAL);
BEGIN
 s:= NIL;
END InitSignal;

BEGIN
 ALLOCATE (currProcess,  TSIZE (PROCESS));  
 WITH currProcess^ DO
  next:= currProcess;
  ready:= TRUE;
  queue:= NIL;
 END;
END M_Process.



