(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Random;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM SYSTEM IMPORT ADR, ADDRESS;
FROM M_Sys  IMPORT App, CallMagic;


PROCEDURE RandomInit (initial: SHORTCARD);
BEGIN
 App^.MagicPB^.IntIn[0]:= initial;  CallMagic (1801);
END RandomInit;

PROCEDURE Randomize;
BEGIN
 CallMagic (1800);
END Randomize;

PROCEDURE RndInt (max: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= max;
  CallMagic (1802);
  RETURN IntOut[0];
 END;
END RndInt;

PROCEDURE RndLInt (max: LONGINT): LONGINT;
BEGIN
 WITH App^.MagicPB^ DO
  LongIn[0]:= max;
  CallMagic (1803);
  RETURN LongOut[0];
 END;
END RndLInt;

PROCEDURE RndReal(): REAL;
VAR r1, r2, r3, r4: SHORTINT;
BEGIN
 r1:= RndInt (10000);
 r2:= RndInt (10000);
 r3:= RndInt (10000);
 r4:= RndInt (10000);
 RETURN  (VAL (REAL, r1) * 1.0E-16) +
         (VAL (REAL, r2) * 1.0E-12) +
         (VAL (REAL, r3) * 1.0E-08) +
         (VAL (REAL, r4) * 1.0E-04);
END RndReal;

END M_Random.

