(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Rsc;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)


FROM SYSTEM IMPORT ADDRESS, ADR;
FROM M_Sys  IMPORT App, CallMagic;

PROCEDURE LoadRsc (name: ARRAY OF CHAR; VAR rsc: RESOURCE): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (name);
  CallMagic (1900);
  rsc:= AddrOut[0];
 END;
 RETURN rsc <> NIL;
END LoadRsc;

PROCEDURE RelocRsc (address: ADDRESS; VAR rsc: RESOURCE): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= address;
  CallMagic (1901);
  rsc:= AddrOut[0];
 END;
 RETURN  rsc <> NIL;
END RelocRsc;

PROCEDURE FreeRsc (VAR rsc: RESOURCE);
BEGIN
 App^.MagicPB^.AddrIn[0]:= rsc;
 CallMagic (1902);
 rsc:= NIL;
END FreeRsc;

PROCEDURE GaddrRsc (rsc: RESOURCE; typ, item: SHORTINT): ADDRESS;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= rsc;
  IntIn[0]:= typ;
  IntIn[1]:= item;
  CallMagic (1904);
  RETURN AddrOut[0];
 END;
END GaddrRsc;

PROCEDURE SaddrRsc (rsc: RESOURCE; typ, item: SHORTINT; tree: ADDRESS);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= rsc;
  AddrIn[1]:= tree;
  IntIn[0]:= typ;
  IntIn[1]:= item;
 END;
 CallMagic (1905);
END SaddrRsc;

PROCEDURE ObfixRsc (rsc: RESOURCE; tree: ADDRESS; objc: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= rsc;
  AddrIn[1]:= tree;
  IntIn[0]:= objc;
 END;
 CallMagic (1906);
END ObfixRsc;

END M_Rsc.
