(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
IMPLEMENTATION MODULE M_Stacks;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM SYSTEM  IMPORT ADDRESS, ADR, TSIZE, LOC;

CONST   cMax =          07FFFH;

TYPE    INFO =          POINTER TO ARRAY [0..cMax] OF LOC;

TYPE    ENTRY =         POINTER TO Entry;
        Entry =         RECORD
                         addr: INFO;
                         size: SHORTINT;
                         next: ENTRY;
                        END;

TYPE    STACK =         POINTER TO Stack;
        Stack =         RECORD
                         start: ENTRY;
                         entry: LONGCARD;
                        END;

PROCEDURE Copy (from, to: INFO; size: SHORTCARD);
VAR c: SHORTCARD;
BEGIN
 FOR c:= 0 TO size DO to^[c]:= from^[c]; END;
END Copy;

PROCEDURE NewStack (VAR stack: STACK): BOOLEAN;
BEGIN
 ALLOCATE (stack, TSIZE(Stack));  
 IF stack = NIL THEN RETURN FALSE; END;
 stack^.start:= NIL;
 stack^.entry:= LONGCARD (0);
 RETURN TRUE;
END NewStack;

PROCEDURE DisposeStack (VAR stack: STACK);
VAR p: ENTRY;
BEGIN
 IF stack # NIL THEN
  WITH stack^ DO
   WHILE start # NIL DO
    p:= start^.next;
    DEALLOCATE (start^.addr, 0);  
    DEALLOCATE (start, 0);  
    start:= p;
   END;
  END;
  DEALLOCATE (stack, 0);  
 END;
 stack:= NIL;
END DisposeStack;

PROCEDURE StackEmpty (stack: STACK): BOOLEAN;
BEGIN
 IF stack = NIL THEN  RETURN TRUE;  END;
 RETURN stack^.start = NIL;
END StackEmpty;

PROCEDURE StackEntries (stack: STACK): LONGCARD;
BEGIN
 IF stack = NIL THEN  RETURN LONGCARD (0);
                ELSE  RETURN stack^.entry;
 END;
END StackEntries;

PROCEDURE Push (stack: STACK; info: ADDRESS; size: SHORTINT): BOOLEAN;
VAR p: ENTRY;
BEGIN
 IF stack = NIL THEN  RETURN FALSE;  END;
 ALLOCATE (p, TSIZE(Entry));
 IF p = NIL THEN  RETURN FALSE;  END;
 p^.size:= size;
 ALLOCATE (p^.addr,  VAL(LONGCARD, p^.size));
 IF p^.addr = NIL THEN  RETURN FALSE;  END;
 Copy (info, p^.addr, p^.size);
 p^.next:= stack^.start;
 stack^.start:= p;
 INC (stack^.entry);
 RETURN TRUE;
END Push;

PROCEDURE Pop (stack: STACK; info: ADDRESS; size: SHORTINT): BOOLEAN;
VAR p: ENTRY;
BEGIN
 IF stack = NIL THEN  RETURN FALSE;  END;
 WITH stack^ DO
  IF start = NIL THEN
   RETURN FALSE;
  ELSE
   IF size < start^.size THEN  RETURN FALSE;  END;
   Copy (start^.addr, info, start^.size);
   p:= start^.next;
   DEALLOCATE (start^.addr, 0);  
   DEALLOCATE (start, 0);  
   start:= p;
  END;
 END;
 DEC (stack^.entry);
 RETURN TRUE;
END Pop;

END M_Stacks.

