(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Strings;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)


FROM SYSTEM IMPORT ADR;
FROM M_Sys IMPORT App, CallMagic;

PROCEDURE StrLen (str: ARRAY OF CHAR): LONGINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(str);
  CallMagic (300);
  RETURN LongOut[0];
 END;
END StrLen;

PROCEDURE StrComp (str1, str2: ARRAY OF CHAR): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(str1);
  AddrIn[1]:= ADR(str2);
  CallMagic (301);
  RETURN IntOut[0];
 END;
END StrComp;

PROCEDURE StrLComp (str1, str2: ARRAY OF CHAR; maxLen: LONGINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(str1);
  AddrIn[1]:= ADR(str2);
  CallMagic (302);
  RETURN IntOut[0];
 END;
END StrLComp;

PROCEDURE StrPos (str1, str2: ARRAY OF CHAR): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(str1);
  AddrIn[1]:= ADR(str2);
  CallMagic (304);
  RETURN IntIn[0];
 END;
END StrPos;

PROCEDURE StrScan (str: ARRAY OF CHAR; c: CHAR): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(str);
  IntIn[0]:= ORD (c);
  CallMagic (305);
  RETURN IntOut[0];
 END;
END StrScan;

PROCEDURE StrIPos (str1, str2: ARRAY OF CHAR; start: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(str1);
  AddrIn[1]:= ADR(str2);
  CallMagic (306);
  RETURN IntOut[0];
 END;
END StrIPos;

PROCEDURE StrWPos (str1, str2: ARRAY OF CHAR; start: SHORTINT; wild, joker: CHAR): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(str1);
  AddrIn[1]:= ADR(str2);
  IntIn[0]:= start;
  IntIn[1]:= ORD (wild);
  IntIn[2]:= ORD (joker);
  CallMagic (307);
  RETURN IntOut[0];
 END;
END StrWPos;

PROCEDURE StrCopy (VAR dest: ARRAY OF CHAR; source: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(dest);
  AddrIn[1]:= ADR(source);
 END;
 CallMagic (308);
END StrCopy;

PROCEDURE StrLCopy (VAR dest: ARRAY OF CHAR; source: ARRAY OF CHAR; maxlen: LONGINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(dest);
  AddrIn[1]:= ADR(source);
  LongIn[0]:= maxlen;
 END;
 CallMagic (309);
END StrLCopy;

PROCEDURE StrCat (VAR dest: ARRAY OF CHAR; source: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(dest);
  AddrIn[1]:= ADR(source);
 END;
 CallMagic (311);
END StrCat;

PROCEDURE StrLCat   (VAR dest: ARRAY OF CHAR; source: ARRAY OF CHAR; maxLen: LONGINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(dest);
  AddrIn[1]:= ADR(source);
  LongIn[0]:= maxLen;
 END;
 CallMagic (312);
END StrLCat;

PROCEDURE StrInsert (str1: ARRAY OF CHAR; VAR str2: ARRAY OF CHAR; start: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(str1);
  AddrIn[1]:= ADR(str2);
  IntIn[0]:= start;
 END;
 CallMagic (313);
END StrInsert;

PROCEDURE StrDelete (VAR str: ARRAY OF CHAR; start, len: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(str);
  IntIn[0]:= start;
  IntIn[1]:= len;
 END;
 CallMagic (314);
END StrDelete;

PROCEDURE StrUpper (VAR str: ARRAY OF CHAR);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADR(str);
 CallMagic (315);
END StrUpper;

PROCEDURE StrLower (VAR str: ARRAY OF CHAR);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADR(str);
 CallMagic (316);
END StrLower;

PROCEDURE StrMatch (str1, str2: ARRAY OF CHAR; wild, joker: CHAR): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR(str1);
  AddrIn[1]:= ADR(str2);
  IntIn[0]:= ORD (wild);
  IntIn[1]:= ORD (joker);
  CallMagic (317);
  RETURN IntOut[0] = 1;
 END;
END StrMatch;

PROCEDURE StrICopy (VAR dest: ARRAY OF CHAR; source: ARRAY OF CHAR;
                    start, len: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (dest);
  AddrIn[1]:= ADR (source);
  IntIn[0]:= start;
  IntIn[1]:= len;
 END;
 CallMagic (318);
END StrICopy;

END M_Strings.
