(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
DEFINITION MODULE M_Sys;

FROM Portab IMPORT tCompiler, Compiler;

FROM M_Types    IMPORT  KeyMap, tKey, tFKeys, PtrConfig, PtrApp,
                        LONGBITSET, PtrLINEA, PtrLINEAFonts,
                        PtrVDIESC, ByteSet;
FROM SYSTEM     IMPORT  ADDRESS, LOC, BYTE, WORD;

(*$?Compiler=Megamax:
  FROM SYSTEM IMPORT LONGWORD;
 *)
(*$?Compiler=Haenisch:
  FROM SYSTEM IMPORT LONG;
 *)

PROCEDURE SetKeymap (map: KeyMap);
PROCEDURE InitKeymap (VAR map: KeyMap);
PROCEDURE ResetKeymap;
PROCEDURE UseDeadkeys (doit: BOOLEAN);
PROCEDURE MapNumblock (doit: BOOLEAN);
PROCEDURE ScanToKey (scan, chr: SHORTINT; status: BITSET; 
                     VAR key: tKey; VAR ch: CHAR);
PROCEDURE KeyToScan (key: tKey; VAR scan: SHORTINT; VAR kbshift: BITSET);
PROCEDURE KeyToChar (key: tKey): CHAR;
PROCEDURE CharToKey (ch: CHAR): tKey;
PROCEDURE UpperCase (lower: tKey): tKey;
PROCEDURE LowerCase (upper: tKey): tKey;
PROCEDURE SetDeadKeys (keys: BITSET);
PROCEDURE SetConfigflag (flag: SHORTCARD; doset: BOOLEAN);
PROCEDURE InConfig (flag: SHORTCARD): BOOLEAN;
PROCEDURE SetDefaultkey (name: tFKeys; val: tKey);
PROCEDURE Defaultkey (name: tFKeys): tKey;
PROCEDURE GetDeads (VAR keys: BITSET);
PROCEDURE SetDeads (keys: BITSET);
PROCEDURE ConfigPtr(): PtrConfig;
PROCEDURE MagicVersion (VAR version, revision: SHORTINT);
PROCEDURE MagicVerString (VAR version: ARRAY OF CHAR);

VAR App: PtrApp;

PROCEDURE InitMagic;
PROCEDURE ExitMagic;
PROCEDURE ProgName (name: ARRAY OF CHAR);
PROCEDURE Min (i1, i2: SHORTINT): SHORTINT;
PROCEDURE Max (i1, i2: SHORTINT): SHORTINT;
PROCEDURE ByteToByteset (value: BYTE; VAR bset: ByteSet);
PROCEDURE ByteToBitset  (value: BYTE; VAR bset: BITSET);
PROCEDURE ByteToLBitset (value: BYTE; VAR bset: LONGBITSET);
PROCEDURE WordToByteset (value: SHORTCARD; VAR bset: ByteSet);
PROCEDURE WordToBitset  (value: SHORTCARD; VAR bset: BITSET);
PROCEDURE WordToLBitset (value: SHORTCARD; VAR bset: LONGBITSET);
PROCEDURE LongToByteset (value: LONGCARD; VAR bset: ByteSet);
PROCEDURE LongToBitset  (value: LONGCARD; VAR bset: BITSET);
PROCEDURE LongToLBitset (value: LONGCARD; VAR bset: LONGBITSET);
PROCEDURE CastToChar    (value: ARRAY OF LOC): CHAR;
PROCEDURE CastToByte    (value: ARRAY OF LOC): BYTE;
PROCEDURE CastToByteset (value: ARRAY OF LOC): ByteSet;
PROCEDURE CastToInt     (value: ARRAY OF LOC): SHORTINT;
PROCEDURE CastToCard    (value: ARRAY OF LOC): SHORTCARD;
PROCEDURE CastToBitset  (value: ARRAY OF LOC): BITSET;
PROCEDURE CastToWord    (value: ARRAY OF LOC): WORD;
PROCEDURE CastToLInt    (value: ARRAY OF LOC): LONGINT;
PROCEDURE CastToLCard   (value: ARRAY OF LOC): LONGCARD;
PROCEDURE CastToLBitset (value: ARRAY OF LOC): LONGBITSET;
PROCEDURE CastToLWord   (value: ARRAY OF LOC)(*$?Compiler=Haenisch: : LONG; *) (*$?Compiler=Megamax: : LONGWORD; *)
PROCEDURE CastToAddr    (value: ARRAY OF LOC): ADDRESS;
PROCEDURE Hi (value: SHORTCARD): SHORTCARD;
PROCEDURE Lo (value: SHORTCARD): SHORTCARD;
PROCEDURE FillChar (VAR value: ARRAY OF LOC; size: SHORTCARD; b: BYTE);
PROCEDURE Move (VAR source, dest: ARRAY OF LOC; size: SHORTCARD);
PROCEDURE BootDevice (): SHORTINT;
PROCEDURE BasepagePtr (): ADDRESS;
PROCEDURE Accessory (): BOOLEAN;
PROCEDURE SysHeader (): ADDRESS;
PROCEDURE TosVersion (): SHORTCARD;
PROCEDURE TosDate (): SHORTCARD;
PROCEDURE Terminate (return: SHORTINT);
PROCEDURE CallGEM (func: SHORTINT; parablock: ADDRESS);
PROCEDURE VqGdos (): LONGINT;
PROCEDURE LineA (): PtrLINEA;
PROCEDURE LineAFonts(): PtrLINEAFonts;
PROCEDURE Vdiesc (): PtrVDIESC;
PROCEDURE CallMagic (func: SHORTINT);

END M_Sys.

