IMPLEMENTATION MODULE M_Sys;

FROM Portab IMPORT tCompiler, Compiler;

(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

IMPORT SYSTEM, M_DOS, M_Types, M_Cookie, M_BitOps, M_XBIOS;
(*$?Compiler=Haenisch:
  IMPORT TOS;
  FROM SYSTEM IMPORT CODE;
  IMPORT System;
 *)
(*$?Compiler=Megamax:  IMPORT PrgCtrl; (*, MOSCtrl;*) *)

CONST MagicNeeded = 0408H; (* diese Versionsnummer sollte Magic mindestens haben *)

TYPE  ErrArray = ARRAY [0..8], [0..50] OF CHAR;

CONST FatalErrors = ErrArray
        (* 0 *)      {'[3][|MAGIC: Fataler Fehler!| |'+0C,
        (* 1 *)       '|Programmausfhrung unmglich!][ OHA!!! ]'+0C,
        (* 2 *)       'Magic nicht gefunden!'+0C,
        (* 3 *)       'Magic nicht installiert!'+0C,
        (* 4 *)       'Magic-Version veraltet!'+0C,
        (* 5 *)       'Cookie nicht installiert!'+0C,
        (* 6 *)       'GEMDOS-Ausfhrungsfehler!'+0C,
        (* 7 *)       'nicht gengend Speicher!'+0C,
        (* 7 *)       'Unbekannter Fehler!'+0C
                     };

TYPE PtrXApp =          POINTER TO XApplication;
     XApplication =     RECORD
                         app:        M_Types.Application;
                         AESGlobal:  M_Types.tAESGLOBAL;
                         AESControl: M_Types.tControl;
                         AESIntIn:   M_Types.tIntIn;
                         AESIntOut:  M_Types.tIntOut;
                         AESAddrin:  M_Types.tAddrIn;
                         AESAddrout: M_Types.tAddrOut;
                         VDIControl: M_Types.tVDICtrlArray;
                         VDIIntIn:   M_Types.tCtrlArray;
                         VDIIntOut:  M_Types.tCtrlArray;
                         VDIPtsin:   M_Types.tCtrlArray;
                         VDIPtsout:  M_Types.tCtrlArray;
                         Handler:    M_Types.tHandlerList;
                         DStack:     M_Types.DialStack;
                         ValTable:   M_Types.AppValues;
                         Prgname:    M_Types.CSTRING;
                         MagicPB:    M_Types.MagicParablock;
                         AESPB:      M_Types.AESParablock;
                         VDIPB:      M_Types.VDIParablock;
                         Ep:         M_Types.EventParameter;
                        END;

VAR MagicPath:       M_Types.PtrCSTRING;
    xapp:            PtrXApp;


VAR cast:       RECORD
                 CASE : SHORTINT OF
                  0: lint: LONGCARD;|
                  1: hw, lw: SHORTCARD;|
                  2: b1, b2, b3, b4: SYSTEM.BYTE;|
                  3: lset: M_Types.LONGBITSET;|
                  4: hs, ls: BITSET;|
                  5: s1, s2, s3, s4: M_Types.ByteSet;|
                 END;
                END;

VAR cast2:     RECORD
                 CASE : SHORTCARD OF
                  0:  hi:   SYSTEM.LOC;
                      lo:   SYSTEM.LOC;|
                  1:  int:  SHORTINT;|
                  2:  card: SHORTCARD;|
                  3:  set:  BITSET;|
                  4:  wrd:  SYSTEM.WORD;|
                 END;
                END;

VAR cast4:     RECORD
                 CASE : SHORTCARD OF
                  0:  b1:  SYSTEM.LOC;
                      b2:  SYSTEM.LOC;
                      b3:  SYSTEM.LOC;
                      b4:  SYSTEM.LOC;|
                  1:  int: LONGINT;|
                  2:  crd: LONGCARD;|
                  3:  set: M_Types.LONGBITSET;|
                  (*$?Compiler=Haenisch:
                    4:  wrd: SYSTEM.LONG;|
                   *)
                  (*$?Compiler=Megamax:
                    4:  wrd: SYSTEM.LONGWORD;|
                   *)
                  5:  adr: SYSTEM.ADDRESS;|
                 END;
                END;

VAR base:       M_Types.PtrPD;
    sys:        M_Types.PtrSYSHDR;
    acc:        BOOLEAN;
    boot:       SHORTINT;
    language:   SHORTINT;
    MagicBase:  LONGINT;
    li:         LONGINT;

VAR ActConfig:  M_Types.PtrConfig;
    MyCookie:   M_Types.TheConfig;
    _magic, _mint, _magx: M_Cookie.Anytype;
    MintIsDa: BOOLEAN;



PROCEDURE RunMagic (): LONGINT;
BEGIN
(*$?Compiler=Haenisch:
  SYSTEM.LOAD(MagicBase, 0);
(*\ONYX v2.01  02.06.94 10:14*)(*$D-*)
(*36 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F3CH,00000H,00000H);
CODE(02F00H);
CODE(02F3CH,00000H,00000H);
CODE(03F3CH,00004H);
CODE(03F3CH,0004BH);
CODE(04E41H);
CODE(04FEFH,00010H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  #0,-(SP)
  MOVE.L  D0,-(SP)
  MOVE.L  #$0,-(SP)
  MOVE.W  #$4,-(SP)
  MOVE.W  #$4B,-(SP)
  TRAP    #1
  LEA     $10(SP),SP
  MOVEM.L (SP)+,D2/A2
 \*)
  SYSTEM.STORE(0, li);
 *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.L  #0,-(SP)
  MOVE.L  MagicBase,-(SP)
  MOVE.L  #$0,-(SP)
  MOVE.W  #$4,-(SP)
  MOVE.W  #$4B,-(SP)
  TRAP    #1
  LEA     $10(SP),SP
  MOVE.L  D0,li
 END;
 *)
 RETURN li;
END RunMagic;

PROCEDURE Halt (return: SHORTCARD);
BEGIN

(*$?Compiler=Haenisch:
(*\ONYX v2.01  02.06.94 10:14*)(*$D-*)
(*10 bytes of MC68000 code*)
CODE(03F2EH,00008H);
CODE(03F3CH,0004CH);
CODE(04E41H);
(*$D=*)
(*\=
  MOVE.W  8(a6), -(SP)
  MOVE.W  #76, -(SP)
  TRAP    #1
 \*)
 *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  return(A6), -(SP)
  MOVE.W  #76, -(SP)
  TRAP    #1
 END;
 *)
END Halt;

PROCEDURE CallGEM (function: SHORTINT; parablock: SYSTEM.ADDRESS);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  02.06.94 10:14*)(*$D-*)
(*18 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(0302EH,00008H);
CODE(0222EH,0000AH);
CODE(04E42H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), D0
  MOVE.L  10(A6), D1
  TRAP    #2
  MOVEM.L (SP)+,D2/A2
 \*)
 *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.W  function(A6), D0
  MOVE.L  parablock(A6), D1
  TRAP    #2
 END;
 *)
END CallGEM;

PROCEDURE VqGdos (): LONGINT;
VAR x: LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  02.06.94 10:14*)(*$D-*)
(*16 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(0203CH,0FFFFH,0FFFEH);
CODE(04E42H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  #-2, D0
  TRAP    #2
  MOVEM.L (SP)+,D2/A2
 \*)
 SYSTEM.STORE(0, x);
 *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  MOVE.L  #-2, D0
  TRAP    #2
  MOVE.L  D0, x(A6)
 END;
 *)
 RETURN x;
END VqGdos;

PROCEDURE Min (i1, i2: SHORTINT): SHORTINT;
BEGIN
 IF i1 < i2 THEN  RETURN i1  ELSE  RETURN i2;  END;
END Min;

PROCEDURE Max (i1, i2: SHORTINT): SHORTINT;
BEGIN
 IF i1 < i2 THEN  RETURN i2  ELSE  RETURN i1;  END;
END Max;

PROCEDURE CastToChar ((* REF *)  value: ARRAY OF SYSTEM.LOC): CHAR;
BEGIN
 RETURN CHAR (value[HIGH (value)]);  
END CastToChar;

PROCEDURE CastToByte ((* REF *)  value: ARRAY OF SYSTEM.LOC): SYSTEM.BYTE;
BEGIN
 RETURN SYSTEM.BYTE (value[HIGH (value)]);
END CastToByte;

PROCEDURE CastToByteset ((* REF *)  value: ARRAY OF SYSTEM.LOC): M_Types.ByteSet;
BEGIN
 RETURN M_Types.ByteSet (value[HIGH (value)]);
END CastToByteset;

PROCEDURE CastToInt ((* REF *)  value: ARRAY OF SYSTEM.LOC): SHORTINT;
BEGIN
 IF HIGH (value) = 0 THEN
  cast2.int:= 0;  cast2.lo:= value[0];
 ELSE
  cast2.hi:= value[HIGH (value)-1];  cast2.lo:= value[HIGH (value)];
 END;
 RETURN cast2.int;
END CastToInt;

PROCEDURE CastToCard ((* REF *)  value: ARRAY OF SYSTEM.LOC): SHORTCARD;
BEGIN
 IF HIGH (value) = 0 THEN
  cast2.card:= 0;  cast2.lo:= value[0];
 ELSE
  cast2.hi:= value[HIGH (value)-1];  cast2.lo:= value[HIGH (value)];
 END;
 RETURN cast2.card;
END CastToCard;

PROCEDURE CastToBitset ((* REF *)  value: ARRAY OF SYSTEM.LOC): BITSET;
BEGIN
 IF HIGH (value) = 0 THEN
  cast2.set:= {};
  cast2.lo:= value[0];
 ELSE
  cast2.hi:= value[HIGH (value)-1];
  cast2.lo:= value[HIGH (value)];
 END;
 RETURN cast2.set;
END CastToBitset;

PROCEDURE CastToWord ((* REF *)   value: ARRAY OF SYSTEM.LOC): SYSTEM.WORD;
BEGIN
 IF HIGH (value) = 0 THEN
  cast2.int:= 0;
  cast2.lo:= value[0];
 ELSE
  cast2.hi:= value[HIGH (value)-1];
  cast2.lo:= value[HIGH (value)];
 END;
 RETURN cast2.wrd;
END CastToWord;

PROCEDURE CastToLInt ((* REF *)   value: ARRAY OF SYSTEM.LOC): LONGINT;
BEGIN
 CASE HIGH (value) OF
  0:    cast4.int:= 0H;
        cast4.b4:= value[0];
        |
  1:    cast4.int:= 0H;
        cast4.b3:= value[HIGH (value)-1];
        cast4.b4:= value[HIGH (value)];
        |
  ELSE  cast4.b1:= value[HIGH (value)-3];
        cast4.b2:= value[HIGH (value)-2];
        cast4.b3:= value[HIGH (value)-1];
        cast4.b4:= value[HIGH (value)];
 END;
 RETURN cast4.int;
END CastToLInt;

PROCEDURE CastToLCard ((* REF *)  value: ARRAY OF SYSTEM.LOC): LONGCARD;
BEGIN
 CASE HIGH (value) OF
  0:    cast4.crd:= 0H;
        cast4.b4:= value[0];
        |
  1:    cast4.crd:= 0H;
        cast4.b3:= value[HIGH (value)-1];
        cast4.b4:= value[HIGH (value)];
        |
  ELSE  cast4.b1:= value[HIGH (value)-3];
        cast4.b2:= value[HIGH (value)-2];
        cast4.b3:= value[HIGH (value)-1];
        cast4.b4:= value[HIGH (value)];
 END;
 RETURN cast4.crd;
END CastToLCard;

PROCEDURE CastToLBitset ((* REF *)  value: ARRAY OF SYSTEM.LOC): M_Types.LONGBITSET;
BEGIN
 CASE HIGH (value) OF
  0:    cast4.int:= 0H;
        cast4.b4:= value[0];
        |
  1:    cast4.int:= 0H;
        cast4.b3:= value[HIGH (value)-1];
        cast4.b4:= value[HIGH (value)];
        |
  ELSE  cast4.b1:= value[HIGH (value)-3];
        cast4.b2:= value[HIGH (value)-2];
        cast4.b3:= value[HIGH (value)-1];
        cast4.b4:= value[HIGH (value)];
 END;
 RETURN cast4.set;
END CastToLBitset;

PROCEDURE CastToLWord ((* REF *)  value: ARRAY OF SYSTEM.LOC)
(*$?Compiler=Haenisch:         : SYSTEM.LONG; *)
(*$?Compiler=Megamax:         : SYSTEM.LONGWORD; *)

BEGIN
 CASE HIGH (value) OF
  0:    cast4.crd:= 0;
        cast4.b4:= value[0];
        |
  1:    cast4.crd:= 0;
        cast4.b3:= value[HIGH (value)-1];
        cast4.b4:= value[HIGH (value)];
        |
  ELSE  cast4.b1:= value[HIGH (value)-3];
        cast4.b2:= value[HIGH (value)-2];
        cast4.b3:= value[HIGH (value)-1];
        cast4.b4:= value[HIGH (value)];
 END;
 RETURN cast4.wrd;
END CastToLWord;

PROCEDURE CastToAddr ((* REF *)  value: ARRAY OF SYSTEM.LOC): SYSTEM.ADDRESS;
BEGIN
 CASE HIGH (value) OF
  0:    cast4.crd:= 0H;
        cast4.b4:= value[0];
        |
  1:    cast4.crd:= 0H;
        cast4.b3:= value[HIGH (value)-1];
        cast4.b4:= value[HIGH (value)];
        |
  ELSE  cast4.b1:= value[HIGH (value)-3];
        cast4.b2:= value[HIGH (value)-2];
        cast4.b3:= value[HIGH (value)-1];
        cast4.b4:= value[HIGH (value)];
 END;
 RETURN cast4.adr;
END CastToAddr;

PROCEDURE Hi (value: SHORTCARD): SHORTCARD;
BEGIN
 cast2.card:= value;  
 cast2.lo:= cast2.hi;
 cast2.hi := SYSTEM.LOC(0);
 RETURN cast2.card;
END Hi;
 
PROCEDURE Lo (value: SHORTCARD): SHORTCARD;
BEGIN
 cast2.card:= value;
 cast2.hi:= SYSTEM.LOC(0);
 RETURN cast2.card;
END Lo;

PROCEDURE FillChar (VAR value: ARRAY OF SYSTEM.LOC; size: SHORTCARD; b: SYSTEM.BYTE);
VAR i: SHORTCARD;
BEGIN
 IF size > HIGH (value) THEN  size:= HIGH (value);  END;
 i:= 0;  WHILE (i < size) DO  value[i]:= SYSTEM.LOC (b);  INC (i); END;
END FillChar;

PROCEDURE Move (VAR source, dest: ARRAY OF SYSTEM.LOC; size: SHORTCARD);
VAR i: SHORTCARD;
BEGIN
 IF size > HIGH (source) THEN  size:= HIGH (source);  END;
 IF size > HIGH (dest) THEN  size:= HIGH (dest);  END;
 i:= 0;  WHILE i < size DO  dest[i]:= source[i];  END;
END Move;

PROCEDURE ByteToByteset (value: SYSTEM.BYTE; VAR bset: M_Types.ByteSet);
BEGIN
 cast.lint:= 0;  cast.b4:= value;  bset := M_Types.ByteSet(cast.s4);
END ByteToByteset;

PROCEDURE ByteToBitset (value: SYSTEM.BYTE; VAR bset: BITSET);
BEGIN
 cast.lint:= 0;  cast.b4:= value;  bset:= cast.ls;
END ByteToBitset;

PROCEDURE ByteToLBitset (value: SYSTEM.BYTE; VAR bset: M_Types.LONGBITSET);
BEGIN
 cast.lint:= 0;  cast.b4:= value;  bset:= cast.lset;
END ByteToLBitset;

(* 16-Bit Casting *)

PROCEDURE WordToByteset (value: SHORTCARD; VAR bset: M_Types.ByteSet);
BEGIN
 cast.lint:= 0;  cast.lw:= value;  bset:= M_Types.ByteSet(cast.s4);
END WordToByteset;

PROCEDURE WordToBitset (value: SHORTCARD; VAR bset: BITSET);
BEGIN
 cast.lint:= 0;  cast.lw:= value;  bset:= cast.ls;
END WordToBitset;

PROCEDURE WordToLBitset (value: SHORTCARD; VAR bset: M_Types.LONGBITSET);
BEGIN
 cast.lint:= 0;  cast.lw:= value;  bset:= cast.lset;
END WordToLBitset;

(* 32-Bit Casting *)

PROCEDURE LongToByteset (value: LONGCARD; VAR bset: M_Types.ByteSet);
BEGIN
 cast.lint:= value;  bset:= M_Types.ByteSet(cast.s4);
END LongToByteset;

PROCEDURE LongToBitset (value: LONGCARD;VAR bset: BITSET);
BEGIN
 cast.lint:= value;  bset:= cast.ls;
END LongToBitset;

PROCEDURE LongToLBitset (value: LONGCARD; VAR bset: M_Types.LONGBITSET);
BEGIN
 cast.lint:= value;  bset:= cast.lset;
END LongToLBitset;

PROCEDURE  BytesetToByte (bset: M_Types.ByteSet): SYSTEM.BYTE;
BEGIN
 cast.s4:= bset;  RETURN cast.b4;
END BytesetToByte;

PROCEDURE  BitsetToByte  (bset: BITSET): SYSTEM.BYTE;
BEGIN
 cast.ls:= bset;  RETURN cast.b4;
END BitsetToByte;

PROCEDURE  LBitsetToByte (bset: M_Types.LONGBITSET): SYSTEM.BYTE;
BEGIN
 cast.lset:= bset;  RETURN cast.b4;
END LBitsetToByte;

PROCEDURE  BytesetToWord (bset: M_Types.ByteSet): SHORTCARD;
BEGIN
 cast.s4:= bset;  RETURN cast.lw;
END BytesetToWord;

PROCEDURE  BitsetToWord  (bset: BITSET): SHORTCARD;
BEGIN
 cast.ls:= bset;  RETURN cast.lw;
END BitsetToWord;

PROCEDURE  LBitsetToWord (bset: M_Types.LONGBITSET): SHORTCARD;
BEGIN
 cast.lset:= bset;  RETURN cast.lw;
END LBitsetToWord;

PROCEDURE BytesetToLong (bset: M_Types.ByteSet): LONGCARD;
BEGIN
 cast.s4:= bset;  RETURN cast.lint;
END BytesetToLong;

PROCEDURE  BitsetToLong (bset: BITSET): LONGCARD;
BEGIN
 cast.ls:= bset;  RETURN cast.lint;
END BitsetToLong;

PROCEDURE  LBitsetToLong (bset: M_Types.LONGBITSET): LONGCARD;
BEGIN
 cast.lset:= bset;  RETURN cast.lint;
END LBitsetToLong;

PROCEDURE BootDevice(): SHORTINT;
BEGIN
 RETURN boot;
END BootDevice;

PROCEDURE BasepagePtr(): SYSTEM.ADDRESS;
BEGIN
 (*$?Compiler=Haenisch:  base := SYSTEM.ADDRESS(TOS.BasePage); *)
 (*$?Compiler=Megamax:   PrgCtrl.GetBasePageAddr (base);  *)
 RETURN base;
END BasepagePtr;

PROCEDURE Accessory(): BOOLEAN;
BEGIN
 RETURN acc;
END Accessory;

PROCEDURE SysHeader(): SYSTEM.ADDRESS;
BEGIN
 RETURN sys;
END SysHeader;

PROCEDURE TosVersion(): SHORTCARD;
BEGIN   
 RETURN sys^.osVersion;
END TosVersion;

PROCEDURE TosDate(): SHORTCARD;
BEGIN
 RETURN sys^.osDosdate;
END TosDate;

PROCEDURE Terminate (return: SHORTINT);
VAR p: M_Types.PtrPD;
    b: BOOLEAN;
BEGIN
 IF MagicBase <> -1 THEN
  p:= SYSTEM.ADDRESS (MagicBase);
  b:= M_DOS.Mfree (NIL);
  b:= M_DOS.Mfree (p^.pEnv);
  b:= M_DOS.Mfree (p);
  ActConfig^.dispatcher:= 00000000H;
 END;
 (*$?Compiler=Haenisch:
  System.Abort(return);
  *)
 (*$?Compiler=Megamax:
  PrgCtrl.TermProcess (return);
  (*M_DOS.Pterm (return);*)
  *)
END Terminate;

VAR hdr[004F2H]: SYSTEM.ADDRESS;
    bdv[00446H]: SHORTINT;
    a:          SYSTEM.ADDRESS;

PROCEDURE GetSyshdr;
BEGIN
 sys:= hdr;
 M_BitOps.ShiftRight (sys^.osConf, language);
 boot:= bdv;
END GetSyshdr;

PROCEDURE LineA (): M_Types.PtrLINEA;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  02.06.94 10:14*)(*$D-*)
(*2 bytes of MC68000 code*)
CODE(0A000H);
(*$D=*)
(*\=
  DC.W    $A000;         LineA initialisieren
 \*)
 SYSTEM.STORE(0, a);
 *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  DC.W    $A000;         LineA initialisieren
  MOVE.L  D0, a
 END;
 *)
 RETURN a;
END LineA;

PROCEDURE LineAFonts (): M_Types.PtrLINEAFonts;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  02.06.94 10:14*)(*$D-*)
(*2 bytes of MC68000 code*)
CODE(0A000H);
(*$D=*)
(*\=
  DC.W    $A000;         LineA initialisieren
 \*)
 SYSTEM.STORE(8, a);
 *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  DC.W    0A000H;         LineA initialisieren
  MOVE.L  A1, a
 END;
 *)
 RETURN a;
END LineAFonts;

PROCEDURE Vdiesc (): M_Types.PtrVDIESC;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  02.06.94 10:14*)(*$D-*)
(*2 bytes of MC68000 code*)
CODE(0A000H);
(*$D=*)
(*\=
  DC.W    $A000;         LineA initialisieren
 \*)
 SYSTEM.STORE(0, a);
 *)
(*$?Compiler=Megamax:
 SYSTEM.ASSEMBLER
  DC.W    0A000H;         LineA initialisieren
  MOVE.L  D0, a
 END;
 *)
 RETURN a - SYSTEM.ADDRESS (038EH);
END Vdiesc;

PROCEDURE UseDeadkeys (doit: BOOLEAN);
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (doit);
 CallMagic (441);
END UseDeadkeys;

PROCEDURE MapNumblock (doit: BOOLEAN);
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (doit);
 CallMagic (442);
END MapNumblock;

PROCEDURE ScanToKey (scan, chr: SHORTINT; status: BITSET;
                     VAR key: M_Types.tKey; VAR ch: CHAR);
BEGIN
 App^.MagicPB^.IntIn[0]:= scan;
 App^.MagicPB^.IntIn[1]:= chr;
 App^.MagicPB^.IntIn[2]:= BitsetToWord (status);
 CallMagic (443);
 key:= VAL(M_Types.tKey, App^.MagicPB^.IntOut[0]);
 ch:= CHR (App^.MagicPB^.IntOut[1]);
END ScanToKey;

PROCEDURE UpperCase (lower: M_Types.tKey): M_Types.tKey;
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (lower);
 CallMagic (448);
 RETURN VAL(M_Types.tKey, App^.MagicPB^.IntOut[0]);
END UpperCase;

PROCEDURE LowerCase (upper: M_Types.tKey): M_Types.tKey;
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (upper);
 CallMagic (448);
 RETURN VAL(M_Types.tKey, App^.MagicPB^.IntOut[0]);
END LowerCase;

PROCEDURE KeyToScan (key: M_Types.tKey; VAR scan: SHORTINT; VAR kbshift: BITSET);
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (key);
 CallMagic (444);
 scan:= App^.MagicPB^.IntOut[0];
 WordToBitset (App^.MagicPB^.IntOut[1], kbshift);
END KeyToScan;

PROCEDURE KeyToChar (key: M_Types.tKey): CHAR;
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (key);
 CallMagic (445);
 RETURN CHR (App^.MagicPB^.IntOut[0]);
END KeyToChar;

PROCEDURE CharToKey (ch: CHAR): M_Types.tKey;
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (ch);
 CallMagic (446);
 RETURN VAL(M_Types.tKey, App^.MagicPB^.IntOut[0]);
END CharToKey;

PROCEDURE SetDeadKeys (keys: BITSET);
BEGIN
 App^.MagicPB^.IntIn[0]:= BitsetToWord (keys);
 CallMagic (449);
END SetDeadKeys;

PROCEDURE InitKeymap (VAR map: M_Types.KeyMap);
BEGIN
 App^.MagicPB^.AddrIn[0]:= SYSTEM.ADR(map);
 CallMagic (439);
END InitKeymap;

PROCEDURE SetKeymap (map: M_Types.KeyMap);
BEGIN
 App^.MagicPB^.AddrIn[0]:= SYSTEM.ADR(map);
 CallMagic (438);
END SetKeymap;

PROCEDURE ResetKeymap;
BEGIN
 CallMagic (440);
END ResetKeymap;

PROCEDURE ConfigPtr (): M_Types.PtrConfig;
VAR l: M_Cookie.Anytype;
BEGIN
 IF M_Cookie.FindCookie (M_Cookie.Magic, l) THEN
  RETURN l.ptr
 ELSE
  RETURN SYSTEM.ADR (MyCookie);
 END;
END ConfigPtr;

PROCEDURE SetConfigflag (flag: SHORTCARD; doset: BOOLEAN);
BEGIN
 ActConfig:= ConfigPtr ();
 IF doset THEN
  INCL (ActConfig^.flags, flag);
 ELSE
  EXCL (ActConfig^.flags, flag);
 END;
END SetConfigflag;

PROCEDURE InConfig (flag: SHORTCARD): BOOLEAN;
BEGIN
 ActConfig:= ConfigPtr ();
 RETURN flag IN ActConfig^.flags;
END InConfig;

PROCEDURE SetDefaultkey (name: M_Types.tFKeys; val: M_Types.tKey);
BEGIN
 ActConfig:= ConfigPtr ();
 ActConfig^.fkeytable^[name]:= ORD (val);
END SetDefaultkey;

PROCEDURE Defaultkey (name: M_Types.tFKeys): M_Types.tKey;
BEGIN
 ActConfig:= ConfigPtr ();
 RETURN VAL(M_Types.tKey, ActConfig^.fkeytable^[name]);
END Defaultkey;

PROCEDURE GetDeads (VAR keys: BITSET);
BEGIN
 ActConfig:= ConfigPtr ();
 keys:= ActConfig^.deadkeys;
END GetDeads;

PROCEDURE SetDeads (keys: BITSET);
BEGIN
 ActConfig:= ConfigPtr ();
 ActConfig^.deadkeys:= keys;
END SetDeads;

PROCEDURE MagicVersion (VAR version, revision: SHORTINT);
BEGIN
 CallMagic (3);
 version:= App^.MagicPB^.IntOut[0];
 revision:= App^.MagicPB^.IntOut[1];
END MagicVersion;

PROCEDURE MagicVerString (VAR version: ARRAY OF CHAR);
BEGIN
 App^.MagicPB^.AddrIn[0]:= SYSTEM.ADR (version);
 CallMagic (5);
END MagicVerString;

VAR d: SYSTEM.ADDRESS;

PROCEDURE CallMagic (func: SHORTINT);
VAR i: LONGINT;
(*$?Compiler=Haenisch:
  (*$K+ $R2+*)
  TYPE tCall = PROCEDURE (LONGINT, SYSTEM.ADDRESS);
  (*$K= $R2=*)
 *)
BEGIN
 REPEAT 
  IF ((ActConfig^.actapp = NIL) OR 
      (ActConfig^.actapp = App)) THEN
(*$?Compiler=Haenisch:  tCall(ActConfig^.dispatcher)(func, App); *)
(*$?Compiler=Megamax:   SYSTEM.CALLEXT (ActConfig^.dispatcher, LONG(func), App); *)
   RETURN;
  END;
  IF MintIsDa THEN  i:= M_DOS.Syield ();  END;
 UNTIL FALSE;
END CallMagic;

PROCEDURE appl_init;
BEGIN
 WITH App^.AESPB^ DO
  cbControl^.opcode:=     10;
  cbControl^.sizeIntIn:=   0;
  cbControl^.sizeIntOut:=  1;
  cbControl^.sizeAddrIn:=  0;
  cbControl^.sizeAddrOut:= 0;
 END;
 CallGEM (200, App^.AESPB);
END appl_init;

PROCEDURE appl_exit;
BEGIN
 WITH App^.AESPB^ DO
  cbControl^.opcode:=     19;
  cbControl^.sizeIntIn:=   0;
  cbControl^.sizeIntOut:=  1;
  cbControl^.sizeAddrIn:=  0;
  cbControl^.sizeAddrOut:= 0;
 END;
 CallGEM (200, App^.AESPB);
END appl_exit;


PROCEDURE FatalError (num, code: LONGINT);
VAR x: ARRAY [0..127] OF CHAR;
    i, l: SHORTINT;
    
 PROCEDURE CopyStr (n: SHORTINT);
 VAR j: SHORTINT;
 BEGIN
  j:= 0;
  WHILE FatalErrors[n, j] <> 0C DO
   x[i]:= FatalErrors[n, j];  INC (i);  INC (j);
  END; 
 END CopyStr; 

BEGIN
 FillChar (x, SIZE(x), 0C);
 i:= 0;
 CopyStr (0);
 CopyStr (VAL(SHORTINT, num));
 CopyStr (1);

 appl_init;

 (* form_alert *)
 WITH App^.AESPB^ DO
  cbPintin^[0]:= 1;
  cbPadrin^[0]:= SYSTEM.ADR (x);
  cbControl^.opcode:=     52;
  cbControl^.sizeIntIn:=   1;
  cbControl^.sizeIntOut:=  1;
  cbControl^.sizeAddrIn:=  1;
  cbControl^.sizeAddrOut:= 0;
 END;
 CallGEM (200, App^.AESPB);

 appl_exit;

 IF code <> 0 THEN Halt (VAL(SHORTINT, code)) ELSE Halt (0FFFFH) END;
END FatalError;

PROCEDURE ProgName (name: ARRAY OF CHAR);
VAR i: SHORTCARD;
BEGIN
 i:= 0;
 WHILE (name[i] <> 0C) AND (i < HIGH (name)) DO
  xapp^.Prgname[i]:= name[i];  INC (i);
 END;
END ProgName;

PROCEDURE InitAppStruct (xalloc: BOOLEAN);
VAR i: SHORTINT;
BEGIN
 App:= NIL;  xapp:= NIL;
 IF xalloc THEN
  (* Global, und TT-RAM, wenns mglich wre... *)
  xapp:= M_DOS.Mxalloc (SYSTEM.TSIZE (XApplication), 32 + 3)
 ELSE
  xapp:= M_DOS.Malloc  (SYSTEM.TSIZE (XApplication));
 END;

 IF xapp = NIL THEN  Halt (0FFFFH);  (* Speicherfehler *) END;

 (*FillChar (xapp^, SIZE (XApplication), 0C);*)

 (* die AES-Parameterblcke *)
 WITH xapp^.AESGlobal DO
   apVersion:=  0;
   apCount:=    0;
   apId:=       0;
   apPprivate:= 0;
   apPtree:=    00000000;
   apPmem:=     00000000;
   apLmem:=     0;
   apNplanes:=  0;
   Reserved1:=  0;
   Reserved2:=  0;
   apBvdisk:=   {};
   apBvhard:=   {};
 END;
 WITH xapp^.AESPB DO
   cbControl:= SYSTEM.ADR (xapp^.AESControl);
   cbPglobal:= SYSTEM.ADR (xapp^.AESGlobal);
   cbPintin:=  SYSTEM.ADR (xapp^.AESIntIn);
   cbPintout:= SYSTEM.ADR (xapp^.AESIntOut);
   cbPadrin:=  SYSTEM.ADR (xapp^.AESAddrin);
   cbPadrout:= SYSTEM.ADR (xapp^.AESAddrout);
 END;

 (* die VDI-Parameterblcke *)
 WITH xapp^.VDIPB DO
   control:=  SYSTEM.ADR (xapp^.VDIControl);
   intin:=    SYSTEM.ADR (xapp^.VDIIntIn);
   ptsin:=    SYSTEM.ADR (xapp^.VDIPtsin);
   intout:=   SYSTEM.ADR (xapp^.VDIIntOut);
   ptsout:=   SYSTEM.ADR (xapp^.VDIPtsout);
 END;

 (* die Eventhandler *)
 WITH xapp^.Handler DO
  max:= M_Types.MaxHandler;
  events:= {};
  disabled:= {};
  prioKeybd:= -1;
  prioButton:= -1;
  prioMesag:= -1;
  prioTimer:= -1;
  FillChar (xapp^.Handler.parablock, SIZE (parablock), 0C);
  FOR i:= 0 TO M_Types.MaxHandler DO
   keybd[i].used:= 0;
   button[i].used:= 0;
   mesag[i].used:= 0;
   moved[i].used:= 0;
   rects[i].used:= 0;
   timer[i].used:= 0;
  END;
 END;

 (* den Dialstack initialisieren *)
 xapp^.DStack.stackptr:= -1;
 xapp^.DStack.max:= M_Types.MaxDials;
 FOR i:= 0 TO M_Types.MaxDials DO xapp^.DStack.dials[i]:= NIL; END;
 xapp^.ValTable.values[0]:= MagicNeeded; (* Versionsnummer fr die Lib! *)

 xapp^.ValTable.max:= M_Types.MaxValues;
 FOR i:= 0 TO M_Types.MaxValues DO xapp^.ValTable.values[i]:= 0; END;

 WITH xapp^.app DO
  AESPB:=        SYSTEM.ADR (xapp^.AESPB);    (* AES-Parameter              *)
  VDIPB:=        SYSTEM.ADR (xapp^.VDIPB);    (* VDI-Parameter              *)
  MagicPB:=      SYSTEM.ADR (xapp^.MagicPB);  (* Magic-Parameter            *)
  Handler:=      SYSTEM.ADR (xapp^.Handler);  (* Eventhandler-Liste         *)
  Stack:=        SYSTEM.ADR (xapp^.DStack);   (* Stack fr modale Dialoge   *)
  Values:=       SYSTEM.ADR (xapp^.ValTable); (* ValueTable                 *)
  Name:=         SYSTEM.ADR (xapp^.Prgname);  (* Name des Programms         *)
  Ident:=        06D4D5048H;  (* Magic-ID *)
  errcode:=      0;
  wucount:=      0;
  flags:=        M_Types.LONGBITSET{M_Types.MapNblock};  (* Default *)
  Keyboard:=     NIL;
  Dials:=        NIL;
  Windows:=      NIL;
  TopWindow:=    NIL;
  TextWindow:=   NIL;
  TopTextwin:=   NIL;
  GraphWindow:=  NIL;
  TopGraphwin:=  NIL;
  Menus:=        NIL;
  MainMenu:=     NIL;
  Alert:=        NIL;
  Rsc:=          NIL;
  Popups:=       NIL;
  Workstations:= NIL;
  TermProc:=     NIL;
  Reserved1:=    NIL;
  Reserved2:=    NIL;
  Reserved3:=    NIL;
  Reserved4:=    NIL;
  Reserved5:=    NIL;
  Next:=         NIL;
 END;
 App:= SYSTEM.ADR (xapp^.app);
END InitAppStruct;

PROCEDURE RunKernel ((* REF *)  path: ARRAY OF CHAR);
VAR p, c: M_Types.CSTRING;
    i: SHORTINT;
    m: LONGINT;
    dta: M_DOS.DTA;
    old: M_DOS.PtrDTA;

 PROCEDURE Find ((* REF *)  x: ARRAY OF CHAR): SHORTINT;
 BEGIN
  RETURN M_DOS.Fsfirst (x, {0..15});
 END Find;

BEGIN
 c[0]:= 0C;
 IF path[0] = 0C THEN 
  (* Nach MAGIC.PRG im Root und im Ordner \MAGIC des Bootlaufwerks suchen *)
  old:= M_DOS.Fgetdta ();  M_DOS.Fsetdta  (SYSTEM.ADR (dta));
  p:= M_Types.MagicName + 0C;
  IF Find (p) <> 0 THEN
   p:= ' :\' + M_Types.MagicName + 0C;  p[0]:= CHR (boot + 65);
   IF Find (p) <> 0 THEN
    p:= ' :\MAGIC' + M_Types.MagicName + 0C;  p[0]:= CHR (boot + 65);
    IF Find (p) <> 0 THEN
     FatalError (2, 0);
    END;
   END;
  END;
  M_DOS.Fsetdta  (old);
 ELSE
  i:= 0;
  WHILE path[i] <> 0C DO  p[i]:= path[i];  INC (i);  END;
  p[i]:= 0C;
 END;

 IF p[0] <> 0C THEN
  IF MintIsDa THEN  (* MiNT ist da, Magic als Dmon starten! *)
   m:= M_DOS.Pexec (0, p, c, c);
   IF m < 0 THEN  FatalError (6, m); END;

  ELSIF M_Cookie.FindCookie (M_Cookie.MagX, _magx) THEN
   (* MagX ist da, Magic als Parallelprozess starten *)

   appl_init;
   (* shel_write *)
   WITH App^.AESPB^ DO
    cbPintin^[0]:= 1;
    cbPintin^[1]:= 1;
    cbPintin^[2]:= 100;
    cbPadrin^[0]:= SYSTEM.ADR (p);
    cbPadrin^[1]:= NIL;
    cbControl^.opcode:=      121;
    cbControl^.sizeIntIn:=   3;
    cbControl^.sizeIntOut:=  1;
    cbControl^.sizeAddrIn:=  2;
    cbControl^.sizeAddrOut:= 0;
   END;
   CallGEM (200, App^.AESPB);
   appl_exit;

   (* Auf Cookie warten *)
   REPEAT UNTIL M_Cookie.FindCookie (M_Cookie.Magic, _magic);
   ActConfig:= _magic.ptr;
   (* Ist der Dispatcher da? *)
   REPEAT UNTIL SYSTEM.ADDRESS (ActConfig^.dispatcher) <> 00000000;

  ELSE  (* Magic als Overlay-Programm starten *)
   MagicBase:= M_DOS.Pexec (3, p, c, c);
   (*RTD.ShowVar ('MagicBase:', MagicBase);*)
   IF MagicBase > 0 THEN
    m:= RunMagic ();
    IF m <> 0 THEN FatalError (8, m); END;
   ELSE
    FatalError (6, MagicBase);
   END;
  END;
 ELSE
  FatalError (2, 0);
 END;
END RunKernel;

PROCEDURE InitMagic;
VAR i, j, e: SHORTINT;
    m, cl: LONGINT;
    a: SYSTEM.ADDRESS;
BEGIN
 MintIsDa:= M_Cookie.FindCookie (M_Cookie.MiNT, _mint);
 InitAppStruct (MintIsDa);
 IF M_Cookie.FindCookie (M_Cookie.Magic, _magic) THEN
  ActConfig:= _magic.ptr;
  IF SYSTEM.ADDRESS (ActConfig^.dispatcher) = 00000000 THEN
   (* Kein Dispatcher?  Magic luft wohl noch nicht... *)
   RunKernel (ActConfig^.path^);
   IF SYSTEM.ADDRESS (ActConfig^.dispatcher) = 00000000 THEN FatalError (3, 0); END;
   IF ActConfig^.version < MagicNeeded THEN  FatalError (4, 0);  END;
  END;
 ELSE (* Kein Cookie... *)
  RunKernel (0C+0C);
  IF M_Cookie.FindCookie (M_Cookie.Magic, _magic) THEN
   ActConfig:= _magic.ptr;
   IF ActConfig^.version < MagicNeeded THEN  FatalError (4, 0);  END;
  ELSE
   FatalError (3, 0);
  END;
 END;
END InitMagic;

PROCEDURE ExitMagic;
BEGIN
 CallMagic (2);
END ExitMagic;

VAR stack: SYSTEM.ADDRESS;

BEGIN
 MagicBase:= -1;
 (*$?Compiler=Haenisch:  base := SYSTEM.ADDRESS(TOS.BasePage); *)
 (*$?Compiler=Megamax:   PrgCtrl.GetBasePageAddr (base);  *)
 stack:= 0;  M_DOS.Super (stack);  GetSyshdr;  M_DOS.Super (stack);
 acc:= (base^.pParent = SYSTEM.ADDRESS (00000000));
 InitMagic;
END M_Sys.
