(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
DEFINITION MODULE M_Terminal;

IMPORT SYSTEM, M_Types, M_Windows, M_AES;

CONST Invers = M_Types.Bit7;  (* Zustzliches Flag fr Text-Effekte.
                               * Wird in M_Terminal emuliert!
                               *)

PROCEDURE OpenTextwindow (draw: M_Windows.WindowHandler;
                          element: BITSET; 
                          extended: BITSET; 
                          x, y, w, h: SHORTINT;
                          xo, yo, wo, ho: SHORTINT;
                          bcolor, fcolor: SHORTINT;
                          font, size: SHORTINT;
                          effects: BITSET;
                          wrappos: SHORTINT;
                          name, info: ARRAY OF CHAR;
                          rsc: M_AES.tObjctree): SHORTINT;
PROCEDURE CloseTextwindow (win: SHORTINT);
PROCEDURE WriteChar (win: SHORTINT; ch: CHAR);
PROCEDURE WriteLine (win: SHORTINT; str: ARRAY OF CHAR);
PROCEDURE WriteLn (win: SHORTINT);
PROCEDURE WriteInt  (win, val, len: SHORTINT);
PROCEDURE WriteWord (win: SHORTINT; val: SHORTCARD; len: SHORTINT);
PROCEDURE WriteLInt (win: SHORTINT; val: LONGINT; len: SHORTINT);
PROCEDURE WriteReal (win: SHORTINT; val: REAL; len: SHORTINT);
PROCEDURE GetChar (win, x, y: SHORTINT): CHAR;
PROCEDURE GetLine (win, line: SHORTINT; VAR strng: ARRAY OF CHAR);
PROCEDURE WindowInfo (win: SHORTINT; VAR column, lines, font: SHORTINT);
PROCEDURE CalcRedraw (win: SHORTINT; rect: M_Types.tRect; VAR von, bis: SHORTINT);
PROCEDURE InsertLine (win: SHORTINT);
PROCEDURE DeleteLine (win: SHORTINT);
PROCEDURE WhereXY (win: SHORTINT; VAR spalte, zeile: SHORTINT);
PROCEDURE GotoXY (win, spalte, zeile: SHORTINT);
PROCEDURE CursorOn  (win: SHORTINT);
PROCEDURE CursorOff (win: SHORTINT);
PROCEDURE WrapPos (win, pos: SHORTINT);
PROCEDURE WrapOff (win: SHORTINT);
PROCEDURE WrapOn  (win: SHORTINT);
PROCEDURE ClearLine (win: SHORTINT);
PROCEDURE ClearStartOfLine (win: SHORTINT);
PROCEDURE ClearEndOfLine (win: SHORTINT);
PROCEDURE ClearScreen (win: SHORTINT);
PROCEDURE ClearStartOfScreen (win: SHORTINT);
PROCEDURE ClearEndOfScreen (win: SHORTINT);
PROCEDURE ForegroundColor (win, color: SHORTINT);
PROCEDURE BackgroundColor (win, color: SHORTINT);
PROCEDURE InversOn  (win: SHORTINT);
PROCEDURE InversOff (win: SHORTINT);
PROCEDURE SetAttribut (win: SHORTINT; attrib: BITSET);
PROCEDURE SetTabspace (win, tab: SHORTINT);
PROCEDURE ChangeFont (win, font, size, color: SHORTINT; attrib: BITSET);
PROCEDURE FontSelector (msg: ARRAY OF CHAR; flags: BITSET);
PROCEDURE TopTerminal(): SHORTINT;

END M_Terminal.

