(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Terminal;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM SYSTEM IMPORT ADR, ADDRESS, BYTE, STORE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM M_Sys  IMPORT App, CallMagic, CastToInt;
FROM M_Windows IMPORT PtrWinpara, WindowHandler;
IMPORT M_Types, M_Convert, M_AES;

(*$?Compiler=Megamax:
 IMPORT Calls, MOSGlobals;

TYPE    PtrWH =         POINTER TO WH;
        WH =            RECORD
                         window:  SHORTINT;
                         handler: WindowHandler;
                         next:    PtrWH;
                        END;

VAR     whlist:         PtrWH;
        p, q:           PtrWH;
        mem:            MOSGlobals.MemArea;
        stack:          ARRAY [0..M_Types.Stacksize-1] OF BYTE;
        caller:         ADDRESS;

  (*$R-*)
  (*$S-*)
  PROCEDURE mm2 (VAR regs: Calls.Registers);
  VAR a: PtrWinpara;
  BEGIN
   a:= regs.regA0.ad;
   p:= whlist;
   WHILE p <> NIL DO
    IF p^.window = a^.window THEN  p^.handler (a);  RETURN;  END;
    p:= p^.next;
   END;
  END mm2;
  (*$S=*)
  (*$R=*)
 *)

PROCEDURE OpenTextwindow (draw: WindowHandler;
                         element: BITSET; 
                         extended: BITSET; 
                         x, y, w, h: SHORTINT;
                         xo, yo, wo, ho: SHORTINT;
                         bcolor, fcolor: SHORTINT;
                         font, size: SHORTINT;
                         effects: BITSET;
                         wrappos: SHORTINT;
                         name, info: ARRAY OF CHAR;
                         rsc: M_AES.tObjctree): SHORTINT;
VAR i: SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
(*$?Compiler=Haenisch:
  AddrIn[ 0]:= ADDRESS(draw);
 *)
(*$?Compiler=Megamax:
 NEW (q);  IF q = NIL THEN  RETURN -1;  END;
 q^.handler:= draw;
 q^.next:= whlist;
  AddrIn[ 0]:= caller;
 *)
  AddrIn[ 1]:= ADR (name);
  AddrIn[ 2]:= ADR (info);
  AddrIn[ 3]:= rsc;
  IntIn[ 0]:= CastToInt (element);
  IntIn[ 1]:= x;
  IntIn[ 2]:= y;
  IntIn[ 3]:= w;
  IntIn[ 4]:= h;
  IntIn[ 5]:= xo;
  IntIn[ 6]:= yo;
  IntIn[ 7]:= wo;
  IntIn[ 8]:= ho;
  IntIn[ 9]:= bcolor;
  IntIn[10]:= fcolor;
  IntIn[11]:= font;
  IntIn[12]:= size;
  IntIn[13]:= CastToInt (effects);
  IntIn[14]:= wrappos;
  IntIn[15]:= CastToInt (extended);
  CallMagic (2000);
  i:= IntOut[0];
 END;
(*$?Compiler=Megamax:
 q^.window:= i;
 whlist:= q;
 *)
 RETURN i;
END OpenTextwindow;
  
PROCEDURE CloseTextwindow (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2001);
(*$?Compiler=Megamax:
 p:= whlist;  q:= whlist;
 WHILE p <> NIL DO
  IF p^.window = win THEN 
   IF q <> NIL THEN q^.next:= p^.next; END;
   DISPOSE (p);
  END;
  q:= p;  p:= p^.next;
 END;
 *)
END CloseTextwindow;

PROCEDURE WriteChar (win: SHORTINT; ch: CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= ORD (ch);
 END;
 CallMagic (2002);
END WriteChar;

PROCEDURE WriteLine (win: SHORTINT; str: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (str);
  IntIn[0]:= win;
 END;
 CallMagic (2003);
END WriteLine;

PROCEDURE WriteLn (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2004);
END WriteLn;

PROCEDURE WriteInt  (win, val, len: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= val;
  IntIn[2]:= len;
 END;
 CallMagic (2005);
END WriteInt; 

PROCEDURE WriteWord (win: SHORTINT; val: SHORTCARD; len: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= val;
  IntIn[2]:= len;
 END;
 CallMagic (2006);
END WriteWord; 

PROCEDURE WriteLInt (win: SHORTINT; val: LONGINT; len: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  LongIn[0]:= val;
  IntIn[1]:= len;
 END;
 CallMagic (2007);
END WriteLInt; 

PROCEDURE WriteReal (win: SHORTINT; val: REAL; len: SHORTINT);
VAR c: M_Types.CSTRING;
BEGIN
 M_Convert.RealToStr (val, len, c);
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (c);
  IntIn[0]:= win;
 END;
 CallMagic (2003);
END WriteReal; 

PROCEDURE GetChar (win, x, y: SHORTINT): CHAR;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= x;
  IntIn[2]:= y;
  CallMagic (2008);
  RETURN CHR (IntOut[0]);
 END;
END GetChar;

PROCEDURE GetLine (win, line: SHORTINT; VAR strng: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (strng);
  IntIn[0]:= win;
  IntIn[1]:= line;
 END;
 CallMagic (2009);
END GetLine;

PROCEDURE WindowInfo (win: SHORTINT; VAR column, lines, font: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  CallMagic (2010);
  column:= IntOut[0];
  lines:= IntOut[1];
  font:= IntOut[2];
 END;
END WindowInfo;

PROCEDURE InsertLine (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2011);
END InsertLine;

PROCEDURE DeleteLine (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2012);
END DeleteLine;

PROCEDURE WhereXY (win: SHORTINT; VAR spalte, zeile: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  CallMagic (2013);
  spalte:= IntOut[0];
  zeile:= IntOut[1];
 END;
END WhereXY;

PROCEDURE GotoXY (win, spalte, zeile: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= spalte;
  IntIn[2]:= zeile;
 END;
 CallMagic (2014);
END GotoXY;

PROCEDURE CursorOn (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2015);
END CursorOn;

PROCEDURE CursorOff (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2016);
END CursorOff;

PROCEDURE WrapPos (win, pos: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 App^.MagicPB^.IntIn[0]:= pos;
 CallMagic (2017);
END WrapPos;

PROCEDURE WrapOff (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2018);
END WrapOff;

PROCEDURE WrapOn (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2019);
END WrapOn;

PROCEDURE ClearLine (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2020);
END ClearLine;

PROCEDURE ClearStartOfLine (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2021);
END ClearStartOfLine;

PROCEDURE ClearEndOfLine (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2022);
END ClearEndOfLine;

PROCEDURE ClearScreen (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2023);
END ClearScreen;

PROCEDURE ClearStartOfScreen (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2024);
END ClearStartOfScreen;

PROCEDURE ClearEndOfScreen (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2025);
END ClearEndOfScreen;

PROCEDURE ForegroundColor (win, color: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= color;
 END;
 CallMagic (2026);
END ForegroundColor;

PROCEDURE BackgroundColor (win, color: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= color;
 END;
 CallMagic (2027);
END BackgroundColor;

PROCEDURE InversOn (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2028);
END InversOn;

PROCEDURE InversOff (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;  CallMagic (2029);
END InversOff;

PROCEDURE SetAttribut (win: SHORTINT; attrib: BITSET);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= CastToInt (attrib);
 END;
 CallMagic (2030);
END SetAttribut;

PROCEDURE SetTabspace (win, tab: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= tab;
 END;
 CallMagic (2031);
END SetTabspace;

PROCEDURE ChangeFont (win, font, size, color: SHORTINT; attrib: BITSET);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= font;
  IntIn[2]:= size;
  IntIn[3]:= color;
  IntIn[4]:= CastToInt (attrib);
 END;
 CallMagic (2032);
END ChangeFont;

PROCEDURE TopTerminal(): SHORTINT;
BEGIN
 CallMagic (2034);
 RETURN App^.MagicPB^.IntOut[0];
END TopTerminal;
  
PROCEDURE CalcRedraw (win: SHORTINT; rect: M_Types.tRect; VAR von, bis: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= win;
  CallMagic (2035);
  von:= IntOut[0];
  bis:= IntOut[1];
 END;
END CalcRedraw;

PROCEDURE FontSelector (msg: ARRAY OF CHAR; flags: BITSET);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (msg);
  IntIn[0]:= CastToInt (flags + {M_Types.Bit3});
 END;
 CallMagic (2036);
END FontSelector;

BEGIN
(*$?Compiler=Megamax:
 whlist:= NIL;
 mem.bottom:= ADR (stack);
 mem.length:= M_Types.Stacksize;
 Calls.NewCaller (mm2, FALSE, mem, caller);
 IF caller = NIL THEN  HALT;  END;
 *)
END M_Terminal.
