(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Time;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM M_Sys IMPORT App, CallMagic;
FROM SYSTEM IMPORT ADR;


PROCEDURE EncodeDate (day, month, year: SHORTCARD): SHORTCARD;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= day;
  IntIn[1]:= month;
  IntIn[2]:= year;
  CallMagic (2100);
  RETURN IntOut[0];
 END;
END EncodeDate;

PROCEDURE DecodeDate (date: SHORTCARD; VAR day, month, year: SHORTCARD);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= date;
  CallMagic (2101);
  day:= IntOut[0];
  month:= IntOut[1];
  year:= IntOut[2];
 END;
END DecodeDate;

PROCEDURE DateInNum (date: SHORTCARD): LONGINT; 
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= date;
  CallMagic (2102);
  RETURN LongOut[0];
 END;
END DateInNum;

PROCEDURE NumInDate (number: LONGINT): SHORTCARD;
BEGIN
 WITH App^.MagicPB^ DO
  LongIn[0]:= number;
  CallMagic (2103);
  RETURN IntOut[0];
 END;
END NumInDate;

PROCEDURE DateString (date: SHORTCARD; VAR str: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (str);
  IntIn[0]:= date;
 END;
 CallMagic (2104);
END DateString;

PROCEDURE DayOfYear (date: SHORTCARD): SHORTCARD;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= date;
  CallMagic (2105);
  RETURN IntOut[0];
 END;
END DayOfYear;

PROCEDURE WeekOfYear (date: SHORTCARD): SHORTCARD;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= date;
  CallMagic (2106);
  RETURN IntOut[0];
 END;
END WeekOfYear;

PROCEDURE DayOfWeek (date: SHORTCARD): SHORTCARD;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= date;
  CallMagic (2107);
  RETURN IntOut[0];
 END;
END DayOfWeek;

PROCEDURE NameOfDay (lang: Language; day: SHORTCARD; VAR name: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= ORD (lang);
  IntIn[1]:= day;
  AddrIn[0]:= ADR (name);
 END;
 CallMagic (2108);
END NameOfDay;

PROCEDURE NameOfMonth (lang: Language; month: SHORTCARD; VAR name: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= ORD (lang);
  IntIn[1]:= month;
  AddrIn[0]:= ADR (name);
 END;
 CallMagic (2109);
END NameOfMonth;

PROCEDURE EncodeTime (hour, minute, second: SHORTCARD): SHORTCARD;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= hour;
  IntIn[1]:= minute;
  IntIn[2]:= second;
  CallMagic (2110);
  RETURN IntOut[0];
 END;
END EncodeTime;

PROCEDURE DecodeTime (time: SHORTCARD; VAR hour, minute, second: SHORTCARD);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= time;
  CallMagic (2111);
  hour:= IntOut[0];
  minute:= IntOut[1];
  second:= IntOut[2];
 END;
END DecodeTime;

PROCEDURE TimeInNum (time: SHORTCARD): LONGINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= time;
  CallMagic (2112);
  RETURN LongOut[0];
 END;
END TimeInNum;

PROCEDURE NumInTime (num: LONGINT): SHORTCARD;
BEGIN
 WITH App^.MagicPB^ DO
  LongIn[0]:= num;
  CallMagic (2113);
  RETURN IntOut[0];
 END;
END NumInTime;

PROCEDURE TimeString (time: SHORTCARD; VAR str: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= time;
  AddrIn[0]:= ADR (str);
 END;
 CallMagic (2114);
END TimeString;

END M_Time.
