(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_Trees;

FROM SYSTEM IMPORT ADDRESS;

TYPE    NODE;  (* Eintrag in den Baum *)

TYPE    TREE;   (* Baumtyp *)

TYPE    CompResult =    (smaller, equal, bigger);
        CompProc =      PROCEDURE ( (* left *)  ADDRESS, 
                                    (* right *) ADDRESS): CompResult;
PROCEDURE NewTree (VAR tree: TREE; comp: CompProc): BOOLEAN;
PROCEDURE DisposeTree (VAR tree: TREE);
PROCEDURE TreeEntries (tree: TREE): LONGCARD;
PROCEDURE NilNode (): NODE;
PROCEDURE InsertNode (tree: TREE; info: ADDRESS; size: SHORTINT): BOOLEAN;
PROCEDURE SearchNode (tree: TREE; from: NODE; info: ADDRESS; size: SHORTINT; key: CompProc): NODE;
PROCEDURE DeleteNode (tree: TREE; VAR node: NODE);
PROCEDURE FirstNode (tree: TREE): NODE;
PROCEDURE LastNode (tree: TREE): NODE;
PROCEDURE NextNode (node: NODE): NODE;
PROCEDURE PrevNode (node: NODE): NODE;
PROCEDURE GetNode (node: NODE; info: ADDRESS; size: SHORTINT): BOOLEAN;

END M_Trees.
