(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1992 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_Types;

FROM Portab IMPORT tCompiler, Compiler;

IMPORT SYSTEM;

CONST   MagicName = 'MAGIC.PRG'+0C;

CONST   Stacksize = 4 * 1024;  (* Stacksize fr die internen Handler
                                * Muss unter Umstnden vergrssert werden!
                                *)

CONST   Nihil = 0FFFFFFFFH; (* NIL gibts schon... *)
        Null =  000000000H; 

CONST   Bit0 =   0;
        Bit1 =   1;
        Bit2 =   2;
        Bit3 =   3;
        Bit4 =   4;
        Bit5 =   5;
        Bit6 =   6;
        Bit7 =   7;
        Bit8 =   8;
        Bit9 =   9;
        Bit10 = 10;
        Bit11 = 11;
        Bit12 = 12;
        Bit13 = 13;
        Bit14 = 14;
        Bit15 = 15;
        Bit16 = 16;
        Bit17 = 17;
        Bit18 = 18;
        Bit19 = 19;
        Bit20 = 20;
        Bit21 = 21;
        Bit22 = 22;
        Bit23 = 23;
        Bit24 = 24;
        Bit25 = 25;
        Bit26 = 26;
        Bit27 = 27;
        Bit28 = 28;
        Bit29 = 29;
        Bit30 = 30;
        Bit31 = 31;

(* 8-Bit Typen *)

TYPE    ByteSet =       SET OF [Bit0..Bit7];

(* 32-Bit Typen *)

TYPE    LONGBITSET =    SET OF [Bit0..Bit31];


(* Spezialtypen fr alle Magic-Module *)

TYPE    tRect =         RECORD
                         x: SHORTINT;
                         y: SHORTINT;
                         w: SHORTINT;
                         h: SHORTINT;
                        END;

TYPE    tPxyRect =      RECORD
                         x1: SHORTINT; 
                         y1: SHORTINT;
                         x2: SHORTINT; 
                         y2: SHORTINT;
                         x3: SHORTINT; 
                         y3: SHORTINT;
                         x4: SHORTINT; 
                         y4: SHORTINT;
                         x5: SHORTINT; 
                         y5: SHORTINT;
                         x6: SHORTINT; 
                         y6: SHORTINT;
                         x7: SHORTINT; 
                         y7: SHORTINT;
                         x8: SHORTINT; 
                         y8: SHORTINT;
                        END;

TYPE    PtrCSTRING =    POINTER TO CSTRING;
        CSTRING =       ARRAY [0..255] OF CHAR;


(*--- Struktur des Cookies -----------------------------------------*)

TYPE  tColortable =     POINTER TO Colortable;
      Colortable =      ARRAY [0..5], [0..1], [1..6] OF SHORTINT;

TYPE  tFKeys =          (fkHelp,        (* Helpbutton auslsen         *)
                         fkUndo,        (* UndoButton auslsen         *)
                         fkEscape,      (* EscapeButton auslsen       *)
                         fkHistory,     (* History durchlaufen         *)
                         fkSearch,      (* History durchsuchen         *)
                         fkCutClip,     (* Zeile ausschneiden          *)
                         fkCopyClip,    (* Zeile auf Clip kopieren     *)
                         fkPasteClip,   (* Clipboard lesen             *)
                         fkSelectAll,   (* Alles als Block selektieren *)
                         fkSelectStart, (* Alles als Block selektieren *)
                         fkCycleWin,    (* Fenster cyclen              *)
                         fkCloseWin,    (* Fenster schliessen          *)
                         fkFullWin,     (* Fenster auf volle Gre     *)
                         fkLineup,      (* Zeile nach oben rollen      *)
                         fkPageup,      (* Seite nach oben rollen      *)
                         fkTopdoc,      (* Zum Anfang des Dokuments    *)
                         fkLinedown,    (* Zeile nach unten rollen     *)
                         fkPagedown,    (* Seite nach unten rollen     *)
                         fkBottomdoc,   (* Zum Ende des Dokuments      *)
                         fkLineleft,    (* Spalte nach links rollen    *)
                         fkPageleft,    (* Seite nach links rollen     *)
                         fkLeftdoc,     (* Zur ersten Spalte.          *)
                         fkLineright,   (* Spalte nach rechts rollen   *)
                         fkPageright,   (* Seite nach rechts rollen    *)
                         fkRightdoc     (* Zur letzten Spalte          *)
                        );

TYPE  tFkeytable =      POINTER TO FKeytable;
      FKeytable =       ARRAY [fkHelp..fkRightdoc] OF SHORTINT;

TYPE  tValues =         (vWinsize,    (* Sizearea-Breite           *)
                         vPopdelay,   (* Delay bei Popups          *)
                         vDropdelay   (* Delay bei Drop-Circlebuttons *)
                        );
      tValuetable =     POINTER TO Valuetable;
      Valuetable =      ARRAY [vWinsize..vDropdelay] OF SHORTINT;

TYPE  PtrConfig =  POINTER TO TheConfig;
      TheConfig =  RECORD
                    version:    SHORTINT;       (* Versionsnummer                *)
                    deadkeys:   BITSET;         (* Daten ber die DeadKeys       *)
                    flags:      LONGBITSET;     (* Flags siehe unten             *)
                    dispatcher: SYSTEM.ADDRESS; (* Einsprung in MAGIC.PRG        *)
                    path:       PtrCSTRING;     (* Pfad fr Magic.PRG            *)
                    colortable: tColortable;    (* Zeiger auf Button-Farbtabelle *)
                    fkeytable:  tFkeytable;     (* Zeiger auf die Standardtasten *)
                    valuetable: tValuetable;    (* Zeiger auf Werte-Tabelle      *)
                    actapp:     SYSTEM.ADDRESS; (* Zeiger auf den App-Block      *)
                    help:       PtrCSTRING;     (* Name des Hilfe-Porgramms      *)
                   END;

(* Flags bei TheCookie.flags: *)

CONST   cfConfig =      Bit0;   (* Config-Dial zulassen         *)
        cfSolid =       Bit1;   (* Solide Verschieben           *)
        cfClip =        Bit2;   (* GEM-Clipboard benutzen       *)
        cfDeadkey =     Bit3;   (* Deadkeys im Edit benutzen    *)
        cfCenter =      Bit4;   (* Dialog zentrieren            *)
        cfMouse =       Bit5;   (* Dialog an Mouseposition      *)
        cfPos =         Bit6;   (* Dialog an letzter Position   *)
        cfGrowbox =     Bit7;   (* Grow-/Shrinkboxen            *)
        cf3DButtons =   Bit8;   (* Buttons im 3D-Look and Feel  *)
        cfWinDials =    Bit9;   (* Dialog im Fenster gewnscht  *)
        cfWinAlerts =   Bit10;  (* Alle Alerts in Fenstern      *)
        cfButtonLeft =  Bit11;  (* Alertbuttons Linksbndig     *)
        cfButtonRight = Bit12;  (* Alertbuttons Rechtsbndig    *)
        cfAltIcon =     Bit13;  (* Alternative Icons verwenden  *)
        cfAllSize =     Bit14;  (* Fenster an allen Ecken und Kanten sizen *)
        cfAllMove =     Bit15;  (* Fenster an allen Ecken und Kanten moven *)
        cfPopClick =    Bit16;  (* Popups durch klicken whlen/verlassen *)
        cfIconpos =     Bit17;  (* iconified Fenster werden beim Vergrssern 
                                 * auf die Iconposition gesetzt, sonst auf die
                                 * letzte Fensterposition *)
        cfRes18 =       Bit18;  (* Reserviert *)
        cfRes19 =       Bit19;  (* Reserviert *)
        cfRes20 =       Bit20;  (* Reserviert *)
        cfRes21 =       Bit21;  (* Reserviert *)
        cfRes22 =       Bit22;  (* Reserviert *)
        cfRes23 =       Bit23;  (* Reserviert *)
        cfRes24 =       Bit24;  (* Reserviert *)
        cfRes25 =       Bit25;  (* Reserviert *)
        cfRes26 =       Bit26;  (* Reserviert *)
        cfRes27 =       Bit27;  (* Reserviert *)
        cfRes28 =       Bit28;  (* Reserviert *)
        cfRes29 =       Bit29;  (* Reserviert *)
        cfRes30 =       Bit30;  (* Reserviert *)
        cfRes31 =       Bit31;  (* Reserviert *)

(*------------------------------------------------------------------*)

CONST   wsPhysical =    Bit0;   (* Gesetzt wenn physikalische WS *)
        wsFontsloaded = Bit1;   (* Gesetzt wenn Fonts geladen wurden *)
        wsReserved1 =   Bit2;   (* Fr interne Zwecke reserviert *)

TYPE    PtrWS =          POINTER TO WORKSTATION;
        WORKSTATION =    RECORD
                          Handle:             SHORTINT; (* Handle der Workstation *)
                          Flags:              LONGBITSET; (* TRUE = Physikalisch geffnet *)
                          MaxWidth:           SHORTINT; (* workout[ 0]*)
                          MaxHeight:          SHORTINT; (* workout[ 1]*)
                          Devicecoord:        SHORTINT; (* workout[ 2]*)
                          PixelWidth:         SHORTINT; (* workout[ 3]*)
                          PixelHight:         SHORTINT; (* workout[ 4]*)
                          FontHeights:        SHORTINT; (* workout[ 5]*)
                          LineTypes:          SHORTINT; (* workout[ 6]*)
                          LineWidth:          SHORTINT; (* workout[ 7]*)
                          MarkerTypes:        SHORTINT; (* workout[ 8]*)
                          MarkerSize:         SHORTINT; (* workout[ 9]*)
                          SystemFonts:        SHORTINT; (* workout[10]*)
                          PatternTypes:       SHORTINT; (* workout[11]*)
                          HatchTypes:         SHORTINT; (* workout[12]*)
                          DefColors:          SHORTINT; (* workout[13]*)
                          GDPFunctions:       SHORTINT; (* workout[14]*)
                          GDP01:              SHORTINT; (* workout[15]*)
                          GDP02:              SHORTINT; (* workout[16]*)
                          GDP03:              SHORTINT; (* workout[17]*)
                          GDP04:              SHORTINT; (* workout[18]*)
                          GDP05:              SHORTINT; (* workout[19]*)
                          GDP06:              SHORTINT; (* workout[20]*)
                          GDP07:              SHORTINT; (* workout[21]*)
                          GDP08:              SHORTINT; (* workout[22]*)
                          GDP09:              SHORTINT; (* workout[23]*)
                          GDP10:              SHORTINT; (* workout[24]*)
                          GDPAttrib01:        SHORTINT; (* workout[25]*)
                          GDPAttrib02:        SHORTINT; (* workout[26]*)
                          GDPAttrib03:        SHORTINT; (* workout[27]*)
                          GDPAttrib04:        SHORTINT; (* workout[28]*)
                          GDPAttrib05:        SHORTINT; (* workout[29]*)
                          GDPAttrib06:        SHORTINT; (* workout[30]*)
                          GDPAttrib07:        SHORTINT; (* workout[31]*)
                          GDPAttrib08:        SHORTINT; (* workout[32]*)
                          GDPAttrib09:        SHORTINT; (* workout[33]*)
                          GDPAttrib10:        SHORTINT; (* workout[34]*)
                          ColorPossible:      SHORTINT; (* workout[35]*)
                          TextRotPossible:    SHORTINT; (* workout[36]*)
                          AreaFillPossible:   SHORTINT; (* workout[37]*)
                          CellArrayPossible:  SHORTINT; (* workout[38]*)
                          MaxColors:          SHORTINT; (* workout[39]*)
                          CursorControl:      SHORTINT; (* workout[40]*)
                          ValuatorControl:    SHORTINT; (* workout[41]*)
                          ChoiceControl:      SHORTINT; (* workout[42]*)
                          AlphaControl:       SHORTINT; (* workout[43]*)
                          InOutType:          SHORTINT; (* workout[44]*)
                          MinCharWidth:       SHORTINT; (* workout[45]*)
                          MinCharHeight:      SHORTINT; (* workout[46]*)
                          MaxCharWidth:       SHORTINT; (* workout[47]*)
                          MaxCharHeight:      SHORTINT; (* workout[48]*)
                          MinLineWidth:       SHORTINT; (* workout[49]*)
                          MaxLineWidth:       SHORTINT; (* workout[51]*)
                          MinMarkerWidth:     SHORTINT; (* workout[53]*)
                          MinMarkerHeight:    SHORTINT; (* workout[54]*)
                          MaxMarkerWidth:     SHORTINT; (* workout[55]*)
                          MaxMarkerHeight:    SHORTINT; (* workout[56]*)

                          (* Extended Inquire *)
                          ScreenType:         SHORTINT; (* workout[ 0]*)
                          BackgroundColors:   SHORTINT; (* workout[ 1]*)
                          Texteffects:        BITSET;  (* workout[ 2]*)
                          Upsizing:           SHORTINT; (* workout[ 3]*)
                          Bitplanes:          SHORTINT; (* workout[ 4]*)
                          LookupTable:        SHORTINT; (* workout[ 5]*)
                          RasterOps:          SHORTINT; (* workout[ 6]*)
                          ContourFill:        SHORTINT; (* workout[ 7]*)
                          TextRotation:       SHORTINT; (* workout[ 8]*)
                          WriteModes:         SHORTINT; (* workout[ 9]*)
                          InputModes:         SHORTINT; (* workout[10]*)
                          TextJustification:  SHORTINT; (* workout[11]*)
                          PencilChange:       SHORTINT; (* workout[12]*)
                          ColorChange:        SHORTINT; (* workout[13]*)
                          MaxCoordPairs:      SHORTINT; (* workout[14]*)
                          MaxIntin:           SHORTINT; (* workout[15]*)
                          MaxMouseButtons:    SHORTINT; (* workout[16]*)
                          FatLineTypes:       SHORTINT; (* workout[17]*)
                          FatLineModes:       SHORTINT; (* workout[18]*)
                          Clipping:           SHORTINT; (* workout[19]*)
                          ClipLeftX:          SHORTINT; (* workout[45]*)
                          ClipLeftY:          SHORTINT; (* workout[46]*)
                          ClipRightX:         SHORTINT; (* workout[47]*)
                          ClipRightY:         SHORTINT; (* workout[48]*)
                            
                          Reserved1:          SYSTEM.ADDRESS; (* Nicht benutzen!!! *)
                          Reserved2:          SYSTEM.ADDRESS; (* Nicht benutzen!!! *)
                          Reserved3:          SYSTEM.ADDRESS; (* Nicht benutzen!!! *)

                          DeviceNum:          SHORTINT;
                          Name:               CSTRING;
                         END;


(*----------------------------------------------------------------------*
 * Bemerkungen zu den Tastencodes                                       *
 *                                                                      *
 * Sh =          Shift                                                  *
 * Ctrl =        Control                                                *
 * ShCtrl =      Shift + Control                                        *
 * Alt =         Alternate                                              *
 * ShAlt =       Shift + Alternate                                      *
 * CtrlAlt =     Control + Alternate                                    *
 * ShCtrlAlt =   Shift + Control + Alternate                            *
 *                                                                      *
 * Grobuchstaben ber CAPSLOCK werden mit Shift-Status gemeldet!       *
 *                                                                      *
 * Einige Kombinationen sind nicht ber die Tastatur zugnglich (zB:    *
 * Maus-Emulation des OS, Ctrl-Alt-Del, Alt-Help)                       *
 *                                                                      *
 * Die Scancodes fr Shift-F1 bis Shift-F10 sowie fr Alt-1 bis Alt-'   *
 * werden bei den jeweiligen Basiscodes mitgemeldet.  Ein Auswerten     *
 * dieser Codes hat also nicht viel Sinn...                             *
 *----------------------------------------------------------------------*)

TYPE tKey = (

(* Escape     *)  Esc,      ShEsc,      CtrlEsc,      ShCtrlEsc,      AltEsc,      ShAltEsc,      CtrlAltEsc,      ShCtrlAltEsc,
(* 1 !        *)  Char1,    Sh1,        Ctrl1,        ShCtrl1,        Alt1,        ShAlt1,        CtrlAlt1,        ShCtrlAlt1,
(* 2 "        *)  Char2,    Sh2,        Ctrl2,        ShCtrl2,        Alt2,        ShAlt2,        CtrlAlt2,        ShCtrlAlt2,
(* 3         *)  Char3,    Sh3,        Ctrl3,        ShCtrl3,        Alt3,        ShAlt3,        CtrlAlt3,        ShCtrlAlt3,
(* 4 $        *)  Char4,    Sh4,        Ctrl4,        ShCtrl4,        Alt4,        ShAlt4,        CtrlAlt4,        ShCtrlAlt4,
(* 5 %        *)  Char5,    Sh5,        Ctrl5,        ShCtrl5,        Alt5,        ShAlt5,        CtrlAlt5,        ShCtrlAlt5,
(* 6 &        *)  Char6,    Sh6,        Ctrl6,        ShCtrl6,        Alt6,        ShAlt6,        CtrlAlt6,        ShCtrlAlt6,
(* 7 /        *)  Char7,    Sh7,        Ctrl7,        ShCtrl7,        Alt7,        ShAlt7,        CtrlAlt7,        ShCtrlAlt7,
(* 8 (        *)  Char8,    Sh8,        Ctrl8,        ShCtrl8,        Alt8,        ShAlt8,        CtrlAlt8,        ShCtrlAlt8,
(* 9 )        *)  Char9,    Sh9,        Ctrl9,        ShCtrl9,        Alt9,        ShAlt9,        CtrlAlt9,        ShCtrlAlt9,
(* 0 =        *)  Char0,    Sh0,        Ctrl0,        ShCtrl0,        Alt0,        ShAlt0,        CtrlAlt0,        ShCtrlAlt0,
(*  ?        *)  CharSS,   ShSS,       CtrlSS,       ShCtrlSS,       AltSS,       ShAltSS,       CtrlAltSS,       ShCtrlAltSS,
(* ' `        *)  Quote,    ShQuote,    CtrlQuote,    ShCtrlQuote,    AltQuote,    ShAltQuote,    CtrlAltQuote,    ShCtrlAltQuote,
(* Backspace  *)  Bs,       ShBs,       CtrlBs,       ShCtrlBs,       AltBs,       ShAltBs,       CtrlAltBs,       ShCtrlAltBs,
(* Tab        *)  Tab,      ShTab,      CtrlTab,      ShCtrlTab,      AltTab,      ShAltTab,      CtrlAltTab,      ShCtrlAltTab,
(* q Q        *)  CharQ,    ShQ,        CtrlQ,        ShCtrlQ,        AltQ,        ShAltQ,        CtrlAltQ,        ShCtrlAltQ,
(* w W        *)  CharW,    ShW,        CtrlW,        ShCtrlW,        AltW,        ShAltW,        CtrlAltW,        ShCtrlAltW,
(* e E        *)  CharE,    ShE,        CtrlE,        ShCtrlE,        AltE,        ShAltE,        CtrlAltE,        ShCtrlAltE,
(* r R        *)  CharR,    Sh_R,       CtrlR,        ShCtrlR,        AltR,        ShAltR,        CtrlAltR,        ShCtrlAltR,
(* t T        *)  CharT,    ShT,        CtrlT,        ShCtrlT,        AltT,        ShAltT,        CtrlAltT,        ShCtrlAltT,
(* z Z        *)  CharZ,    ShZ,        CtrlZ,        ShCtrlZ,        AltZ,        ShAltZ,        CtrlAltZ,        ShCtrlAltZ,
(* u U        *)  CharU,    ShU,        CtrlU,        ShCtrlU,        AltU,        ShAltU,        CtrlAltU,        ShCtrlAltU,
(* i I        *)  CharI,    ShI,        CtrlI,        ShCtrlI,        AltI,        ShAltI,        CtrlAltI,        ShCtrlAltI,
(* o O        *)  CharO,    ShO,        CtrlO,        ShCtrlO,        AltO,        ShAltO,        CtrlAltO,        ShCtrlAltO,
(* p P        *)  CharP,    ShP,        CtrlP,        ShCtrlP,        AltP,        ShAltP,        CtrlAltP,        ShCtrlAltP,
(*     @ \  *)  CharUE,   ShUE,       CtrlUE,       ShCtrlUE,       AltUE,       ShAltUE,       CtrlAltUE,       ShCtrlAltUE,
(* + *        *)  Plus,     ShPlus,     CtrlPlus,     ShCtrlPlus,     AltPlus,     ShAltPlus,     CtrlAltPlus,     ShCtrlAltPlus,
(* Return     *)  Return,   ShReturn,   CtrlReturn,   ShCtrlReturn,   AltReturn,   ShAltReturn,   CtrlAltReturn,   ShCtrlAltReturn,
(* Control    *)  Scan29,   ShScan29,   CtrlScan29,   ShCtrlScan29,   AltScan29,   ShAltScan29,   CtrlAltScan29,   ShCtrlAltScan29,
(* a A        *)  CharA,    ShA,        CtrlA,        ShCtrlA,        AltA,        ShAltA,        CtrlAltA,        ShCtrlAltA,
(* s S        *)  CharS,    ShS,        CtrlS,        ShCtrlS,        AltS,        ShAltS,        CtrlAltS,        ShCtrlAltS,
(* d D        *)  CharD,    ShD,        CtrlD,        ShCtrlD,        AltD,        ShAltD,        CtrlAltD,        ShCtrlAltD,
(* f F        *)  CharF,    ShF,        CtrlF,        ShCtrlF,        AltF,        ShAltF,        CtrlAltF,        ShCtrlAltF,
(* g G        *)  CharG,    ShG,        CtrlG,        ShCtrlG,        AltG,        ShAltG,        CtrlAltG,        ShCtrlAltG,
(* h H        *)  CharH,    ShH,        CtrlH,        ShCtrlH,        AltH,        ShAltH,        CtrlAltH,        ShCtrlAltH,
(* j J        *)  CharJ,    ShJ,        CtrlJ,        ShCtrlJ,        AltJ,        ShAltJ,        CtrlAltJ,        ShCtrlAltJ,
(* k K        *)  CharK,    ShK,        CtrlK,        ShCtrlK,        AltK,        ShAltK,        CtrlAltK,        ShCtrlAltK,
(* l L        *)  CharL,    Sh_L,       CtrlL,        ShCtrlL,        AltL,        ShAltL,        CtrlAltL,        ShCtrlAltL,
(*     [ {  *)  CharOE,   ShOE,       CtrlOE,       ShCtrlOE,       AltOE,       ShAltOE,       CtrlAltOE,       ShCtrlAltOE,
(*     ] }  *)  CharAE,   ShAE,       CtrlAE,       ShCtrlAE,       AltAE,       ShAltAE,       CtrlAltAE,       ShCtrlAltAE,
(* # ^        *)  Number,   ShNumber,   CtrlNumber,   ShCtrlNumber,   AltNumber,   ShAltNumber,   CtrlAltNumber,   ShCtrlAltNumber,
(* L-Shift    *)  Scan42,   ShScan42,   CtrlScan42,   ShCtrlScan42,   AltScan42,   ShAltScan42,   CtrlAltScan42,   ShCtrlAltScan42,
(* ~ |        *)  Tilde,    ShTilde,    CtrlTilde,    ShCtrlTilde,    AltTilde,    ShAltTilde,    CtrlAltTilde,    ShCtrlAltTilde,
(* y Y        *)  CharY,    ShY,        CtrlY,        ShCtrlY,        AltY,        ShAltY,        CtrlAltY,        ShCtrlAltY,
(* x X        *)  CharX,    ShX,        CtrlX,        ShCtrlX,        AltX,        ShAltX,        CtrlAltX,        ShCtrlAltX,
(* c C        *)  CharC,    ShC,        CtrlC,        ShCtrlC,        AltC,        ShAltC,        CtrlAltC,        ShCtrlAltC,
(* v V        *)  CharV,    ShV,        CtrlV,        ShCtrlV,        AltV,        ShAltV,        CtrlAltV,        ShCtrlAltV,
(* b B        *)  CharB,    ShB,        CtrlB,        ShCtrlB,        AltB,        ShAltB,        CtrlAltB,        ShCtrlAltB,
(* n N        *)  CharN,    ShN,        CtrlN,        ShCtrlN,        AltN,        ShAltN,        CtrlAltN,        ShCtrlAltN,
(* m M        *)  CharM,    ShM,        CtrlM,        ShCtrlM,        AltM,        ShAltM,        CtrlAltM,        ShCtrlAltM,
(* , ;        *)  Colon,    ShColon,    CtrlColon,    ShCtrlColon,    AltColon,    ShAltColon,    CtrlAltColon,    ShCtrlAltColon,
(* . :        *)  Point,    ShPoint,    CtrlPoint,    ShCtrlPoint,    AltPoint,    ShAltPoint,    CtrlAltPoint,    ShCtrlAltPoint,
(* - _        *)  Minus,    ShMinus,    CtrlMinus,    ShCtrlMinus,    AltMinus,    ShAltMinus,    CtrlAltMinus,    ShCtrlAltMinus,
(* R-Shift    *)  Scan54,   ShScan54,   CtrlScan54,   ShCtrlScan54,   AltScan54,   ShAltScan54,   CtrlAltScan54,   ShCtrlAltScan54,
(*  nicht da  *)  Scan55,   ShScan55,   CtrlScan55,   ShCtrlScan55,   AltScan55,   ShAltScan55,   CtrlAltScan55,   ShCtrlAltScan55,
(* Alternate  *)  Scan56,   ShScan56,   CtrlScan56,   ShCtrlScan56,   AltScan56,   ShAltScan56,   CtrlAltScan56,   ShCtrlAltScan56,
(*            *)  Space,    ShSpace,    CtrlSpace,    ShCtrlSpace,    AltSpace,    ShAltSpace,    CtrlAltSpace,    ShCtrlAltSpace,
(* Capslock   *)  Scan58,   ShScan58,   CtrlScan58,   ShCtrlScan58,   AltScan58,   ShAltScan58,   CtrlAltScan58,   ShCtrlAltScan58,
(* F1         *)  F1,       ShF1,       CtrlF1,       ShCtrlF1,       AltF1,       ShAltF1,       CtrlAltF1,       ShCtrlAltF1,
(* F2         *)  F2,       ShF2,       CtrlF2,       ShCtrlF2,       AltF2,       ShAltF2,       CtrlAltF2,       ShCtrlAltF2,
(* F3         *)  F3,       ShF3,       CtrlF3,       ShCtrlF3,       AltF3,       ShAltF3,       CtrlAltF3,       ShCtrlAltF3,
(* F4         *)  F4,       ShF4,       CtrlF4,       ShCtrlF4,       AltF4,       ShAltF4,       CtrlAltF4,       ShCtrlAltF4,
(* F5         *)  F5,       ShF5,       CtrlF5,       ShCtrlF5,       AltF5,       ShAltF5,       CtrlAltF5,       ShCtrlAltF5,
(* F6         *)  F6,       ShF6,       CtrlF6,       ShCtrlF6,       AltF6,       ShAltF6,       CtrlAltF6,       ShCtrlAltF6,
(* F7         *)  F7,       ShF7,       CtrlF7,       ShCtrlF7,       AltF7,       ShAltF7,       CtrlAltF7,       ShCtrlAltF7,
(* F8         *)  F8,       ShF8,       CtrlF8,       ShCtrlF8,       AltF8,       ShAltF8,       CtrlAltF8,       ShCtrlAltF8,
(* F9         *)  F9,       ShF9,       CtrlF9,       ShCtrlF9,       AltF9,       ShAltF9,       CtrlAltF9,       ShCtrlAltF9,
(* F10        *)  F10,      ShF10,      CtrlF10,      ShCtrlF10,      AltF10,      ShAltF10,      CtrlAltF10,      ShCtrlAltF10,
(*  nicht da  *)  Scan69,   ShScan69,   CtrlScan69,   ShCtrlScan69,   AltScan69,   ShAltScan69,   CtrlAltScan69,   ShCtrlAltScan69,
(*  nicht da  *)  Scan70,   ShScan70,   CtrlScan70,   ShCtrlScan70,   AltScan70,   ShAltScan70,   CtrlAltScan70,   ShCtrlAltScan70,
(* Clr/Home   *)  Clr,      ShClr,      CtrlClr,      ShCtrlClr,      AltClr,      ShAltClr,      CtrlAltClr,      ShCtrlAltClr,
(* Cursor Up  *)  Up,       ShUp,       CtrlUp,       ShCtrlUp,       AltUp,       ShAltUp,       CtrlAltUp,       ShCtrlAltUp,
(*  nicht da  *)  Scan73,   ShScan73,   CtrlScan73,   ShCtrlScan73,   AltScan73,   ShAltScan73,   CtrlAltScan73,   ShCtrlAltScan73,
(* NumBlock - *)  NumMinus, ShNumMinus, CtrlNumMinus, ShCtrlNumMinus, AltNumMinus, ShAltNumMinus, CtrlAltNumMinus, ShCtrlAltNumMinus,
(* Curs Left  *)  Left,     ShLeft,     CtrlLeft,     ShCtrlLeft,     AltLeft,     ShAltLeft,     CtrlAltLeft,     ShCtrlAltLeft,
(*  nicht da  *)  Scan76,   ShScan76,   CtrlScan76,   ShCtrlScan76,   AltScan76,   ShAltScan76,   CtrlAltScan76,   ShCtrlAltScan76,
(* Curs Right *)  Right,    ShRight,    CtrlRight,    ShCtrlRight,    AltRight,    ShAltRight,    CtrlAltRight,    ShCtrlAltRight,
(* NumBlock + *)  NumPlus,  ShNumPlus,  CtrlNumPlus,  ShCtrlNumPlus,  AltNumPlus,  ShAltNumPlus,  CtrlAltNumPlus,  ShCtrlAltNumPlus,
(*  nicht da  *)  Scan79,   ShScan79,   CtrlScan79,   ShCtrlScan79,   AltScan79,   ShAltScan79,   CtrlAltScan79,   ShCtrlAltScan79,
(* Curs  Down *)  Down,     ShDown,     CtrlDown,     ShCtrlDown,     AltDown,     ShAltDown,     CtrlAltDown,     ShCtrlAltDown,
(*  nicht da  *)  Scan81,   ShScan81,   CtrlScan81,   ShCtrlScan81,   AltScan81,   ShAltScan81,   CtrlAltScan81,   ShCtrlAltScan81,
(* Insert     *)  Ins,      ShIns,      CtrlIns,      ShCtrlIns,      AltIns,      ShAltIns,      CtrlAltIns,      ShCtrlAltIns,
(* Delete     *)  Del,      ShDel,      CtrlDel,      ShCtrlDel,      AltDel,      ShAltDel,      CtrlAltDel,      ShCtrlAltDel,
(* Shift-F1   *)  Scan84,   ShScan84,   CtrlScan84,   ShCtrlScan84,   AltScan84,   ShAltScan84,   CtrlAltScan84,   ShCtrlAltScan84,
(* Shift-F2   *)  Scan85,   ShScan85,   CtrlScan85,   ShCtrlScan85,   AltScan85,   ShAltScan85,   CtrlAltScan85,   ShCtrlAltScan85,
(* Shift-F3   *)  Scan86,   ShScan86,   CtrlScan86,   ShCtrlScan86,   AltScan86,   ShAltScan86,   CtrlAltScan86,   ShCtrlAltScan86,
(* Shift-F4   *)  Scan87,   ShScan87,   CtrlScan87,   ShCtrlScan87,   AltScan87,   ShAltScan87,   CtrlAltScan87,   ShCtrlAltScan87,
(* Shift-F5   *)  Scan88,   ShScan88,   CtrlScan88,   ShCtrlScan88,   AltScan88,   ShAltScan88,   CtrlAltScan88,   ShCtrlAltScan88,
(* Shift-F6   *)  Scan89,   ShScan89,   CtrlScan89,   ShCtrlScan89,   AltScan89,   ShAltScan89,   CtrlAltScan89,   ShCtrlAltScan89,
(* Shift-F7   *)  Scan90,   ShScan90,   CtrlScan90,   ShCtrlScan90,   AltScan90,   ShAltScan90,   CtrlAltScan90,   ShCtrlAltScan90,
(* Shift-F8   *)  Scan91,   ShScan91,   CtrlScan91,   ShCtrlScan91,   AltScan91,   ShAltScan91,   CtrlAltScan91,   ShCtrlAltScan91,
(* Shift-F9   *)  Scan92,   ShScan92,   CtrlScan92,   ShCtrlScan92,   AltScan92,   ShAltScan92,   CtrlAltScan92,   ShCtrlAltScan92,
(* Shift-F10  *)  Scan93,   ShScan93,   CtrlScan93,   ShCtrlScan93,   AltScan93,   ShAltScan93,   CtrlAltScan93,   ShCtrlAltScan93,
(*  nicht da  *)  Scan94,   ShScan94,   CtrlScan94,   ShCtrlScan94,   AltScan94,   ShAltScan94,   CtrlAltScan94,   ShCtrlAltScan94,
(*  nicht da  *)  Scan95,   ShScan95,   CtrlScan95,   ShCtrlScan95,   AltScan95,   ShAltScan95,   CtrlAltScan95,   ShCtrlAltScan95,
(* < >        *)  Small,    ShSmall,    CtrlSmall,    ShCtrlSmall,    AltSmall,    ShAltSmall,    CtrlAltSmall,    ShCtrlAltSmall,
(* Undo       *)  Undo,     ShUndo,     CtrlUndo,     ShCtrlUndo,     AltUndo,     ShAltUndo,     CtrlAltUndo,     ShCtrlAltUndo,
(* Help       *)  Help,     ShHelp,     CtrlHelp,     ShCtrlHelp,     AltHelp,     ShAltHelp,     CtrlAltHelp,     ShCtrlAltHelp,
(* NumBlock ( *)  LBracket, ShLBracket, CtrlLBracket, ShCtrlLBracket, AltLBracket, ShAltLBracket, CtrlAltLBracket, ShCtrlAltLBracket,
(* NumBlock ) *)  RBracket, ShRBracket, CtrlRBracket, ShCtrlRBracket, AltRBracket, ShAltRBracket, CtrlAltRBracket, ShCtrlAltRBracket,
(* NumBlock / *)  Slash,    ShSlash,    CtrlSlash,    ShCtrlSlash,    AltSlash,    ShAltSlash,    CtrlAltSlash,    ShCtrlAltSlaSh,
(* NumBlock * *)  Asteric,  ShAsteric,  CtrlAsteric,  ShCtrlAsteric,  AltAsteric,  ShAltAsteric,  CtrlAltAsteric,  ShCtrlAltAsteric,
(* NumBlock 7 *)  Num7,     ShNum7,     CtrlNum7,     ShCtrlNum7,     AltNum7,     ShAltNum7,     CtrlAltNum7,     ShCtrlAltNum7,
(* NumBlock 8 *)  Num8,     ShNum8,     CtrlNum8,     ShCtrlNum8,     AltNum8,     ShAltNum8,     CtrlAltNum8,     ShCtrlAltNum8,
(* NumBlock 9 *)  Num9,     ShNum9,     CtrlNum9,     ShCtrlNum9,     AltNum9,     ShAltNum9,     CtrlAltNum9,     ShCtrlAltNum9,
(* NumBlock 4 *)  Num4,     ShNum4,     CtrlNum4,     ShCtrlNum4,     AltNum4,     ShAltNum4,     CtrlAltNum4,     ShCtrlAltNum4,
(* NumBlock 5 *)  Num5,     ShNum5,     CtrlNum5,     ShCtrlNum5,     AltNum5,     ShAltNum5,     CtrlAltNum5,     ShCtrlAltNum5,
(* NumBlock 6 *)  Num6,     ShNum6,     CtrlNum6,     ShCtrlNum6,     AltNum6,     ShAltNum6,     CtrlAltNum6,     ShCtrlAltNum6,
(* NumBlock 1 *)  Num1,     ShNum1,     CtrlNum1,     ShCtrlNum1,     AltNum1,     ShAltNum1,     CtrlAltNum1,     ShCtrlAltNum1,
(* NumBlock 2 *)  Num2,     ShNum2,     CtrlNum2,     ShCtrlNum2,     AltNum2,     ShAltNum2,     CtrlAltNum2,     ShCtrlAltNum2,
(* NumBlock 3 *)  Num3,     ShNum3,     CtrlNum3,     ShCtrlNum3,     AltNum3,     ShAltNum3,     CtrlAltNum3,     ShCtrlAltNum3,
(* NumBlock 0 *)  Num0,     ShNum0,     CtrlNum0,     ShCtrlNum0,     AltNum0,     ShAltNum0,     CtrlAltNum0,     ShCtrlAltNum0,
(* NumBlock . *)  NumPoint, ShNumPoint, CtrlNumPoint, ShCtrlNumPoint, AltNumPoint, ShAltNumPoint, CtrlAltNumPoint, ShCtrlAltNumPoint,
(* Enter      *)  Enter,    ShEnter,    CtrlEnter,    ShCtrlEnter,    AltEnter,    ShAltEnter,    CtrlAltEnter,    ShCtrlAltEnter,
(*  nicht da  *)  Scan115,  ShScan115,  CtrlScan115,  ShCtrlScan115,  AltScan115,  ShAltScan115,  CtrlAltScan115,  ShCtrlAltScan115,
(*  nicht da  *)  Scan116,  ShScan116,  CtrlScan116,  ShCtrlScan116,  AltScan116,  ShAltScan116,  CtrlAltScan116,  ShCtrlAltScan116,
(*  nicht da  *)  Scan117,  ShScan117,  CtrlScan117,  ShCtrlScan117,  AltScan117,  ShAltScan117,  CtrlAltScan117,  ShCtrlAltScan117,
(*  nicht da  *)  Scan118,  ShScan118,  CtrlScan118,  ShCtrlScan118,  AltScan118,  ShAltScan118,  CtrlAltScan118,  ShCtrlAltScan118,
(*  nicht da  *)  Scan119,  ShScan119,  CtrlScan119,  ShCtrlScan119,  AltScan119,  ShAltScan119,  CtrlAltScan119,  ShCtrlAltScan119,
(* Alt-1      *)  Scan120,  ShScan120,  CtrlScan120,  ShCtrlScan120,  AltScan120,  ShAltScan120,  CtrlAltScan120,  ShCtrlAltScan120,
(* Alt-2      *)  Scan121,  ShScan121,  CtrlScan121,  ShCtrlScan121,  AltScan121,  ShAltScan121,  CtrlAltScan121,  ShCtrlAltScan121,
(* Alt-3      *)  Scan122,  ShScan122,  CtrlScan122,  ShCtrlScan122,  AltScan122,  ShAltScan122,  CtrlAltScan122,  ShCtrlAltScan122,
(* Alt-4      *)  Scan123,  ShScan123,  CtrlScan123,  ShCtrlScan123,  AltScan123,  ShAltScan123,  CtrlAltScan123,  ShCtrlAltScan123,
(* Alt-5      *)  Scan124,  ShScan124,  CtrlScan124,  ShCtrlScan124,  AltScan124,  ShAltScan124,  CtrlAltScan124,  ShCtrlAltScan124,
(* Alt-6      *)  Scan125,  ShScan125,  CtrlScan125,  ShCtrlScan125,  AltScan125,  ShAltScan125,  CtrlAltScan125,  ShCtrlAltScan125,
(* Alt-7      *)  Scan126,  ShScan126,  CtrlScan126,  ShCtrlScan126,  AltScan126,  ShAltScan126,  CtrlAltScan126,  ShCtrlAltScan126,
(* Alt-8      *)  Scan127,  ShScan127,  CtrlScan127,  ShCtrlScan127,  AltScan127,  ShAltScan127,  CtrlAltScan127,  ShCtrlAltScan127,
(* Alt-9      *)  Scan128,  ShScan128,  CtrlScan128,  ShCtrlScan128,  AltScan128,  ShAltScan128,  CtrlAltScan128,  ShCtrlAltScan128,
(* Alt-0      *)  Scan129,  ShScan129,  CtrlScan129,  ShCtrlScan129,  AltScan129,  ShAltScan129,  CtrlAltScan129,  ShCtrlAltScan129,
(* Alt-      *)  Scan130,  ShScan130,  CtrlScan130,  ShCtrlScan130,  AltScan130,  ShAltScan130,  CtrlAltScan130,  ShCtrlAltScan130,
(* Alt-'      *)  Scan131,  ShScan131,  CtrlScan131,  ShCtrlScan131,  AltScan131,  ShAltScan131,  CtrlAltScan131,  ShCtrlAltScan131,
(*  nicht da  *)  Scan132,  ShScan132,  CtrlScan132,  ShCtrlScan132,  AltScan132,  ShAltScan132,  CtrlAltScan132,  ShCtrlAltScan132,
(* Nada       *)  NullChar); (*Phew!*)

TYPE  PtrKeyMap = POINTER TO KeyMap;
      KeyMap =    ARRAY [Esc..NullChar] OF CHAR;
                 (* Die Keymap bestimmt, welche Zeichen einem Tastendruck 
                  * zugeordnet werden.  Nicht jede Tastenkombination entspricht
                  * einen lesbarem Asciizeichen!
                  *)

CONST DkCircum = Bit0;  (* ^ *)
      DkTilde =  Bit1;  (* ~ *)
      DkAgui =   Bit2;  (* ' *)
      DkGrave =  Bit3;  (* ` *)
      DkQuote =  Bit4;  (* " *)
      DkSmoere = Bit5;  (*  *)
      DkCedil =  Bit6;  (* , *)
      DkSlash =  Bit7;  (* / *)


(* AES-Felder *)

TYPE  tAESGLOBAL =    RECORD
                       apVersion:     SHORTINT; (* globl 0 *)
                       apCount:       SHORTINT; (* globl 1 *)
                       apId:          SHORTINT; (* globl 2 *)
                       apPprivate:    LONGINT; (* globl 3/4 *)
                       apPtree:       SYSTEM.ADDRESS; (* globl 5/6*)
                       apPmem:        SYSTEM.ADDRESS; (* globl 7/8 *)
                       apLmem:        SHORTINT; (* globl 9 *)
                       apNplanes:     SHORTINT; (* globl 10 *)
                       Reserved1:     SHORTINT; (* globl 11 *)
                       Reserved2:     SHORTINT; (* globl 12 *)
                       apBvdisk:      BITSET;  (* globl 13 *)
                       apBvhard:      BITSET;  (* globl 14 *)
                      END;

TYPE  tControl =      RECORD
                       opcode:        SHORTINT;
                       sizeIntIn:     SHORTINT;
                       sizeIntOut:    SHORTINT;
                       sizeAddrIn:    SHORTINT;
                       sizeAddrOut:   SHORTINT;
                      END;

TYPE  tIntIn =        ARRAY [0..16] OF SHORTINT;
      tIntOut =       ARRAY [0.. 7] OF SHORTINT;
      tAddrIn =       ARRAY [0.. 2] OF SYSTEM.ADDRESS;
      tAddrOut =      ARRAY [0.. 1] OF SYSTEM.ADDRESS;

TYPE  PtrAESPB =      POINTER TO AESParablock;
      AESParablock =  RECORD
                       cbControl: POINTER TO tControl;
                       cbPglobal: POINTER TO tAESGLOBAL;
                       cbPintin:  POINTER TO tIntIn;
                       cbPintout: POINTER TO tIntOut;
                       cbPadrin:  POINTER TO tAddrIn;
                       cbPadrout: POINTER TO tAddrOut;
                      END;

(* VDI-Felder *)

TYPE  tCtrlArray =    ARRAY [0..512] OF SHORTINT;
      tVDICtrlArray = ARRAY [0.. 11] OF SHORTINT;

TYPE  PtrVDIPB =      POINTER TO VDIParablock;
      VDIParablock =  RECORD
                       control:   POINTER TO tVDICtrlArray;
                       intin:     POINTER TO tCtrlArray;
                       ptsin:     POINTER TO tCtrlArray;
                       intout:    POINTER TO tCtrlArray;
                       ptsout:    POINTER TO tCtrlArray;
                      END;

(* Eventhandler *)

CONST MaxHandler =      63; (* (0..MaxHandler) Handler maximal zulassen 
                             * Kann bei Bedarf erweitert werden, Magic
                             * reagiert darauf!!!
                             *)

TYPE  PtrEP =           POINTER TO EventParameter;
      EventParameter =  RECORD
                         id:      SHORTINT;
                         mstatus: BITSET;  (* Maustastenstatus *)
                         mx, my:  SHORTINT; (* Mausposition *)
                         mklicks: SHORTINT; (* Anzahl Klicks *)
                         kcode:   tKey;    (* mpKeyboard-Tastenkode *)
                         ktaste:  SHORTINT; (* AES-Tastenkode *)
                         kscan:   SHORTINT; (* Scancode *)
                         kascii:  CHAR;    (* Ascii-Kode *)
                         kstatus: BITSET;  (* Sondertastenstatus *)
                         mesag:   ARRAY [0..7] OF SHORTINT; (* Messagebuffer *)
                         stepin:  SHORTINT; (* TRUE = Rechteck betreten *)
                         ready:   SHORTINT; (* <> 0 Ereignis bearbeitet *)
                         app:     SYSTEM.ADDRESS;
                         res1:    BITSET;
                         res2:    BITSET;
                         res3:    SHORTINT;
                        END;
      
(*$?Compiler=Haenisch: (*$K+*) *)
TYPE  HandleEvent =    PROCEDURE (PtrEP);
(*$?Compiler=Haenisch: (*$K=*) *)

TYPE  HandlerArray =   ARRAY [0..MaxHandler] OF
                         RECORD
                          proc: HandleEvent;
                          used: SHORTINT;
                         END;

TYPE  TimerArray =      ARRAY [0..MaxHandler] OF
                         RECORD
                          proc:    HandleEvent;
                          time:    LONGINT;
                          elapsed: LONGINT;
                          used:    SHORTINT;
                         END;

TYPE  RectArray =       ARRAY [0..MaxHandler] OF
                         RECORD
                          proc: HandleEvent;
                          rect: tRect;
                          drin: SHORTINT;
                          used: SHORTINT;
                         END;

TYPE  PtrHandlerList =  POINTER TO tHandlerList;
      tHandlerList =    RECORD
                         max:        SHORTINT;
                         events:     BITSET;
                         disabled:   BITSET;
                         prioKeybd:  SHORTINT;
                         prioButton: SHORTINT;
                         prioMesag:  SHORTINT;
                         prioTimer:  SHORTINT;
                         parablock:  EventParameter;
                         keybd:      HandlerArray;
                         button:     HandlerArray;
                         mesag:      HandlerArray;
                         moved:      HandlerArray;
                         timer:      TimerArray;
                         rects:      RectArray;
                        END;


(* Magic Felder *)

TYPE  tLongArray =      ARRAY [0..15] OF LONGINT;
      tAddrArray =      ARRAY [0..15] OF SYSTEM.ADDRESS;

TYPE  PtrMagicPB =      POINTER TO MagicParablock;
      MagicParablock =  RECORD
                         IntIn:   tIntIn;
                         LongIn:  tLongArray;
                         AddrIn:  tAddrArray;
                         IntOut:  tIntIn;
                         LongOut: tLongArray;
                         AddrOut: tAddrArray;
                        END;


CONST MaxDials = 15; (* Stapeltiefe fr normale Dialoge. Kann bei Bedarf
                      * beliebig erweitert werden, Magic reagiert darauf.
                      *)

TYPE PtrDialstack =     POINTER TO DialStack;
     DialStack =        RECORD
                         stackptr: SHORTINT; (* Stapeltiefe der Dialoge *)
                         max:      SHORTINT; (* Wieviele drfens denn sein? *)
                         dials:    ARRAY [0..MaxDials] OF SYSTEM.ADDRESS;
                        END;

CONST MaxValues = 9; (* Anzahl der Eintrge im Valuetable.
                       * Kann beliebig erweitert werden, Magic reagiert darauf.
                       *)

TYPE  PtrAppValues =    POINTER TO AppValues;
      AppValues =       RECORD
                         max:    SHORTINT;
                         values: ARRAY [0..MaxValues] OF LONGINT;
                        END;
     

(* Parameterblcke *)

TYPE PtrApp =           POINTER TO Application;
     Application =      RECORD
                         AESPB:         PtrAESPB;   (* AES-Parameter *)
                         VDIPB:         PtrVDIPB;   (* VDI-Parameter *)
                         MagicPB:       PtrMagicPB; (* Magic Parameter *)
                         
                         (* Eventdispatcher *)
                         Handler:       PtrHandlerList;
                         
                         Dials:         SYSTEM.ADDRESS;
                         Alert:         SYSTEM.ADDRESS;
                         Stack:         PtrDialstack;
                         (* da steht spter fr jede Applikation die Liste 
                          * der Dialoge drin...
                          *)

                         Windows:       SYSTEM.ADDRESS;
                         TopWindow:     SYSTEM.ADDRESS;
                         TextWindow:    SYSTEM.ADDRESS;
                         TopTextwin:    SYSTEM.ADDRESS;
                         GraphWindow:   SYSTEM.ADDRESS; (* Not supported yet! *)
                         TopGraphwin:   SYSTEM.ADDRESS; (* Not supported yet! *)
                          (* ...und hier die Fenster... *)
                          
                         MainMenu:      SYSTEM.ADDRESS;
                         Menus:         SYSTEM.ADDRESS;
                          (* ...und die Menzeilen... *)
                          
                         Popups:        SYSTEM.ADDRESS;
                          (* ...und die Popups... *)
                        
                         Rsc:           SYSTEM.ADDRESS;
                          (* ...die geladenen Resourcen *)
                          
                         Workstations:  PtrWS;
                          (* Liste der Workstations *)

                         TermProc:      SYSTEM.ADDRESS;
                          (* Liste der End-Prozeduren *)
                          
                         Name:          SYSTEM.ADDRESS;
                          (* Zeiger auf Nullchar-terminierte Zeichenkette, 
                           * die den Namen des Programms enthlt
                           *)
                         
                         Values:        PtrAppValues;
                          (* Zeiger auf den Valuetable einer Applikation
                           * Hier werden diverse Werte zwischengespeichert,
                           * als Quasi-Konstanten sozusagen.
                           *)
                           
                         Keyboard:      PtrKeyMap;

                         flags:         LONGBITSET;
                         Ident:         LONGINT;
                         errcode:       LONGINT;
                         wucount:       LONGINT;
                         Reserved1:     SYSTEM.ADDRESS;
                         Reserved2:     SYSTEM.ADDRESS;
                         Reserved3:     SYSTEM.ADDRESS;
                         Reserved4:     SYSTEM.ADDRESS;
                         Reserved5:     SYSTEM.ADDRESS;
                          (* Vorsichtshalber, man weiss ja nie was kommt *)
                         Next:          PtrApp;
                        END;

CONST Appsize = SYSTEM.TSIZE (Application);


CONST AppGesperrt =   Bit0;  (* Applikationsspezifische Flags *)
      EndDispatch =   Bit1;
      ScreenLocked =  Bit2;
      ScreenControl = Bit3;
      MapNblock =     Bit4;  (* Gesetzt = Nummernblock auf normale Tastatur abbilden *)
      (* Alle anderen Flags sind fr interne Zwecke reserviert!!! *)

(* Typdeklarationen nach dem Profibuch *)

TYPE    Int11Array =    ARRAY [0.. 11] OF SHORTINT;
        Int255Array =   ARRAY [0..255] OF SHORTINT;
        Int512Array =   ARRAY [0..512] OF SHORTINT;

TYPE    PtrPD =         POINTER TO PD;
        PD =            RECORD
                         pLowtpa:       SYSTEM.ADDRESS;
                         pHitpa:        SYSTEM.ADDRESS;
                         pTbase:        SYSTEM.ADDRESS;
                         pTlen:         LONGINT;
                         pDbase:        SYSTEM.ADDRESS;
                         pDlen:         LONGINT;
                         pBbase:        SYSTEM.ADDRESS;
                         pBlen:         LONGINT;
                         pDta:          SYSTEM.ADDRESS;
                         pParent:       PtrPD;
                         res1:          SYSTEM.ADDRESS;
                         pEnv:          SYSTEM.ADDRESS;
                         devx:          ARRAY [0..5] OF SYSTEM.BYTE;
                         res2:          SYSTEM.BYTE;
                         defdrv:        SYSTEM.BYTE;
                         pUndef:        ARRAY [0..17] OF LONGINT;
                         pCmdlin:       ARRAY [0..126] OF CHAR;
                        END;

TYPE    BITBLK =        RECORD
                         bWd:           SHORTINT;
                         bHt:           SHORTINT;
                         planeCt:       SHORTINT;
                         fgCol:         SHORTINT;
                         bgCol:         SHORTINT;
                         opTab:         ARRAY [0..3] OF SYSTEM.BYTE;
                         sXmin:         SHORTINT;
                         sYmin:         SHORTINT;
                         sForm:         SYSTEM.ADDRESS;
                         sNxwd:         SHORTINT;
                         sNxln:         SHORTINT;
                         sNxpl:         SHORTINT;
                         dXmin:         SHORTINT;
                         dYmin:         SHORTINT;
                         dForm:         SYSTEM.ADDRESS;
                         dNxwd:         SHORTINT;
                         dNxln:         SHORTINT;
                         dNxpl:         SHORTINT;
                         pAddr:         SYSTEM.ADDRESS;
                         pNxln:         SHORTINT;
                         pNxpl:         SHORTINT;
                         pMask:         SHORTINT;
                         filler:        ARRAY [0..23] OF SYSTEM.BYTE;
                        END;

TYPE    PtrFONTHDR =    POINTER TO FONTHDR;
        FONTHDR =       RECORD
                         fontId:        SHORTINT;
                         point:         SHORTINT;
                         name:          ARRAY [0..31] OF CHAR;
                         firstAde:      SHORTINT;
                         lastAde:       SHORTINT;
                         top:           SHORTINT;
                         ascent:        SHORTINT;
                         half:          SHORTINT;
                         descent:       SHORTINT;
                         bottom:        SHORTINT;
                         maxCharwidth:  SHORTINT;
                         maxCellwidth:  SHORTINT;
                         leftOffset:    SHORTINT;
                         rightOffset:   SHORTINT;
                         thicken:       SHORTINT;
                         ulSize:        SHORTINT;
                         lighten:       SHORTINT;
                         skew:          SHORTINT;
                         flags:         BITSET;
                         horTable:      POINTER TO Int255Array;
                         offTable:      POINTER TO Int255Array;
                         datTable:      SYSTEM.ADDRESS;
                         formWidth:     SHORTINT;
                         formHeight:    SHORTINT;
                         nextFont:      PtrFONTHDR;
                        END;

TYPE    IMGHEADER =     RECORD
                         imVersion:     SHORTINT;
                         imHeadlength:  SHORTINT;
                         imNplanes:     SHORTINT;
                         imPatlen:      SHORTINT;
                         imPixwidth:    SHORTINT;
                         imPixheight:   SHORTINT;
                         imScanwidth:   SHORTINT;
                         imNlines:      SHORTINT;
                        END;

TYPE    PtrLINEA =      POINTER TO LINEAVARS;
        LINEAVARS =     RECORD
                         PLANES:        SHORTINT;
                         WIDTH:         SHORTINT;
                         CONTRL:        POINTER TO Int11Array;
                         INTIN:         POINTER TO Int255Array;
                         PTSIN:         POINTER TO Int255Array;
                         INTOUT:        POINTER TO Int255Array;
                         PTSOUT:        POINTER TO Int255Array;
                         COLBIT0:       SHORTINT;
                         COLBIT1:       SHORTINT;
                         COLBIT2:       SHORTINT;
                         COLBIT3:       SHORTINT;
                         LSTLIN:        SHORTINT;
                         LNMASK:        BITSET;
                         WMODE:         SHORTINT;
                         X1:            SHORTINT;
                         Y1:            SHORTINT;
                         X2:            SHORTINT;
                         Y2:            SHORTINT;
                         PATPTR:        SYSTEM.ADDRESS;
                         PATMSK:        BITSET;
                         MFILL:         SHORTINT;
                         CLIP:          SHORTINT;
                         XMINCL:        SHORTINT;
                         YMINCL:        SHORTINT;
                         XMAXCL:        SHORTINT;
                         YMAXCL:        SHORTINT;
                         XDDA:          SHORTINT;
                         DDAINC:        SHORTINT;
                         SCALDIR:       SHORTINT;
                         MONO:          SHORTINT;
                         SOURCEX:       SHORTINT;
                         SOURCEY:       SHORTINT;
                         DESTX:         SHORTINT;
                         DESTY:         SHORTINT;
                         DELX:          SHORTINT;
                         DELY:          SHORTINT;
                         FBASE:         PtrFONTHDR;
                         FWIDTH:        SHORTINT;
                         STYLE:         BITSET;
                         LITEMASK:      BITSET;
                         SKEWMASK:      BITSET;
                         WEIGHT:        SHORTINT;
                         ROFF:          SHORTINT;
                         LOFF:          SHORTINT;
                         SCALE:         SHORTINT;
                         CHUP:          SHORTINT;
                         TEXTFG:        SHORTINT;
                         SCRTCHP:       SYSTEM.ADDRESS;
                         SCRTP2:        SHORTINT;
                         TEXTBG:        SHORTINT;
                         COPYTRAN:      SHORTINT;
                         SEEDABORT:     SYSTEM.ADDRESS;
                        END;

TYPE    PtrLINEAFonts = POINTER TO LINEAFontArray;
        LINEAFontArray = ARRAY [0..2] OF PtrFONTHDR;

TYPE    METAHDR =       RECORD
                         mfHeader:      SHORTINT;
                         mfHlenght:     SHORTINT;
                         mfVersion:     SHORTINT;
                         mfNdcrcfl:     SHORTINT;
                         mfExtents:     ARRAY [0..3] OF SHORTINT;
                         mfPagesz:      ARRAY [0..1] OF SHORTINT;
                         mfCoords:      ARRAY [0..3] OF SHORTINT;
                         mfImgflag:     SHORTINT;
                         mfResvd:       ARRAY [0..8] OF SHORTINT;
                        END;

TYPE    MFORM =         RECORD
                         mfXhot:        SHORTINT;
                         mfYhot:        SHORTINT;
                         mfNplanes:     SHORTINT;
                         mfFg:          SHORTINT;
                         mfBg:          SHORTINT;
                         mfMask:        ARRAY [0..15] OF SHORTINT;
                         mfData:        ARRAY [0..15] OF SHORTINT;
                        END;

TYPE    RSHDR =         RECORD
                         rshVrsn:       SHORTINT;
                         rshObject:     SHORTINT;
                         rshTedinfo:    SHORTINT;
                         rshIconblk:    SHORTINT;
                         rshBitblk:     SHORTINT;
                         rshFrstr:      SHORTINT;
                         rshString:     SHORTINT;
                         rshImdata:     SHORTINT;
                         rshFrimg:      SHORTINT;
                         rshTrindex:    SHORTINT;
                         rshNobs:       SHORTINT;
                         rshNtree:      SHORTINT;
                         rshNted:       SHORTINT;
                         rshNib:        SHORTINT;
                         rshNbb:        SHORTINT;
                         rshNstring:    SHORTINT;
                         rshNimages:    SHORTINT;
                         rshRssize:     SYSTEM.WORD;
                        END;

TYPE    SDB =           RECORD
                         xhot:          SHORTINT;
                         yhot:          SHORTINT;
                         form:          SHORTINT;
                         bgcol:         SHORTINT;
                         fgcol:         SHORTINT;
                         image:         ARRAY [0..31] OF SHORTINT;
                        END;

TYPE    PtrSYSHDR =     POINTER TO SYSHDR;
        SYSHDR =        RECORD
                         osEntry:       SHORTINT; 
                         osVersion:     SHORTINT;
                         osReset:       SYSTEM.ADDRESS;
                         osBeg:         SYSTEM.ADDRESS;
                         osEnd:         SYSTEM.ADDRESS;
                         osRsv1:        SYSTEM.ADDRESS;
                         osMagic:       SYSTEM.ADDRESS;
                         osDate:        LONGINT;
                         osConf:        SHORTINT;
                         osDosdate:     SHORTINT;
                         root:          SYSTEM.ADDRESS;
                         kbshift:       SYSTEM.ADDRESS;
                         run:           SYSTEM.ADDRESS;
                         osRsv2:        SYSTEM.ADDRESS; 
                        END;

TYPE    PtrVDIESC =     POINTER TO VDIESCVars;
        VDIESCVars =    RECORD
                         RESERVED6:     LONGINT;
                         CURFONT:       POINTER TO FONTHDR;
                         RESERVED5:     ARRAY [0..23] OF SHORTINT;
                         MPOSHX:        SHORTINT;
                         MPOSHY:        SHORTINT;
                         MPLANES:       SHORTINT;
                         MCDBBG:        SHORTINT;
                         MCDBFG:        SHORTINT;
                         MASKFORM:      ARRAY [0..31] OF SHORTINT;
                         INQTAB:        ARRAY [0..44] OF SHORTINT;
                         DEVTAB:        ARRAY [0..44] OF SHORTINT;
                         GCURX:         SHORTINT;
                         GCURY:         SHORTINT;
                         MHIDCT:        SHORTINT;
                         MOUSEBT:       SHORTINT;
                         REQCOL:        ARRAY [0..47] OF SHORTINT;
                         SIZTAB:        ARRAY [0..14] OF SHORTINT;
                         RESERVED4:     ARRAY [0..1] OF SHORTINT;
                         CURWORK:       SYSTEM.ADDRESS;
                         DEFFONT:       POINTER TO FONTHDR;
                         FONTRING:      ARRAY [0..3] OF SYSTEM.ADDRESS;
                         FONTCOUNT:     SHORTINT;
                         RESERVED3:     ARRAY [0..44] OF SHORTINT;
                         CURMSSTAT:     SYSTEM.BYTE;
                         RESERVED2:     SYSTEM.BYTE;
                         VHIDCNT:       SHORTINT;
                         CURX:          SHORTINT;
                         CURY:          SHORTINT;
                         CURFLAG:       SYSTEM.BYTE;
                         MOUSEFLAG:     SYSTEM.BYTE;
                         RESERVED1:     LONGINT;
                         VSAVXY:        ARRAY [0..1] OF SHORTINT;
                         SAVELEN:       SHORTINT;
                         SAVEADDR:      SYSTEM.ADDRESS;
                         SAVESTAT:      BITSET;
                         SAVEAREA:      ARRAY [0..63] OF LONGINT;
                         USERTIM:       SYSTEM.ADDRESS;
                         NEXTTIM:       SYSTEM.ADDRESS;
                         USERBUT:       SYSTEM.ADDRESS;
                         USERCUR:       SYSTEM.ADDRESS;
                         USERMOT:       SYSTEM.ADDRESS;
                         VCELHT:        SHORTINT;
                         VCELMX:        SHORTINT;
                         VCELMY:        SHORTINT;
                         VCELWR:        SHORTINT;
                         VCOLBG:        SHORTINT;
                         VCOLFG:        SHORTINT;
                         VCURAD:        SYSTEM.ADDRESS;
                         VCUROF:        SHORTINT;
                         VCURXY:        ARRAY [0..1] OF SHORTINT;
                         VPERIOD:       SYSTEM.BYTE;
                         VCURCT:        SYSTEM.BYTE;
                         VFNTAD:        SYSTEM.ADDRESS;
                         VFNTND:        SHORTINT;
                         VFNTST:        SHORTINT;
                         VFNTWD:        SHORTINT;
                         VREZHZ:        SHORTINT;
                         VOFFAD:        SYSTEM.ADDRESS;
                         RESERVED:      SHORTINT;
                         VREZVT:        SHORTINT;
                         BYTESLIN:      SHORTINT;
                        END;

TYPE tChar =    RECORD
                 CASE x: SHORTINT OF
                  0: long:   LONGINT;|
                  1: hi, lo: SHORTINT;|
                  2: kbshift, reserved, scan, char: CHAR;
                 END;
                END;

TYPE    PtrDTA =        POINTER TO mDTA;
        mDTA =          RECORD
                         dReserved: ARRAY [0..20] OF SYSTEM.BYTE;
                         dAttrib:   SYSTEM.BYTE;
                         dTime:     SHORTINT;
                         dDate:     SHORTINT;
                         dLength:   LONGINT;
                         dFname:    ARRAY [0..13] OF CHAR;
                        END;

CONST   ReadOnly =      Bit0;
        Hidden =        Bit1;
        Systemfile =    Bit2;
        Volume =        Bit3;
        Folder =        Bit4;
        Archive =       Bit5;


(* MiNT Signale und Konstanten *)

CONST NSIG =      31;       (* number of signals recognized    *)
      SIGNULL =    0;       (* not really a signal             *)
      SIGHUP =     1;       (* hangup signal                   *)
      SIGINT =     2;       (* sent by ^C                      *)
      SIGQUIT =    3;       (* quit signal                     *)
      SIGILL =     4;       (* illegal instruction             *)
      SIGTRAP =    5;       (* trace trap                      *)
      SIGABRT =    6;       (* abort signal                    *)
      SIGPRIV =    7;       (* privilege violation             *)
      SIGFPE =     8;       (* divide by zero                  *)
      SIGKILL =    9;       (* cannot be ignored               *)
      SIGBUS =    10;       (* bus error                       *)
      SIGSEGV =   11;       (* illegal memory reference        *)
      SIGSYS =    12;       (* bad argument to a system call   *)
      SIGPIPE =   13;       (* broken pipe                     *)
      SIGALRM =   14;       (* alarm clock                     *)
      SIGTERM =   15;       (* software termination signal     *)
      SIGURG =    16;       (* urgent condition on I/O channel *)
      SIGSTOP =   17;       (* stop signal not from terminal   *)
      SIGTSTP =   18;       (* stop signal from terminal       *)
      SIGCONT =   19;       (* continue stopped process        *)
      SIGCHLD =   20;       (* child stopped or exited         *)
      SIGTTIN =   21;       (* read by background process      *)
      SIGTTOU =   22;       (* write by background process     *)
      SIGIO =     23;       (* I/O possible on a descriptor    *)
      SIGXCPU =   24;       (* CPU time exhausted              *)
      SIGXFSZ =   25;       (* file size limited exceeded      *)
      SIGVTALRM = 26;       (* virtual timer alarm             *)
      SIGPROF =   27;       (* profiling timer expired         *)
      SIGWINCH =  28;       (* window size changed             *)
      SIGUSR1 =   29;       (* user signal 1                   *)
      SIGUSR2 =   30;       (* user signal 2                   *)
      SIG_DFL =    0;       (* default signal handler          *)
      SIG_IGN =    1;       (* ignore the signal               *)

END M_Types.

