(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
 
DEFINITION MODULE M_Utils;

FROM SYSTEM IMPORT BYTE, ADDRESS;
FROM M_Types IMPORT tRect;
FROM M_AES IMPORT Objcspec, PtrObjcspec, tObjctree;

TYPE    AnyType =       RECORD
                         CASE : SHORTINT OF
                          0: int:  LONGINT;|
                          2: hword: SHORTCARD; lword: SHORTCARD;|
                          4: b4: BYTE; b3: BYTE; b2: BYTE; b1: BYTE;|
                         END;
                        END;

PROCEDURE InclFlag (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD);
PROCEDURE ExclFlag (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD);
PROCEDURE SetFlag (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD; setit: BOOLEAN);
PROCEDURE InFlag (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD): BOOLEAN;
PROCEDURE InclState (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD);
PROCEDURE ExclState (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD);
PROCEDURE InState (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD): BOOLEAN;
PROCEDURE SetState (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD; setit: BOOLEAN);
PROCEDURE ObjcString (tree: tObjctree; entry: SHORTINT; VAR str: ARRAY OF CHAR);
PROCEDURE ObjcFString (tree: tObjctree; entry: SHORTINT; VAR str: ARRAY OF CHAR);
PROCEDURE SetObjcString (tree: tObjctree; entry: SHORTINT; str: ARRAY OF CHAR);
PROCEDURE ObjcStringAdr (tree: tObjctree; entry: SHORTINT): ADDRESS;
PROCEDURE SetObjcStringAdr (tree: tObjctree; entry: SHORTINT; str: ADDRESS);
PROCEDURE ObjcStrLen (tree: tObjctree; entry: SHORTINT;
                      VAR textLen, tmpltLen: SHORTINT);
PROCEDURE ObjcColor (tree: tObjctree; entry: SHORTINT;
                     VAR inner, text, frame, raster: SHORTINT);
PROCEDURE SetObjcColor (tree: tObjctree;
                        entry, inner, text, frame, raster: SHORTINT);
PROCEDURE ObjcPos (tree: tObjctree; entry: SHORTINT; VAR x, y: SHORTINT);
PROCEDURE ObjcParent (tree: tObjctree; entry: SHORTINT): SHORTINT;
PROCEDURE ObjcRect (tree: tObjctree; entry: SHORTINT; VAR rect: tRect);
PROCEDURE SetObjcRect (tree: tObjctree; entry: SHORTINT; rect: tRect);
PROCEDURE ObjcArea (tree: tObjctree; entry: SHORTINT; VAR rect: tRect);
PROCEDURE ObjcFrame (tree: tObjctree; entry: SHORTINT): SHORTINT;
PROCEDURE CalcArea (tree: tObjctree; entry: SHORTINT; VAR rect: tRect);

TYPE    ScanType = (SearchType, SearchState, SearchFlags);

PROCEDURE ScanFlags (tree: tObjctree; styp: ScanType;
                    entry, typ: SHORTINT; flag: SHORTCARD): SHORTINT;
PROCEDURE SetObjc (tree: tObjctree; num, parent, typ: SHORTINT;
                   flags, state: BITSET;  spec: Objcspec; 
                   obx, oby, obw, obh: SHORTINT; add: BOOLEAN);
PROCEDURE GetObjcspec (tree: tObjctree; entry: SHORTINT): PtrObjcspec;

TYPE BounceMode = (Left, Right, Both);

PROCEDURE Bounce (mode: BounceMode);
PROCEDURE AbsRect (VAR rect: tRect);
PROCEDURE RelRect (VAR rect: tRect);
PROCEDURE RectToVars (rect: tRect;  abs: BOOLEAN;
                      VAR x, y, w, h: SHORTINT);
PROCEDURE VarsToRect (x, y, w, h: SHORTINT; abs: BOOLEAN; VAR rect: tRect);
PROCEDURE AbsRectToVars (rect: tRect;  abs: BOOLEAN;
                         VAR x, y, w, h: SHORTINT);
PROCEDURE AbsVarsToRect (x, y, w, h: SHORTINT; abs: BOOLEAN;
                         VAR rect: tRect);
PROCEDURE DecAbsRect (VAR r: tRect; num: SHORTINT);
PROCEDURE DecRelRect (VAR r: tRect; num: SHORTINT);
PROCEDURE IncAbsRect (VAR r: tRect; num: SHORTINT);
PROCEDURE IncRelRect (VAR r: tRect; num: SHORTINT);
PROCEDURE InAbsRect (x, y: SHORTINT; rect: tRect): BOOLEAN;
PROCEDURE InRelRect (x, y: SHORTINT; rect: tRect): BOOLEAN;
PROCEDURE CalcSlider (max, act, fpos: SHORTINT; VAR pos, size: SHORTINT);
PROCEDURE CalcDocPos (max, act, spos: SHORTINT): SHORTINT;

END M_Utils.
