(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Utils;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM SYSTEM IMPORT ADDRESS, ADR;
FROM M_Sys  IMPORT App, CallMagic, CastToInt;
FROM M_Types IMPORT tRect;
FROM M_AES IMPORT Objcspec, PtrObjcspec, tObjctree;


PROCEDURE InclFlag (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD);
BEGIN
 INCL (tree^[entry].obFlags, bit);
END InclFlag;

PROCEDURE ExclFlag (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD);
BEGIN
 EXCL (tree^[entry].obFlags, bit);
END ExclFlag;

PROCEDURE SetFlag (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD; setit: BOOLEAN);
BEGIN
 IF setit THEN  INCL (tree^[entry].obFlags, bit)
          ELSE  EXCL (tree^[entry].obFlags, bit);
 END;
END SetFlag;

PROCEDURE InFlag (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD): BOOLEAN;
BEGIN
  RETURN bit IN tree^[entry].obFlags;
END InFlag;

PROCEDURE InclState (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD);
BEGIN
  INCL (tree^[entry].obState, bit);
END InclState;

PROCEDURE ExclState (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD);
BEGIN
  EXCL (tree^[entry].obState, bit);
END ExclState;

PROCEDURE SetState (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD; setit: BOOLEAN);
BEGIN
 IF setit THEN  INCL (tree^[entry].obState, bit)
          ELSE  EXCL (tree^[entry].obState, bit);
 END;
END SetState;

PROCEDURE InState (tree: tObjctree; entry: SHORTINT; bit: SHORTCARD): BOOLEAN;
BEGIN
  RETURN bit IN tree^[entry].obState;
END InState;

(*----------------------------------------------------------------------*)

PROCEDURE ObjcString (tree: tObjctree; entry: SHORTINT; VAR str: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (str);
  IntIn[0]:= entry;
 END;
 CallMagic (2208);
END ObjcString;

PROCEDURE ObjcFString (tree: tObjctree; entry: SHORTINT; VAR str: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (str);
  IntIn[0]:= entry;
 END;
 CallMagic (2240);
END ObjcFString;

PROCEDURE ObjcStringAdr (tree: tObjctree; entry: SHORTINT): ADDRESS;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  CallMagic (2210);
  RETURN AddrOut[0];
 END;
END ObjcStringAdr;

PROCEDURE SetObjcString (tree: tObjctree; entry: SHORTINT; str: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (str);
  IntIn[0]:= entry;
 END;
 CallMagic (2209);
END SetObjcString;

PROCEDURE SetObjcStringAdr (tree: tObjctree; entry: SHORTINT; str: ADDRESS);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= str;
  IntIn[0]:= entry;
 END;
 CallMagic (2211);
END SetObjcStringAdr;

PROCEDURE ObjcStrLen (tree: tObjctree; entry: SHORTINT;
                      VAR textlen, tmpltlen: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  CallMagic (2212);
  textlen:= IntOut[0];
  tmpltlen:= IntOut[1];
 END;
END ObjcStrLen;

(*----------------------------------------------------------------------*)

PROCEDURE ObjcColor (tree: tObjctree; entry: SHORTINT;
                     VAR inner, text, frame, raster: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  CallMagic (2213);
  inner:= IntOut[0];
  text:= IntOut[1];
  frame:= IntOut[2];
  raster:= IntOut[3];
 END;
END ObjcColor;

PROCEDURE SetObjcColor (tree: tObjctree;
                        entry, inner, text, frame, raster: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  IntIn[1]:= inner;
  IntIn[2]:= text;
  IntIn[3]:= frame;
  IntIn[4]:= raster;
 END;
 CallMagic (2214);
END SetObjcColor;

(*----------------------------------------------------------------------*)

PROCEDURE ObjcParent (tree: tObjctree; entry: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  CallMagic (2216);
  RETURN IntOut[0];
 END;
END ObjcParent;
        
PROCEDURE ObjcPos (tree: tObjctree; entry: SHORTINT; VAR x, y: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  CallMagic (2215);
  x:=  IntOut[0];
  y:=  IntOut[1];
 END;
END ObjcPos;

PROCEDURE ObjcArea (tree: tObjctree; entry: SHORTINT; VAR rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (rect);
  IntIn[0]:= entry;
 END;
 CallMagic (2219);
END ObjcArea;

PROCEDURE ObjcRect (tree: tObjctree; entry: SHORTINT; VAR rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (rect);
  IntIn[0]:= entry;
 END;
 CallMagic (2217);
END ObjcRect;

PROCEDURE SetObjcRect (tree: tObjctree; entry: SHORTINT; rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (rect);
  IntIn[0]:= entry;
 END;
 CallMagic (2218);
END SetObjcRect;

PROCEDURE ObjcFrame (tree: tObjctree; entry: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  CallMagic (2220);
  RETURN IntOut[0];
 END;
END ObjcFrame;

PROCEDURE CalcArea (tree: tObjctree; entry: SHORTINT; VAR rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  AddrIn[1]:= ADR (rect);
  IntIn[0]:= entry;
 END;
 CallMagic (2221);
END CalcArea;

PROCEDURE ScanFlags (tree: tObjctree; styp: ScanType;
                    entry, typ: SHORTINT; flag: SHORTCARD): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= ORD (styp);
  IntIn[1]:= entry;
  IntIn[2]:= typ;
  IntIn[3]:= ORD (flag);
  CallMagic (2222);
  RETURN IntOut[0];
 END;
END ScanFlags;

PROCEDURE SetObjc (tree: tObjctree; num, parent, typ: SHORTINT;
                   flags, state: BITSET;  spec: Objcspec; 
                   obx, oby, obw, obh: SHORTINT; add: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  LongIn[0]:= LONGINT (spec.address);
  IntIn[0]:= num;
  IntIn[1]:= parent;
  IntIn[2]:= typ;
  IntIn[3]:= CastToInt (flags);
  IntIn[4]:= CastToInt (state);
  IntIn[5]:= obx;
  IntIn[6]:= oby;
  IntIn[7]:= obw;
  IntIn[8]:= obh;
  IntIn[8]:= ORD (add);
 END;
 CallMagic (2223);
END SetObjc;

PROCEDURE GetObjcspec (tree: tObjctree; entry: SHORTINT): PtrObjcspec;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= tree;
  IntIn[0]:= entry;
  CallMagic (2224);
  RETURN AddrOut[0];
 END;
END GetObjcspec;

PROCEDURE Bounce (mode: BounceMode);
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (mode);
 CallMagic (2225);
END Bounce;

PROCEDURE AbsRect (VAR rect: tRect);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADR (rect);
 CallMagic (2226);
END AbsRect;

PROCEDURE RelRect (VAR rect: tRect);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADR (rect);
 CallMagic (2227);
END RelRect;

PROCEDURE RectToVars (rect: tRect;  abs: BOOLEAN;
                      VAR x, y, w, h: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= ORD (abs);
  CallMagic (2228);
  x:= IntOut[0];
  y:= IntOut[1];
  w:= IntOut[2];
  h:= IntOut[3];
 END;
END RectToVars;

PROCEDURE VarsToRect (x, y, w, h: SHORTINT; abs: BOOLEAN;
                      VAR rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= x;
  IntIn[1]:= y;
  IntIn[2]:= w;
  IntIn[3]:= h;
  IntIn[4]:= ORD (abs);
 END;
 CallMagic (2229);
END VarsToRect;

PROCEDURE AbsRectToVars (rect: tRect;  abs: BOOLEAN;
                         VAR x, y, w, h: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= ORD (abs);
  CallMagic (2230);
  x:= IntOut[0];
  y:= IntOut[1];
  w:= IntOut[2];
  h:= IntOut[3];
 END;
END AbsRectToVars;

PROCEDURE AbsVarsToRect (x, y, w, h: SHORTINT; abs: BOOLEAN;
                         VAR rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= x;
  IntIn[1]:= y;
  IntIn[2]:= w;
  IntIn[3]:= h;
  IntIn[4]:= ORD (abs);
 END;
 CallMagic (2231);
END AbsVarsToRect;

PROCEDURE InAbsRect (x, y: SHORTINT; rect: tRect): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= x;
  IntIn[1]:= y;
  CallMagic (2232);
  RETURN IntOut[0] = 1;
 END;
END InAbsRect;

PROCEDURE InRelRect (x, y: SHORTINT; rect: tRect): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= x;
  IntIn[1]:= y;
  CallMagic (2233);
  RETURN IntOut[0] = 1;
 END;
END InRelRect;

PROCEDURE DecAbsRect (VAR r: tRect; num: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (r);
  IntIn[0]:= num;
 END;
 CallMagic (2236);
END DecAbsRect;

PROCEDURE DecRelRect (VAR r: tRect; num: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (r);
  IntIn[0]:= num;
 END;
 CallMagic (2237);
END DecRelRect;

PROCEDURE IncAbsRect (VAR r: tRect; num: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (r);
  IntIn[0]:= num;
 END;
 CallMagic (2238);
END IncAbsRect;

PROCEDURE IncRelRect (VAR r: tRect; num: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (r);
  IntIn[0]:= num;
 END;
 CallMagic (2239);
END IncRelRect;

PROCEDURE CalcSlider (max, act, fpos: SHORTINT; VAR pos, size: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= max;
  IntIn[1]:= act;
  IntIn[2]:= fpos;
  CallMagic (2234);
  pos:= IntOut[0];
  size:= IntOut[1];
 END;
END CalcSlider;

PROCEDURE CalcDocPos (max, act, spos: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= max;
  IntIn[1]:= act;
  IntIn[2]:= spos;
  CallMagic (2235);
  RETURN IntOut[0];
 END;
END CalcDocPos;


END M_Utils.
