(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * MagicVDI     Virtual Device Interface             Modula-2 Interface *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_VDI;

IMPORT SYSTEM, M_Types;

(*-- VDI-Parameter ---------------------------------------------------*)

TYPE    tWorkIn =        ARRAY [0.. 10] OF SHORTINT;
        tWorkOut =       ARRAY [0.. 57] OF SHORTINT;
        tPxyArray =      ARRAY [0..  3] OF SHORTINT;
        tBigPxyArray =   ARRAY [0..  7] OF SHORTINT;
        tMouseArray =    ARRAY [0.. 38] OF SHORTINT;
        tSmallArray =    ARRAY [0..  1] OF SHORTINT;
        tRGBArray =      ARRAY [0..  2] OF SHORTINT;
        tTextAttrArray = ARRAY [0..  9] OF SHORTINT;
        tFontName =      ARRAY [0.. 31] OF CHAR;
        tDistanceArray = ARRAY [0..  4] OF SHORTINT;
        tFilmName =      ARRAY [0..124] OF CHAR;
        tFilmIndex =     ARRAY [0..7],[0..1] OF SHORTINT;
        tCtrlArray =     ARRAY [0..512] OF SHORTINT;
        tVDICtrlArray =  ARRAY [0.. 11] OF SHORTINT;

PROCEDURE VDICall (c0, c1, c3, c5, c6: SHORTINT);

CONST   NoGdos =   00FFFFFFFEH;  (* Kein GDOS isntalliert *)
        Gdos =     000007E88AH;  (* GDOS 1.1 von Atari Corp. *)
        AMCGdos =  000007E864H;  (* AMCGDos von Arnd Beissner *)
        AMCLight = 000007E8BAH;  (* GEMINI-Spezial-GDos von Arnd Beissner *)
        NVDI =     0000000000H;  (* NVDI von Bela GmbH *)

PROCEDURE vq_gdos (): LONGINT;
(* Achtung, das ABC-GEM (GEM 2.1) schmiert bei dieser Funktion ab!!! *)

(*-- VDI-Attrib ------------------------------------------------------*)

CONST   REPLACE =        1;      (* Schreibmodi *)
        TRANSPARENT =    2;
        XORMODE =        3;
        REVTRANSPARENT = 4;

PROCEDURE vswr_mode (handle, mode: SHORTINT): SHORTINT;
PROCEDURE vs_color (handle, index: SHORTINT; rgb: tRGBArray);
          
CONST   Line =          1;      (* Linienstile *)
        LongDash =      2;
        Dot =           3;
        DashDot =       4;
        Dash =          5;
        DashDotDot =    6;
        User =          7;

PROCEDURE vsl_type (handle, typ: SHORTINT): SHORTINT;
PROCEDURE vsl_udsty (handle: SHORTINT; style: SHORTCARD);
PROCEDURE vsl_width (handle, width: SHORTINT): SHORTINT;
PROCEDURE vsl_color (handle, color: SHORTINT): SHORTINT;

CONST   Cornerd =       0;      (* Linien-Endtypen *)
        Arrow =         1;
        Rounded =       2;
                      
PROCEDURE vsl_ends (handle, begstyle, endstyle: SHORTINT);

CONST   Point =         1;      (* Markertypen *)
        Plus =          2;
        Star =          3;
        Square =        4;
        Cross =         5;
        Diamond =       6;

PROCEDURE vsm_type (handle, typ: SHORTINT): SHORTINT;
PROCEDURE vsm_height (handle, height: SHORTINT): SHORTINT; 
PROCEDURE vsm_color (handle, index: SHORTINT): SHORTINT;
PROCEDURE vst_height (handle, h: SHORTINT; VAR cw, ch, bw, bh: SHORTINT);
PROCEDURE vst_point (handle, h: SHORTINT; VAR cw, ch, bw, bh: SHORTINT): SHORTINT;
PROCEDURE vst_rotation (handle, angle: SHORTINT): SHORTINT;
PROCEDURE vst_font (handle, font: SHORTINT): SHORTINT;
PROCEDURE vst_color (handle, index: SHORTINT): SHORTINT;

CONST   Fat =           M_Types.Bit0;      (* Text-Effekte *)
        Light =         M_Types.Bit1;
        Italic =        M_Types.Bit2;
        Underline =     M_Types.Bit3;
        Outline =       M_Types.Bit4;
        Shadowed =      M_Types.Bit5;

PROCEDURE vst_effects (handle: SHORTINT; effect: BITSET; VAR old: BITSET);

CONST   LeftJust =      0;
        Centerd =       1;
        RightJust =     2;

CONST   BaseJust =      0;
        HalfJust =      1;
        AscentJust =    2;
        BottomJust =    3;
        DescentJust =   4;
        TopJust =       5;

PROCEDURE vst_alignment (handle, hin, vin: SHORTINT; VAR hout, vout: SHORTINT);

CONST   None =          0;      (* Flltypen *)
        Full =          1;
        Pattern =       2;
        Hatch =         3;
        UserFill =      4;

PROCEDURE vsf_interior (handle: SHORTINT; index: SHORTINT): SHORTINT;
PROCEDURE vsf_style (handle, style: SHORTINT): SHORTINT;
PROCEDURE vsf_color (handle, index: SHORTINT): SHORTINT; 
PROCEDURE vsf_perimeter (handle: SHORTINT; border: BOOLEAN): BOOLEAN;
PROCEDURE vsf_udpat (handle: SHORTINT; pat: SYSTEM.ADDRESS; planes: SHORTINT);

(*-- VDI-Control -----------------------------------------------------*)


PROCEDURE v_opnwk (VAR win: tWorkIn; VAR handle: SHORTINT; VAR wout: tWorkOut);
PROCEDURE v_clswk  (handle: SHORTINT);
PROCEDURE v_opnvwk (VAR win: tWorkIn; VAR handle: SHORTINT; VAR wout: tWorkOut);
PROCEDURE v_clsvwk (handle: SHORTINT);
PROCEDURE v_clrwk (handle: SHORTINT);
PROCEDURE v_updwk (handle: SHORTINT);
PROCEDURE vst_load_fonts (handle, select: SHORTINT): SHORTINT;
PROCEDURE vst_unload_fonts (handle, select: SHORTINT);
PROCEDURE vs_clip (handle: SHORTINT; rect: M_Types.tRect; doit: BOOLEAN);

(*-- VDI-Escape ------------------------------------------------------*)

PROCEDURE vq_chcells (handle: SHORTINT; VAR rows, colums: SHORTINT);
PROCEDURE v_exit_cur (handle: SHORTINT);
PROCEDURE v_enter_cur (handle: SHORTINT);
PROCEDURE v_curup (handle: SHORTINT);
PROCEDURE v_curdown (handle: SHORTINT);
PROCEDURE v_curright (handle : SHORTINT);
PROCEDURE v_curleft (handle: SHORTINT);
PROCEDURE v_curhome (handle: SHORTINT);
PROCEDURE v_eeos (handle: SHORTINT);
PROCEDURE v_eeol (handle: SHORTINT);
PROCEDURE v_curaddress (handle, row, column: SHORTINT);
PROCEDURE v_curtext (handle: SHORTINT; (* REF *)  str: ARRAY OF CHAR);
PROCEDURE v_rvon (handle: SHORTINT);
PROCEDURE v_rvoff (handle: SHORTINT);
PROCEDURE vq_curaddress (handle: SHORTINT; VAR row, column: SHORTINT);
PROCEDURE vq_tabstatus (handle: SHORTINT): SHORTINT;
PROCEDURE v_hardcopy (handle: SHORTINT);
PROCEDURE v_dspcur (handle, x, y: SHORTINT);
PROCEDURE v_rmcur (handle: SHORTINT);
PROCEDURE v_form_adv (handle: SHORTINT);
PROCEDURE v_output_window (handle: SHORTINT; pxy: M_Types.tRect);
PROCEDURE v_clear_disp_list (handle: SHORTINT);
PROCEDURE v_bit_image (handle: SHORTINT; (* REF *)  fileName: ARRAY OF CHAR; aspect, scaling, numPts: SHORTINT; pxy: SYSTEM.ADDRESS);
PROCEDURE vq_scan (handle: SHORTINT; VAR gSlice, gPage, size, page, dv: SHORTINT);
PROCEDURE v_alpha_text (handle: SHORTINT; (* REF *)  str: ARRAY OF CHAR);
PROCEDURE vs_palette (handle, palette: SHORTINT): SHORTINT;
PROCEDURE v_sound (handle, freq, time: SHORTINT);
PROCEDURE vs_mute (handle, action: SHORTINT);
PROCEDURE vt_resolution (handle, xres, yres: SHORTINT; VAR xset, yset: SHORTINT);
PROCEDURE vt_axis (handle, xres, yres: SHORTINT; VAR xset, yset: SHORTINT);
PROCEDURE vt_origin (handle, x, y: SHORTINT);
PROCEDURE vq_tdimensions (handle: SHORTINT; VAR x, y: SHORTINT);
PROCEDURE vt_alignment (handle, x, y: SHORTINT);
PROCEDURE vsp_film (handle, index, light: SHORTINT);
PROCEDURE vqp_filmname (handle: SHORTINT; VAR filmName: ARRAY OF CHAR);
PROCEDURE vsc_expose (handle, state: SHORTINT);
PROCEDURE v_meta_extents (handle, minX, minY, maxX, maxY: SHORTINT);
PROCEDURE v_write_meta (handle, numIntin: SHORTINT; intIn: SYSTEM.ADDRESS; numPtsin: SHORTINT; ptsIn: SYSTEM.ADDRESS);
PROCEDURE vm_pagesize (handle, width, height: SHORTINT);
PROCEDURE vm_coords (handle, llx, lly, urx, ury: SHORTINT);
PROCEDURE vm_filename (handle: SHORTINT; (* REF *)  fileName: ARRAY OF CHAR);
PROCEDURE v_offset (handle, offset: SHORTINT);
PROCEDURE v_fontinit (handle: SHORTINT; header: SYSTEM.ADDRESS);

(*-- VDI-Input -------------------------------------------------------*)

CONST   Mouse =         1;      (* Device-Typen *)
        Cursor =        2;
        FKey =          3;
        Keyboard =      4;

CONST   Request =       1;      (* Input-Modus *)
        Sample =        2;

PROCEDURE vsin_mode (handle, device, mode: SHORTINT): SHORTINT;
PROCEDURE vrq_locator (handle, x, y: SHORTINT; VAR xo, yo: SHORTINT; VAR term: CHAR);
PROCEDURE vsm_locator (handle, x, y: SHORTINT; VAR xo, yo: SHORTINT; VAR term: CHAR; VAR result: BITSET);
PROCEDURE vrq_valuator (handle, inv: SHORTINT; VAR out: SHORTINT; VAR term: CHAR);
PROCEDURE vsm_valuator (handle, inv: SHORTINT; VAR out: SHORTINT; VAR term: CHAR; VAR result: BITSET);
PROCEDURE vrq_choice (handle, inv: SHORTINT; VAR out: SHORTINT);
PROCEDURE vsm_choice (handle: SHORTINT; VAR choice: SHORTINT): SHORTINT;
PROCEDURE vrq_string (handle, len: SHORTINT; echo: BOOLEAN; x, y: SHORTINT; VAR str: ARRAY OF CHAR);
PROCEDURE vsm_string (handle, len: SHORTINT; echo: BOOLEAN; x, y: SHORTINT; VAR str: ARRAY OF CHAR): SHORTINT;
PROCEDURE vsc_form (handle: SHORTINT; form: SYSTEM.ADDRESS);
PROCEDURE v_show (handle: SHORTINT; reset: BOOLEAN);
PROCEDURE v_hide (handle: SHORTINT);
PROCEDURE vq_mouse (handle: SHORTINT; VAR stat: BITSET; VAR x, y: SHORTINT);
PROCEDURE vex_timv (handle: SHORTINT; new: SYSTEM.ADDRESS; VAR intervall: SHORTINT): SYSTEM.ADDRESS;
PROCEDURE vex_butv (handle: SHORTINT; new: SYSTEM.ADDRESS): SYSTEM.ADDRESS;
PROCEDURE vex_motv (handle: SHORTINT; new: SYSTEM.ADDRESS): SYSTEM.ADDRESS;
PROCEDURE vex_curv (handle: SHORTINT; new: SYSTEM.ADDRESS): SYSTEM.ADDRESS;

CONST   KRSHIFT =       M_Types.Bit0;   (* Tastatur-Status *)
        KLSHIFT =       M_Types.Bit1;
        KCTRL =         M_Types.Bit2;
        KALT =          M_Types.Bit3;
        KCAPS =         M_Types.Bit4;   (* Fr VDI undokumentiert *)

PROCEDURE vq_key_s (handle: SHORTINT; VAR status: BITSET);


(*-- VDI-Inquire -----------------------------------------------------*)

CONST   Workstation =   0;
        Extended =      1;

PROCEDURE vq_extnd (handle, wich: SHORTINT; VAR out: tWorkOut);
PROCEDURE vq_color (handle, color: SHORTINT; setit: BOOLEAN; VAR rgb: tRGBArray);
PROCEDURE vql_attributes (handle: SHORTINT; VAR attrib: tPxyArray);
PROCEDURE vqm_attributes (handle: SHORTINT; VAR attrib: tPxyArray);
PROCEDURE vqf_attributes (handle: SHORTINT; VAR attrib: tDistanceArray);
PROCEDURE vqt_attributes (handle: SHORTINT; VAR attrib: tTextAttrArray);
PROCEDURE vqt_extent (handle: SHORTINT; (* REF *)  str: ARRAY OF CHAR; VAR extent: tBigPxyArray);
PROCEDURE vqt_width (handle: SHORTINT; ch: CHAR; VAR width, left, right: SHORTINT): SHORTINT;
PROCEDURE vqt_name (handle, element: SHORTINT; VAR name: ARRAY OF CHAR): SHORTINT;
PROCEDURE vq_cellarray (handle: SHORTINT; pxy: M_Types.tRect; len, rows: SHORTINT; VAR elUsed, rowsUsed, status: SHORTINT; colArray: SYSTEM.ADDRESS);
PROCEDURE vqin_mode (handle, device: SHORTINT): SHORTINT;
PROCEDURE vqt_fontinfo (handle : SHORTINT; VAR minADE, maxADE, maxWidth: SHORTINT; VAR dist: tDistanceArray; VAR effects: tRGBArray);

(*-- VDI-Output ------------------------------------------------------*)

PROCEDURE v_pline (handle, count: SHORTINT; pxy: SYSTEM.ADDRESS);
PROCEDURE v_pmarker (handle, count: SHORTINT; pxy: SYSTEM.ADDRESS);
PROCEDURE v_gtext (handle, x, y: SHORTINT; (* REF *)  str: ARRAY OF CHAR);
PROCEDURE v_fillarea (handle, count: SHORTINT; pxy: SYSTEM.ADDRESS);
PROCEDURE v_cellarray (handle, len, used, rows, mode: SHORTINT; pxy: tPxyArray; color: SYSTEM.ADDRESS);
PROCEDURE v_contourfill (handle, x, y, index: SHORTINT);
PROCEDURE vr_recfl (handle: SHORTINT; pxy: M_Types.tRect);
PROCEDURE v_bar (handle: SHORTINT; pxy: M_Types.tRect);
PROCEDURE v_arc (handle, x, y, rad, bega, enda: SHORTINT);
PROCEDURE v_pieslice (handle, x, y, rad, begp, endp: SHORTINT);
PROCEDURE v_circle (handle, x, y, rad: SHORTINT);
PROCEDURE v_ellipse (handle, x, y, xrad, yrad: SHORTINT);
PROCEDURE v_ellarc (handle, x, y, xrad, yrad, bega, enda: SHORTINT);
PROCEDURE v_ellpie (handle, x, y, xrad, yrad, begp, endp: SHORTINT);
PROCEDURE v_rbox (handle: SHORTINT; pxy: M_Types.tRect);
PROCEDURE v_rfbox (handle: SHORTINT; pxy: M_Types.tRect);
PROCEDURE v_justified (handle, x, y, len, wspace, cspace: SHORTINT; (* REF *)  str: ARRAY OF CHAR);


(*-- VDI-Raster ------------------------------------------------------*)

TYPE MFDB =     RECORD
                 fdAddr:    SYSTEM.ADDRESS;
                 fdW:       SHORTINT;
                 fdH:       SHORTINT;
                 fdWdwidth: SHORTINT;
                 fdStand:   SHORTINT;
                 fdNplanes: SHORTINT;
                 fdR1:      SHORTINT;
                 fdR2:      SHORTINT;
                 fdR3:      SHORTINT;
                END;

PROCEDURE vro_cpyfm (handle, mode: SHORTINT; pxy: M_Types.tRect; srcMFDB, destMFDB: MFDB);
PROCEDURE vrt_cpyfm (handle, mode, cSet, cNotset: SHORTINT; pxy: M_Types.tRect; srcMFDB, destMFDB: MFDB);
PROCEDURE vr_trnfm (handle: SHORTINT; VAR srcMFDB, destMFDB: MFDB);
PROCEDURE v_get_pixel (handle, x, y: SHORTINT; VAR index: SHORTINT): BOOLEAN;


(*----------------------------------------------------------------------*
 * Die von Atari zustzlich eingefhrten erweiterten Funktionen um das  *
 * neue FSMGDOS bzw. Speedo anzusteuern. Fr nhere Informationen bitte *
 * unbedingt den FSM-Programmers Guide von Atari GmbH anfordern!        *
 *----------------------------------------------------------------------*)

CONST   FSMGdos =    005F46534DH;  (* = '_FSM' FSMGdos von Atari Corp. *)
        FontGdos =   005F464E54H;  (* = '_FNT' FontGdos von Atari Corp. *)
        SpeedoGdos = 00464E5443H;  (* = 'FSMC' Speedo von Atari Corp. *)

TYPE tSpeedoHeader = RECORD
                      FHFMVER: ARRAY [0..7] OF SYSTEM.BYTE;
                      FHFNTSZ: LONGINT;
                      FHFBFSZ: LONGINT;
                      FHCBFSZ: SHORTCARD;
                      FHHEDSZ: SHORTCARD;
                      FHFNTID: SHORTCARD;
                      FHSFVNR: SHORTCARD;
                      FHFNTNM: ARRAY [0..69] OF CHAR;
                      FHMDATE: ARRAY [0.. 9] OF CHAR;
                      FHLAYNM: ARRAY [0..69] OF CHAR;
                      FHCPYRT: ARRAY [0..77] OF CHAR;
                      FHNCHRL: SHORTCARD;
                      FHNCHRF: SHORTCARD;
                      FHFCHRF: SHORTCARD;
                      FHNKTKS: SHORTCARD;
                      FHNKPRS: SHORTCARD;
                      FHFLAGS: M_Types.ByteSet;
                      FHCLFGS: M_Types.ByteSet;
                      FHFAMCL: SYSTEM.BYTE;
                      FHFRMCL: M_Types.ByteSet;
                      FHSFNTN: ARRAY [0..31] OF CHAR;
                      FHSFACN: ARRAY [0..15] OF CHAR;
                      FHFNTFM: ARRAY [0..14] OF CHAR;
                      FHITANG: SHORTCARD;
                      FHORUPM: SHORTCARD;
                      FHWDWTH: SHORTCARD;
                      FHEMWTH: SHORTCARD;
                      FHENWTH: SHORTCARD;
                      FHTNWTH: SHORTCARD;
                      FHFGWTH: SHORTCARD;
                      FHFXMIN: SHORTCARD;
                      FHFYMIN: SHORTCARD;
                      FHFXMAX: SHORTCARD;
                      FHFYMAX: SHORTCARD;
                      FHULPOS: SHORTCARD;
                      FHULTHK: SHORTCARD;
                      FHSMCTR: ARRAY [0..5] OF SYSTEM.BYTE;
                      FHDPSTR: ARRAY [0..5] OF SYSTEM.BYTE;
                      FHFNSTR: ARRAY [0..5] OF SYSTEM.BYTE;
                      FHALSTR: ARRAY [0..5] OF SYSTEM.BYTE;
                      FHCMITR: ARRAY [0..5] OF SYSTEM.BYTE;
                      FHSNMTR: ARRAY [0..5] OF SYSTEM.BYTE;
                      FHSDNTR: ARRAY [0..5] OF SYSTEM.BYTE;
                      FHMNMTR: ARRAY [0..5] OF SYSTEM.BYTE;
                      FHMDNTR: ARRAY [0..5] OF SYSTEM.BYTE;
                      FHLNMTR: ARRAY [0..5] OF SYSTEM.BYTE;
                      FHLDNTR: ARRAY [0..2] OF SHORTCARD;
                      SIZEFW:  LONGINT;
                      EXTFHMETRES: LONGINT;
                     END;

PROCEDURE vqt_fontheader (handle: SHORTINT; VAR header: tSpeedoHeader;
                          VAR path: ARRAY OF CHAR);

CONST   ScratchFSM =    0;
        ScratchBitmap = 1;
        NoScratch =     2;

PROCEDURE vst_scratch (handle, mode: SHORTINT);

CONST   NoError =        0;  (* Fehlermeldungen *)
        CharNotFound =   1;
        ReadError =      8;
        OpenError =      9;
        BadFileformat = 10;
        OutOfMemory =   11;
        MiscError =     -1;

CONST   ToApplication = 0;
        ToScreen =      1;   (* 8^( *)

PROCEDURE vst_error (handle, mode: SHORTINT; VAR errorcode: SHORTINT);
PROCEDURE vqt_f_name (handle, num: SHORTINT; VAR name: ARRAY OF CHAR; VAR fsm: BOOLEAN): SHORTINT;
PROCEDURE vqt_f_extent (handle: SHORTINT; str: ARRAY OF CHAR; extent: SYSTEM.ADDRESS);
PROCEDURE v_ftext (handle, x, y: SHORTINT; str: ARRAY OF CHAR);
PROCEDURE v_killoutline (handle: SHORTINT; component: SYSTEM.ADDRESS);
PROCEDURE v_getoutline (handle, ch: SHORTINT; xyarray, bezarray: SYSTEM.ADDRESS; maxverts: SHORTINT; VAR numvert: SHORTINT);
PROCEDURE vqt_pairkern (handle, ch1, ch2: SHORTINT; VAR x, y: LONGINT);
PROCEDURE vqt_trackkern (handle: SHORTINT; VAR x, y: LONGINT);
PROCEDURE vst_kern (handle, tmode, pmode: SHORTINT; VAR tracks, pairs: SHORTINT);
PROCEDURE vst_arbpt (handle, point: SHORTINT; VAR cw, ch, bw, bh: SHORTINT): SHORTINT;
PROCEDURE vst_arbpt32 (handle: SHORTINT; point: LONGINT; VAR cw, ch, bw, bh: SHORTINT): LONGINT;
PROCEDURE vqt_advance   (handle, ch: SHORTINT; VAR advx, advy, xremain, yremain: SHORTINT);
PROCEDURE vqt_advance32 (handle, ch: SHORTINT; VAR advx, advy: LONGINT);
PROCEDURE vqt_devinfo (handle, device: SHORTINT; VAR devstr: ARRAY OF CHAR): BOOLEAN;
PROCEDURE vst_width (handle, h: SHORTINT; VAR cw, ch, bw, bh: SHORTINT);

PROCEDURE  v_savecache (handle: SHORTINT; filename: ARRAY OF CHAR): SHORTINT;
PROCEDURE  v_loadcache (handle: SHORTINT; filename: ARRAY OF CHAR; mode: SHORTINT): SHORTINT;
PROCEDURE v_flushcache (handle: SHORTINT);
PROCEDURE  v_cachesize (handle, cache: SHORTINT): LONGINT;

PROCEDURE  vst_setsize (handle, point: SHORTINT; VAR cw, ch, bw, bh: SHORTINT): SHORTINT;
PROCEDURE  vst_setsize32 (handle: SHORTINT; point: LONGINT; VAR cw, ch, bw, bh: SHORTINT): LONGINT;
PROCEDURE  vst_skew (handle, skew: SHORTINT): SHORTINT;
PROCEDURE v_get_table (handle: SHORTINT; VAR ascii, style: SYSTEM.ADDRESS);

CONST AtariChars =     0;
      BitstreamChars = 1;
      
PROCEDURE vst_charmap (handle, mode: SHORTINT);

PROCEDURE v_getbitmap_info (handle, ch: SHORTINT; VAR advx, advy, xoff, yoff, width, height: LONGINT);

PROCEDURE  v_bez_on (handle: SHORTINT): SHORTINT;
PROCEDURE v_bez_off (handle: SHORTINT);
PROCEDURE v_set_app_buff (handle: SHORTINT; buff: SYSTEM.ADDRESS; words: SHORTINT);
PROCEDURE v_bez (handle, count: SHORTINT;  xyarr, bezarr, extent: SYSTEM.ADDRESS; VAR totpts, totmoves: SHORTINT);
PROCEDURE v_bez_fill (handle, count: SHORTINT; xyarr, bezarr, extent: SYSTEM.ADDRESS; VAR totpts, totmoves: SHORTINT);
PROCEDURE  v_bez_qual (handle, percent: SHORTINT): SHORTINT;

(*----------------------------------------------------------------------*
 * nderungen, die COMPO an Speedo 5.0 durchgefhrt hat                 *
 *----------------------------------------------------------------------*)

CONST UNKNOWN_FONT =     $00;  (* unbekannter Font     *)
      BITMAP_FONT =      $01;  (* Bitmap               *)
      SPEEDO_FONT =      $02;  (* Speedo Vektorfont    *)
      TT_FONT =          $04;  (* Truetype             *)
      PFB_FONT =         $08;  (* Type 1 Font          *)
      CFN_FONT =         $10;  (* Calamus Font         *)
      ANY_FONT =         $FF;  (* Maske fr alle Fonts *)

CONST FONT_CHECK =       $0000; (* nichts, nur intout[0-2]          *)
      FONT_NAME =        $0001; (* Name des Fonts (Bitmap+Vektor)   *)
      FONT_FAMILY =      $0002; (* Familienbeschreibung             *)
      FONT_STYLE =       $0004; (* Stilbeschreibung                 *)
      FONT_FILE =        $0008; (* Dateinamen des Fonts             *)
      FONT_FILE_A =      $0010; (* zustzliche Datei (z.B. AFM/PFM) *)
      FONT_FILE_B =      $0020; (* zustzliche Datei                *)
      FONT_PNTS_SINGLE = $0040;
      FONT_PNTS_DOUBLE = $0080;
      FONT_PNTS =        $0100; (* gewnschte Punktgren           *)
      FONT_STRUCT =      $0200; (* Daten in Struktur eintragen      *)
      FONT_ALL_DATA =    $FFFF;

TYPE  Font_Info =        RECORD
                          size:   LONGINT;                  (* Gre der Struktur  *)
                          typ:    BITSET;                   (* Fonttyp             *)
                          id:     SHORTINT;                  (* ID                  *)
                          elem:   SHORTINT;                  (* Element Nummer      *)
                          name:   ARRAY [0.. 49] OF CHAR;   (* Fontname            *)
                          family: ARRAY [0.. 49] OF CHAR;   (* Familie             *)
                          style:  ARRAY [0.. 49] OF CHAR;   (* Stil                *)
                          ffile:  ARRAY [0..199] OF CHAR;   (* Dateiname des Fonts *)
                          file_a: ARRAY [0..199] OF CHAR;   (* erster Zusatzfile   *)
                          file_b: ARRAY [0..199] OF CHAR;   (* zweiter Zusatzfile  *)
                          num_points: SHORTINT;              (* Anzahl Punktgren  *)
                          points: ARRAY [0..63] OF SHORTINT; (* Maximal Punktgren *)
                         END;

PROCEDURE  vqt_s_info (handle, flag, id, elem: SHORTINT; VAR info: Font_Info): SHORTINT;
(* Spezielle Informationen ber den Font erfragen *)

PROCEDURE  vqt_s_name (handle, num: SHORTINT; VAR name: ARRAY OF CHAR; 
                     VAR fsm: BOOLEAN; VAR typ, flag: SHORTINT): SHORTINT;

PROCEDURE vst_font_by_name (handle, typ: SHORTINT;  VAR name: ARRAY OF CHAR): SHORTINT; 
PROCEDURE vqt_name_id  (handle, typ: SHORTINT; VAR name: ARRAY OF CHAR): SHORTINT; 
PROCEDURE vs_outmode   (handle, mode: SHORTINT; flags: BITSET): SHORTINT;
PROCEDURE vs_use_fonts (handle, types: SHORTINT; flags: BITSET): SHORTINT;
PROCEDURE vs_backmap   (handle: SHORTINT; flags: BITSET; VAR mapon: BOOLEAN; VAR point: SHORTINT);
PROCEDURE v_mono_ftext (handle, x, y: SHORTINT; str: ARRAY OF CHAR);

END M_VDI.

