(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_VDI;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM SYSTEM     IMPORT  ADDRESS, BYTE, ADR, STORE;
FROM M_Sys      IMPORT  App, CallGEM, WordToBitset, LongToBitset, 
                        CastToInt, Hi, Lo, VqGdos, FillChar;
FROM M_Types    IMPORT  Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6, Bit7, Bit8,
                        Bit9, Bit10, Bit11, Bit12, Bit13, Bit14, Bit15, Bit16,
                        Bit17, Bit18, Bit19, Bit20, Bit21, Bit22, Bit23, Bit24,
                        Bit25, Bit26, Bit27, Bit28, Bit29, Bit30, Bit31,
                        tRect, LONGBITSET;

TYPE tIntArray = ARRAY [0..07FFFH] OF SHORTINT;

VAR iarray:   POINTER TO tIntArray;

PROCEDURE VDICall (c0, c1, c3, c5, c6: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  control^[0]:= c0;
  control^[1]:= c1;
  control^[3]:= c3;
  control^[5]:= c5;
  control^[6]:= c6;
 END;
 CallGEM (115, App^.VDIPB);
END VDICall;

PROCEDURE Copy2intin (s: ARRAY OF CHAR; start: SHORTINT): SHORTINT;
VAR i: SHORTINT;
BEGIN
 i:= 0;
 WHILE s[i] <> 0C DO
  App^.VDIPB^.intin^[start+i]:= ORD(s[i]);  INC (i);
 END;
 RETURN i;
END Copy2intin;

PROCEDURE vqt_x_name (handle, element: SHORTINT; 
                     VAR name: ARRAY OF CHAR; VAR flags: ARRAY OF SHORTINT): SHORTINT;
VAR i: CARDINAL;
BEGIN
 FOR i:= 0 TO HIGH (name) DO name[i]:= 0C;  END;
 FOR i:= 0 TO HIGH (flags) DO flags[i]:= 0;  END;
 WITH App^.VDIPB^ DO
  intin^[0]:= element;
  intout^[33]:= 0;
  intout^[34]:= 0;
  VDICall (130, 0, 2, 1, handle);
  FOR i:= 1 TO 32 DO  name[i-1]:= CHR(intout^[i]);  END;  name[32]:= 0C;
  flags[0]:= intout^[33];
  flags[1]:= intout^[34];
  RETURN intout^[0];
 END;
END vqt_x_name;

PROCEDURE vq_gdos(): LONGINT;
BEGIN
 RETURN VqGdos();
END vq_gdos;

PROCEDURE  vswr_mode (handle, mode: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= mode;
  VDICall (32, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vswr_mode;

PROCEDURE vs_color (handle, index: SHORTINT; rgb: tRGBArray);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= index;
  intin^[1]:= rgb[0];
  intin^[2]:= rgb[1];
  intin^[3]:= rgb[2];
 END;
 VDICall(14, 0, 4, 0, handle);
END vs_color;

PROCEDURE  vsl_type (handle, typ: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= typ;
  VDICall (15, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vsl_type;

PROCEDURE vsl_udsty (handle: SHORTINT; style: SHORTCARD);
BEGIN
 App^.VDIPB^.intin^[0]:= style;
 VDICall (113, 0, 1, 0, handle);
END vsl_udsty;

PROCEDURE  vsl_width (handle, width: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= width;
  ptsin^[1]:= 0;
  VDICall (16, 1, 0, 0, handle);
  RETURN ptsout^[0];
 END;
END vsl_width;

PROCEDURE  vsl_color (handle, color: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= color;
  VDICall (17, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vsl_color;

PROCEDURE vsl_ends (handle, begstyle, endstyle: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= begstyle;
  intin^[1]:= endstyle;
 END;
 VDICall (108, 0, 2, 0, handle);
END vsl_ends;

PROCEDURE  vsm_type (handle, typ: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= typ;
  VDICall (18, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vsm_type;

PROCEDURE  vsm_height (handle, height: SHORTINT): SHORTINT; 
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= height;
  ptsin^[1]:= 0;
  VDICall (19, 1, 0, 0, handle);
  RETURN ptsout^[0];
 END;
END vsm_height;

PROCEDURE  vsm_color (handle, index: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= index;
  VDICall (20, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vsm_color;

PROCEDURE vst_height (handle, h: SHORTINT;
                         VAR cw, ch, bw, bh: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= 0;
  ptsin^[1]:= h;
  VDICall (12, 1, 0, 0, handle);
  cw:= ptsout^[0];
  ch:= ptsout^[1];
  bw:= ptsout^[2];
  bh:= ptsout^[3];
 END;
END vst_height;

PROCEDURE vst_width (handle, h: SHORTINT;
                         VAR cw, ch, bw, bh: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= 0;
  ptsin^[1]:= h;
  VDICall (231, 1, 0, 0, handle);
  cw:= ptsout^[0];
  ch:= ptsout^[1];
  bw:= ptsout^[2];
  bh:= ptsout^[3];
 END;
END vst_width;

PROCEDURE  vst_point (handle, h: SHORTINT;
                         VAR cw, ch, bw, bh: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= h;
  VDICall (107, 0, 1, 0, handle);
  cw:= ptsout^[0];
  ch:= ptsout^[1];
  bw:= ptsout^[2];
  bh:= ptsout^[3];
  RETURN intout^[0];
 END;
END vst_point;

PROCEDURE  vst_rotation (handle, angle: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= angle;
  VDICall (13, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vst_rotation;

PROCEDURE  vst_font (handle, font: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= font;
  VDICall (21, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vst_font;

PROCEDURE  vst_color (handle, index: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= index;
  VDICall (22, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vst_color;

PROCEDURE vst_effects (handle: SHORTINT; effect: BITSET; VAR old: BITSET);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= CastToInt (effect);
  VDICall (106, 0, 1, 0, handle);
  WordToBitset (intout^[0], old);
 END;
END vst_effects;

PROCEDURE vst_alignment (handle, hin, vin: SHORTINT; 
                            VAR hout, vout: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= hin;
  intin^[1]:= vin;
  VDICall (39, 0, 2, 0, handle);
  hout:= intout^[0];
  vout:= intout^[1];
 END;
END vst_alignment;

PROCEDURE  vsf_interior (handle, index: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= index;
  VDICall (23, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vsf_interior;

PROCEDURE  vsf_style (handle, style: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= style;
  VDICall (24, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vsf_style;

PROCEDURE  vsf_color (handle, index: SHORTINT): SHORTINT; 
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= index;
  VDICall (25, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vsf_color;

PROCEDURE  vsf_perimeter (handle: SHORTINT; border: BOOLEAN): BOOLEAN;
BEGIN
 WITH App^.VDIPB^ DO
  IF border THEN
   intin^[0]:= 1;
  ELSE
   intin^[0]:= 0;
  END;
  VDICall (104, 0, 1, 0, handle);
  RETURN intout^[0] = 1;
 END;
END vsf_perimeter;

PROCEDURE vsf_udpat (handle: SHORTINT; pat: ADDRESS; planes: SHORTINT);
VAR old: ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  old:= intin;
  intin:= pat;
  VDICall (112, 0, planes * 16, 0, handle);
  intin:= old;
 END;
END vsf_udpat;

PROCEDURE v_opnwk (VAR win: tWorkIn; VAR handle: SHORTINT; VAR wout: tWorkOut);
VAR c: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  FOR c:= 0 TO 10 DO  intin^[c]:= win[c];  END;
  VDICall(1, 0, 11, 0, handle);
  handle:= control^[6];
  FOR c:= 0 TO 44 DO  wout[c]:= intout^[c]; END;
  FOR c:= 0 TO 11 DO  wout[c+45]:= ptsout^[c]; END;
 END;
END v_opnwk;

PROCEDURE v_clswk (handle: SHORTINT);
BEGIN
 VDICall(2, 0, 0, 0, handle);
END v_clswk;

PROCEDURE v_opnvwk (VAR win: tWorkIn; VAR handle: SHORTINT;
                       VAR wout: tWorkOut);
VAR c: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  FOR c:= 0 TO 10 DO intin^[c]:= win[c]; END;
  VDICall(100, 0, 11, 0, handle);
  handle:= control^[6];
  FOR c:= 0 TO 44 DO wout[c]:= intout^[c]; END;
  FOR c:= 0 TO 11 DO wout[c+45]:= ptsout^[c]; END;
 END;
END v_opnvwk;

PROCEDURE v_clsvwk (handle: SHORTINT);
BEGIN
 VDICall(101, 0, 0, 0, handle);
END v_clsvwk;

PROCEDURE v_clrwk (handle: SHORTINT);
BEGIN
 VDICall(3, 0, 0, 0, handle);
END v_clrwk;

PROCEDURE v_updwk (handle: SHORTINT);
BEGIN
 VDICall(4, 0, 0, 0, handle);
END v_updwk;

PROCEDURE  vst_load_fonts (handle, select: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= select;
  VDICall(119, 0, 1, 0, handle);
  RETURN intout^[0];
 END;
END vst_load_fonts;

PROCEDURE vst_unload_fonts (handle, select: SHORTINT);
BEGIN
 App^.VDIPB^.intin^[0]:= select;
 VDICall(120, 0, 1, 0, handle);
END vst_unload_fonts;

PROCEDURE vs_clip (handle: SHORTINT; rect: tRect; doit: BOOLEAN);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= rect.x;
  ptsin^[1]:= rect.y;
  ptsin^[2]:= rect.w;
  ptsin^[3]:= rect.h;
  IF doit THEN
   intin^[0]:= 1;
  ELSE
   intin^[0]:= 0;
  END;
 END;
 VDICall(129, 2, 1, 0, handle);
END vs_clip;

PROCEDURE vq_chcells (handle: SHORTINT; VAR rows, colums: SHORTINT);
BEGIN
 VDICall  (5, 0, 0, 1, handle);
 WITH App^.VDIPB^ DO
  rows:= intout^[0];
  colums:= intout^[1];
 END;
END vq_chcells;

PROCEDURE v_exit_cur (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 2, handle);
END v_exit_cur;

PROCEDURE v_enter_cur (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 3, handle);
END v_enter_cur;

PROCEDURE v_curup (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 4, handle);
END v_curup;

PROCEDURE v_curdown (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 5, handle);
END v_curdown;

PROCEDURE v_curright (handle : SHORTINT);
BEGIN
 VDICall (5, 0, 0, 6, handle);
END v_curright;

PROCEDURE v_curleft (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 7, handle);
END v_curleft;

PROCEDURE v_curhome (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 8, handle);
END v_curhome;

PROCEDURE v_eeos (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 9, handle);
END v_eeos;

PROCEDURE v_eeol (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 10, handle);
END v_eeol;

PROCEDURE v_curaddress (handle, row, column: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= row;
  intin^[1]:= column;
 END;
 VDICall (5, 0, 2, 11, handle);
END v_curaddress;

PROCEDURE v_curtext (handle: SHORTINT; (* REF *)  str: ARRAY OF CHAR);
BEGIN
 VDICall (5, 0, Copy2intin (str, 0) - 1, 12, handle);
END v_curtext;

PROCEDURE v_rvon (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 13, handle);
END v_rvon;

PROCEDURE v_rvoff (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 14, handle);
END v_rvoff;

PROCEDURE vq_curaddress (handle: SHORTINT; VAR row, column: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 15, handle);
 WITH App^.VDIPB^ DO
  row:= intout^[0];
  column:= intout^[1];
 END;
END vq_curaddress;

PROCEDURE  vq_tabstatus (handle: SHORTINT): SHORTINT;
BEGIN
 VDICall (5, 0, 0, 16, handle);
 RETURN App^.VDIPB^.intout^[0];
END vq_tabstatus;

PROCEDURE v_hardcopy (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 17, handle);
END v_hardcopy;

PROCEDURE v_dspcur (handle, x, y: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
 END;
 VDICall (5, 1, 0, 18, handle);
END v_dspcur;

PROCEDURE v_rmcur (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 19, handle);
END v_rmcur;

PROCEDURE v_form_adv (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 20, handle);
END v_form_adv;

PROCEDURE v_output_window (handle: SHORTINT; pxy: tRect);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= pxy.x;
  ptsin^[1]:= pxy.y;
  ptsin^[2]:= pxy.w;
  ptsin^[3]:= pxy.h;
 END;
 VDICall (5, 2, 0, 21, handle);
END v_output_window;

PROCEDURE v_clear_disp_list (handle: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 22, handle);
END v_clear_disp_list;

PROCEDURE v_bit_image (handle: SHORTINT; (* REF *)  filename: ARRAY OF CHAR;
                        aspect, scaling, numPts: SHORTINT;
                        pxy: ADDRESS);
VAR i: SHORTINT;
    o: ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= aspect;
  intin^[1]:= scaling;
  o:= ptsin;  ptsin:= pxy;
  VDICall (5, numPts, Copy2intin (filename, 2) - 1, 23, handle);
  ptsin:= o;
 END;
END v_bit_image;

PROCEDURE vq_scan(handle: SHORTINT; VAR gSlice, gPage, size, page, dv: SHORTINT);
BEGIN
 VDICall (5, 0, 0, 24, handle);
 WITH App^.VDIPB^ DO
  gSlice:= intout^[0];
  gPage:= intout^[1];
  size:= intout^[2];
  page:= intout^[3];
  dv:= intout^[4];
 END;
END vq_scan;

PROCEDURE v_alpha_text (handle: SHORTINT; (* REF *)  str: ARRAY OF CHAR);
BEGIN
 VDICall (5, 0, Copy2intin(str, 0) - 1, 25, handle);
END v_alpha_text;

PROCEDURE  vs_palette (handle, palette: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= palette;
  VDICall (5, 0, 1, 60, handle);
  RETURN intout^[0];
 END;
END vs_palette;

PROCEDURE v_sound(handle, freq, time: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= freq;
  intin^[1]:= time;
 END;
 VDICall (5, 0, 2, 61, handle);
END v_sound;

PROCEDURE vs_mute (handle, action: SHORTINT);
BEGIN
 App^.VDIPB^.intin^[0]:= action;
 VDICall (5, 0, 1, 62, handle);
END vs_mute;

PROCEDURE vt_resolution (handle, xres, yres: SHORTINT;
                             VAR xset, yset: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= xres;
  intin^[1]:= yres;
  VDICall (5, 0, 2, 81, handle);
  xset:= intin^[0];
  yset:= intin^[1];
 END;
END vt_resolution;

PROCEDURE vt_axis (handle, xres, yres: SHORTINT;
                             VAR xset, yset: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= xres;
  intin^[1]:= yres;
  VDICall (5, 0, 2, 82, handle);
  xset:= intin^[0];
  yset:= intin^[1];
 END;
END vt_axis;

PROCEDURE vt_origin (handle, x, y: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= x;
  intin^[1]:= y;
 END;
 VDICall (5, 0, 2, 83, handle);
END vt_origin;

PROCEDURE vq_tdimensions (handle: SHORTINT; VAR x, y: SHORTINT);
BEGIN
 VDICall  (5, 0, 0, 84, handle);
 WITH App^.VDIPB^ DO
  x:=  intin^[0];
  y:=  intin^[1];
 END;
END vq_tdimensions;

PROCEDURE vt_alignment (handle, x, y: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= x;
  intin^[1]:= y;
 END;
 VDICall (5, 0, 2, 85, handle);
END vt_alignment;

PROCEDURE vsp_film (handle, index, light: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= index;
  intin^[1]:= light;
 END;
 VDICall (5, 0, 2, 91, handle);
END vsp_film;

PROCEDURE vqp_filmname (handle: SHORTINT; VAR filmName: ARRAY OF CHAR);
VAR i: SHORTINT;
BEGIN
 VDICall (5, 0, 1, 92, handle);
 WITH App^.VDIPB^ DO
  FOR i:= 0 TO 24 DO filmName[i]:= CHR(intout^[i]) END;
 END;
 filmName[25]:= CHR (0);
END vqp_filmname;

PROCEDURE vsc_expose (handle, state: SHORTINT);
BEGIN
 App^.VDIPB^.intin^[0]:= state;
 VDICall (5, 0, 1, 93, handle);
END vsc_expose;

PROCEDURE v_meta_extents (handle, minX, minY, maxX, maxY: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= minX;
  ptsin^[1]:= minY;
  ptsin^[2]:= maxX;
  ptsin^[3]:= maxY;
 END;
 VDICall (5, 2, 0, 98, handle);
END v_meta_extents;

PROCEDURE v_write_meta (handle, numintin: SHORTINT; intin: ADDRESS;
                         numPtsin: SHORTINT;  ptsIn: ADDRESS);
VAR oldInt, oldPts: ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  oldInt:=  intin;
  oldPts:=  ptsin;
  intin:= intin;
  ptsin:= ptsIn;
  VDICall (5, numPtsin, numintin, 99, handle);
  intin:= oldInt;
  ptsin:= oldPts;
 END;
END v_write_meta;

PROCEDURE vm_pagesize (handle, width, height: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= 0;
  intin^[1]:= width;
  intin^[2]:= height;
 END;
 VDICall (5, 0, 3, 99, handle);
END vm_pagesize;

PROCEDURE vm_coords (handle, llx, lly, urx, ury: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= 1;
  intin^[1]:= llx;
  intin^[2]:= lly;
  intin^[3]:= urx;
  intin^[4]:= ury;
 END;
 VDICall (5, 0, 5, 99, handle);
END vm_coords;

PROCEDURE vm_filename (handle: SHORTINT; (* REF *)  filename: ARRAY OF CHAR);
BEGIN
 VDICall (5, 0, Copy2intin(filename, 0) - 1, 100, handle);
END vm_filename;

PROCEDURE v_offset (handle, offset: SHORTINT);
BEGIN
 App^.VDIPB^.intin^[0]:= offset;
 VDICall (5, 0, 1, 101, handle);
END v_offset;

PROCEDURE v_fontinit (handle: SHORTINT; header: ADDRESS);
BEGIN
 iarray:= header;
 WITH App^.VDIPB^ DO
  intin^[0]:= iarray^[0];
  intin^[1]:= iarray^[1];
 END;
 VDICall (5, 0, 2, 102, handle);
END v_fontinit;

VAR old:   ADDRESS;
    trick: POINTER TO ADDRESS;

PROCEDURE  vsin_mode (handle, device, mode: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= device;
  intin^[1]:= mode;
 END;
 VDICall(33, 0, 2, 0, handle);
 RETURN App^.VDIPB^.intout^[0];
END vsin_mode;

PROCEDURE vrq_locator (handle, x, y: SHORTINT;
                          VAR xo, yo: SHORTINT; VAR term: CHAR);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  VDICall(28, 1, 0, 0, handle);
  xo:=  ptsout^[0];
  yo:=  ptsout^[1];
  term:= CHR(intout^[0]);
 END;
END vrq_locator;

PROCEDURE vsm_locator (handle, x, y: SHORTINT; VAR xo, yo: SHORTINT;
                     VAR term: CHAR; VAR result: BITSET);
VAR l:  LONGINT;
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  control^[0]:= 28;
  control^[1]:= 1;
  control^[3]:= 0;
  control^[5]:= 0;
  control^[6]:= handle;
  CallGEM (115, ADR (App^.VDIPB));
  STORE (0, l); (* D0 sichern *)
  xo:=  ptsout^[0];
  yo:=  ptsout^[1];
  term:= CHR(intout^[0]);
  LongToBitset (l, result);
 END;
END vsm_locator;

PROCEDURE vrq_valuator (handle, inv: SHORTINT; VAR out: SHORTINT; VAR term: CHAR);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= inv;
  VDICall (29, 0, 1, 0, handle);
  out:=  intout^[0];
  term:= CHR(intout^[1]);
 END;
END vrq_valuator;

PROCEDURE vsm_valuator (handle, inv: SHORTINT; VAR out: SHORTINT;
                      VAR term: CHAR; VAR result: BITSET);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= inv;
  VDICall (29, 0, 1, 0, handle);
  out:= intout^[0];
  term:= CHR(intout^[1]);
  WordToBitset (control^[4], result);
 END;
END vsm_valuator;

PROCEDURE vrq_choice (handle, inv: SHORTINT; VAR out: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= inv;
  VDICall (30, 0, 1, 0, handle);
  out:= intout^[0];
 END;
END vrq_choice;

PROCEDURE  vsm_choice (handle: SHORTINT; VAR choice: SHORTINT ): SHORTINT;
BEGIN
 VDICall  (30, 0, 0, 0, handle);
 WITH App^.VDIPB^ DO
  choice:=  intout^[0];
  RETURN control^[4];
 END;
END vsm_choice;

PROCEDURE vrq_string (handle, len: SHORTINT; echo: BOOLEAN;
                         x, y: SHORTINT;
                         VAR str: ARRAY OF CHAR);
VAR h: SHORTINT;
    i: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= len;
  IF echo THEN
   intin^[1]:= 1;
  ELSE
   intin^[1]:= 0;
  END;
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  VDICall (31, 1, 2, 0, handle);
  h:= control^[4] - 1;
  FOR i:= 0 TO h DO  str[i]:= CHR(intout^[i]);  str[h+1]:= 0C;  END;
 END;
END vrq_string;

PROCEDURE  vsm_string (handle, len: SHORTINT; echo: BOOLEAN;
                        x, y: SHORTINT; VAR str: ARRAY OF CHAR): SHORTINT;
VAR h: SHORTINT;
    i: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= len;
  IF echo THEN
   intin^[1]:= 1;
  ELSE
   intin^[1]:= 0;
  END;
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  VDICall (31, 1, 2, 0, handle);
  h:= control^[4] - 1;
  FOR i:= 0 TO h DO  str[i]:= CHR(intout^[i]); str[h+1]:= 0C; END;
  RETURN control^[4];
 END;
END vsm_string;

PROCEDURE vsc_form (handle: SHORTINT; form: ADDRESS);
BEGIN
 WITH App^.VDIPB^ DO
  old:= intin;
  intin:= form;
  VDICall (111, 0, 37, 0, handle);
  intin:= old;
 END;
END vsc_form;

PROCEDURE v_show (handle: SHORTINT; reset: BOOLEAN);
BEGIN
 WITH App^.VDIPB^ DO
  IF reset THEN
   intin^[0]:= 0;
  ELSE
   intin^[0]:= 1;
  END;
 END;
 VDICall (122, 0, 1, 0, handle);
END v_show;

PROCEDURE v_hide (handle: SHORTINT);
BEGIN
 VDICall (123, 0, 0, 0, handle);
END v_hide;

PROCEDURE vq_mouse (handle: SHORTINT; VAR stat: BITSET; VAR x, y: SHORTINT);
BEGIN
 VDICall (124, 0, 0, 0, handle);
 WITH App^.VDIPB^ DO
  WordToBitset (intout^[0], stat);
  x:= ptsout^[0];
  y:= ptsout^[1];
 END;
END vq_mouse;

PROCEDURE  vex_timv (handle: SHORTINT; new: ADDRESS;
                        VAR intervall: SHORTINT): ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  trick:= ADR (control^[7]);  trick^:= new;
  VDICall (118, 0, 0, 0, handle);
  intervall:= intout^[0];
  trick:= ADR (control^[9]);
 END;
 RETURN trick^;
END vex_timv;

PROCEDURE  vex_butv (handle: SHORTINT; new: ADDRESS): ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  trick:= ADR (control^[7]); trick^:= new;
  VDICall (125, 0, 0, 0, handle);
  trick:= ADR (control^[9]);
 END;
 RETURN trick^;
END vex_butv;

PROCEDURE  vex_motv (handle: SHORTINT; new: ADDRESS): ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  trick:= ADR (control^[7]); trick^:= new;
  VDICall (126, 0, 0, 0, handle);
  trick:= ADR (control^[9]);
 END;
 RETURN trick^;
END vex_motv;

PROCEDURE  vex_curv (handle: SHORTINT; new: ADDRESS): ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  trick:= ADR (control^[7]); trick^:= new;
  VDICall (127, 0, 0, 0, handle);
  trick:= ADR (control^[9]);
 END;
 RETURN trick^;
END vex_curv;

PROCEDURE vq_key_s (handle: SHORTINT; VAR status: BITSET);
BEGIN
 VDICall (128, 0, 0, 0, handle);
 WordToBitset (App^.VDIPB^.intout^[0], status);
END vq_key_s;

PROCEDURE vq_extnd (handle, wich: SHORTINT; VAR out: tWorkOut);
VAR i: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= wich;
  VDICall (102, 0, 1, 0, handle);
  FOR i:=  0 TO 44 DO  out[i]:= intout^[i]; END;
  FOR i:= 45 TO 56 DO  out[i]:= ptsout^[i-45]; END;
 END;
END vq_extnd;

PROCEDURE vq_color (handle, color: SHORTINT; setit: BOOLEAN; VAR rgb: tRGBArray);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= color;
  IF setit THEN
   intin^[0]:= 0;
  ELSE
   intin^[0]:= 1;
  END;
  VDICall (26, 0, 2, 0, handle);
  rgb[0]:= intout^[1];
  rgb[1]:= intout^[2];
  rgb[2]:= intout^[3];
 END;
END vq_color;

PROCEDURE vql_attributes (handle: SHORTINT; VAR attrib: tPxyArray);
BEGIN
 VDICall (35, 0, 0, 0, handle);
 WITH App^.VDIPB^ DO
  attrib[0]:=  intout^[0];
  attrib[1]:=  intout^[1];
  attrib[2]:=  intout^[2];
  attrib[3]:=  ptsout^[0];
 END;
END vql_attributes;

PROCEDURE vqm_attributes (handle: SHORTINT; VAR attrib: tPxyArray);
BEGIN
 VDICall (36, 0, 0, 0, handle);
 WITH App^.VDIPB^ DO
  attrib[0]:=  intout^[0];
  attrib[1]:=  intout^[1];
  attrib[2]:=  intout^[2];
  attrib[3]:=  ptsout^[1];
 END;
END vqm_attributes;

PROCEDURE vqf_attributes (handle: SHORTINT; VAR attrib: tDistanceArray);
VAR i: SHORTINT;
BEGIN
 VDICall (37, 0, 0, 0, handle);
 WITH App^.VDIPB^ DO
  FOR i:= 0 TO 4 DO  attrib[i]:= intout^[i]; END;
 END;
END vqf_attributes;

PROCEDURE vqt_attributes (handle: SHORTINT; VAR attrib: tTextAttrArray);
VAR i: SHORTINT;
BEGIN
 VDICall (38, 0, 0, 0, handle);
 WITH App^.VDIPB^ DO
  FOR i:= 0 TO 5 DO  attrib[i]:=  intout^[i]; END;
  FOR i:= 6 TO 9 DO  attrib[i]:=  ptsout^[i-6]; END;
 END;
END vqt_attributes;

PROCEDURE vqt_extent (handle: SHORTINT; (* REF *)  str: ARRAY OF CHAR;
                         VAR extent: tBigPxyArray);
VAR i: SHORTINT;
BEGIN
 VDICall (116, 0, Copy2intin(str, 0) - 1, 0, handle);
 WITH App^.VDIPB^ DO
  FOR i:= 0 TO 7 DO  extent[i]:= ptsout^[i]; END;
 END;
END vqt_extent;

PROCEDURE  vqt_width (handle: SHORTINT; ch: CHAR; 
                       VAR width, left, right: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= ORD(ch);
  VDICall (117, 0, 1, 0, handle);
  width:=  ptsout^[0];
  left:=  ptsout^[2];
  right:=  ptsout^[4];
  RETURN  intout^[0];
 END;
END vqt_width;

PROCEDURE  vqt_name (handle, element: SHORTINT;
                      VAR name: ARRAY OF CHAR): SHORTINT;
VAR i: SHORTINT;
    f: ARRAY [0..1] OF SHORTINT;
BEGIN
 RETURN vqt_x_name (handle, element, name, f);
END vqt_name;

PROCEDURE vq_cellarray (handle: SHORTINT; pxy: tRect;
                     len, rows: SHORTINT; 
                     VAR elUsed, rowsUsed, status: SHORTINT;
                     colArray: ADDRESS);
VAR i: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= pxy.x;
  ptsin^[1]:= pxy.y;
  ptsin^[2]:= pxy.w;
  ptsin^[3]:= pxy.h;
  control^[7]:= len;
  control^[8]:= rows;
  old:=  ptsin;
  ptsin:= ADR (colArray);
  VDICall  (27, 2, 0, 0, handle);
  ptsin:= old;
  elUsed:=  control^[9];
  rowsUsed:=  control^[10];
  status:=  control^[11];
 END;
END vq_cellarray;

PROCEDURE  vqin_mode (handle: SHORTINT; device: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= device;
  VDICall (115, 0, 1, 0, handle);
  RETURN  intout^[0];
 END;
END vqin_mode;

PROCEDURE vqt_fontinfo (handle : SHORTINT;
                       VAR minADE, maxADE, maxWidth: SHORTINT;
                       VAR dist: tDistanceArray;
                       VAR effects: tRGBArray);
VAR i: SHORTINT;
BEGIN
 VDICall (131, 0, 0, 0, handle);
 WITH App^.VDIPB^ DO
  minADE:=  intout^[0];
  maxADE:=  intout^[1];
  FOR i:= 0 TO 4 DO  dist[i]:=  ptsout^[2 * i + 1]; END;
  maxWidth:=  ptsout^[0];
  effects[0]:=  ptsout^[2];
  effects[1]:=  ptsout^[4];
  effects[2]:=  ptsout^[6];
 END;
END vqt_fontinfo;

VAR oldPts: ADDRESS;
    oldInt: ADDRESS;

PROCEDURE v_pline (handle, count: SHORTINT; pxy: ADDRESS);
BEGIN
 WITH App^.VDIPB^ DO
  oldPts:=  ptsin;
  ptsin:= pxy;
  VDICall(6, count, 0, 0, handle);
  ptsin:= oldPts;
 END;
END v_pline;

PROCEDURE v_pmarker (handle, count: SHORTINT; pxy: ADDRESS);
BEGIN
 WITH App^.VDIPB^ DO
  oldPts:=  ptsin;
  ptsin:= pxy;
  VDICall(7, count, 0, 0, handle);
  ptsin:= oldPts;
 END;
END v_pmarker;

PROCEDURE v_gtext (handle, x, y: SHORTINT; (* REF *)  str: ARRAY OF CHAR);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
 END;
 VDICall(8, 1, Copy2intin(str, 0), 0, handle);
END v_gtext;

PROCEDURE v_fillarea (handle, count: SHORTINT; pxy: ADDRESS);
BEGIN
 WITH App^.VDIPB^ DO
  oldPts:= ptsin;
  ptsin:= pxy;
  VDICall(9, count, 0, 0, handle);
  ptsin:= oldPts;
 END;
END v_fillarea;

PROCEDURE v_cellarray (handle, len, used, rows, mode: SHORTINT;
                     pxy: tPxyArray; color: ADDRESS);
BEGIN
 WITH App^.VDIPB^ DO
  control^[7]:= len;
  control^[8]:= used;
  control^[9]:= rows;
  control^[10]:= mode;
  oldPts:=  intin;
  oldInt:=  ptsin;
  ptsin:= ADR (pxy);
  intin:= color;
  VDICall (10, 2, len * rows, 0, handle);
  ptsin:= oldPts;
  intin:= oldInt;
 END;
END v_cellarray;

PROCEDURE v_contourfill (handle, x, y, index: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= index;
  ptsin^[0]:= x;
  ptsin^[1]:= y;
 END;
 VDICall(103, 1, 1, 0, handle);
END v_contourfill;

PROCEDURE vr_recfl (handle: SHORTINT; pxy: tRect);
BEGIN
 WITH App^.VDIPB^ DO
  oldPts:=  ptsin;
  ptsin:= ADR (pxy);
  VDICall(114, 2, 0, 0, handle);
  ptsin:= oldPts;
 END;
END vr_recfl;

PROCEDURE v_bar (handle: SHORTINT; pxy: tRect);
BEGIN
 WITH App^.VDIPB^ DO
  oldPts:= ptsin;
  ptsin:= ADR (pxy);
  VDICall(11, 2, 0, 1, handle);
  ptsin:= oldPts;
 END;
END v_bar;

PROCEDURE v_arc (handle, x, y, rad, bega, enda: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  ptsin^[2]:= 0;
  ptsin^[3]:= 0;
  ptsin^[4]:= 0;
  ptsin^[5]:= 0;
  ptsin^[6]:= rad;
  ptsin^[7]:= 0;
  intin^[0]:= bega;
  intin^[1]:= enda;
 END;
 VDICall(11, 4, 2, 2, handle);
END v_arc;

PROCEDURE v_pieslice (handle, x, y, rad, begp, endp: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  ptsin^[2]:= 0;
  ptsin^[3]:= 0;
  ptsin^[4]:= 0;
  ptsin^[5]:= 0;
  ptsin^[6]:= rad;
  ptsin^[7]:= 0;
  intin^[0]:= begp;
  intin^[1]:= endp;
 END;
 VDICall(11, 4, 2, 3, handle);
END v_pieslice;

PROCEDURE v_circle (handle, x, y, rad: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  ptsin^[2]:= 0;
  ptsin^[3]:= 0;
  ptsin^[4]:= rad;
  ptsin^[5]:= 0;
 END;
 VDICall(11, 3, 0, 4, handle);
END v_circle;

PROCEDURE v_ellipse (handle, x, y, xrad, yrad: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  ptsin^[2]:= xrad;
  ptsin^[3]:= yrad;
 END;
 VDICall(11, 2, 0, 5, handle);
END v_ellipse;

PROCEDURE v_ellarc (handle, x, y, xrad, yrad, bega, enda: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  ptsin^[2]:= xrad;
  ptsin^[3]:= yrad;
  intin^[0]:= bega;
  intin^[1]:= enda;
 END;VDICall(11, 2, 2, 6, handle);
END v_ellarc;

PROCEDURE v_ellpie (handle, x, y, xrad, yrad, begp, endp: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  ptsin^[2]:= xrad;
  ptsin^[3]:= yrad;
  intin^[0]:= begp;
  intin^[1]:= endp;
 END;
 VDICall(11, 2, 2, 7, handle);
END v_ellpie;

PROCEDURE v_rbox (handle: SHORTINT; pxy: tRect);
BEGIN
 WITH App^.VDIPB^ DO
  oldPts:=  ptsin;
  ptsin:= ADR (pxy);
  VDICall (11, 2, 0, 8, handle);
  ptsin:= oldPts;
 END;
END v_rbox;

PROCEDURE v_rfbox (handle: SHORTINT; pxy: tRect);
BEGIN
 WITH App^.VDIPB^ DO
  oldPts:= ptsin;
  ptsin:= ADR (pxy);
  VDICall(11, 2, 0, 9, handle);
  ptsin:= oldPts;
 END;
END v_rfbox;

PROCEDURE v_justified (handle, x, y, len, wspace, cspace: SHORTINT; (* REF *)  str: ARRAY OF CHAR);
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  ptsin^[2]:= len;
  ptsin^[3]:= 0;
  intin^[0]:= wspace;
  intin^[1]:= cspace;
 END;
 VDICall (11, 2, Copy2intin (str, 2), 10, handle);
END v_justified;

VAR ptsIn,
    intin:      ADDRESS;
    control7:   POINTER TO ADDRESS;
    control9:   POINTER TO ADDRESS;

PROCEDURE vro_cpyfm (handle, mode: SHORTINT; pxy: tRect; srcMFDB, destMFDB: MFDB);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= mode;
  ptsIn:=  ptsin;
  ptsin:= ADR (pxy);
  control7 := ADR(control^[7]);
  control9 := ADR(control^[9]);
  control7^:= ADR (srcMFDB);
  control9^:= ADR (destMFDB);
  VDICall (109, 4, 1, 0, handle);
  ptsin:= ptsIn;
 END;
END vro_cpyfm;

PROCEDURE vrt_cpyfm (handle, mode, cSet, cNotset: SHORTINT; pxy: tRect; srcMFDB, destMFDB: MFDB);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= mode;
  intin^[1]:= cSet;
  intin^[2]:= cNotset;
  ptsIn:=  ptsin;
  ptsin:= ADR (pxy);
  control7 := ADR(control^[7]);
  control9 := ADR(control^[9]);
  control7^:= ADR (srcMFDB);
  control9^:= ADR (destMFDB);
  VDICall (121, 4, 1, 0, handle);
  ptsin:= ptsIn;
 END;
END vrt_cpyfm;

PROCEDURE vr_trnfm (handle: SHORTINT; VAR srcMFDB, destMFDB: MFDB);
BEGIN

 WITH App^.VDIPB^ DO
  control7 := ADR(control^[7]);
  control9 := ADR(control^[9]);
 END;
 control7^:= ADR (srcMFDB);
 control9^:= ADR (destMFDB);
 VDICall (110, 0, 0, 0, handle);
END vr_trnfm;

PROCEDURE  v_get_pixel (handle, x, y: SHORTINT; VAR index: SHORTINT): BOOLEAN;
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  VDICall (105, 1, 0, 0, handle);
  index:=  intout^[1];
  RETURN  intout^[0] = 0;
 END;
END v_get_pixel;

PROCEDURE vqt_fontheader (handle: SHORTINT; VAR header: tSpeedoHeader;
                          VAR path: ARRAY OF CHAR);
VAR p: POINTER TO ADDRESS;
    i, l: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  p:= ADR ( intin^[0]);
  p^:= ADR (header);
  VDICall  (105, 1, 0, 0, handle);
  FillChar (path, HIGH (path), 0C);  l:= 1;
  FOR i:= 0 TO  control^[4] DO
   path[i]:= CHR ( intout^[i]);  INC (l);
  END;
  path[l]:= 0C;
 END;
END vqt_fontheader;

PROCEDURE vst_scratch (handle, mode: SHORTINT);
BEGIN
 App^.VDIPB^.intin^[0]:= mode;
 VDICall  (244, 0, 0, 0, handle);
END vst_scratch;

PROCEDURE vst_error (handle, mode: SHORTINT; VAR errorcode: SHORTINT);
VAR p: POINTER TO ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= mode;
(******* Hh??? *)
  p:= ADR (intin^[1]);
  p^:= ADR (errorcode);
 END;
 VDICall (245, 0, 3, 0, handle);
END vst_error;

PROCEDURE  vqt_f_name (handle, num: SHORTINT; VAR name: ARRAY OF CHAR; VAR fsm: BOOLEAN): SHORTINT;
VAR f: ARRAY [0..1] OF SHORTINT;
    i: SHORTINT;
BEGIN
 i:= vqt_x_name (handle, num, name, f);
 fsm:=  f[0] = 1;
 RETURN  i;
END vqt_f_name;

PROCEDURE vqt_f_extent (handle: SHORTINT; str: ARRAY OF CHAR; extent: ADDRESS);
VAR i: SHORTINT;
    p: POINTER TO tRGBArray;
BEGIN
 VDICall  (240, 0, Copy2intin(str, 0), 0, handle);
 p:= extent;
 WITH App^.VDIPB^ DO
  FOR i:= 0 TO 7 DO p^[i]:= ptsout^[i]; END;
 END;
END vqt_f_extent;

PROCEDURE v_ftext (handle, x, y: SHORTINT; str: ARRAY OF CHAR);
VAR i: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
 END;
 VDICall (241, 1, Copy2intin (str, 0), 0, handle);
END v_ftext;

PROCEDURE v_killoutline (handle: SHORTINT; component: ADDRESS);
VAR p: POINTER TO ADDRESS;
BEGIN
 p:= ADR (App^.VDIPB^.intin^[0]); p^:= component;
 VDICall (242, 0, 2, 0, handle);
END v_killoutline;

PROCEDURE v_getoutline (handle, ch: SHORTINT; xyarray, bezarray: ADDRESS;
                        maxverts: SHORTINT; VAR numvert: SHORTINT);
VAR p: POINTER TO ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= ch;
  intin^[1]:= maxverts;
  p:= ADR ( intin^[2]); p^:= xyarray;
  p:= ADR ( intin^[4]); p^:= bezarray;
  VDICall (243, 0, 6, 0, handle);
  numvert:=  intout^[0];
 END;
END v_getoutline;

PROCEDURE vqt_pairkern (handle, ch1, ch2: SHORTINT; VAR x, y: LONGINT);
VAR p: POINTER TO LONGINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= ch1;
  intin^[1]:= ch2;
  VDICall (235, 0, 2, 0, handle);
  p:= ADR ( ptsout^[0]); x:= p^;
  p:= ADR ( ptsout^[2]); y:= p^;
 END;
END vqt_pairkern;

PROCEDURE vqt_trackkern (handle: SHORTINT; VAR x, y: LONGINT);
VAR p: POINTER TO LONGINT;
BEGIN
 VDICall (234, 0, 2, 0, handle);
 WITH App^.VDIPB^ DO
  p:= ADR ( ptsout^[0]); x:= p^;
  p:= ADR ( ptsout^[2]); y:= p^;
 END;
END vqt_trackkern;

PROCEDURE vst_kern (handle, tmode, pmode: SHORTINT; VAR tracks, pairs: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= tmode;
  intin^[1]:= pmode;
  VDICall (237, 0, 2, 0, handle);
  tracks:=  ptsout^[0];
  pairs:=  ptsout^[1];
 END;
END vst_kern;

PROCEDURE  vst_arbpt (handle, point: SHORTINT; VAR cw, ch, bw, bh: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= point;
  VDICall (246, 0, 1, 0, handle);
  cw:=  ptsout^[0];
  ch:=  ptsout^[1];
  bw:=  ptsout^[2];
  bh:=  ptsout^[3];
  RETURN  intout^[0];
 END;
END  vst_arbpt;

PROCEDURE  vst_arbpt32 (handle: SHORTINT; point: LONGINT; VAR cw, ch, bw, bh: SHORTINT): LONGINT;
VAR p: POINTER TO LONGINT;
BEGIN
 WITH App^.VDIPB^ DO
  p:= ADR ( intin^[0]);  p^:= point;
  VDICall (246, 0, 2, 0, handle);
  cw:=  ptsout^[0];
  ch:=  ptsout^[1];
  bw:=  ptsout^[2];
  bh:=  ptsout^[3];
  p:= ADR( intout^[0]);
 END;
 RETURN p^;
END  vst_arbpt32;

PROCEDURE vqt_advance (handle, ch: SHORTINT; VAR advx, advy, xremain, yremain: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= ch;
  VDICall (247, 0, 1, 0, handle);
  advx:=  ptsout^[0];
  advy:=  ptsout^[1];
  xremain:=  ptsout^[2];
  yremain:=  ptsout^[3];
 END;
END vqt_advance;

PROCEDURE vqt_advance32 (handle, ch: SHORTINT; VAR advx, advy: LONGINT);
VAR p: POINTER TO LONGINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= ch;
  VDICall (247, 0, 1, 0, handle);
  p:= ADR ( ptsout^[4]);  advx:= p^;
  p:= ADR ( ptsout^[6]);  advy:= p^;
 END;
END vqt_advance32;

PROCEDURE  vqt_devinfo (handle, device: SHORTINT; VAR devstr: ARRAY OF CHAR): BOOLEAN;
VAR i: SHORTINT;
    b: BOOLEAN;
BEGIN
 b:= FALSE;
 FillChar (devstr, HIGH (devstr), 0C);
 WITH App^.VDIPB^ DO
  intin^[0]:= device;
  VDICall (248, 0, 1, 0, handle);
  IF App^.VDIPB^.ptsout^[0] = 1 THEN
   i:= 0;
   WHILE  intout^[i] <> 0 DO
    devstr[i]:= CHR ( intout^[i]);  INC (i);
   END;
   devstr[i]:= 0C;
   b:= TRUE;
  END;
 END;
 RETURN b;
END vqt_devinfo;

PROCEDURE  v_savecache (handle: SHORTINT; filename: ARRAY OF CHAR): SHORTINT;
VAR i, l: SHORTINT;
BEGIN
 VDICall (249, 0, Copy2intin(filename, 0), 0, handle);
 RETURN App^.VDIPB^.intout^[0];
END v_savecache;

PROCEDURE  v_loadcache (handle: SHORTINT; filename: ARRAY OF CHAR; mode: SHORTINT): SHORTINT;
VAR i, l: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= mode;
  VDICall (250, 0, Copy2intin(filename, 1), 0, handle);
  RETURN  intout^[0];
 END;
END  v_loadcache;

PROCEDURE v_flushcache (handle: SHORTINT);
BEGIN
 VDICall (251, 0, 0, 0, handle);
END v_flushcache;

PROCEDURE  v_cachesize (handle, cache: SHORTINT): LONGINT;
VAR p:POINTER TO LONGINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= cache;
  VDICall (255, 0, 1, 0, handle);
  p:= ADR ( intout^[0]);
 END;
 RETURN p^;
END v_cachesize;

PROCEDURE  vst_setsize (handle, point: SHORTINT; VAR cw, ch, bw, bh: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= point;
  VDICall (252, 0, 1, 0, handle);
  cw:=  ptsout^[0];
  ch:=  ptsout^[1];
  bw:=  ptsout^[2];
  bh:=  ptsout^[3];
  RETURN  intout^[0];
 END;
END vst_setsize;

PROCEDURE  vst_setsize32 (handle: SHORTINT; point: LONGINT; VAR cw, ch, bw, bh: SHORTINT): LONGINT;
VAR p:POINTER TO LONGINT;
BEGIN
 WITH App^.VDIPB^ DO
  p:= ADR( intin^[0]); p^:= point;
  VDICall (252, 0, 2, 0, handle);
  cw:=  ptsout^[0];
  ch:=  ptsout^[1];
  bw:=  ptsout^[2];
  bh:=  ptsout^[3];
  p:= ADR( intout^[0]);
 END;
 RETURN p^;
END vst_setsize32;

PROCEDURE  vst_skew (handle, skew: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= skew;
  VDICall (253, 0, 1, 0, handle);
  RETURN  intout^[0];
 END;
END vst_skew;

PROCEDURE v_get_table (handle: SHORTINT; VAR ascii, style: ADDRESS);
VAR p: POINTER TO ADDRESS;
BEGIN
 VDICall (254, 0, 0, 0, handle);
 WITH App^.VDIPB^ DO
  p:= ADR ( intout^[0]); ascii:= p^;
  p:= ADR ( intout^[2]); style:= p^;
 END;
END v_get_table;

PROCEDURE vst_charmap (handle, mode: SHORTINT);
BEGIN
 App^.VDIPB^.intin^[0]:= mode;
 VDICall (232, 0, 1, 0, handle);
END vst_charmap;

PROCEDURE v_getbitmap_info (handle, ch: SHORTINT;
                            VAR advx, advy, xoff, yoff, width, height: LONGINT);
VAR p: POINTER TO LONGINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= ch;
  VDICall (239, 0, 1, 0, handle);
  width:=  ptsout^[0];
  height:=  ptsout^[1];
  p:= ADR ( ptsout^[2]); advx:= p^;
  p:= ADR ( ptsout^[4]); advy:= p^;
  p:= ADR ( ptsout^[6]); xoff:= p^;
  p:= ADR ( ptsout^[8]); yoff:= p^;
 END;
END v_getbitmap_info;

PROCEDURE  v_bez_on (handle: SHORTINT): SHORTINT;
BEGIN
 VDICall (11, 1, 0, 13, handle);
 RETURN App^.VDIPB^.intout^[0];
END v_bez_on;

PROCEDURE v_bez_off (handle: SHORTINT);
BEGIN
 VDICall (11, 0, 0, 13, handle);
END v_bez_off;

PROCEDURE v_set_app_buff (handle: SHORTINT; buff: ADDRESS; words: SHORTINT);
VAR p: POINTER TO ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  p:= ADR ( intin^[0]);  p^:= buff;
  intin^[2]:= words;
 END;
 VDICall (-1, 0, 0, 6, handle);
END v_set_app_buff;

PROCEDURE v_bez (handle, count: SHORTINT;  xyarr, bezarr, extent: ADDRESS;
                 VAR totpts, totmoves: SHORTINT);
VAR ointin, oPtsin, ointout, oPtsout: ADDRESS;
    x: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  ointin:=  intin;  intin:=  bezarr;
  oPtsin:=  ptsin;  ptsin:=  xyarr;
  oPtsout:= ptsout; ptsout:= extent;
  x:= (count + 1) DIV 2;
  VDICall (6, count, x, 13, handle);
  totpts:= intout^[0];
  totmoves:= intout^[1];
  intin:= ointin;
  ptsin:= oPtsin;
  ptsout:= oPtsout;
 END;
END v_bez;

PROCEDURE v_bez_fill (handle, count: SHORTINT; xyarr, bezarr, extent: ADDRESS;
                      VAR totpts, totmoves: SHORTINT);
VAR ointin, oPtsin, ointout, oPtsout: ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  ointin:=   intin;   intin:=  bezarr;
  oPtsin:=   ptsin;   ptsin:=  xyarr;
  oPtsout:=  ptsout;  ptsout:= extent;
  VDICall (9, count, (count + 1) DIV 2, 13, handle);
  totpts:=  intout^[0];
  totmoves:=  intout^[1];
  intin:= ointin;
  ptsin:= oPtsin;
  ptsout:= oPtsout;
 END;
END v_bez_fill;

PROCEDURE v_bez_qual (handle, percent: SHORTINT): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= 32;
  intin^[1]:= 1;
  intin^[2]:= percent;
  VDICall (5, 0, 3, 99, handle);
  RETURN  intout^[0];
 END;
END v_bez_qual;

PROCEDURE vqt_s_info (handle, flag, id, elem: SHORTINT; VAR info: Font_Info): SHORTINT;
VAR p: POINTER TO ADDRESS;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= flag;
  intin^[1]:= id;
  intin^[2]:= elem;
  p:= ADR (intin^[3]);
  p^:= ADR (info);
  VDICall (229, 0, 5, 0, handle);
  RETURN intout^[0];
 END;
END vqt_s_info;

PROCEDURE  vqt_s_name (handle, num: SHORTINT; VAR name: ARRAY OF CHAR; 
                       VAR fsm: BOOLEAN; VAR typ, flag: SHORTINT): SHORTINT;
VAR fl: ARRAY [0..1] OF SHORTINT;
    ret: SHORTINT;
    i: CARDINAL;
    w1, w2, w3: POINTER TO BITSET;
BEGIN
 ret:= vqt_x_name (handle, num, name, fl);
 fsm:= fl[0] = 1;
 i:= 00FFH;  w1:= ADR (fl[0]);  w2:= ADR (i);  w3:= ADR (typ);
 w3^:= w1^ * w2^; (* Bitweises AND *)
 i:= 0FF00H;  w1:= ADR (fl[1]);  w2:= ADR (i);  w3:= ADR (flag);
 w3^:= w1^ * w2^; (* Bitweises AND *)
 RETURN ret;
END vqt_s_name;

PROCEDURE vst_font_by_name (handle, typ: SHORTINT; VAR name: ARRAY OF CHAR): SHORTINT; 
VAR i: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= typ;
  VDICall (230, 0, Copy2intin (name, 1), 0, handle);
  i:= 0;
  WHILE i < control^[4] DO
   name[i]:= CHR (intout^[i+1]);  INC (i);
  END;
  name[i]:= 0C;
  RETURN intout^[0];
 END;
END vst_font_by_name;

PROCEDURE vqt_name_id (handle, typ: SHORTINT; VAR name: ARRAY OF CHAR): SHORTINT; 
VAR i: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= typ;
  VDICall (230, 0, Copy2intin (name, 1), 100, handle);
  i:= 0;
  WHILE i < control^[4] DO
   name[i]:= CHR (intout^[i+1]);  INC (i);
  END;
  name[i]:= 0C;
  RETURN intout^[0];
 END;
END vqt_name_id;

PROCEDURE vs_outmode (handle, mode: SHORTINT; flags: BITSET): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= mode;
  intin^[1]:= CastToInt (flags);
  VDICall (224, 0, 2, 101, handle);
  RETURN intout^[0];
 END;
END vs_outmode;

PROCEDURE vs_use_fonts (handle, types: SHORTINT; flags: BITSET): SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  intin^[0]:= types;
  intin^[1]:= CastToInt (flags);
  VDICall (224, 0, 2, 105, handle);
  RETURN intout^[0];
 END;
END vs_use_fonts;

PROCEDURE vs_backmap (handle: SHORTINT; flags: BITSET; 
                      VAR mapon: BOOLEAN; VAR point: SHORTINT);
BEGIN
 WITH App^.VDIPB^ DO
  IF mapon THEN intin^[0]:= 0; ELSE  intin^[0]:= 0;  END;
  intin^[1]:= point;
  intin^[2]:= CastToInt (flags);
  VDICall (224, 1, 2, 100, handle);
  mapon:= intout^[0] = 0;
  point:= intout^[1];
 END;
END vs_backmap;

PROCEDURE v_mono_ftext (handle, x, y: SHORTINT; str: ARRAY OF CHAR);
VAR i: SHORTINT;
BEGIN
 WITH App^.VDIPB^ DO
  ptsin^[0]:= x;
  ptsin^[1]:= y;
  VDICall ( 233, 1, Copy2intin (str, 0), 0, handle);
 END;
END v_mono_ftext;

END M_VDI.

