(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)

DEFINITION MODULE M_Windows;

FROM Portab IMPORT tCompiler, Compiler;

FROM SYSTEM     IMPORT  ADDRESS, BYTE;
FROM M_AES      IMPORT  PtrCICONBLK, tObjctree;
FROM M_Types    IMPORT  Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6, Bit7, Bit8,
                        Bit9, Bit10, Bit11, Bit12, Bit13, Bit14, Bit15, Bit16,
                        Bit17, Bit18, Bit19, Bit20, Bit21, Bit22, Bit23, Bit24,
                        Bit25, Bit26, Bit27, Bit28, Bit29, Bit30, Bit31,
                        tRect, LONGBITSET;

CONST wBell =          Bit0;  (* Kling Glckchen klingelingeling      *)
      wColor =         Bit1;  (* Hintergrundfarbe des Fensters ndern *)
      wFulled =        Bit2;  (* Fenster auf volle Gre bringen      *)
      wTopped =        Bit3;  (* Fenster toppen                       *)
      wHSlide =        Bit4;  (* Horizontal-Slider setzen             *)
      wVSlide =        Bit5;  (* Vertikal-Slider setzen               *)
      wSized =         Bit6;  (* Fenstergre ndern                  *)
      wMoved =         Bit7;  (* Fensterposition ndern               *)
      wSizePos =       Bit8;  (* Fenster auf Gre + Position bringen *)
      wChangeFont =    Bit9;  (* Font ndern                          *)
      wClose =         Bit10; (* Fenster schliessen                   *)
      wBottomed =      Bit11; (* Fenster in den Hintergrund legen (AES 4.0) *)
      wIconify =       Bit12; (* Fenster in Icon wandeln              *)
      wAllIconify =    Bit13; (* Programm "schrumpfen"                *)
      wUniconify =     Bit14; (* Fenster wieder auf alte Gre        *)
      wHSUpdate =      Bit15; (* Horizontalen Slider updaten          *)
      wVSUpdate =      Bit16; (* Vertikalen Slider updaten            *)
      wCallback =      Bit17; (* Handler nach Ausfhren der Aktionen erneut aufrufen *)
      wTempClose =     Bit18; (* Fenster temporr schliessen          *)
      wReopen =        Bit19; (* temporr geschlossenes Fenster ffnen *)
      wSetAsterik =    Bit20; (* Sternchen in Titelzeile platzieren   *)
      wDelAsterik =    Bit21; (* Sternchen aus Titelzeile lschen     *)

CONST VSlider =        0;
      HSlider =        1;

TYPE  tExData =        ARRAY [0..15] OF SHORTINT;

TYPE  PtrWinpara =     POINTER TO WinParameter;
      WinParameter =   RECORD
                        window:   SHORTINT;
                        mx, my:   SHORTINT;
                        message:  SHORTINT;
                        spec:     tRect;
                        extended: tExData;
                        action:   LONGBITSET;
                        res:      ADDRESS;
                       END;

(*$?Compiler=Haenisch: (*$K+*) *)
TYPE WindowHandler =   PROCEDURE (PtrWinpara);
(*$?Compiler=Haenisch: (*$K=*) *)

CONST WinMenu =    Bit0;
      WinText =    Bit1;
      WinDial =    Bit2;
      WinDrag =    Bit3;
      WinMaxsize = Bit4;
      WinArrows =  Bit5;
      WinAlert =      Bit6;
      WinTopAllowed = Bit7;
      (* Dialoge, die dieses Flag setzen, werden bei WinTop gefunden,
       * auch wenn Dialoge ausgeblendet werden sollen. Dadurch erreichen
       * auch Nachrichten wie WinChangeFont den Dialog.
       *)
                  
PROCEDURE OpenWindow (handler: WindowHandler; 
                     element: BITSET;  extended: BITSET;
                     backcolor, backrast: SHORTINT;
                     x, y, w, h, xo, yo, wo, ho: SHORTINT;
                     name, info: ARRAY OF CHAR;
                     rsc: tObjctree; exinfo: ADDRESS): SHORTINT;
PROCEDURE CloseWindow (VAR win: SHORTINT);
PROCEDURE WinOpen (win: SHORTINT): BOOLEAN;
PROCEDURE RedrawObjc (win: SHORTINT; tree: tObjctree; entry, depth: SHORTINT; clip: tRect);
PROCEDURE RedrawWindow (win, entry, depth: SHORTINT; clip: tRect);
PROCEDURE RedrawScreen;

(*$?Compiler=Haenisch: (*$K+*) *)
TYPE RewriteProc = PROC;
(*$?Compiler=Haenisch: (*$K=*) *)

PROCEDURE RewriteWindow (win, handle: SHORTINT; prc: RewriteProc);
PROCEDURE SetWinName (win: SHORTINT; name: ARRAY OF CHAR);
PROCEDURE WinName (win: SHORTINT; VAR name: ARRAY OF CHAR);
PROCEDURE SetWinAsterik (win: SHORTINT);
PROCEDURE DelWinAsterik (win: SHORTINT);
PROCEDURE SetWinInfo (win: SHORTINT; info: ARRAY OF CHAR);
PROCEDURE WinInfo (win: SHORTINT; VAR name: ARRAY OF CHAR);
PROCEDURE SetWinTop (win: SHORTINT);
PROCEDURE SetWinBottom (win: SHORTINT);
PROCEDURE WinTop (nodials: BOOLEAN): SHORTINT;
PROCEDURE GEMTop (VAR win: SHORTINT; VAR own: BOOLEAN);
PROCEDURE TopNext;
PROCEDURE SetWinFull (win: SHORTINT);
PROCEDURE SetWinRect (win: SHORTINT; rect: tRect);
PROCEDURE SetWinColor (win: SHORTINT; color, back: SHORTINT);
PROCEDURE SetWinPos (win: SHORTINT; xx, yy: SHORTINT);
PROCEDURE SetWinSize (win: SHORTINT; ww, hh: SHORTINT);
PROCEDURE SetWinSlider (win, which, pos, size: SHORTINT);
PROCEDURE SetWinIcon (win: SHORTINT; icon: PtrCICONBLK);
PROCEDURE SetIcontext (win: SHORTINT; text: ARRAY OF CHAR);
PROCEDURE IconifyWindow (win: SHORTINT; rect: tRect; iconify: BOOLEAN);
PROCEDURE  WinIconified (win: SHORTINT): BOOLEAN;
PROCEDURE GetWinRect (win: SHORTINT; VAR rect: tRect);
PROCEDURE GetWorkRect (win: SHORTINT; VAR rect: tRect);
PROCEDURE GetUseableRect (win: SHORTINT; VAR rect: tRect);
PROCEDURE GetWinExinfo (win: SHORTINT): ADDRESS;
PROCEDURE PreventTopping (prevent: BOOLEAN);
PROCEDURE DisposeWindows(): SHORTINT;
PROCEDURE GetObjctree (win: SHORTINT): tObjctree;
PROCEDURE GetMenutree (win: SHORTINT): tObjctree;
PROCEDURE RectList (win: SHORTINT; flag: SHORTINT; VAR rect: tRect): BOOLEAN;
PROCEDURE RcIntersect (VAR rc1, rc2: tRect): BOOLEAN;
PROCEDURE TempCloseWin (win: SHORTINT);
PROCEDURE ReopenWin (win: SHORTINT);
PROCEDURE SendSpecMessage (win, winmsg, mx, my: SHORTINT; VAR r: tRect; VAR ex: tExData);

END M_Windows.

