(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Windows;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM SYSTEM     IMPORT  ADR, ADDRESS, BYTE, STORE;
FROM Storage    IMPORT  ALLOCATE, DEALLOCATE;
FROM M_Sys      IMPORT  App, CallMagic, CastToInt;
FROM M_AES      IMPORT  PtrCICONBLK, tObjctree;
FROM M_Types    IMPORT  Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6, Bit7, Bit8,
                        Bit9, Bit10, Bit11, Bit12, Bit13, Bit14, Bit15, Bit16,
                        Bit17, Bit18, Bit19, Bit20, Bit21, Bit22, Bit23, Bit24,
                        Bit25, Bit26, Bit27, Bit28, Bit29, Bit30, Bit31,
                        tRect, LONGBITSET, Stacksize;

(*$?Compiler=Megamax:
  IMPORT Calls, MOSGlobals;

TYPE    PtrWH =         POINTER TO WH;
        WH =            RECORD
                         window:  SHORTINT;
                         handler: WindowHandler;
                         next:    PtrWH;
                        END;

VAR     whlist:         PtrWH;
        p, q:           PtrWH;
        drawproc:       RewriteProc;
        mem:            MOSGlobals.MemArea;
        stack1:         ARRAY [0..Stacksize-1] OF BYTE;
        stack2:         ARRAY [0..Stacksize-1] OF BYTE;
        caller:         ADDRESS;
        rewrite:        ADDRESS;

  (*$R-*)
  (*$S-*)
  PROCEDURE mm2 (VAR regs: Calls.Registers);
  VAR a: PtrWinpara;
  BEGIN
   a:= regs.regA0.ad;
   p:= whlist;
   WHILE p <> NIL DO
    IF p^.window = a^.window THEN  p^.handler (a);  RETURN  END;
    p:= p^.next;
   END;
  END mm2;
  (*$S=*)
  (*$R=*)

  (*$R-*)
  (*$S-*)
  PROCEDURE mm2draw (VAR regs: Calls.Registers);
  BEGIN
   drawproc;
  END mm2draw;
  (*$S=*)
  (*$R=*)
 *)


PROCEDURE RectList (win: SHORTINT; flag: SHORTINT; VAR rect: tRect): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= win;
  IntIn[1]:= flag;
  CallMagic (2427);
  RETURN IntOut[0] = 1;
 END;
END RectList;

PROCEDURE RcIntersect (VAR rc1, rc2: tRect): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rc1);
  AddrIn[1]:= ADR (rc2);
  CallMagic (2428);
  RETURN IntOut[0] = 1;
 END;
END RcIntersect;

PROCEDURE RedrawObjc (win: SHORTINT; tree: tObjctree; entry, depth: SHORTINT; clip: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (clip);
  AddrIn[1]:= tree;
  IntIn[0]:= win;
  IntIn[1]:= entry;
  IntIn[2]:= depth;
 END;
 CallMagic (2402);
END RedrawObjc; 

PROCEDURE RedrawWindow (win, entry, depth: SHORTINT; clip: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (clip);
  IntIn[0]:= win;
  IntIn[1]:= entry;
  IntIn[2]:= depth;
 END;
 CallMagic (2403);
END RedrawWindow; 

PROCEDURE RedrawScreen;
BEGIN
 CallMagic (2404);
END RedrawScreen;

PROCEDURE OpenWindow (handler: WindowHandler; 
                     element: BITSET;  extended: BITSET;
                     backcolor, backrast: SHORTINT;
                     x, y, w, h, xo, yo, wo, ho: SHORTINT;
                     name, info: ARRAY OF CHAR;
                     rsc: tObjctree; exinfo: ADDRESS): SHORTINT;
VAR i: SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
(*$?Compiler=Megamax:
  NEW (q);  IF q = NIL THEN  RETURN -1;  END;
  q^.handler:= handler;
  q^.next:= whlist;
  AddrIn[0]:= caller;
 *)
(*$?Compiler=Haenisch:
  AddrIn[0]:= ADDRESS(handler);
 *)
  AddrIn[1]:= ADR (name);
  AddrIn[2]:= ADR (info);
  AddrIn[3]:= rsc;
  AddrIn[4]:= exinfo;
  IntIn[ 0]:= CastToInt (element);
  IntIn[ 1]:= backcolor;
  IntIn[ 2]:= backrast;
  IntIn[ 3]:= x;
  IntIn[ 4]:= y;
  IntIn[ 5]:= w;
  IntIn[ 6]:= h;
  IntIn[ 7]:= xo;
  IntIn[ 8]:= yo;
  IntIn[ 9]:= wo;
  IntIn[10]:= ho;
  IntIn[11]:= CastToInt (extended);
  CallMagic (2400);
(*$?Compiler=Haenisch:
  RETURN IntOut[0];
 *)
(*$?Compiler=Megamax:
  i:= IntOut[0];
  q^.window:= i;
  whlist:= q;
  RETURN i;
 *)
 END;
END OpenWindow;

PROCEDURE CloseWindow (VAR win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2401);
(*$?Compiler=Megamax:
 p:= whlist;  q:= whlist;
 WHILE p <> NIL DO
  IF p^.window = win THEN 
   IF q <> NIL THEN q^.next:= p^.next; END;
   DISPOSE (p);
  END;
  q:= p;  p:= p^.next;
 END;
 *)
END CloseWindow;

PROCEDURE DisposeWindows(): SHORTINT;
VAR i: SHORTINT;
BEGIN
 CallMagic (2424);
(*$?Compiler=Haenisch:
 RETURN App^.MagicPB^.IntOut[0];
 *)
(*$?Compiler=Megamax:
 i:= App^.MagicPB^.IntOut[0];
 p:= whlist;
 WHILE p <> NIL DO
  q:= p;  p:= p^.next;  DISPOSE (q);
 END;
 RETURN i;
 *)
END DisposeWindows;

PROCEDURE SetWinName (win: SHORTINT; name: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (name);
  IntIn[0]:= win;
 END;
 CallMagic (2405);
END SetWinName;

PROCEDURE SetWinInfo (win: SHORTINT; info: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (info);
  IntIn[0]:= win;
 END;
 CallMagic (2409);
END SetWinInfo;

PROCEDURE WinName (win: SHORTINT; VAR name: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (name);
  IntIn[0]:= win;
 END;
 CallMagic (2406);
END WinName;

PROCEDURE WinInfo (win: SHORTINT; VAR name: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (name);
  IntIn[0]:= win;
 END;
 CallMagic (2410);
END WinInfo;

PROCEDURE SetWinAsterik (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2407);
END SetWinAsterik;

PROCEDURE DelWinAsterik (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2408);
END DelWinAsterik;

PROCEDURE SetWinTop (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2411);
END SetWinTop;

PROCEDURE SetWinBottom (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2430);
END SetWinBottom;

PROCEDURE WinTop (nodials: BOOLEAN): SHORTINT;
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (nodials);
 CallMagic (2412);
 RETURN App^.MagicPB^.IntOut[0];
END WinTop;

PROCEDURE TopNext;
BEGIN
 CallMagic (2413);
END TopNext;

PROCEDURE SetWinFull (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2414);
END SetWinFull;

PROCEDURE SetWinRect (win: SHORTINT; rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= win;
 END;
 CallMagic (2415);
END SetWinRect;

PROCEDURE SetWinColor  (win: SHORTINT; color, back: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= color;
  IntIn[2]:= back;
 END;
 CallMagic (2416);
END SetWinColor;

PROCEDURE SetWinPos (win: SHORTINT; xx, yy: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= xx;
  IntIn[2]:= yy;
 END;
 CallMagic (2417);
END SetWinPos;

PROCEDURE SetWinSize (win: SHORTINT; ww, hh: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= ww;
  IntIn[2]:= hh;
 END;
 CallMagic (2418);
END SetWinSize;

PROCEDURE GetWinRect (win: SHORTINT; VAR rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= win;
 END;
 CallMagic (2420);
END GetWinRect;

PROCEDURE GetWorkRect (win: SHORTINT; VAR rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= win;
 END;
 CallMagic (2421);
END GetWorkRect;

PROCEDURE GetUseableRect (win: SHORTINT; VAR rect: tRect);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= win;
 END;
 CallMagic (2422);
END GetUseableRect;

PROCEDURE SetWinSlider (win, which, pos, size: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= which;
  IntIn[2]:= pos;
  IntIn[3]:= size;
 END;
 CallMagic (2419);
END SetWinSlider;

PROCEDURE PreventTopping (prevent: BOOLEAN);
BEGIN
 App^.MagicPB^.IntIn[0]:= ORD (prevent);
 CallMagic (2423);
END PreventTopping;

PROCEDURE GetObjctree (win: SHORTINT): tObjctree;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  CallMagic (2425);
  RETURN  AddrOut[0];
 END;
END GetObjctree;

PROCEDURE GetMenutree (win: SHORTINT): tObjctree;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  CallMagic (2426);
  RETURN  AddrOut[0];
 END;
END GetMenutree;

PROCEDURE RewriteWindow (win, handle: SHORTINT; prc: RewriteProc);
BEGIN
(*$?Compiler=Megamax:
 drawproc:= prc;
 *)
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= handle;
(*$?Compiler=Haenisch:
  AddrIn[0]:= ADDRESS(prc);
 *)
(*$?Compiler=Megamax:
  AddrIn[0]:= rewrite;
 *)
 END;
 CallMagic (2432)
END RewriteWindow;

PROCEDURE GetWinExinfo (win: SHORTINT): ADDRESS;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  CallMagic (2433);
  RETURN AddrOut[0];
 END;
END GetWinExinfo;

PROCEDURE GEMTop (VAR win: SHORTINT; VAR own: BOOLEAN);
BEGIN
 CallMagic (2434);
 WITH App^.MagicPB^ DO
  win:= IntOut[0];
  own:= IntOut[1] = 1;
 END;
END GEMTop;

PROCEDURE SetWinIcon (win: SHORTINT; icon: PtrCICONBLK);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  AddrIn[0]:= icon;
 END;
 CallMagic (2435);
END SetWinIcon;

PROCEDURE SetIcontext (win: SHORTINT; text: ARRAY OF CHAR);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (text);
  IntIn[0]:= win;
 END;
 CallMagic (2436);
END SetIcontext;

PROCEDURE IconifyWindow (win: SHORTINT; rect: tRect; iconify: BOOLEAN);
BEGIN
 WITH App^.MagicPB^ DO
  AddrIn[0]:= ADR (rect);
  IntIn[0]:= win;
  IntIn[1]:= ORD (iconify);
 END;
 CallMagic (2437);
END IconifyWindow;

PROCEDURE  WinIconified (win: SHORTINT): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  CallMagic (2438);
  RETURN IntOut[0] = 1;
 END;
END WinIconified;

PROCEDURE TempCloseWin (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2439);
END TempCloseWin;

PROCEDURE ReopenWin (win: SHORTINT);
BEGIN
 App^.MagicPB^.IntIn[0]:= win;
 CallMagic (2440);
END ReopenWin;

PROCEDURE SendSpecMessage (win, winmsg, mx, my: SHORTINT; VAR r: tRect; VAR ex: tExData);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  IntIn[1]:= winmsg;
  IntIn[2]:= mx;
  IntIn[3]:= my;
  AddrIn[0]:= ADR (r);
  AddrIn[1]:= ADR (ex);
 END;
 CallMagic (2431);
END SendSpecMessage;

PROCEDURE WinOpen (win: SHORTINT): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= win;
  CallMagic (2441);
  RETURN IntOut[0] = 1;
 END;
END WinOpen;

BEGIN
(*$?Compiler=Megamax:
 whlist:= NIL;
 mem.bottom:= ADR (stack1);  mem.length:= Stacksize;
 Calls.NewCaller (mm2, FALSE, mem, caller);
 mem.bottom:= ADR (stack2);  mem.length:= Stacksize;
 Calls.NewCaller (mm2draw, FALSE, mem, rewrite);
 IF (caller = NIL) OR (rewrite = NIL) THEN  HALT;  END;
 *)
END M_Windows.
