(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modular  Applications  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.01.1994   (C)1990..1992 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
 
DEFINITION MODULE M_XBIOS;

IMPORT SYSTEM;
FROM M_Types    IMPORT  Nihil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5,
                        Bit6, Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13,
                        Bit14, Bit15, LONGBITSET;


CONST   DisableMouse =  0;
        RelativeMouse = 1;
        AbsoluteMouse = 2;
        KeycodeMouse =  4;

TYPE    PARAM =         RECORD
                         topMode:  SYSTEM.BYTE;
                         buttons:  SYSTEM.BYTE;
                         xparam:   SYSTEM.BYTE;
                         yparam:   SYSTEM.BYTE;
                         EXTRA:    RECORD
                                    xmax:     SHORTCARD;
                                    ymax:     SHORTCARD;
                                    xinitial: SHORTCARD;
                                    yInitial: SHORTCARD;
                                   END;
                        END;

PROCEDURE Initmouse (type: SHORTINT; VAR param: ARRAY OF SYSTEM.LOC; vec: PROC);
PROCEDURE Physbase (): SYSTEM.ADDRESS;
PROCEDURE Logbase (): SYSTEM.ADDRESS;
PROCEDURE Getrez (): SHORTINT;
PROCEDURE Setscreen (logloc, physloc: SYSTEM.ADDRESS; rez: SHORTINT);

TYPE    Palette =  ARRAY [0..15] OF SHORTCARD;

PROCEDURE Setpalette (VAR palette: ARRAY OF SYSTEM.LOC);
PROCEDURE Setcolor (colourNum, colour: SHORTCARD): SHORTCARD;
PROCEDURE Floprd (buf: SYSTEM.ADDRESS; drv, sec, trck, side, count: SHORTINT): SHORTINT;
PROCEDURE Flopwr (buf: SYSTEM.ADDRESS; drv, sec, trck, side, count: SHORTINT): SHORTINT;
PROCEDURE Flopfmt (buf: SYSTEM.ADDRESS; drv, spt, trck, side, il, virg: SHORTINT): SHORTINT;
PROCEDURE Midiws (VAR string: ARRAY OF SYSTEM.LOC; len: SHORTCARD);
PROCEDURE Mfpint (intNo: SHORTCARD; vector: PROC);

CONST   RS232 =         0;
        IKBD =          1;
        MIDI =          2;

TYPE    PtrIOREC =      POINTER TO IOREC;
        IOREC =         RECORD
                         ibuf:     SYSTEM.ADDRESS;     (* pointer to buffer *)
                         ibufsize: SHORTCARD;    (* buffer size *)
                         ibufhd:   SHORTCARD;    (* head index *)
                         ibuftl:   SHORTCARD;    (* tail index *)
                         ibuflow:  SHORTCARD;    (* low water mark *)
                         ibufhi:   SHORTCARD;    (* high water mark *)
                        END;

PROCEDURE Iorec (dev: SHORTINT): SYSTEM.ADDRESS;

CONST   Sp19200 =       0;
        Sp9600 =        1;
        Sp4800 =        2;
        Sp3600 =        3;
        Sp2400 =        4;
        Sp2000 =        5;
        Sp1800 =        6;
        Sp1200 =        7;
        Sp600 =         8;
        Sp300 =         9;
        Sp200 =         10;
        Sp150 =         11;
        Sp134 =         12;
        Sp110 =         13;
        Sp75 =          14;
        Sp50 =          15;

CONST   XONXOFF =       Bit0;
        RTSCTS =        Bit1;

PROCEDURE Rsconf (speed: SHORTINT; flavor: BITSET;  u, r, t, s: SHORTINT): SHORTINT;

TYPE    Keycode =       POINTER TO ARRAY [0..132] OF CHAR;  (* JGS *)

TYPE    PtrKEYTAB =     POINTER TO KEYTAB;
        KEYTAB =        RECORD
                         unshift:  Keycode;
                         shift:    Keycode;
                         capslock: Keycode;
                        END;

PROCEDURE Keytbl (VAR unshift, shift, capslock: SYSTEM.ADDRESS): SYSTEM.ADDRESS;
PROCEDURE Random (): LONGCARD;

CONST   SameNumber =    -1;
        NewNumber =     01000000H;
        
CONST   SameType =      -1;
        SS180 =         0;
        DS360 =         1;
        SS360 =         2;
        DS720 =         3;

CONST   NoExecute =     0;
        Execute =       1;
        
PROCEDURE Protobt (buf: SYSTEM.ADDRESS; num: LONGINT; typ, exec: SHORTINT);
PROCEDURE Flopver (buf: SYSTEM.ADDRESS; drv, sec, trck, side, count: SHORTINT): SHORTINT;
PROCEDURE Scrdmp;

CONST   CURSHIDE =      0;
        CURSSHOW =      1;
        CURSBLINK =     2;
        CURSNOBLINK =   3;
        CURSSETRATE =   4;
        CURSGETRATE =   5;

PROCEDURE Cursconf (function, operand: SHORTINT): SHORTINT;
PROCEDURE Settime (datetime: LONGCARD);
PROCEDURE Gettime (): LONGCARD;
PROCEDURE Bioskeys;
PROCEDURE Ikbdws (str: ARRAY OF SYSTEM.LOC; len: SHORTCARD);
PROCEDURE Jdisint (intNo: SHORTCARD);
PROCEDURE Jenabint (intNo: SHORTCARD);
PROCEDURE Giaccess (regno: SHORTCARD; data: SYSTEM.BYTE): SHORTCARD;
PROCEDURE Offgibit (bitno: SHORTCARD);
PROCEDURE Ongibit (bitno: SHORTCARD);

CONST   TimerA =  0;
        TimerB =  1;
        TimerC =  2;
        TimerD =  3;

PROCEDURE Xbtimer (timer, control, data: SHORTCARD; vec: PROC);
PROCEDURE Dosound ((* REF *)   data: ARRAY OF SYSTEM.LOC);

CONST   DaisyWheel =    Bit0;
        Monochrome =    Bit1;
        EpsonPrinter =  Bit2;
        Final =         Bit3;
        RS232Port =     Bit4;
        SingleSheet =   Bit5;

PROCEDURE Setprt (config: BITSET): BITSET;

TYPE    PtrKBVECS =     POINTER TO KBVECS;
        KBVECS =        RECORD
                         midivec:  SYSTEM.ADDRESS;     (* MIDI input *)
                         vkbderr:  SYSTEM.ADDRESS;     (* keyboard error *)
                         vmidierr: SYSTEM.ADDRESS;     (* MIDI error *)
                         statvec:  SYSTEM.ADDRESS;     (* ikdb status packet *)
                         mousevec: SYSTEM.ADDRESS;     (* mouse packet *)
                         clockvec: SYSTEM.ADDRESS;     (* clock packet *)
                         joyvec:   SYSTEM.ADDRESS;     (* joystick packet *)
                         midisys:  SYSTEM.ADDRESS;
                         ikbdsys:  SYSTEM.ADDRESS;
                        END;

PROCEDURE Kbdvbase(): SYSTEM.ADDRESS;
PROCEDURE Kbrate (initial, repeat: SHORTINT): SHORTCARD;

TYPE    PtrPBDEF =      POINTER TO PBDEF;
        PBDEF =         RECORD
                         pbScrptr:      SYSTEM.ADDRESS;
                         pbOffset:      SHORTINT;
                         pbWidth:       SHORTINT;
                         pbHeight:      SHORTINT;
                         pbLeft:        SHORTINT;
                         pbRight:       SHORTINT;
                         pbScrez:       SHORTINT;
                         pbPrrez:       SHORTINT;
                         pbColptr:      SYSTEM.ADDRESS;
                         pbPrttype:     LONGCARD;
                         pbPrport:      SHORTINT;
                         pbMask:        SHORTINT;
                        END;

PROCEDURE Prtblk (block: ARRAY OF SYSTEM.LOC);
PROCEDURE Vsync;
PROCEDURE Supexec (code: PROC);
PROCEDURE Puntaes;
PROCEDURE Blitmode (flag: SHORTINT): BITSET;
PROCEDURE Floprate (devno: SHORTCARD; newrate: SHORTINT): SHORTINT;
PROCEDURE DMAread (sec: LONGINT; cnt: SHORTINT; buf: SYSTEM.ADDRESS; 
                   dev: SHORTINT): LONGINT;
PROCEDURE DMAwrite (sec: LONGINT; cnt: SHORTINT; buf: SYSTEM.ADDRESS;
                    dev: SHORTINT): LONGINT;

TYPE    BCONMAP = POINTER TO
                   RECORD
                    maptab:     POINTER TO ARRAY [0..5] OF PROC;
                    maptabsize: SHORTINT;
                   END;

PROCEDURE Bconmap (dev: SHORTINT): SYSTEM.ADDRESS;

CONST   NVMread =  0;
        NVMwrite = 1;
        NVMinit =  2; (* loescht NVM und initialisiert Checksumme *)

PROCEDURE NVMaccess (mode, start, cnt: SHORTINT; buf: SYSTEM.ADDRESS): SHORTINT;

CONST   GRAY =   4096;  (* 2^12 *)
        SMEAR =  32768; (* 2^15 *)
        STLOW =  0;     (* 000-00000000 *)
        STMED =  256;   (* 001- *)
        STHIGH = 512;   (* 010- *)
        TTLOW =  1792;  (* 111- *)
        TTMED =  1024;  (* 100- *)
        TTHIGH = 1536;  (* 110- *)

PROCEDURE EsetShift (mode: SHORTINT);
PROCEDURE EgetShift (): SHORTINT;
PROCEDURE EsetBank (bank: SHORTINT): SHORTINT;
PROCEDURE EsetColor (num, col: SHORTINT): SHORTINT;
PROCEDURE EsetPalette (start, cnt: SHORTINT; pal: ARRAY OF SYSTEM.LOC): SHORTINT;
PROCEDURE EgetPalette (start, cnt: SHORTINT; VAR pal: ARRAY OF SYSTEM.LOC): SHORTINT;
PROCEDURE EsetGray (mode: SHORTINT): SHORTINT;
PROCEDURE EsetSmear(mode: SHORTINT): SHORTINT;

TYPE    METAINFOPtr =   POINTER TO METAINFO;
        METAINFO =      RECORD
                         drivemap: LONGINT;
                         version:  SYSTEM.ADDRESS;
                         reserved: ARRAY [1..2] OF LONGINT;
                        END;

PROCEDURE Metainit (VAR buffer: METAINFO);
PROCEDURE DspLoadProg (filename: ARRAY OF CHAR; ability: SHORTINT; buffer: SYSTEM.ADDRESS): SHORTINT;
PROCEDURE DspLodToBinary (filename: ARRAY OF CHAR; codeptr: SYSTEM.ADDRESS): LONGINT;
PROCEDURE DspDoBlock (data_in: SYSTEM.ADDRESS; size_in: LONGINT; data_out: SYSTEM.ADDRESS; size_out: LONGINT);
PROCEDURE DspBlkHandShake (data_in: SYSTEM.ADDRESS; size_in: LONGINT; data_out: SYSTEM.ADDRESS; size_out: LONGINT);
PROCEDURE DspBlkUnpacked (data_in: SYSTEM.ADDRESS; size_in: LONGINT; data_out: SYSTEM.ADDRESS; size_out: LONGINT);
PROCEDURE DspInStream (data_in: SYSTEM.ADDRESS; block_size, num_blocks: LONGINT; VAR blocks_done: LONGINT);
PROCEDURE DspOutStream (data_out: SYSTEM.ADDRESS; block_size, num_blocks: LONGINT; VAR blocks_done: LONGINT);
PROCEDURE DspIOStream (data_in, data_out: SYSTEM.ADDRESS; block_insize, block_outsize, num_blocks: LONGINT; VAR blocks_done: LONGINT);
PROCEDURE DspRemoveInterrupts (mask: SHORTINT);
PROCEDURE DspGetWordSize (): SHORTINT;
PROCEDURE DspLock (): SHORTINT;
PROCEDURE DspUnlock;
PROCEDURE DspAvailable (VAR xavailable, yavailable: LONGINT);
PROCEDURE DspReserve (xreserve, yreserve: LONGINT): SHORTINT;
PROCEDURE DspExecProg (codeptr: SYSTEM.ADDRESS; codesize: LONGINT; ability: SHORTINT);
PROCEDURE DspExecBoot (codeptr: SYSTEM.ADDRESS; codesize: LONGINT; ability: SHORTINT);
PROCEDURE DspTriggerHC (vector: SHORTINT);
PROCEDURE DspRequestUniqueAbility(): SHORTINT;
PROCEDURE DspGetProgAbility (): SHORTINT;
PROCEDURE DspFlushSubroutines;
PROCEDURE DspLoadSubroutine (codeptr: SYSTEM.ADDRESS; codesize: LONGINT; ability: SHORTINT): SHORTINT;
PROCEDURE DspInqSubrAbility (ability: SHORTINT): SHORTINT;
PROCEDURE DspRunSubroutine (handle: SHORTINT): SHORTINT;
PROCEDURE DspHf0 (flag: SHORTINT): SHORTINT;
PROCEDURE DspHf1 (flag: SHORTINT): SHORTINT;
PROCEDURE DspHf2 (): SHORTINT;
PROCEDURE DspHf3 (): SHORTINT;
PROCEDURE DspBlkWords (data_in: SYSTEM.ADDRESS; size_in: LONGINT; data_out: SYSTEM.ADDRESS; size_out: LONGINT);
PROCEDURE DspBlkBytes (data_in: SYSTEM.ADDRESS; size_in: LONGINT; data_out: SYSTEM.ADDRESS; size_out: LONGINT);
PROCEDURE DspHStat (): SYSTEM.BYTE;
PROCEDURE DspSetVectors (receiver, transmitter: SYSTEM.ADDRESS);

TYPE    DSPBLOCKPtr =   POINTER TO DSPBLOCK;
        DSPBLOCK =      RECORD
                         blocktype: SHORTINT;
                         blocksize: LONGINT;
                         blockaddr: SYSTEM.ADDRESS;
                        END;

PROCEDURE DspMultBlocks (numsend, numreceive: LONGINT; sendblocks, receiveblocks: DSPBLOCKPtr);
PROCEDURE Vsetmode (modecode: SHORTINT): SHORTINT;
PROCEDURE MonType (): SHORTINT;
PROCEDURE VgetSize (mode: SHORTINT): LONGINT;
PROCEDURE VsetSync (flag: SHORTINT);
PROCEDURE VsetRGB (index, count: SHORTINT; xrgbArray: ARRAY OF LONGINT);
PROCEDURE VgetRGB (index, count: SHORTINT; VAR xrgbArray: ARRAY OF LONGINT);
PROCEDURE VsetMask (ormask, andmask, overlay: SHORTINT);
PROCEDURE LockSnd (): LONGINT;
PROCEDURE UnlockSnd (): LONGINT;
PROCEDURE SoundCmd (mode, data: SHORTINT): LONGINT;
PROCEDURE SetBuffer (reg: SHORTINT; begaddr, endaddr: SYSTEM.ADDRESS): LONGINT;
PROCEDURE SetMode (mode: SHORTINT): LONGINT;
PROCEDURE SetTracks (playtracks, rectracks: SHORTINT): LONGINT;
PROCEDURE SetMontracks (montrack: SHORTINT): LONGINT;
PROCEDURE SetInterrupt (src_inter, cause: SHORTINT): LONGINT;
PROCEDURE BuffOper (mode: SHORTINT): LONGINT;
PROCEDURE DspTristate (dspxmit, dsprec: SHORTINT): LONGINT;
PROCEDURE GPIO (mode, data: SHORTINT): LONGINT;
PROCEDURE DevConnect (src, dst, srcclk, prescale, protocol: SHORTINT): LONGINT;
PROCEDURE SndStatus (res: SHORTINT): LONGINT;
PROCEDURE BuffPtr (bptr: SYSTEM.ADDRESS): LONGINT;

END M_XBIOS.

