(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_XBIOS;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM M_Types    IMPORT  Nihil, Null,
                        Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6, Bit7,
                        Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14, Bit15,
                        Bit16, Bit17, Bit18, Bit19, Bit20, Bit21, Bit22, Bit23,
                        Bit24, Bit25, Bit26, Bit27, Bit28, Bit29, Bit30, Bit31,
                        LONGBITSET;


FROM SYSTEM IMPORT ADDRESS, ADR, WORD, BYTE, LOC;

(*$?Compiler=Megamax:
  FROM SYSTEM IMPORT ASSEMBLER;
 *)
(*$?Compiler=Haenisch:
  FROM SYSTEM IMPORT CODE;
 *)

(* Wegen bergang auf lokale Variablen entfernt  SE 04.01.94
VAR by: BYTE;
    c: SHORTCARD;
    i: SHORTINT;
    l: SHORTINT;
    a, b, d: ADDRESS;
 *)

PROCEDURE Initmouse (type: SHORTINT; VAR param: ARRAY OF LOC; vec: PROC);
VAR a: ADDRESS;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*30 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00012H);
CODE(02F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00000H);
CODE(04E4EH);
CODE(04FEFH,0000CH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  18(A6), -(SP)
  MOVE.L  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #0, -(SP);
  TRAP    #14
  LEA     12(SP), SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  vec(A6), -(SP)
  MOVE.L  param(A6), -(SP)
  MOVE.W  type(A6), -(SP)
  MOVE.W  #0, -(SP);
  TRAP    #14
  LEA     12(SP), SP
 END;
  *)
END Initmouse;

PROCEDURE Physbase (): ADDRESS;
VAR a  : ADDRESS;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00002H);
CODE(04E4EH);
CODE(0548FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #2, -(SP);
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.L  D0, -4(a6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #2, -(SP);
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.L  D0, a(A6)
 END;
   *)
 RETURN a;
END Physbase;

PROCEDURE Logbase (): ADDRESS;
VAR a : ADDRESS;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00003H);
CODE(04E4EH);
CODE(0548FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #3, -(SP);
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #3, -(SP);
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.L  D0, a(A6)
 END;
   *)
 RETURN a;
END Logbase;

PROCEDURE Getrez (): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00004H);
CODE(04E4EH);
CODE(0548FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #4, -(SP);
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #4, -(SP);
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END Getrez;

PROCEDURE Setscreen (log, phys: ADDRESS; rez: SHORTINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*30 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,00005H);
CODE(04E4EH);
CODE(04FEFH,0000CH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  16(A6), -(SP)
  MOVE.L  12(A6), -(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #5, -(SP)
  TRAP    #14
  LEA     $C(SP), SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  rez(A6), -(SP)
  MOVE.L  phys(A6), -(SP)
  MOVE.L  log(A6), -(SP)
  MOVE.W  #5, -(SP)
  TRAP    #14
  LEA     $C(SP), SP
 END;
  *)
END Setscreen;

PROCEDURE Setpalette (VAR palette: ARRAY OF LOC);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00008H);
CODE(03F3CH,00006H);
CODE(04E4EH);
CODE(05C8FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #6, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  palette(A6), -(SP)
  MOVE.W  #6, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
 END;
  *)
END Setpalette;

PROCEDURE Setcolor (colNum, color: SHORTCARD): SHORTCARD;
VAR c: SHORTCARD;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00007H);
CODE(04E4EH);
CODE(05C8FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #7, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  color(A6), -(SP)
  MOVE.W  colNum(A6), -(SP)
  MOVE.W  #7, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, c(A6)
 END;
   *)
 RETURN c;
END Setcolor;

PROCEDURE Floprd (buf: ADDRESS; drv, sec, trck, side, count: SHORTINT): SHORTINT;
VAR i: SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*52 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00014H);
CODE(03F2EH,00012H);
CODE(03F2EH,00010H);
CODE(03F2EH,0000EH);
CODE(03F2EH,0000CH);
CODE(02F3CH,00000H,00000H);
CODE(02F2EH,00008H);
CODE(03F3CH,00008H);
CODE(04E4EH);
CODE(04FEFH,00014H);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  20(A6), -(SP)
  MOVE.W  18(A6), -(SP)
  MOVE.W  16(A6), -(SP)
  MOVE.W  14(A6), -(SP)
  MOVE.W  12(A6), -(SP)
  MOVE.L  #0, -(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #8, -(SP)
  TRAP    #14
  LEA     $14(SP), SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  count(A6), -(SP)
  MOVE.W  side(A6), -(SP)
  MOVE.W  trck(A6), -(SP)
  MOVE.W  sec(A6), -(SP)
  MOVE.W  drv(A6), -(SP)
  MOVE.L  #0, -(SP)
  MOVE.L  buf(A6), -(SP)
  MOVE.W  #8, -(SP)
  TRAP    #14
  LEA     $14(SP), SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END Floprd;

PROCEDURE Flopwr (buf: ADDRESS; drv, sec, trck, side, count: SHORTINT): SHORTINT;
VAR i: SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*52 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00014H);
CODE(03F2EH,00012H);
CODE(03F2EH,00010H);
CODE(03F2EH,0000EH);
CODE(03F2EH,0000CH);
CODE(02F3CH,00000H,00000H);
CODE(02F2EH,00008H);
CODE(03F3CH,00009H);
CODE(04E4EH);
CODE(04FEFH,00014H);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  20(A6), -(SP)
  MOVE.W  18(A6), -(SP)
  MOVE.W  16(A6), -(SP)
  MOVE.W  14(A6), -(SP)
  MOVE.W  12(A6), -(SP)
  MOVE.L  #0, -(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #9, -(SP)
  TRAP    #14
  LEA     $14(SP), SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  count(A6), -(SP)
  MOVE.W  side(A6), -(SP)
  MOVE.W  trck(A6), -(SP)
  MOVE.W  sec(A6), -(SP)
  MOVE.W  drv(A6), -(SP)
  MOVE.L  #0, -(SP)
  MOVE.L  buf(A6), -(SP)
  MOVE.W  #9, -(SP)
  TRAP    #14
  LEA     $14(SP), SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END Flopwr;

PROCEDURE Flopfmt (buf: ADDRESS; drv, spt, trck, side, il, virgin: SHORTINT): SHORTINT;
VAR i: SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*62 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00016H);
CODE(02F3CH,08765H,04321H);
CODE(03F2EH,00014H);
CODE(03F2EH,00012H);
CODE(03F2EH,00010H);
CODE(03F2EH,0000EH);
CODE(03F2EH,0000CH);
CODE(02F3CH,00000H,00000H);
CODE(02F2EH,00008H);
CODE(03F3CH,0000AH);
CODE(04E4EH);
CODE(04FEFH,0001AH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  22(A6), -(SP)
  MOVE.L  #$087654321, -(SP)
  MOVE.W  20(A6), -(SP)
  MOVE.W  18(A6), -(SP)
  MOVE.W  16(A6), -(SP)
  MOVE.W  14(A6), -(SP)
  MOVE.W  12(A6), -(SP)
  MOVE.L  #0, -(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #10, -(SP)
  TRAP    #14
  LEA     $1A(SP), SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  virgin(A6), -(SP)
  MOVE.L  #$087654321, -(SP)
  MOVE.W  il(A6), -(SP)
  MOVE.W  side(A6), -(SP)
  MOVE.W  trck(A6), -(SP)
  MOVE.W  spt(A6), -(SP)
  MOVE.W  drv(A6), -(SP)
  MOVE.L  #0, -(SP)
  MOVE.L  buf(A6), -(SP)
  MOVE.W  #10, -(SP)
  TRAP    #14
  LEA     $1A(SP), SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END Flopfmt;

PROCEDURE Midiws (VAR string: ARRAY OF LOC; len: SHORTCARD);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00008H);
CODE(03F2EH,00010H);
CODE(03F3CH,0000CH);
CODE(04E4EH);
CODE(0508FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  16(A6), -(SP)
  MOVE.W  #12, -(SP)
  TRAP    #14
  ADDQ.L  #8, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  string(A6), -(SP)
  MOVE.W  len(A6), -(SP)
  MOVE.W  #12, -(SP)
  TRAP    #14
  ADDQ.L  #8, SP
 END;
  *)
END Midiws;

PROCEDURE Mfpint (intNo: SHORTCARD; vector: PROC);
VAR x: ADDRESS;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,0000DH);
CODE(04E4EH);
CODE(0508FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #13, -(SP)
  TRAP    #14
  ADDQ.L  #8, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  vector(A6), -(SP)
  MOVE.W  intNo(A6), -(SP)
  MOVE.W  #13, -(SP)
  TRAP    #14
  ADDQ.L  #8, SP
 END;
  *)
END Mfpint;

PROCEDURE Iorec (dev: SHORTINT): ADDRESS;
VAR a: ADDRESS;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,0000EH);
CODE(04E4EH);
CODE(0588FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #14, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  dev(A6), -(SP)
  MOVE.W  #14, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.L  D0, a(A6)
 END;
   *)
 RETURN a;
END Iorec;

PROCEDURE Rsconf (speed: SHORTINT; flavor: BITSET;  u, r, t, s: SHORTINT): SHORTINT;
VAR i: SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*46 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00012H);
CODE(03F2EH,00010H);
CODE(03F2EH,0000EH);
CODE(03F2EH,0000CH);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,0000FH);
CODE(04E4EH);
CODE(04FEFH,0000EH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  18(A6), -(SP)
  MOVE.W  16(A6), -(SP)
  MOVE.W  14(A6), -(SP)
  MOVE.W  12(A6), -(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #15, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  s(A6), -(SP)
  MOVE.W  t(A6), -(SP)
  MOVE.W  r(A6), -(SP)
  MOVE.W  u(A6), -(SP)
  MOVE.W  flavor(A6), -(SP)
  MOVE.W  speed(A6), -(SP)
  MOVE.W  #15, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END Rsconf;

PROCEDURE Keytbl (VAR unshift, shift, capslock: ADDRESS): ADDRESS;
VAR a, b, d : ADDRESS;
BEGIN
 a:= unshift;
 b:= shift;
 d:= capslock;
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0FFFCH);
CODE(02F2EH,0FFF8H);
CODE(02F2EH,0FFF4H);
CODE(03F3CH,00010H);
CODE(04E4EH);
CODE(04FEFH,0000EH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  -4(A6), -(SP)
  MOVE.L  -8(A6), -(SP)
  MOVE.L  -12(A6), -(SP)
  MOVE.W  #16, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  a(A6), -(SP)
  MOVE.L  b(A6), -(SP)
  MOVE.L  d(A6), -(SP)
  MOVE.W  #16, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVE.L  D0, a(A6)
 END;
   *)
 RETURN a;
END Keytbl;

PROCEDURE Random(): LONGCARD;
VAR l: LONGCARD;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00011H);
CODE(04E4EH);
CODE(0548FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #17, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #17, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.L  D0, l(A6)
 END;
   *)
 RETURN l;
END Random;

PROCEDURE Protobt (buf: ADDRESS; num: LONGINT; typ, exec: SHORTINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00012H);
CODE(03F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,00012H);
CODE(04E4EH);
CODE(04FEFH,0000EH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  18(A6), -(SP)
  MOVE.W  16(A6), -(SP)
  MOVE.L  12(A6), -(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #18, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  exec(A6), -(SP)
  MOVE.W  typ(A6), -(SP)
  MOVE.L  num(A6), -(SP)
  MOVE.L  buf(A6), -(SP)
  MOVE.W  #18, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
 END;
  *)
END Protobt;

PROCEDURE Flopver (buf: ADDRESS; drv, sec, trck, side, count: SHORTINT): SHORTINT;
VAR i: SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*52 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00014H);
CODE(03F2EH,00012H);
CODE(03F2EH,00010H);
CODE(03F2EH,0000EH);
CODE(03F2EH,0000CH);
CODE(02F3CH,00000H,00000H);
CODE(02F2EH,00008H);
CODE(03F3CH,00013H);
CODE(04E4EH);
CODE(04FEFH,0000EH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  20(A6), -(SP)
  MOVE.W  18(A6), -(SP)
  MOVE.W  16(A6), -(SP)
  MOVE.W  14(A6), -(SP)
  MOVE.W  12(A6), -(SP)
  MOVE.L  #0, -(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #19, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  count(A6), -(SP)
  MOVE.W  side(A6), -(SP)
  MOVE.W  trck(A6), -(SP)
  MOVE.W  sec(A6), -(SP)
  MOVE.W  drv(A6), -(SP)
  MOVE.L  #0, -(SP)
  MOVE.L  buf(A6), -(SP)
  MOVE.W  #19, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END Flopver;

PROCEDURE Scrdmp;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*16 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00014H);
CODE(04E4EH);
CODE(0548FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #20, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #20, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
 END;
  *)
END Scrdmp;

PROCEDURE Cursconf (function, operand: SHORTINT): SHORTINT;
VAR i: SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00015H);
CODE(04E4EH);
CODE(05C8FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #21, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  operand(A6), -(SP)
  MOVE.W  function(A6), -(SP)
  MOVE.W  #21, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END Cursconf;

PROCEDURE Settime (datetime: LONGCARD);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00016H);
CODE(04E4EH);
CODE(05C8FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #22, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  datetime(A6), -(SP)
  MOVE.W  #22, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
 END;
  *)
END Settime;

PROCEDURE Gettime (): LONGCARD;
VAR l: LONGCARD;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00017H);
CODE(04E4EH);
CODE(0548FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W    #23, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W    #23, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.L  D0, l(A6)
 END; 
   *)
 RETURN l;
END Gettime;

PROCEDURE Bioskeys;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*16 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00018H);
CODE(04E4EH);
CODE(0548FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #24, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #24, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
 END;
  *)
END Bioskeys;

PROCEDURE Ikbdws (str: ARRAY OF LOC; len: SHORTCARD);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00019H);
CODE(04E4EH);
CODE(0508FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #25, -(SP)
  TRAP    #14
  ADDQ.L  #8, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  str(A6), -(SP)
  MOVE.W  len(A6), -(SP)
  MOVE.W  #25, -(SP)
  TRAP    #14
  ADDQ.L  #8, SP
 END; 
  *)
END Ikbdws;

PROCEDURE Jdisint (intNo: SHORTCARD);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,0001AH);
CODE(04E4EH);
CODE(0588FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #26, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  intNo(A6), -(SP)
  MOVE.W  #26, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
 END;
  *)
END Jdisint;

PROCEDURE Jenabint (intNo: SHORTCARD);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,0001BH);
CODE(04E4EH);
CODE(0588FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #27, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  intNo(A6), -(SP)
  MOVE.W  #27, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
 END;
  *)
END Jenabint;

PROCEDURE Giaccess (regno: SHORTCARD; data: BYTE): SHORTCARD;
VAR c: SHORTCARD;
BEGIN
(*$?Compiler=Haenisch:
 c:= ORD (CHAR(data));
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F2EH,0FFFEH);
CODE(03F3CH,0001CH);
CODE(04E4EH);
CODE(05C8FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  -2(A6), -(SP)
  MOVE.W  #28, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 c:= ORD (data);
 ASSEMBLER
  MOVE.W  regno(A6), -(SP)
  MOVE.W  c(A6), -(SP)
  MOVE.W  #28, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, c(A6)
 END;
   *)
 RETURN c;
END Giaccess;

PROCEDURE Offgibit (bitno: SHORTCARD);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,0001DH);
CODE(04E4EH);
CODE(0588FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #29, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  bitno(A6), -(SP)
  MOVE.W  #29, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
 END;
  *)
END Offgibit;

PROCEDURE Ongibit (bitno: SHORTCARD);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,0001EH);
CODE(04E4EH);
CODE(0588FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #30, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  bitno(A6), -(SP)
  MOVE.W  #30, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
 END;
  *)
END Ongibit;

PROCEDURE Xbtimer (timer, control, data: SHORTCARD; vec: PROC);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000EH);
CODE(03F2EH,0000CH);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,0001FH);
CODE(04E4EH);
CODE(04FEFH,0000CH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  14(A6), -(SP)
  MOVE.W  12(A6), -(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #31, -(SP)
  TRAP    #14
  LEA     $C(SP), SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  vec(A6), -(SP)
  MOVE.W  data(A6), -(SP)
  MOVE.W  control(A6), -(SP)
  MOVE.W  timer(A6), -(SP)
  MOVE.W  #31, -(SP)
  TRAP    #14
  LEA     $C(SP), SP
 END;
  *)
END Xbtimer;

PROCEDURE Dosound ((* REF *)  data: ARRAY OF LOC);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00008H);
CODE(03F3CH,00020H);
CODE(04E4EH);
CODE(05C8FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #32, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  data(A6), -(SP)
  MOVE.W  #32, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
 END;
  *)
END Dosound;

PROCEDURE Setprt (config: BITSET): BITSET;
VAR b: BITSET;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00021H);
CODE(04E4EH);
CODE(05C8FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #33, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  config(A6), -(SP)
  MOVE.W  #33, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, b(A6)
 END;
   *)
 RETURN b;
END Setprt;

PROCEDURE Kbdvbase(): ADDRESS;
VAR a: ADDRESS;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00022H);
CODE(04E4EH);
CODE(0548FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #34, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #34, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.L  D0, a(A6)
 END;
   *)
 RETURN a;
END Kbdvbase;

PROCEDURE Kbrate (initial, repeat: SHORTINT): SHORTCARD;
VAR c: SHORTCARD;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00023H);
CODE(04E4EH);
CODE(05C8FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #35, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  repeat(A6), -(SP)
  MOVE.W  initial(A6), -(SP)
  MOVE.W  #35, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, c(A6)
 END;
   *)
 RETURN c;
END Kbrate;

PROCEDURE Prtblk (block: ARRAY OF LOC);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00008H);
CODE(03F3CH,00024H);
CODE(04E4EH);
CODE(05C8FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #36, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  block(A6), -(SP)
  MOVE.W  #36, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
 END;
  *)
END Prtblk;

PROCEDURE Vsync;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*16 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00025H);
CODE(04E4EH);
CODE(0548FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #37, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #37, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
 END;
  *)
END Vsync;

PROCEDURE Supexec (code: PROC);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00008H);
CODE(03F3CH,00026H);
CODE(04E4EH);
CODE(05C8FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #38, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  code(A6), -(SP)
  MOVE.W  #38, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
 END;
  *)
END Supexec;

PROCEDURE Puntaes;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*16 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00027H);
CODE(04E4EH);
CODE(0548FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #39, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #39, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
 END;
  *)
END Puntaes;

PROCEDURE Blitmode (flag: SHORTINT): BITSET;
VAR b: BITSET;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00040H);
CODE(04E4EH);
CODE(0588FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #64, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  flag(A6), -(SP)
  MOVE.W  #64, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.W  D0, b(A6)
 END;
   *)
 RETURN b;
END Blitmode;

PROCEDURE Floprate (devno: SHORTCARD; newrate: SHORTINT): SHORTINT;
VAR i: SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00041H);
CODE(04E4EH);
CODE(05C8FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #65, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  newrate(A6), -(SP)
  MOVE.W  devno(A6), -(SP)
  MOVE.W  #65, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END Floprate;

PROCEDURE DMAread (sec: LONGINT; cnt: SHORTINT; buf: ADDRESS; 
                   dev: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*38 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00012H);
CODE(02F2EH,0000EH);
CODE(03F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,0002AH);
CODE(04E4EH);
CODE(04FEFH,0000EH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  18(A6), -(SP)
  MOVE.L  14(A6), -(SP)
  MOVE.W  12(A6), -(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #42, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  dev(A6), -(SP)
  MOVE.L  buf(A6), -(SP)
  MOVE.W  cnt(A6), -(SP)
  MOVE.L  sec(A6), -(SP)
  MOVE.W  #42, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVE.L  D0, l(A6)
 END;
   *)
 RETURN l;
END DMAread;

PROCEDURE DMAwrite (sec: LONGINT; cnt: SHORTINT; buf: ADDRESS;
                    dev: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*38 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00012H);
CODE(02F2EH,0000EH);
CODE(03F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,0002BH);
CODE(04E4EH);
CODE(04FEFH,0000EH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  18(A6), -(SP)
  MOVE.L  14(A6), -(SP)
  MOVE.W  12(A6), -(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #43, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVE.L  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  dev(A6), -(SP)
  MOVE.L  buf(A6), -(SP)
  MOVE.W  cnt(A6), -(SP)
  MOVE.L  sec(A6), -(SP)
  MOVE.W  #43, -(SP)
  TRAP    #14
  LEA     $E(SP), SP
  MOVE.L  D0, l(A6)
 END;
   *)
 RETURN l;
END DMAwrite;

PROCEDURE Bconmap (dev: SHORTINT): ADDRESS;
VAR a : ADDRESS;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,0002CH);
CODE(04E4EH);
CODE(0588FH);
CODE(03D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #44, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.W  D0, -4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W dev(A6), -(SP)
  MOVE.W  #44, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.W  D0, a(A6)
 END;
   *)
 RETURN a;
END Bconmap;

PROCEDURE NVMaccess (mode, start, cnt: SHORTINT; buf: ADDRESS): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*38 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000EH);
CODE(03F2EH,0000CH);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,0002EH);
CODE(04E4EH);
CODE(04FEFH,0000CH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  14(A6), -(SP)
  MOVE.W  12(A6), -(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #46, -(SP)
  TRAP    #14
  LEA     $C(SP), SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  buf(A6), -(SP)
  MOVE.W  cnt(A6), -(SP)
  MOVE.W  start(A6), -(SP)
  MOVE.W  mode(A6), -(SP)
  MOVE.W  #46, -(SP)
  TRAP    #14
  LEA     $C(SP), SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END NVMaccess;

PROCEDURE EsetShift (mode: SHORTINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00050H);
CODE(04E4EH);
CODE(0588FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #80, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  mode(A6), -(SP)
  MOVE.W  #80, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
 END;
  *)
END EsetShift;

PROCEDURE EgetShift (): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00051H);
CODE(04E4EH);
CODE(0548FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #81, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #81, -(SP)
  TRAP    #14
  ADDQ.L  #2, SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END EgetShift;

PROCEDURE EsetBank (bank: SHORTINT): SHORTINT;
VAR i : SHORTINT; 
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00052H);
CODE(04E4EH);
CODE(0588FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #82, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  bank(A6), -(SP)
  MOVE.W  #82, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END EsetBank;

PROCEDURE EsetColor (num, col: SHORTINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00053H);
CODE(04E4EH);
CODE(05C8FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #83, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  col(A6), -(SP)
  MOVE.W  num(A6), -(SP)
  MOVE.W  #83, -(SP)
  TRAP    #14
  ADDQ.L  #6, SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END EsetColor;

PROCEDURE EsetPalette (start, cnt: SHORTINT; pal: ARRAY OF LOC): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000CH);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00054H);
CODE(04E4EH);
CODE(04FEFH,0000AH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  12(A6), -(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #84, -(SP)
  TRAP    #14
  LEA     $A(SP), SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  pal(A6), -(SP)
  MOVE.W  cnt(A6), -(SP)
  MOVE.W  start(A6), -(SP)
  MOVE.W  #84, -(SP)
  TRAP    #14
  LEA     $A(SP), SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i
END EsetPalette;

PROCEDURE EgetPalette (start, cnt: SHORTINT; VAR pal: ARRAY OF LOC): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000CH);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00055H);
CODE(04E4EH);
CODE(04FEFH,0000AH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  12(A6), -(SP)
  MOVE.W  10(A6), -(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #85, -(SP)
  TRAP    #14
  LEA     $A(SP), SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  pal(A6), -(SP)
  MOVE.W  cnt(A6), -(SP)
  MOVE.W  start(A6), -(SP)
  MOVE.W  #85, -(SP)
  TRAP    #14
  LEA     $A(SP), SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END EgetPalette;

PROCEDURE EsetGray (mode: SHORTINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00056H);
CODE(04E4EH);
CODE(0588FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #86, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  mode(A6), -(SP)
  MOVE.W  #86, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END EsetGray;

PROCEDURE EsetSmear(mode: SHORTINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00057H);
CODE(04E4EH);
CODE(0588FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6), -(SP)
  MOVE.W  #87, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  mode(A6), -(SP)
  MOVE.W  #87, -(SP)
  TRAP    #14
  ADDQ.L  #4, SP
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END EsetSmear;

PROCEDURE Metainit (VAR buffer: METAINFO);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00008H);
CODE(03F3CH,00030H);
CODE(04E4EH);
CODE(05C4FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #$0030,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  buffer(A6), -(SP)
  MOVE.W  #$0030,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
 END;
  *)
END Metainit;

PROCEDURE DspLoadProg (filename: ARRAY OF CHAR; ability: SHORTINT;
                       buffer: ADDRESS): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00012H);
CODE(03F2EH,00010H);
CODE(02F2EH,00008H);
CODE(03F3CH,0006CH);
CODE(04E4EH);
CODE(04FEFH,0000CH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  18(A6), -(SP)
  MOVE.W  16(A6), -(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #$006C,-(A7)
  TRAP    #14
  LEA     $000C(A7),A7
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  buffer(A6), -(SP)
  MOVE.L  ability(A6), -(SP)
  MOVE.L  filename(A6), -(SP)
  MOVE.W  #$006C,-(A7)
  TRAP    #14
  LEA     $000C(A7),A7
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END DspLoadProg;

PROCEDURE DspLodToBinary (filename: ARRAY OF CHAR; codeptr: ADDRESS): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*30 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00010H);
CODE(02F2EH,00008H);
CODE(03F3CH,0006FH);
CODE(04E4EH);
CODE(04FEFH,0000AH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  16(A6), -(SP)
  MOVE.L  8(A6), -(SP)
  MOVE.W  #$006F,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  codeptr(A6), -(SP)
  MOVE.L  filename(A6), -(SP)
  MOVE.W  #$006F,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END DspLodToBinary;

PROCEDURE DspDoBlock (datain: ADDRESS; sizein: LONGINT;
                      dataout: ADDRESS; sizeout: LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00014H);
CODE(02F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,00060H);
CODE(04E4EH);
CODE(04FEFH,00012H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  20(A6),-(A7)
  MOVE.L  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$0060,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  sizeout(A6),-(A7)
  MOVE.L  dataout(A6),-(A7)
  MOVE.L  sizein(A6),-(A7)
  MOVE.L  datain(A6),-(A7)
  MOVE.W  #$0060,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
 END;
  *)
END DspDoBlock;

PROCEDURE DspBlkHandShake (datain: ADDRESS; sizein: LONGINT;
                           dataout: ADDRESS; sizeout: LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00014H);
CODE(02F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,00061H);
CODE(04E4EH);
CODE(04FEFH,00012H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  20(A6),-(A7)
  MOVE.L  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$0061,-(A7)
  TRAP    #14
  LEA    $0012(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  sizeout(A6),-(A7)
  MOVE.L  dataout(A6),-(A7)
  MOVE.L  sizein(A6),-(A7)
  MOVE.L  datain(A6),-(A7)
  MOVE.W  #$0061,-(A7)
  TRAP    #14
  LEA    $0012(A7),A7
 END;
  *)
END DspBlkHandShake;

PROCEDURE DspBlkUnpacked (datain: ADDRESS; sizein: LONGINT; 
                          dataout: ADDRESS; sizeout: LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00014H);
CODE(02F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,00062H);
CODE(04E4EH);
CODE(04FEFH,00012H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  20(A6),-(A7)
  MOVE.L  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$0062,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  sizeout(A6),-(A7)
  MOVE.L  dataout(A6),-(A7)
  MOVE.L  sizein(A6),-(A7)
  MOVE.L  datain(A6),-(A7)
  MOVE.W  #$0062,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
 END;
  *)
END DspBlkUnpacked;

PROCEDURE DspInStream (datain: ADDRESS; blocksize, numblocks: LONGINT;
                       VAR blocksdone: LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00014H);
CODE(02F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,00063H);
CODE(04E4EH);
CODE(04FEFH,00012H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  20(A6),-(A7)
  MOVE.L  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$0063,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  blocksdone(A6),-(A7)
  MOVE.L  numblocks(A6),-(A7)
  MOVE.L  blocksize(A6),-(A7)
  MOVE.L  datain(A6),-(A7)
  MOVE.W  #$0063,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
 END;
  *)
END DspInStream;

PROCEDURE DspOutStream (dataout: ADDRESS; blocksize, numblocks: LONGINT;
                        VAR blocksdone: LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00014H);
CODE(02F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,00064H);
CODE(04E4EH);
CODE(04FEFH,00012H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  20(A6),-(A7)
  MOVE.L  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$0064,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  blocksdone(A6),-(A7)
  MOVE.L  numblocks(A6),-(A7)
  MOVE.L  blocksize(A6),-(A7)
  MOVE.L  dataout(A6),-(A7)
  MOVE.W  #$0064,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
 END;
  *)
END DspOutStream;

PROCEDURE DspIOStream (datain, dataout: ADDRESS;
                       blockinsize, blockoutsize, numblocks: LONGINT;
                       VAR blocksdone: LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*42 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0001CH);
CODE(02F2EH,00018H);
CODE(02F2EH,00014H);
CODE(02F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,00065H);
CODE(04E4EH);
CODE(04FEFH,00016H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  28(A6),-(A7)
  MOVE.L  24(A6),-(A7)
  MOVE.L  20(A6),-(A7)
  MOVE.L  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$0065,-(A7)
  TRAP    #14
  LEA     $0016(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  blocksdone(A6),-(A7)
  MOVE.L  numblocks(A6),-(A7)
  MOVE.L  blockoutsize(A6),-(A7)
  MOVE.L  blockinsize(A6),-(A7)
  MOVE.L  dataout(A6),-(A7)
  MOVE.L  datain(A6),-(A7)
  MOVE.W  #$0065,-(A7)
  TRAP    #14
  LEA     $0016(A7),A7
 END;
  *)
END DspIOStream;

PROCEDURE DspRemoveInterrupts (mask: SHORTINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00066H);
CODE(04E4EH);
CODE(0584FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0066,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  mask(A6),-(A7)
  MOVE.W  #$0066,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
 END;
  *)
END DspRemoveInterrupts;

PROCEDURE DspGetWordSize (): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00067H);
CODE(04E4EH);
CODE(0544FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$0067,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$0067,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END DspGetWordSize;

PROCEDURE DspLock (): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00068H);
CODE(04E4EH);
CODE(0544FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$0068,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0, -2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$0068,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0, i(A6)
 END;
   *)
 RETURN i;
END DspLock;

PROCEDURE DspUnlock;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*16 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00069H);
CODE(04E4EH);
CODE(0544FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$0069,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$0069,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
 END;
  *)
END DspUnlock;

PROCEDURE DspAvailable (VAR xavailable, yavailable: LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*26 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,0006AH);
CODE(04E4EH);
CODE(04FEFH,0000AH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$006A,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  yavailable(A6),-(A7)
  MOVE.L  xavailable(A6),-(A7)
  MOVE.W  #$006A,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
 END;
  *)
END DspAvailable;

PROCEDURE DspReserve (xreserve, yreserve: LONGINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*30 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,0006BH);
CODE(04E4EH);
CODE(04FEFH,0000AH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$006B,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  yreserve(A6),-(A7)
  MOVE.L  xreserve(A6),-(A7)
  MOVE.W  #$006B,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END DspReserve;

PROCEDURE DspExecProg (codeptr: ADDRESS; codesize: LONGINT; ability: SHORTINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*30 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,0006DH);
CODE(04E4EH);
CODE(04FEFH,0000CH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$006D,-(A7)
  TRAP    #14
  LEA     $000C(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  ability(A6),-(A7)
  MOVE.L  codesize(A6),-(A7)
  MOVE.L  codeptr(A6),-(A7)
  MOVE.W  #$006D,-(A7)
  TRAP    #14
  LEA     $000C(A7),A7
 END;
  *)
END DspExecProg;

PROCEDURE DspExecBoot (codeptr: ADDRESS; codesize: LONGINT; ability: SHORTINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*30 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,0006EH);
CODE(04E4EH);
CODE(04FEFH,0000CH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$006E,-(A7)
  TRAP    #14
  LEA     $000C(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  ability(A6),-(A7)
  MOVE.L  codesize(A6),-(A7)
  MOVE.L  codeptr(A6),-(A7)
  MOVE.W  #$006E,-(A7)
  TRAP    #14
  LEA     $000C(A7),A7
 END;
  *)
END DspExecBoot;

PROCEDURE DspTriggerHC (vector: SHORTINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00070H);
CODE(04E4EH);
CODE(0584FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0070,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  vector(A6),-(A7)
  MOVE.W  #$0070,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
 END;
  *)
END DspTriggerHC;

PROCEDURE DspRequestUniqueAbility (): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00071H);
CODE(04E4EH);
CODE(0544FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$0071,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$0071,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END DspRequestUniqueAbility;

PROCEDURE DspGetProgAbility (): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00072H);
CODE(04E4EH);
CODE(0544FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$0072,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$0072,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END DspGetProgAbility;

PROCEDURE DspFlushSubroutines;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*16 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00073H);
CODE(04E4EH);
CODE(0544FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$0073,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$0073,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
 END;
  *)
END DspFlushSubroutines;

PROCEDURE DspLoadSubroutine (codeptr: ADDRESS; codesize: LONGINT;
                             ability: SHORTINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,00074H);
CODE(04E4EH);
CODE(04FEFH,0000CH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$0074,-(A7)
  TRAP    #14
  LEA     $000C(A7),A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  ability(A6),-(A7)
  MOVE.L  codesize(A6),-(A7)
  MOVE.L  codeptr(A6),-(A7)
  MOVE.W  #$0074,-(A7)
  TRAP    #14
  LEA     $000C(A7),A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END DspLoadSubroutine;

PROCEDURE DspInqSubrAbility (ability: SHORTINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00075H);
CODE(04E4EH);
CODE(0584FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0075,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  ability(A6),-(A7)
  MOVE.W  #$0075,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END DspInqSubrAbility;

PROCEDURE DspRunSubroutine (handle: SHORTINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00076H);
CODE(04E4EH);
CODE(0584FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0076,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  handle(A6),-(A7)
  MOVE.W  #$0076,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END DspRunSubroutine;

PROCEDURE DspHf0 (flag: SHORTINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00077H);
CODE(04E4EH);
CODE(0584FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0077,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  flag(A6),-(A7)
  MOVE.W  #$0077,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END DspHf0;

PROCEDURE DspHf1 (flag: SHORTINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00078H);
CODE(04E4EH);
CODE(0584FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0078,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  flag(A6),-(A7)
  MOVE.W  #$0078,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END DspHf1;

PROCEDURE DspHf2 (): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00079H);
CODE(04E4EH);
CODE(0544FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$0079,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$0079,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END DspHf2;

PROCEDURE DspHf3 (): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,0007AH);
CODE(04E4EH);
CODE(0544FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$007A,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$007A,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END DspHf3;

PROCEDURE DspBlkWords (datain: ADDRESS; sizein: LONGINT; 
                       dataout: ADDRESS; sizeout: LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00014H);
CODE(02F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,0007BH);
CODE(04E4EH);
CODE(04FEFH,00012H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  20(A6),-(A7)
  MOVE.L  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$007B,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  sizeout(A6),-(A7)
  MOVE.L  dataout(A6),-(A7)
  MOVE.L  sizein(A6),-(A7)
  MOVE.L  datain(A6),-(A7)
  MOVE.W  #$007B,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
 END;
  *)
END DspBlkWords;

PROCEDURE DspBlkBytes (datain: ADDRESS; sizein: LONGINT;
                       dataout: ADDRESS; sizeout: LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00014H);
CODE(02F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,0007CH);
CODE(04E4EH);
CODE(04FEFH,00012H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  20(A6),-(A7)
  MOVE.L  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$007C,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  sizeout(A6),-(A7)
  MOVE.L  dataout(A6),-(A7)
  MOVE.L  sizein(A6),-(A7)
  MOVE.L  datain(A6),-(A7)
  MOVE.W  #$007C,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
 END;
  *)
END DspBlkBytes;

PROCEDURE DspHStat (): BYTE;
VAR by : BYTE;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,0007DH);
CODE(04E4EH);
CODE(0544FH);
CODE(01D40H,0FFFFH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$007D,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.B  D0,-1(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$007D,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.B  D0,by(A6)
 END;
   *)
 RETURN by;
END DspHStat;

PROCEDURE DspSetVectors (receiver, transmitter: ADDRESS);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*26 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,0007EH);
CODE(04E4EH);
CODE(04FEFH,0000AH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$007E,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  transmitter(A6),-(A7)
  MOVE.L  receiver(A6),-(A7)
  MOVE.W  #$007E,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
 END;
  *)
END DspSetVectors;

PROCEDURE DspMultBlocks (numsend, numreceive: LONGINT; 
                         sendblocks, receiveblocks: DSPBLOCKPtr);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00014H);
CODE(02F2EH,00010H);
CODE(02F2EH,0000CH);
CODE(02F2EH,00008H);
CODE(03F3CH,0007FH);
CODE(04E4EH);
CODE(04FEFH,00012H);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  20(A6),-(A7)
  MOVE.L  16(A6),-(A7)
  MOVE.L  12(A6),-(A7)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$007F,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  receiveblocks(A6),-(A7)
  MOVE.L  sendblocks(A6),-(A7)
  MOVE.L  numreceive(A6),-(A7)
  MOVE.L  numsend(A6),-(A7)
  MOVE.W  #$007F,-(A7)
  TRAP    #14
  LEA     $0012(A7),A7
 END;
  *)
END DspMultBlocks;

PROCEDURE Vsetmode (modecode: SHORTINT): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00058H);
CODE(04E4EH);
CODE(0584FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0058,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  modecode(A6),-(A7)
  MOVE.W  #$0058,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END Vsetmode;

PROCEDURE MonType (): SHORTINT;
VAR i : SHORTINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00059H);
CODE(04E4EH);
CODE(0544FH);
CODE(03D40H,0FFFEH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$0059,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0,-2(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$0059,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.W  D0,i(A6)
 END;
   *)
 RETURN i;
END MonType;

PROCEDURE VgetSize (mode: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,0005BH);
CODE(04E4EH);
CODE(0584FH);
CODE(03D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$005B,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  mode(A6),-(A7)
  MOVE.W  #$005B,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.W  D0,l(A6)
 END;
   *)
 RETURN l;
END VgetSize;

PROCEDURE VsetSync (flag: SHORTINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,0005AH);
CODE(04E4EH);
CODE(0584FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$005A,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  flag(A6),-(A7)
  MOVE.W  #$005A,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
 END;
  *)
END VsetSync;

PROCEDURE VsetRGB (index, count: SHORTINT; xrgbArray: ARRAY OF LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*30 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000CH);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,0005DH);
CODE(04E4EH);
CODE(04FEFH,0000AH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  12(A6),-(A7)
  MOVE.W  10(A6),-(A7)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$005D,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  xrgbArray(A6),-(A7)
  MOVE.W  count(A6),-(A7)
  MOVE.W  index(A6),-(A7)
  MOVE.W  #$005D,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
 END;
  *)
END VsetRGB;

PROCEDURE VgetRGB (index, count: SHORTINT; VAR xrgbArray: ARRAY OF LONGINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*30 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,0000CH);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,0005EH);
CODE(04E4EH);
CODE(04FEFH,0000AH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  12(A6),-(A7)
  MOVE.W  10(A6),-(A7)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$005E,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  xrgbArray(A6),-(A7)
  MOVE.W  count(A6),-(A7)
  MOVE.W  index(A6),-(A7)
  MOVE.W  #$005E,-(A7)
  TRAP    #14
  LEA     $000A(A7),A7
 END;
  *)
END VgetRGB;

PROCEDURE VsetMask (ormask, andmask, overlay: SHORTINT);
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000CH);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00096H);
CODE(04E4EH);
CODE(0504FH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  12(A6),-(A7)
  MOVE.W  10(A6),-(A7)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0096,-(A7)
  TRAP    #14
  ADDQ.W  #8,A7
  MOVEM.L (SP)+,D2/A2
 \*)
  *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  overlay(A6),-(A7)
  MOVE.W  andmask(A6),-(A7)
  MOVE.W  ormask(A6),-(A7)
  MOVE.W  #$0096,-(A7)
  TRAP    #14
  ADDQ.W  #8,A7
 END;
  *)
END VsetMask;

PROCEDURE LockSnd (): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00080H);
CODE(04E4EH);
CODE(0544FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$0080,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$0080,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END LockSnd;

PROCEDURE UnlockSnd (): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*20 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F3CH,00081H);
CODE(04E4EH);
CODE(0544FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  #$0081,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  #$0081,-(A7)
  TRAP    #14
  ADDQ.W  #2,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END UnlockSnd;

PROCEDURE SoundCmd (mode, data: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00082H);
CODE(04E4EH);
CODE(05C4FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6),-(A7)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0082,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  data(A6),-(A7)
  MOVE.W  mode(A6),-(A7)
  MOVE.W  #$0082,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END SoundCmd;

PROCEDURE SetBuffer (reg: SHORTINT; begaddr, endaddr: ADDRESS): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*34 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02EAEH,0000EH);
CODE(02EAEH,0000AH);
CODE(03EAEH,00008H);
CODE(03EBCH,00083H);
CODE(04E4EH);
CODE(04FEFH,0000CH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  14(A6),(A7)
  MOVE.L  10(A6),(A7)
  MOVE.W  8(A6),(A7)
  MOVE.W  #$0083,(A7)
  TRAP    #14
  LEA     $000C(A7),A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  endaddr(A6),(A7)
  MOVE.L  begaddr(A6),(A7)
  MOVE.W  reg(A6),(A7)
  MOVE.W  #$0083,(A7)
  TRAP    #14
  LEA     $000C(A7),A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END SetBuffer;

PROCEDURE SetMode (mode: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00084H);
CODE(04E4EH);
CODE(0584FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0084,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  mode(A6),-(A7)
  MOVE.W  #$0084,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END SetMode;

PROCEDURE SetTracks (playtracks, rectracks: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00085H);
CODE(04E4EH);
CODE(05C4FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6),-(A7)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0085,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  rectracks(A6),-(A7)
  MOVE.W  playtracks(A6),-(A7)
  MOVE.W  #$0085,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END SetTracks;

PROCEDURE SetMontracks (montrack: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00086H);
CODE(04E4EH);
CODE(0584FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0086,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  montrack(A6),-(A7)
  MOVE.W  #$0086,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END SetMontracks;

PROCEDURE SetInterrupt (srcinter, cause: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00087H);
CODE(04E4EH);
CODE(05C4FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6),-(A7)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0087,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  cause(A6),-(A7)
  MOVE.W  srcinter(A6),-(A7)
  MOVE.W  #$0087,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END SetInterrupt;

PROCEDURE BuffOper (mode: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,00088H);
CODE(04E4EH);
CODE(0584FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0088,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  mode(A6),-(A7)
  MOVE.W  #$0088,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END BuffOper;

PROCEDURE DspTristate (dspxmit, dsprec: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,00089H);
CODE(04E4EH);
CODE(05C4FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6),-(A7)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$0089,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  dsprec(A6),-(A7)
  MOVE.W  dspxmit(A6),-(A7)
  MOVE.W  #$0089,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END DspTristate;

PROCEDURE GPIO (mode, data: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*28 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,0008AH);
CODE(04E4EH);
CODE(05C4FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  10(A6),-(A7)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$008A,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  data(A6),-(A7)
  MOVE.W  mode(A6),-(A7)
  MOVE.W  #$008A,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END GPIO;

PROCEDURE DevConnect (src, dst, srcclk, prescale, protocol: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*42 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00010H);
CODE(03F2EH,0000EH);
CODE(03F2EH,0000CH);
CODE(03F2EH,0000AH);
CODE(03F2EH,00008H);
CODE(03F3CH,0008BH);
CODE(04E4EH);
CODE(04FEFH,0000CH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  16(A6),-(A7)
  MOVE.W  14(A6),-(A7)
  MOVE.W  12(A6),-(A7)
  MOVE.W  10(A6),-(A7)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$008B,-(A7)
  TRAP    #14
  LEA     $000C(A7),A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER 
  MOVE.W  protocol(A6),-(A7)
  MOVE.W  prescale(A6),-(A7)
  MOVE.W  srcclk(A6),-(A7)
  MOVE.W  dst(A6),-(A7)
  MOVE.W  src(A6),-(A7)
  MOVE.W  #$008B,-(A7)
  TRAP    #14
  LEA     $000C(A7),A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END DevConnect;

PROCEDURE SndStatus (res: SHORTINT): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(03F2EH,00008H);
CODE(03F3CH,0008CH);
CODE(04E4EH);
CODE(0584FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.W  8(A6),-(A7)
  MOVE.W  #$008C,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.W  res(A6),-(A7)
  MOVE.W  #$008C,-(A7)
  TRAP    #14
  ADDQ.W  #4,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END SndStatus;

PROCEDURE BuffPtr (bptr: ADDRESS): LONGINT;
VAR l : LONGINT;
BEGIN
(*$?Compiler=Haenisch:
(*\ONYX v2.01  06.01.94 00:32*)(*$D-*)
(*24 bytes of MC68000 code*)
CODE(048E7H,02020H);
CODE(02F2EH,00008H);
CODE(03F3CH,0008DH);
CODE(04E4EH);
CODE(05C4FH);
CODE(02D40H,0FFFCH);
CODE(04CDFH,00404H);
(*$D=*)
(*\=
  MOVEM.L D2/A2,-(SP)
  MOVE.L  8(A6),-(A7)
  MOVE.W  #$008D,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,-4(A6)
  MOVEM.L (SP)+,D2/A2
 \*)
   *)
(*$?Compiler=Megamax:
 ASSEMBLER
  MOVE.L  bptr(A6),-(A7)
  MOVE.W  #$008D,-(A7)
  TRAP    #14
  ADDQ.W  #6,A7
  MOVE.L  D0,l(A6)
 END;
   *)
 RETURN l;
END BuffPtr;

END M_XBIOS.



