(*----------------------------------------------------------------------*)

IMPLEMENTATION MODULE M_Xobjects;

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)

FROM SYSTEM     IMPORT  ADR, ADDRESS, STORE, LOAD;
FROM Storage    IMPORT  ALLOCATE, DEALLOCATE;
FROM M_Sys      IMPORT  App, CallMagic;
IMPORT M_AES;

(*$?Compiler=Megamax:
CONST   D0 =    0;
        A0 =    8;

TYPE    PtrUSER__BLK =   POINTER TO USER__BLK;
        USER__BLK =      RECORD
                         ubCode: ADDRESS;
                         ubPara: ADDRESS;
                         draw:   ADDRESS;
                         obType: SHORTINT;
                         priv:   ADDRESS;
                         appl:   ADDRESS;
                         box:    LONGINT;
                         value:  SHORTINT;
                         flags:  LONGINT;
                         proc:   DrawProc; (* Zeiger auf MM2-Zeichenprozedur *)
                        END;

PROCEDURE mm2;
VAR a: M_AES.PtrPARMBLK;
    t: M_AES.tObjctree;
    u: PtrUSER__BLK;
    i: SHORTINT;
BEGIN
 STORE (A0, a); (* Parameter in A0 *)
 t:= a^.pbTree;
 u:= t^[a^.pbObj].obSpec.address; 
 i:= u^.proc (a);
 LOAD (i, D0); (* Rckgabe nach D0 *)
END mm2;
 *)


PROCEDURE InstUserdef (tree: ADDRESS; objc: SHORTINT;
                      proc: DrawProc; private: ADDRESS): BOOLEAN;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= objc;
  AddrIn[0]:= tree;
(*$?Compiler=Haenisch:
  AddrIn[1]:= ADDRESS (proc);
 *)
(*$?Compiler=Megamax:
  AddrIn[1]:= ADDRESS (mm2);
 *)
  AddrIn[2]:= private;
(*$?Compiler=Megamax:
  AddrIn[3]:= ADDRESS (proc);
 *)
  CallMagic(2500);
  RETURN IntOut[0] = 1;
 END;
END InstUserdef;

PROCEDURE FreeUserdef (tree: ADDRESS; objc: SHORTINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= objc;
  AddrIn[0]:= tree;
 END;
 CallMagic(2501);
END FreeUserdef;

PROCEDURE GetObtype (tree: ADDRESS; objc: SHORTINT): SHORTINT;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= objc;
  AddrIn[0]:= tree;
  CallMagic(2502);
  RETURN IntOut[0];
 END;
END GetObtype;

PROCEDURE GetObSpec (tree: ADDRESS; objc: SHORTINT): ADDRESS;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= objc;
  AddrIn[0]:= tree;
  CallMagic(2503);
  RETURN AddrOut[0];
 END;
END GetObSpec;

PROCEDURE GetPrivate (tree: ADDRESS; objc: SHORTINT): ADDRESS;
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= objc;
  AddrIn[0]:= tree;
  CallMagic(2504);
  RETURN AddrOut[0];
 END;
END GetPrivate;

PROCEDURE GetValues (tree: ADDRESS; objc: SHORTINT; VAR v1, v2: LONGINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= objc;
  AddrIn[0]:= tree;
  CallMagic(2505);
  v1:= LongOut[0];
  v2:= LongOut[1];
 END;
END GetValues;

PROCEDURE SetValues (tree: ADDRESS; objc: SHORTINT; v1, v2: LONGINT);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= objc;
  AddrIn[0]:= tree;
  LongIn[0]:= v1;
  LongIn[1]:= v2;
  CallMagic(2506);
 END;
END SetValues;

PROCEDURE SetPrivate (tree: ADDRESS; objc: SHORTINT; priv: ADDRESS);
BEGIN
 WITH App^.MagicPB^ DO
  IntIn[0]:= objc;
  AddrIn[0]:= tree;
  AddrIn[1]:= priv;
  CallMagic(2507);
 END;
END SetPrivate;

END M_Xobjects.
