 
IMPLEMENTATION MODULE RTD;

(*----------------------------------------------------------------------*
 * Int. Vers | Datum    | Name | nderung                               *
 *-----------+----------+------+----------------------------------------*
 *  3.00     | 18.01.92 |  Hp  |                                        *
 *-----------+----------+------+----------------------------------------*)

FROM Portab IMPORT tCompiler, Compiler;
(*$?Compiler=Haenisch:
(* IMPLEMENTATION FR  >>> Hnisch-Modula-2 <<< *)
(*                                              *)
(*$V-   Range-Checks                            *)
(*$T-   Parameter-Checks                        *)
(*$S-   Stack-Check                             *)
(*$Y-   Runtime-Checks                          *)
(*$I-   keine Variablen-Initialisierung         *)
(*                                              *)
(*----------------------------------------------*)
 *)

(*$?Compiler=Megamax:
(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)
 *)


FROM SYSTEM IMPORT LOC;
FROM M_Sys  IMPORT CastToChar, CastToCard, CastToLCard;
FROM M_BIOS  IMPORT  Bconout, Bconstat, Bconin, CON, PRT, AUX;

(*$?Compiler=Megamax:
  IMPORT Convert;
 *)

CONST   cMaxIndent =    40;

VAR     indent, i:      SHORTCARD;
        device:         SHORTINT;


PROCEDURE write (string: ARRAY OF CHAR);
VAR i: SHORTCARD;
    ch: CHAR;
BEGIN
 FOR i:= 0 TO HIGH(string) DO
  IF string[i] = 0C THEN  RETURN  END;
  ch:= string[i];  Bconout (device, ch);
 END;
END write;

PROCEDURE writeLn;
BEGIN
 Bconout (device, 15C);  Bconout (device, 12C);
END writeLn;

PROCEDURE writeIndent;
VAR i: SHORTCARD;
BEGIN
 FOR i:= 0 TO indent DO  Bconout (device, ' ');  END;
END writeIndent;

PROCEDURE Into ((* REF *)  procedure: ARRAY OF CHAR);
BEGIN
 writeIndent;  write ("I: ");  write (procedure);  writeLn;
 IF indent < cMaxIndent THEN INC(indent);  END;
END Into;

PROCEDURE Leaving ((* REF *)  procedure: ARRAY OF CHAR);
BEGIN
 IF indent > 0 THEN DEC(indent); END;
 writeIndent;  write ("L: ");  write (procedure);  writeLn;
END Leaving;

PROCEDURE Message ((* REF *)  string: ARRAY OF CHAR);
BEGIN
 writeIndent;  write (string);  writeLn;
END Message;

PROCEDURE ShowStr ((* REF *)  msg, string: ARRAY OF CHAR);
BEGIN
 writeIndent;  write (msg);  write ('  ');  write (string);  writeLn;
END ShowStr;

VAR s: ARRAY [0..32] OF CHAR; 

PROCEDURE ShowVar ((* REF *)  name: ARRAY OF CHAR; VAR value: ARRAY OF LOC);
VAR wert: LONGCARD;
BEGIN
 writeIndent;
 write (name);
 write(" = "); 
 wert:= CastToLCard (value);
 (*$?Compiler=Haenisch:
   s := FORM(wert:10:10:' ');
  *)
 (*$?Compiler=Megamax:
   Convert.ConvLNum (wert, 10, 7, ' ', s);
  *)
 write (s);  write ('  ');
 (*$?Compiler=Haenisch:
   s := FORM(wert:8:16:' ');
  *)
 (*$?Compiler=Megamax:
   Convert.ConvLNum (wert, 16, 8, ' ', s);
  *)
 write (s);  write ('H ');
 IF HIGH (value) = 0 THEN
 (*$?Compiler=Haenisch:
   s := FORM(wert:32:2:' ');
  *)
 (*$?Compiler=Megamax:
   Convert.ConvLNum (wert, 9, 2, ' ', s);
  *)
  write (s);
  IF ( CastToChar(value[0]) >= ' ' ) THEN
   write ("  <");  Bconout (device, CastToChar(value[0])); write ("> ");
  END; 
 END;
 writeLn;
END ShowVar;

PROCEDURE SetDevice(dev: DEVICE);
BEGIN
 CASE dev OF
  printer: device:= PRT;|
  rs232:   device:= AUX;|
  console: device:= CON;|
  ELSE     device:= CON;
 END;
END SetDevice;

PROCEDURE WaitKey;
VAR d: LONGCARD;
BEGIN
 (* REPEAT UNTIL Bconstat (device); *)
 d:= Bconin (device);
END WaitKey; 

BEGIN
 indent:= 0;
 device:= CON;
END RTD.



